Please refer to the [wiki](https://gitlab.com/qualikiz-group/QLKNN-fortran/wikis) for more usage-type documentation. Detailed information about all methods and types defined in QLKNN-fortran can be found on the [GitLab Pages](https://qualikiz-group.gitlab.io/QLKNN-fortran/)

Quick Overview
==============

This document outlines the usage of the `make`-based build "system".

## Quick start

The code can be built as follows:

`$ make -f Makefile.take2 -j4`

(the standard make option `-j4` enables parallel builds with up to four
processes; change the number four to match the resources available to you.)

By default, this builds the "debug" configuration using the GCC toolchain
(i.e., using `gfortran`). A different configuration may be selected via the
`BUILD` value:

`$ make -f Makefile.take2 -j4 BUILD=release`

The toolchain can be changed via the `TOOLCHAIN` value:

`$ make -f Makefile.take2 -j4 TOOLCHAIN=intel`

The aim is to support at least the following build configurations for each
toolchain:

 - `debug`: unoptimized build with debug information and possibly with 
   additional run-time checks. Mostly relevant for code development.
 - `release`: fully optimized build sans debug information.
 - `relWithDbgInfo`: fully optimized build with debug information.

At the time of writing, two toolchains are supported:

 - `gcc`: using the GNU Compiler Collection (i.e., `gfortran` et al.)
 - `intel`: using the Intel compilers (i.e., `ifort` et al.)

All values are case sensitive. 


Built files are placed in the following output directories:
  - `bin/`
  - `lib/`
The names of these files (binaries and libraries) include a suffix
`-<toolchain>-<build>`, corresponding to the `TOOLCHAIN` and `BUILD` settings
that were selected.

Temporary files are placed in the directory `build/<toolchain>-<build>/`. 
All fortran module files are placed in `include/<toolchain>-<build>`.


Additionally, the following two options may be passed to `make`:

  - `VERBOSE=1`: prints the full commands that are executed by the build
  - `NOCOLOR=1`: disables the colorization of the output by make (#)

(#): Some tools (e.g., gfortran) may still include color in their output,
regardless of this setting.


To generate a list of the processed makefiles, use `make overview`. This
displays a list of all included sub-makefiles and their locations. Support
files (i.e., the build system functions located in `defs/`) are excluded from
this list.

## Makefiles

There are three different types of makefiles present:
 - Build definitions
 - Build configuration
 - Build system components

Build definitions contain information on how to build source code into the
final products. Build configuration define properties of each build, i.e., what
tools to use, what flags should be enabled, and where to find external
libraries and sources. Both build definitions and build configurations need to
be updated during development. The build system components instead hold the
system together, and (hopefully) do not need to be changed.

### Build configuration

Build configuration is contained in the following files:

 - `defs/variants/$(TOOLCHAIN)-$(BUILD).make`
 - `defs/localcfg/<machine-name>.make`
 - `usercfg.make`

Additionally, build definitions can add/override certain settings locally. See
next section.

Each combination of toolchain and build configuration is referred to as a 
variant. Each variant is defined by a single file in the `defs/variants/`
directory. Creating a new variant is as simple as creating the corresponding
file in the variants directory.

Machine-dependent settings should be placed in the `defs/localcfg` directory.
The settings are loaded based on the hostname (as reported by `hostname -f`) of
the machine where `make` is run. For example, when running on the machine
`r000u05g02.marconi.cineca.it`, the build will attempt to load the following
files

  - `defs/localcfg/r000u05g02.marconi.cineca.it.make`
  - `defs/localcfg/marconi.cineca.it.make`
  - `defs/localcfg/cineca.it.make`
  - `defs/localcfg/it.make`

in the above order. It is recommended that `localcfg` files are checked into
source control.

Finally, a `usercfg.make` is loaded from the root directory (i.e., the parent
of the `defs/` directory). This file can be used to override settings on a
per-user level. The `usercfg.make` *should not* be checked into source control.

Configuration files may not contain build rules, but must instead only define
variables and macros.

### Build definitions

Build definitions define the inputs and outputs of the build. These start with
the entry points (e.g., top-level `Makefile`s), and include any number of sub-
makefiles. 

A project is defined for each target:

```
$(call SUBPROJECT_open,<name>,<targetType>)
...
$(call SUBPROJECT_close)
```

`<name>` is a user-selected unique name for the "project". `<targetType>`
is one of the following
  - `staticlib` (static library, `lib<name>-<variant>.a`)
  - `app` (executable, `<name>-<variant>.exe`)

All of the following commands must be issued between the `open`/`close` pair
above (i.e., in the location of `...`).
 
A project may depend on other projects; these dependencies are defined via
`SUBPROJECT_depend`:

```
$(call SUBPROJECT_depend,<nameA> <nameB>)
```

The current project now depends on the projects named `<nameA>` and `<nameB>`.
One or more projects may be listed.  Typically, a `app` project will depend on
one or more `staticlibrary` projects.

Additional flags to the linker may be specified using

```
$(call SUBPROJECT_set_linkflags, <toolchain>, <flags...> )
``` 

The flags `<flags...>` will be passed to the linking stage as-is when built with
the selected `<toolchain>`. For example

```
$(call SUBPROJECT_set_linkflags, gcc, -lgcc_only_library )
$(call SUBPROJECT_set_linkflags, intel, -lintel_only_library )
```

will append `-lgcc_only_library` to the linker's command line when building with 
the `gcc` toolchain, and `-lintel_only_library` when building with the `intel` 
toolchain.


Sources may be added via `SUBPROJECT_add`; however, this command assumes that
full (absolute) paths are used. In order to simplify the use of local sources
(i.e., with paths relative to the current makefile), a number of "local" 
commands are provided.

The following example adds the files `a.f90` and `b.f90` which are in the same
directory as the current makefile.

```
$(call SUBPROJECT_reset_local)
$(call SUBPROJECT_set_local_dir_here)
$(call LOCAL_add, a.f90 b.f90)
```

WARNING: using `include <file>.make` in the _same file_ may prior to the 
`SUBPROJECT_set_local_dir_here` command may confuse that command. 
TODO-workaround!

These commands may be issued multiple times in each project. Therefore it is
important to use `SUBPROJECT_reset_local`, which resets any local settings (as
set by `SUBPROJECT_set_local_*`). `SUBPROJECT_set_local_dir_here` tells the
build system that any sources referred to in the following commands use paths
relative to the current makefile's location. `LOCAL_add` finally adds the
source files.

Additional local commands include:
  - `SUBPROJECT_set_local_fflags, <toolchain>, <flags...>`
  - `LOCAL_mod_dep, <source>, <module names...>`
  - `LOCAL_mod_out, <source>, <module names...>`

`SUBPROJECT_set_local_fflags` may be used to add the fortran compiler flags
`<flags...>` to the source files added in the following `LOACL_add` commands.
Compiler flags, like linker flags, are defined separately for each toolchain.

`LOCAL_mod_dep` specifies a list of modules that the source file `<source>`
depends upon. For example,

```
$(call LOCAL_mod_dep, a.f90, b.mod c.mod)
```

ensures that the sources producing `b.mod` and `c.mod` are built before
attempting to build `a.f90`. By default, the system assumes that a source file
named `foo.f90` will produce a module `foo.mod`. Occasionally this is not the
case; produced modules can therefore be specified using the command
`LOCAL_mod_out` as follows:

```
$(call LOCAL_mod_out, vexing.f90, unrelated.mod modules.mod)
```

NOTE: All file names are case-sensitive. In particular, module files should
always use lower-case names, as the output modules files created by the fortran
compilers use lower-case names.

WARNING: all modules from all projects are placed into the same directory. Two
modules with the same name may therefore result in excessive "fun".

### Build System components

All build system components are located in `defs/` and have the extension
`*.make`. Developers entertaining thoughts of inspecting these parts should be
prepared to abandon any semblance of sanity. (Make is not a pretty language.)


## TODO-Title




#%EOF vim:syntax=markdown:spell:

# cla.f90 is a module for parsing command-line arguments in Fortran-90.

## Features

-    Handles key/value pairs and flags in arbitrary order on the command line.

-    Includes validation and error messages for invalid or ill-formed command line arguments.

-    Is aware of help flags (--help, etc) by default.

-    Values passed as arguments can be character string, integer, real, or boolean.

-    Depends on kinds.f90 for specification of size of strings, integers, reals, and pointers.

-    Uses the F03 standard for accessing the command line arguments (`command_argument_count` and `get_command_argument`).

-    Tested with gfortran, ifort, and pgf90.

-    See cla_test.f90 for an example of usage.

## Usage Example

     use cla
     ...
     call cla_init
     call cla_register(key='--input',description='inputfile',kind=cla_char,default='../prm/grid')
     call cla_register(key='-q', description='quiet flag',kind=cla_flag,default='f' )
     call cla_validate
     call cla_get('-q', lquiet)      ! assigns the value .true. to if -q is present
     call cla_get('--input',cfname)  ! assigns input filename to cfname
     ...

## Download

- Grab the [compressed tar file](https://hachi.cee.pdx.edu/fossil/CLAF90/info/tip)

## Contributors

-    Daan van Vugt (d.c.v.vugt ~at~ tue.nl), improved help message (2015-06-24).

-    Eli Ateljevich (Eli.Ateljevich ~at~ water.ca.gov), positional arguments and other enhancements (2015-01-03).

## Acknowledgement

This software was developed with support from the Naval Research Laboratory (Grant #N00173-08-2-C015) and NASA (Grant #NNX13AH06G).

! Module qlknn_disk_io defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_disk_io.f90

subroutine f90wrap_load_qlknn_hyper_nets_from_disk(folder, verbosityin)
    use qlknn_disk_io, only: load_qlknn_hyper_nets_from_disk
    implicit none
    
    character(*), intent(in) :: folder
    integer(8), optional, intent(in) :: verbosityin
    call load_qlknn_hyper_nets_from_disk(folder=folder, verbosityin=verbosityin)
end subroutine f90wrap_load_qlknn_hyper_nets_from_disk

subroutine f90wrap_load_fullflux_nets_from_disk(folder, verbosityin)
    use qlknn_disk_io, only: load_fullflux_nets_from_disk
    implicit none
    
    character(*), intent(in) :: folder
    integer(8), optional, intent(in) :: verbosityin
    call load_fullflux_nets_from_disk(folder=folder, verbosityin=verbosityin)
end subroutine f90wrap_load_fullflux_nets_from_disk

subroutine f90wrap_load_jetexp_nets_from_disk(folder, n_members, verbosityin)
    use qlknn_disk_io, only: load_jetexp_nets_from_disk
    implicit none
    
    character(*), intent(in) :: folder
    integer(8), intent(in) :: n_members
    integer(8), optional, intent(in) :: verbosityin
    call load_jetexp_nets_from_disk(folder=folder, n_members=n_members, verbosityin=verbosityin)
end subroutine f90wrap_load_jetexp_nets_from_disk

subroutine f90wrap_load_hornnet_nets_from_disk(folder, verbosityin)
    use qlknn_disk_io, only: load_hornnet_nets_from_disk
    implicit none
    
    character(*), intent(in) :: folder
    integer(8), optional, intent(in) :: verbosityin
    call load_hornnet_nets_from_disk(folder=folder, verbosityin=verbosityin)
end subroutine f90wrap_load_hornnet_nets_from_disk

subroutine f90wrap_load_multinet_from_disk(netlist, folder, verbosityin, stylein, n0)
    use qlknn_disk_io, only: load_multinet_from_disk
    implicit none
    
    character(*), intent(in), dimension(n0) :: netlist
    character(*), intent(in) :: folder
    integer(8), optional, intent(in) :: verbosityin
    integer(8), optional, intent(in) :: stylein
    integer :: n0
    !f2py intent(hide), depend(netlist) :: n0 = shape(netlist,0)
    call load_multinet_from_disk(netlist=netlist, folder=folder, verbosityin=verbosityin, stylein=stylein)
end subroutine f90wrap_load_multinet_from_disk

subroutine f90wrap_load_net_from_disk(filename, net)
    use qlknn_types, only: networktype
    use qlknn_disk_io, only: load_net_from_disk
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    character(*), intent(in) :: filename
    type(networktype_ptr_type) :: net_ptr
    integer, intent(out), dimension(2) :: net
    allocate(net_ptr%p)
    call load_net_from_disk(filename=filename, net=net_ptr%p)
    net = transfer(net_ptr, net)
end subroutine f90wrap_load_net_from_disk

subroutine f90wrap_load_hornnet_output_block_from_disk(filename, output_block)
    use qlknn_disk_io, only: load_hornnet_output_block_from_disk
    use qlknn_types, only: hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    character(*), intent(in) :: filename
    type(hornnet_output_block_ptr_type) :: output_block_ptr
    integer, intent(out), dimension(2) :: output_block
    allocate(output_block_ptr%p)
    call load_hornnet_output_block_from_disk(filename=filename, output_block=output_block_ptr%p)
    output_block = transfer(output_block_ptr, output_block)
end subroutine f90wrap_load_hornnet_output_block_from_disk

subroutine f90wrap_load_hornnet_input_block_from_disk(filename, input_block)
    use qlknn_types, only: hornnet_input_block
    use qlknn_disk_io, only: load_hornnet_input_block_from_disk
    implicit none
    
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    character(*), intent(in) :: filename
    type(hornnet_input_block_ptr_type) :: input_block_ptr
    integer, intent(out), dimension(2) :: input_block
    allocate(input_block_ptr%p)
    call load_hornnet_input_block_from_disk(filename=filename, input_block=input_block_ptr%p)
    input_block = transfer(input_block_ptr, input_block)
end subroutine f90wrap_load_hornnet_input_block_from_disk

subroutine f90wrap_qlknn_disk_io__get__nets(f90wrap_nets)
    use qlknn_types, only: net_collection
    use qlknn_disk_io, only: qlknn_disk_io_nets => nets
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(out) :: f90wrap_nets(2)
    type(net_collection_ptr_type) :: nets_ptr
    
    nets_ptr%p => qlknn_disk_io_nets
    f90wrap_nets = transfer(nets_ptr,f90wrap_nets)
end subroutine f90wrap_qlknn_disk_io__get__nets

subroutine f90wrap_qlknn_disk_io__set__nets(f90wrap_nets)
    use qlknn_types, only: net_collection
    use qlknn_disk_io, only: qlknn_disk_io_nets => nets
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in) :: f90wrap_nets(2)
    type(net_collection_ptr_type) :: nets_ptr
    
    nets_ptr = transfer(f90wrap_nets,nets_ptr)
    qlknn_disk_io_nets = nets_ptr%p
end subroutine f90wrap_qlknn_disk_io__set__nets

subroutine f90wrap_qlknn_disk_io__get__blocks(f90wrap_blocks)
    use qlknn_types, only: block_collection
    use qlknn_disk_io, only: qlknn_disk_io_blocks => blocks
    implicit none
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    integer, intent(out) :: f90wrap_blocks(2)
    type(block_collection_ptr_type) :: blocks_ptr
    
    blocks_ptr%p => qlknn_disk_io_blocks
    f90wrap_blocks = transfer(blocks_ptr,f90wrap_blocks)
end subroutine f90wrap_qlknn_disk_io__get__blocks

subroutine f90wrap_qlknn_disk_io__set__blocks(f90wrap_blocks)
    use qlknn_types, only: block_collection
    use qlknn_disk_io, only: qlknn_disk_io_blocks => blocks
    implicit none
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    integer, intent(in) :: f90wrap_blocks(2)
    type(block_collection_ptr_type) :: blocks_ptr
    
    blocks_ptr = transfer(f90wrap_blocks,blocks_ptr)
    qlknn_disk_io_blocks = blocks_ptr%p
end subroutine f90wrap_qlknn_disk_io__set__blocks

! End of module qlknn_disk_io defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_disk_io.f90

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_primitives
#include "preprocessor.inc"
  use qlknn_types

  implicit none

  interface calc_length
     module procedure &
          calc_length_li, &
          calc_length_lli, &
          calc_length_mixed1, &
          calc_length_mixed2
  end interface

  interface is_not_close
     module procedure &
          double_2d_2d_is_not_close, &
          double_1d_1d_is_not_close, &
          double_1d_0d_is_not_close
  end interface
! Removing this seems to not matter. Dependent on linking? Keeping them around just to be sure
!#ifdef USE_MKL
  !include "mkl_vml.fi"
  !include "mkl_blas.fi"
!#endif

contains
  subroutine evaluate_network(input, net, output_1d, verbosityin, dnet_out1d_dinput)
    !! Evaluate a single feed-forward neural network. Assumes the output of the network is 1D.
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    !! Input array fed to the network
    type(networktype), intent(in) :: net
    !! A 1D network to be evaluated
    integer(lli), optional, intent(in) :: verbosityin
    !! Verbosity of this function
    integer(lli):: verbosity
    real(qlknn_dp), dimension(:,:), allocatable :: output
    real(qlknn_dp), dimension(:), intent(out) :: output_1d
    !! Output of the network cast to a 1D array
    real(qlknn_dp), dimension(:,:), optional, intent(out) :: dnet_out1d_dinput
    !! Jacobian of the network cast to a 2D array

    integer(lli) :: rho, outp, inp, ii, lay, n_inputs_layer
    integer(lli) :: n_hidden_layers, n_hidden_nodes, n_inputs, n_outputs, n_rho
    real(qlknn_dp), dimension(:,:), allocatable :: inp_resc
    real(qlknn_dp), dimension(:,:,:), allocatable :: dnet_out_dinput, dthis_dprev, dlayers_dnorm
    real(qlknn_dp), dimension(:,:), allocatable :: dlayers_dnorm_tmp
    logical :: calcder
    character(len=200) :: error_msg
    real(qlknn_dp), dimension(:,:), allocatable :: outp_resc

    if(present(verbosityin)) then
      verbosity=verbosityin
    else
      verbosity = 0
    end if

    if(present(dnet_out1d_dinput)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    n_hidden_layers = net%n_hidden_layers
    n_hidden_nodes = net%n_max_nodes
    n_inputs = size(net%weights_input, 2)
    n_outputs = size(net%weights_output, 1)
    n_rho = size(input, 2)
    write(error_msg, *) 'Expected 1D output from network, not', n_outputs, 'D'
    ERRORSTOP(n_outputs > 1, error_msg)
    ERRORSTOP(.NOT. size(output_1d) == n_rho, 'Passed output_1d has wrong shape!')
    if (.NOT. n_inputs == size(input, 1)) then
      write(stderr,*) 'Passed input has wrong number of inputs! size(input, 1)=', size(input, 1), ', needed n_inputs=', n_inputs
      ERRORSTOP(.true., '')
    end if

    allocate(inp_resc(n_inputs, n_rho))
    allocate(outp_resc(n_hidden_nodes, n_rho))
    allocate(output(n_outputs, n_rho))
    if (calcder) then
      allocate(dthis_dprev(n_hidden_nodes, n_rho, n_hidden_nodes))
      allocate(dlayers_dnorm(n_hidden_nodes, n_rho, n_inputs))
      allocate(dnet_out_dinput(n_outputs, n_rho, n_inputs))
#ifdef USE_MKL
      allocate(dlayers_dnorm_tmp(n_hidden_nodes, n_inputs))
#else
      allocate(dlayers_dnorm_tmp(0, 0))
#endif
    else
      allocate(dthis_dprev(0, 0, 0))
      allocate(dlayers_dnorm(0, 0, 0))
      allocate(dnet_out_dinput(0, 0, 0))
      allocate(dlayers_dnorm_tmp(0, 0))
    endif
    inp_resc = 0
    outp_resc = 0

    if (verbosity >= 4) then
      write(*, *) 'n_hidden_layers', n_hidden_layers
      write(*, *) 'n_hidden_nodes', n_hidden_nodes
      write(*, *) 'n_inputs', n_inputs
      write(*, *) 'n_outputs', n_outputs
      write(*, *) 'n_rho', n_rho
      write(*,*) 'input'
      do rho = 1, n_rho
        write(*,'(11(f7.2, 1X))') input(:, rho)
      end do
    end if
    if (verbosity >= 4) write(*,*) 'evaluating network'
    if (verbosity >= 4) write(*,*) 'inp_resc'
    do rho = 1, n_rho
      inp_resc(:,rho) = net%feature_prescale_factor * input(:,rho) + &
           net%feature_prescale_bias
      if (calcder) then
        do outp = 1, n_outputs
          dnet_out_dinput(outp, rho, :) = net%feature_prescale_factor
        end do
      end if
      if (verbosity >= 4) write(*,'(11(f7.2, 1X))') inp_resc(:, rho)
    end do

    !----------------------------
    ! Apply input layer
    if (calcder) then
      call evaluate_layer(inp_resc, net%weights_input, net%biases_input, net%hidden_activation(1), &
         outp_resc, verbosity, dlayers_dnorm)
    else
      call evaluate_layer(inp_resc, net%weights_input, net%biases_input, net%hidden_activation(1), &
         outp_resc, verbosity)
    endif
    if (verbosity >= 4) then
      write(*,*) 'input_layer post_tanh. (1:12, 1:12)'
      do ii = 1, 12
        write(*,'(12(f7.2, 1x))') outp_resc(ii, 1:12)
      end do
    end if

    !----------------------------
    ! Apply hidden layers
    do lay = 1, n_hidden_layers - 1
      n_inputs_layer = size(net%weights_hidden(lay)%weight_layer, 2)
      if (calcder) then
        call evaluate_layer(outp_resc(:n_inputs_layer, :), net%weights_hidden(lay)%weight_layer, net%biases_hidden(lay)%bias_layer, net%hidden_activation(lay+1), &
           outp_resc, verbosity, dthis_dprev)
        do rho = 1, n_rho
#ifdef USE_MKL
          ! MKL with GCC actually faster with explicit temp variable
          dlayers_dnorm_tmp = dlayers_dnorm(:, rho, :)
          call dgemm('N', 'N', n_hidden_nodes, n_inputs, n_hidden_nodes, 1._qlknn_dp, dthis_dprev(:, rho, :), n_hidden_nodes, &
             dlayers_dnorm_tmp, n_hidden_nodes, 0._qlknn_dp, dlayers_dnorm(:, rho, :), n_hidden_nodes)
#else
          call dgemm('N', 'N', n_hidden_nodes, n_inputs, n_hidden_nodes, 1._qlknn_dp, dthis_dprev(:, rho, :), n_hidden_nodes, &
             dlayers_dnorm(:, rho, :), n_hidden_nodes, 0._qlknn_dp, dlayers_dnorm(:, rho, :), n_hidden_nodes)
#endif
        end do
      else
        call evaluate_layer(outp_resc(:n_inputs_layer, :), net%weights_hidden(lay)%weight_layer, net%biases_hidden(lay)%bias_layer, net%hidden_activation(lay+1), &
           outp_resc, verbosity)
      endif
      if (verbosity >= 5) then
        write(*,*) 'layer ', lay, ' weights. (1:12, 1:12)'
        do ii = 1, 12
          write(*,'(12(f7.2, 1X))') net%weights_hidden(lay)%weight_layer(ii, 1:12)
        end do
        write(*,*) 'layer ', lay, ' biases. (1:12)'
        write(*,'(12(f7.2, 1X))') net%biases_hidden(lay)%bias_layer(1:12)
        write(*,*) 'layer ', lay, ' act.'
        write(*, '(A)') net%hidden_activation(lay)
      end if
      if (verbosity >= 4) then
        write(*,*) 'layer ', lay, ' post_act. (1:12, 1:12)'
        do ii = 1, 12
          write(*,'(12(f7.2, 1X))') outp_resc(ii, 1:12)
        end do
      end if
    end do

    !---------------------
    ! Apply output layer
    n_inputs_layer = size(net%weights_output, 2)
    if (calcder) then
      call evaluate_layer(outp_resc(:n_inputs_layer, :), net%weights_output, net%biases_output, 'none', &
         outp_resc, verbosity, dthis_dprev)
      do rho = 1, n_rho
#ifdef USE_MKL
        ! MKL with GCC actually faster with explicit temp variable
        dlayers_dnorm_tmp = dlayers_dnorm(:, rho, :)
        call dgemm('N', 'N', n_hidden_nodes, n_inputs, n_hidden_nodes, 1._qlknn_dp, dthis_dprev(:, rho, :), n_hidden_nodes, &
             dlayers_dnorm_tmp, n_hidden_nodes, 0._qlknn_dp, dlayers_dnorm(:, rho, :), n_hidden_nodes)
#else
        call dgemm('N', 'N', n_hidden_nodes, n_inputs, n_hidden_nodes, 1._qlknn_dp, dthis_dprev(:, rho, :), n_hidden_nodes, &
             dlayers_dnorm(:, rho, :), n_hidden_nodes, 0._qlknn_dp, dlayers_dnorm(:, rho, :), n_hidden_nodes)
#endif
      end do
    else
      call evaluate_layer(outp_resc(:n_inputs_layer, :), net%weights_output, net%biases_output, 'none', &
         outp_resc, verbosity)
    endif
    output = outp_resc(:n_outputs, :)
    if (verbosity >= 4) write(*,*) 'output_layer'
    if (verbosity >= 4) write(*,'(20(f7.2, 1x))') output

    !------------------------
    ! Denormalize output
    do rho = 1, n_rho
      output(:, rho) = dot_product(1/net%target_prescale_factor(:), output(:, rho) - &
           net%target_prescale_bias)
    end do
    if (calcder) then
      do rho = 1, n_rho
        do inp = 1, n_inputs
          call vdmul(n_outputs, 1/net%target_prescale_factor(:), dnet_out_dinput(:, rho, inp), dnet_out_dinput(:, rho, inp))
          call vdmul(n_outputs, dnet_out_dinput(:, rho, inp), dlayers_dnorm(:n_outputs, rho, inp),  dnet_out_dinput(:, rho, inp))
        end do
      end do
    end if
    if (verbosity >= 4) write(*,*) 'output_descaled'
    if (verbosity >= 4) write(*,'(20(f7.2, 1x))') output

    output_1d(:) = output(1, :)
    if (calcder) then
      dnet_out1d_dinput = dnet_out_dinput(1, :, :)
    end if
    !WRITE(*,'(*(F7.2 X))'), (output(1, ii), ii=1,n_rho)
    !deallocate(inp_resc)
    !deallocate(B_hidden)
    !deallocate(B_output)
    !deallocate(dthis_dprev)
    !deallocate(dlayers_dnorm_tmp)
    !deallocate(dnet_out_dinput_tmp)
    !deallocate(outp_resc)
  end subroutine evaluate_network

  subroutine evaluate_layers(input, weights, biases, activation, outp_resc, verbosityin, doutput_dnorm)
    !! Evaluate multiple (hidden) layers, layer shapes handled by ragged arrays
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    !! Input array fed to the layers (n_in x n_rho)
    type(ragged_weights_array), dimension(:), intent(in) :: weights
    !! Weights of the layers (n_layers % (n_out x n_in))
    type(ragged_biases_array), dimension(:), intent(in) :: biases
    !! Biases of the layer (n_layers % (n_out))
    character(len=4), dimension(:), intent(in) :: activation
    !! Activation functions of the layer
    integer(lli), optional, intent(in) :: verbosityin
    !! Verbosity of this function
    integer(lli):: verbosity
    real(qlknn_dp), dimension(:,:), intent(out) :: outp_resc
    !! Output of the layers
    real(qlknn_dp), dimension(:,:,:), intent(inout), optional :: doutput_dnorm
    !! Already existing Jacobian to start with (n_out x n_rho x n_norm_in)

    integer(lli) rho, lay, ii
    integer(lli) :: n_layers, n_inputs, n_outputs, n_rho, n_inputs_layer, n_norm_inputs
    logical :: calcder
    real(qlknn_dp), dimension(:,:), allocatable :: output_prev
    real(qlknn_dp), dimension(:,:,:), allocatable :: dthis_dprev
#ifdef USE_MKL
    real(qlknn_dp), dimension(:,:), allocatable :: doutput_dnorm_tmp
#endif


    if(present(verbosityin)) then
      verbosity=verbosityin
    else
      verbosity = 0
    end if

    if (verbosity >= 3) then
      write(*,*) 'evaluate_layers'
    endif

    if(present(doutput_dnorm)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    n_layers = size(weights)
    n_inputs = size(biases(1)%bias_layer)
    n_outputs = size(weights(n_layers)%weight_layer, 2)
    n_rho = size(input, 2)

    !write(*,*) 'n_layers=', n_layers, 'n_inputs=', n_inputs, 'n_outputs', n_outputs, 'n_rho=', n_rho

    allocate(output_prev(n_outputs, n_rho))
    if (calcder) then
      allocate(dthis_dprev(n_outputs, n_rho, n_outputs))
      n_norm_inputs = size(doutput_dnorm, 3)
    else
      allocate(dthis_dprev(0, 0, 0))
    endif

#ifdef USE_MKL
    if (calcder) then
      allocate(doutput_dnorm_tmp(n_outputs, n_outputs))
    else
      allocate(doutput_dnorm_tmp(0, 0))
    endif
#endif

    !----------------------------
    ! Apply hidden layers
    outp_resc = input
    do lay = 1, n_layers
      n_inputs_layer = size(weights(lay)%weight_layer, 2)
      if (calcder) then
        call evaluate_layer(outp_resc(:n_inputs_layer, :), weights(lay)%weight_layer, biases(lay)%bias_layer, activation(lay), &
           outp_resc, verbosity, dthis_dprev)
        if (verbosity >= 5) then
          write(*,'(A,I2,A,I2,A)') 'layer ', lay, ' dthis_dprev from evaluate_layer. (1:12, ', floor(real(n_rho)/2.), ', 1:12)'
          do ii = 1, 12
            write(*,'(12(f7.2, 1X))') dthis_dprev(ii, floor(real(n_rho)/2.), 1:12)
          end do
        endif
        do rho = 1, n_rho
#ifdef USE_MKL
          ! MKL with GCC actually faster with explicit temp variable
          doutput_dnorm_tmp = doutput_dnorm(:, rho, :)
          call dgemm('N', 'N', n_outputs, n_norm_inputs, n_outputs, 1._qlknn_dp, dthis_dprev(:, rho, :), n_outputs, &
             doutput_dnorm_tmp, n_outputs, 0._qlknn_dp, doutput_dnorm(:, rho, :), n_outputs)
#else
          call dgemm('N', 'N', n_outputs, n_norm_inputs, n_outputs, 1._qlknn_dp, dthis_dprev(:, rho, :), n_outputs, &
               doutput_dnorm(:, rho, :), n_outputs, 0._qlknn_dp, doutput_dnorm(:, rho, :), n_outputs)
#endif
        end do
        if (verbosity >= 5) then
          write(*,'(A,I2,A,I2,A,I2,A)') 'layer ', lay, ' doutput_dnorm from evaluate_layer. (1:12, ', floor(real(n_rho)/2.), ', 1:', n_norm_inputs, ')'
          do ii = 1, 12
            write(*,'(12(f7.2, 1X))') doutput_dnorm(ii, floor(real(n_rho)/2.), 1:n_norm_inputs)
          end do
        endif
      else
        call evaluate_layer(outp_resc(:n_inputs_layer, :), weights(lay)%weight_layer, biases(lay)%bias_layer, activation(lay), &
           outp_resc, verbosity)
      endif
      if (verbosity >= 5) then
        write(*,*) 'layer ', lay, ' weights. (1:12, 1:12)'
        do ii = 1, 12
          write(*,'(12(f7.2, 1X))') weights(lay)%weight_layer(ii, 1:12)
        end do
        write(*,*) 'layer ', lay, ' biases. (1:12)'
        write(*,'(12(f7.2, 1X))') biases(lay)%bias_layer(1:12)
        write(*,*) 'layer ', lay, ' act.'
        write(*, '(A)') activation(lay)
      end if
      if (verbosity >= 4) then
        write(*,*) 'layer ', lay, ' post_act. (1:12, 1:12)'
        do ii = 1, 12
          write(*,'(12(f7.2, 1X))') outp_resc(ii, 1:12)
        end do
      end if
    end do

  end subroutine evaluate_layers

  subroutine evaluate_layer(input, weights, biases, activation_func, output, verbosityin, doutput_dinput)
    !! Evaluate a single layer
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    !! Input array fed to the layer (n_in x n_rho)
    real(qlknn_dp), dimension(:,:), intent(in) :: weights
    !! Weights of the layer (n_out x n_in)
    real(qlknn_dp), dimension(:), intent(in) :: biases
    !! Biases of the layer (n_out)
    character(len=4), intent(in) :: activation_func
    !! Activation function of the layer. 0: tanh, 1: linear
    integer(lli), optional, intent(in) :: verbosityin
    !! Verbosity of this function
    integer(lli):: verbosity
    real(qlknn_dp), dimension(:,:), intent(out) :: output
    !! Output of the layer
    real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: doutput_dinput
    !! Jacobian of the layer

    integer(lli) rho, inp
    integer(lli) :: n_inputs, n_outputs, n_rho
    real(qlknn_dp), dimension(:,:), allocatable :: output_shaped
    logical :: calcder
    integer(lli), parameter :: n_plot_outputs_max = 24
    integer(lli) :: n_plot_outputs

    if(present(verbosityin)) then
      verbosity=verbosityin
    else
      verbosity = 0
    end if

    if(present(doutput_dinput)) then
      calcder = .true.
    else
      calcder = .false.
    end if
    n_inputs = size(weights, 2)
    n_outputs = size(weights, 1)
    n_rho = size(input, 2)

    allocate(output_shaped(n_outputs, n_rho))

    if (verbosity >= 3) then
      write(*, '(A,I2,A,I3,A,I3)') 'Evaluate layer with n_inputs=', n_inputs, ', n_outputs=', n_outputs, ', n_rho=', n_rho
      write(*, '(A,I4,A,I4,A)') 'Results in output_shaped(', size(output_shaped, 1), ',', size(output_shaped, 2), ')'
    endif

    if (size(output, 1) < n_outputs .or. size(output, 2) < n_rho) then
      write(*,'(A,I4,A,I4,A,I4,A,I4,A,I4,A,I4,A)') 'weights(', n_outputs, ', ', n_inputs, ') x input(',  size(input, 1), ', ', &
           n_rho, ') /= output(', size(output, 1), ',', size(output, 2), ')'
      ERRORSTOP(size(output, 1) < n_outputs, 'Passed output has wrong amount of rows!')
      ERRORSTOP(size(output, 2) < n_rho, 'Passed output has wrong amount of columns!')
    endif
    if (calcder) then
      if (size(doutput_dinput, 1) < n_outputs .or. size(doutput_dinput, 2) < n_rho .or. size(doutput_dinput, 3) < n_inputs) then
        write(*,'(A,I4,A,I4,A,I4,A,I4,A,I4,A,I4,A,I4,A)') 'for nrho=', n_rho, ' do output_tmp(', n_outputs, ', ', n_rho, ', ', n_inputs, &
             ') x doutput_dinput(', size(doutput_dinput, 1), ', ', size(doutput_dinput, 2), ', ', size(doutput_dinput, 3), ')'
        ERRORSTOP(size(doutput_dinput, 1) < n_outputs, 'Passed output Jacobian has wrong amount of rows!')
        ERRORSTOP(size(doutput_dinput, 2) < n_rho, 'Passed output Jacobian has wrong amount of columns!')
        ERRORSTOP(size(doutput_dinput, 3) < n_inputs, 'Passed output Jacobian has wrong amount of pages!')
      endif
    endif

    do rho = 1, n_rho
      output_shaped(:, rho) = biases
    end do
    ! dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc)
    ! lda = m, ldb=k, ldc=m
    call dgemm('N', 'N', n_outputs, n_rho, n_inputs, 1._qlknn_dp, weights, n_outputs, input, &
          n_inputs, 1._qlknn_dp, &
          output_shaped, n_outputs)
    if (activation_func == 'tanh') then
      call vdtanh(n_rho * n_outputs, output_shaped(:, :), output_shaped) !Does not work without colons
    endif
    output(:n_outputs, :) = output_shaped
    if (n_outputs < size(output, 1)) output(n_outputs+1:, :) = 0

    if (calcder) then
      ! Df/Dx = f'(W * in_0 + b) .* W
      do inp = 1, n_inputs
        doutput_dinput(:, :, inp) = output !dactivation_dx == f'(W * in_0 + b)
      end do
      if (n_inputs < size(doutput_dinput, 3)) doutput_dinput(:, :, n_inputs+1:) = 0
      if (activation_func == 'tanh') then
        doutput_dinput(:n_outputs, :, :n_inputs) = 1 - doutput_dinput(:n_outputs, :, :n_inputs) ** 2
        do rho = 1, n_rho
          call matr_mult_elemwise(n_outputs * n_inputs, doutput_dinput(:n_outputs, rho, :n_inputs), weights, doutput_dinput(:n_outputs, rho, :n_inputs))
        end do
      else if (activation_func == 'none') then
        do rho = 1, n_rho
          doutput_dinput(:n_outputs, rho, :n_inputs) = weights
        end do
      endif
    endif

    if (verbosity >= 4) then
      if (n_outputs > n_plot_outputs_max) then
        n_plot_outputs = n_plot_outputs_max
        write(*, '(A,I4,A)') 'layer out(:, :', n_plot_outputs, ')'
      else
        n_plot_outputs = n_outputs
        write(*, '(A)') 'layer out(:,:)'
      endif
      do rho = 1, n_rho
        WRITE(*,'(*(F7.2, 1X))') output(:n_plot_outputs, rho)
      enddo
    endif
  end subroutine evaluate_layer

  subroutine impose_output_constraints(output, opts, verbosity, dnet_out_dinput, output_eb)
    !! Clip given network output array to [min, mix, margin]_output given in opts.
    !!
    !! Using a maximum of \( c_{max} \), minimum of \( c_{min} \), margin of \( c_{margin} \)
    !! and value \( y \), the value x will be clipped in place to
    !! $$ y_{min} = c_{min} + (1-c_{margin}) * abs(c_{min}) $$
    !! $$ y_{max} = c_{max} - (1-c_{margin}) * abs(c_{max}) $$
    real(qlknn_dp), dimension(:,:), intent(inout) :: output
    !! To-be clipped output (n_rho x n_outputs)
    type (qlknn_options), intent(in) :: opts
    !! Options containing [min, mix, margin]_output
    integer(lli), intent(in) :: verbosity
    !! Verbosity of this function
    real(qlknn_dp), dimension(:,:,:), optional, intent(inout) :: dnet_out_dinput
    !! Jacobian of clipped output
    real(qlknn_dp), dimension(:,:), optional, intent(inout) :: output_eb
    !! Error bounds of clipped output

    integer(lli) :: ii, rho, n_rho, n_inp, inp, n_outputs
    real(qlknn_dp), dimension(:), allocatable :: output_min, output_max
    logical :: calcder, calceb
    character(200) :: fmt_str

    n_rho = size(output, 1)
    n_outputs = size(output, 2)
    if(present(dnet_out_dinput)) then
      calcder = .true.
      n_inp = size(dnet_out_dinput, 3)
    else
      calcder = .false.
      n_inp = -1
    endif
    if (present(output_eb)) then
      calceb = .true.
      ERRORSTOP(.not. all(shape(output_eb) == shape(output)),'Clipped errorbound array should be the same shape as out array')
    else
      calceb = .false.
    endif

    ERRORSTOP(size(opts%min_output) /= n_outputs, 'min_output not same size as number of outputs')
    ERRORSTOP(size(opts%max_output) /= n_outputs, 'max_output not same size as number of outputs')
    ERRORSTOP(size(opts%margin_output) /= n_outputs, 'margin_output not same size as number of outputs')

    allocate(output_min(n_outputs))
    allocate(output_max(n_outputs))

    output_min = opts%min_output + (1-opts%margin_output) * abs(opts%min_output)
    output_max = opts%max_output - (1-opts%margin_output) * abs(opts%max_output)
    if (calcder) then
      do inp = 1, n_inp
        do rho = 1, n_rho
          where (output(rho, :) < output_min .AND. opts%constrain_outputs)
            dnet_out_dinput(:, rho, inp) = 0
          end where
        end do
      end do
      do inp = 1, n_inp
        do rho = 1, n_rho
          where (output(rho, :) > output_max .AND. opts%constrain_outputs)
            dnet_out_dinput(:, rho, inp) = 0
          end where
        end do
      end do
    endif
    do rho = 1, n_rho
      if (calceb) then
        where ((output(rho, :) < output_min) .AND. opts%constrain_outputs)
          output_eb(rho, :) = output_eb(rho, :) + abs(output_min - output(rho, :))
        elsewhere ((output(rho, :) > output_max) .AND. opts%constrain_outputs)
          output_eb(rho, :) = output_eb(rho, :) + abs(output(rho, :) - output_max)
        endwhere
      endif
      where ((output(rho, :) < output_min) .AND. opts%constrain_outputs)
        output(rho, :) = output_min
      elsewhere ((output(rho, :) > output_max) .AND. opts%constrain_outputs)
        output(rho, :) = output_max
      endwhere
    end do

    if (verbosity >= 3) then
      write(*,*) 'output clipped, n_rho=', n_rho
      do rho = 1, n_rho
        write(fmt_str, '(A, I0, A)') '(', n_outputs, '(F7.2, 1X))'
        WRITE(*, fmt_str) (output(rho, ii), ii=1,n_outputs)
      end do
    end if
  end subroutine impose_output_constraints

  subroutine impose_input_constraints(input, input_clipped, opts, verbosity, jacobian_clipmask)
    !! Clip given network input array to [min, mix, margin]_input given in opts.
    !!
    !! Using a maximum of \( c_{max} \), minimum of \( c_{min} \), margin of \( c_{margin} \)
    !! and value \( x \), the value x will be copied and clipped to
    !! $$ x_{min} = c_{min} + (1-c_{margin}) * abs(c_{min}) $$
    !! $$ x_{max} = c_{max} - (1-c_{margin}) * abs(c_{max}) $$
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    !! Network input
    type (qlknn_options), intent(in) :: opts
    !! Options containing [min, mix, margin]_input
    integer(lli), intent(in) :: verbosity
    !! Verbosity of this function
    real(qlknn_dp), dimension(:,:), allocatable, intent(out) :: input_clipped
    !! Clipped network input array
    logical, dimension(:,:), allocatable, intent(out), optional :: jacobian_clipmask
    !! Mask containing true for input elements that were clipped

    integer(lli) :: ii, rho, n_rho, n_inp
    real(qlknn_dp), dimension(:), allocatable :: input_min, input_max
    logical :: calcder
    character(200) :: fmt_str

    n_rho = size(input, 2)
    n_inp = size(input, 1)
    allocate(input_min(n_inp))
    allocate(input_max(n_inp))

    if(present(jacobian_clipmask)) then
      calcder = .true.
      allocate(jacobian_clipmask(n_inp, n_rho))
    else
      calcder = .false.
    endif

    input_min = opts%min_input + (1-opts%margin_input) * abs(opts%min_input)
    input_max = opts%max_input - (1-opts%margin_input) * abs(opts%max_input)
#if (defined(__PGI) && __PGIC__ < 15) || (defined(__INTEL_COMPILER) && !defined(USE_MKL))
    allocate(input_clipped(lbound(input,1):ubound(input,1), lbound(input,2):ubound(input,2)))
#else
    allocate(input_clipped(n_inp, n_rho))
#endif
    input_clipped = input
    do rho = 1, n_rho
      where ((input_clipped(:, rho) < input_min) .AND. opts%constrain_inputs)
        input_clipped(:, rho) = input_min
      endwhere
      where ((input_clipped(:, rho) > input_max) .AND. opts%constrain_inputs)
        input_clipped(:, rho) = input_max
      endwhere
    end do
    if (calcder) then
      call is_not_close(input_clipped, input, jacobian_clipmask)
    endif

    if (verbosity >= 3) then
      write(*,*) 'input clipped, n_rho=', n_rho
      do rho = 1, n_rho
        write(fmt_str, '(A, I0, A)') '(', n_inp, '(F7.2, 1X))'
        WRITE(*, fmt_str) (input_clipped(ii, rho), ii=1,n_inp)
      end do
    end if
    end subroutine impose_input_constraints

  subroutine apply_stability_clipping(leading_map, net_result, verbosity)
      !! Clip in-place columns that are [ETG,TEM,ITG] stable to 0
      integer(lli), dimension(:,:), intent(in) :: leading_map
      !! Map with 3 columns representing ETG, TEM, and ITG. The first row
      !! contains the indices of net_result containing the leading flux and
      !! the other rows containing non-leading flux indices padded with 0's
      real(qlknn_dp), dimension(:,:), intent(inout):: net_result
      !! The leading flux stable points clipped to 0
      integer(lli), intent(in) :: verbosity
      !! Verbosity of this function
      integer(lli) :: ii, idx, leading_ETG, leading_TEM, leading_ITG

      leading_ETG = leading_map(1, 1)
      leading_TEM = leading_map(1, 2)
      leading_ITG = leading_map(1, 3)
      ! Clip leading fluxes to 0
      if (verbosity >= 3) then
        write(*,*) net_result(:, (/leading_ETG, leading_ITG, leading_TEM/)).le.0
      end if
      where (net_result(:, (/leading_ETG, leading_ITG, leading_TEM/)).le.0)
        net_result(:, (/leading_ETG, leading_ITG, leading_TEM/)) = 0
      endwhere
      do ii = 2, size(leading_map,1)
        idx = leading_map(ii, 3)
        if (idx == 0) then
          cycle
        endif
        where (net_result(:, leading_ITG).le.0)
          net_result(:, idx) = 0
        endwhere
      enddo
      do ii = 2, size(leading_map,1)
        idx = leading_map(ii, 2)
        if (idx == 0) then
          cycle
        endif
        where (net_result(:, leading_TEM).le.0)
          net_result(:, idx) = 0
        endwhere
      enddo
    end subroutine apply_stability_clipping

    subroutine impose_leading_flux_constraints(leading_map, net_result, verbosity, dnet_out_dnet_in, net_eb)
      !! Clip in-place leading-flux columns that are [ETG,TEM,ITG] stable to 0
      integer(lli), dimension(:,:), intent(in) :: leading_map
      !! Map with 3 columns representing ETG, TEM, and ITG. The first row
      !! contains the indices of net_result containing the leading flux
      real(qlknn_dp), dimension(:,:), intent(inout):: net_result
      !! The original data (in) and stable leading fluxes clipped to 0 (out)
      real(qlknn_dp), dimension(:,:,:), optional, intent(inout):: dnet_out_dnet_in
      !! The Jacobian of net_result to the input
      real(qlknn_dp), dimension(:,:), optional, intent(inout):: net_eb
      !! The error bounds of net_result. Will be set to 0 for stable points
      integer(lli), intent(in) :: verbosity
      !! Verbosity of this function
      integer(lli) :: n_inp, n_rho, inp, rho

      ! Clip leading fluxes to 0
      if (verbosity >= 3) then
        write(*,*) net_result(:, leading_map(1, :)).le.0
      end if
      where (net_result(:, leading_map(1, :)).le.0)
        net_result(:, leading_map(1, :)) = 0
      endwhere
      if (present(net_eb)) then
        where (net_eb(:, leading_map(1, :)).le.0)
          net_eb(:, leading_map(1, :)) = 0
        endwhere
      endif
      if(present(dnet_out_dnet_in)) then
        n_inp = size(dnet_out_dnet_in, 3)
        n_rho = size(dnet_out_dnet_in, 2)
        do rho = 1, n_rho
          do inp = 1, n_inp
            where (net_result(rho, leading_map(1, :)).le.0)
              dnet_out_dnet_in(leading_map(1, :), rho, inp) = 0
            endwhere
          enddo
        enddo
      endif
    end subroutine impose_leading_flux_constraints

    subroutine multiply_div_networks(leading_map, net_result, verbosity, dqlknn_out_dinput, net_eb)
      !! Multiply div networks with their leading flux in-place.

      !! The net_result (and dqlknn_out_dinput and net_eb) array(s) will be
      !! re-used to store the result. The result is stored in the columns where
      !! the div network was in before. For error bounds we assume the variables
      !! are uncorrelated and normal distributed with \( \mu_1, \sigma_1 \) and
      !! \( \mu_2, \sigma_2 \), resulting in a result \( \mu_r, \sigma_r \) of:
      !! $$ \mu_r = \mu_1 \times \mu_2 $$
      !! $$ \sigma_r = \sqrt{\mu_1^2 \sigma_2^2 + \mu_2^2 \sigma_1^2} $$
      integer(lli), dimension(:,:), intent(in) :: leading_map
      !! Map with 3 columns representing ETG, TEM, and ITG. The first row
      !! contains the indices of net_result containing the leading flux and
      !! the other rows containing non-leading flux indices padded with 0's
      real(qlknn_dp), dimension(:,:), intent(inout):: net_result
      !! The original data (in) and multiplied data (out)
      real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: dqlknn_out_dinput
      !! The original Jacobian (in) and multiplied Jacobian (out)
      real(qlknn_dp), dimension(:,:), optional, intent(inout):: net_eb
      !! The original error bounds (in) and multiplied error bounds (out)
      real(qlknn_dp), dimension(:), allocatable :: temp_eb
      real(qlknn_dp), dimension(:,:,:), allocatable :: jaco_tmp
      integer(lli), intent(in) :: verbosity
      !! Verbosity of this function
      integer(lli) :: ii, idx, n_rho, n_inp, n_out, leading_ITG, leading_TEM
      logical :: calceb

      if (verbosity >= 3) then
        write(*,*) 'Multiplying div nets'
      endif

      leading_TEM = leading_map(1, 2)
      leading_ITG = leading_map(1, 3)
      n_rho = size(net_result, 1)
      if (present(dqlknn_out_dinput)) then
        n_inp = size(dqlknn_out_dinput, 3)
        n_out = size(dqlknn_out_dinput, 1)
        allocate(jaco_tmp(n_out, n_rho, n_inp))
        jaco_tmp = -99999
      else
        allocate(jaco_tmp(0, 0, 0))
        n_inp = -1
      endif
      if (present(net_eb)) then
        calceb = .true.
        ERRORSTOP(.not. all(shape(net_eb) == shape(net_result)),'Multiplied errorbound array should be the same shape as out array')
        allocate(temp_eb(n_rho))
      else
        calceb = .false.
        allocate(temp_eb(0))
      endif

      do ii = 2, size(leading_map,1)
        idx = leading_map(ii, 3)
        if (idx == 0) then
          cycle
        endif
        if (calceb) then
          CALL vdmul(n_rho, net_result(:, idx)**2, net_eb(:, leading_ITG)**2, temp_eb)
          CALL vdmul(n_rho, net_eb(:, idx)**2, net_result(:, leading_ITG)**2, net_eb(:, idx))
          net_eb(:, idx) = sqrt(net_eb(:, idx) + temp_eb)
        endif
        if (present(dqlknn_out_dinput)) then
          CALL matr_vec_mult_elemwise(n_rho * n_inp, dqlknn_out_dinput(idx, :, :), net_result(:, leading_ITG), dqlknn_out_dinput(idx, :, :))
          CALL matr_vec_mult_elemwise(n_rho * n_inp, dqlknn_out_dinput(leading_ITG, :, :), net_result(:, idx), jaco_tmp(idx, :, :))
          dqlknn_out_dinput(idx, :, :) = dqlknn_out_dinput(idx, :, :) + jaco_tmp(idx, :, :)
        endif
        CALL vdmul(n_rho, net_result(:, idx), net_result(:, leading_ITG), net_result(:, idx))
      enddo
      do ii = 2, size(leading_map,1)
        idx = leading_map(ii, 2)
        if (idx == 0) then
          cycle
        endif
        if (present(dqlknn_out_dinput)) then
          CALL matr_vec_mult_elemwise(n_rho * n_inp, dqlknn_out_dinput(idx, :, :), net_result(:, leading_TEM), dqlknn_out_dinput(idx, :, :))
          CALL matr_vec_mult_elemwise(n_rho * n_inp, dqlknn_out_dinput(leading_TEM, :, :), net_result(:, idx), jaco_tmp(idx, :, :))
          dqlknn_out_dinput(idx, :, :) = dqlknn_out_dinput(idx, :, :) + jaco_tmp(idx, :, :)
        endif
        CALL vdmul(n_rho, net_result(:, idx), net_result(:, leading_TEM), net_result(:, idx))
      enddo
    end subroutine multiply_div_networks

    subroutine merge_modes(merge_map, net_result, merged_net_result, verbosity, dqlknn_out_dinput, dqlknn_out_merged_dinput, net_eb, merged_net_eb)
      !! Sum columns of the same variable and same mode together

      !! For error bounds we assume the variables are uncorrolated and normal distributed
      !! with \( \mu_i, \sigma_i \) resulting in a result \( \mu_r, \sigma_r \) of:
      !! $$ \mu_r = \sum_i \mu_i $$
      !! $$ \sigma_r = \sqrt{\left(\sum_i \sigma_i^2\right)} $$

      integer(lli), dimension(:,:), intent(in) :: merge_map
      !! Map with the columns to be merged together. Each column of the map
      !! represents the column of merged_net_result the result will be stored
      !! in. Each index in the column, padded with 0's, will be merged together
      real(qlknn_dp), dimension(:,:), intent(in):: net_result
      !! The original to-be-merged data
      real(qlknn_dp), dimension(:,:), intent(out) :: merged_net_result
      !! The merged togethed data
      integer(lli), intent(in) :: verbosity
      real(qlknn_dp), dimension(:,:,:), optional, intent(in) :: dqlknn_out_dinput
      !! The jacobian of the to-be-merged data
      real(qlknn_dp), dimension(:,:,:), optional, intent(inout) :: dqlknn_out_merged_dinput
      !! The merged together jacobians of the data
      real(qlknn_dp), dimension(:,:), optional, intent(in) :: net_eb
      !! The error bounds of the original to-be-merged data
      real(qlknn_dp), dimension(:,:), optional, intent(out) :: merged_net_eb
      !! The merged together error bounds of the data
      integer(lli) :: n_rho, n_inputs, n_outputs, n_merged_out, ii, jj
      integer(lli), dimension(:), allocatable :: map
      logical :: calcder, calceb
      !character(len=200) :: error_msg

      if (verbosity >= 3) then
        write(*,*) 'Merging modes'
      endif

      ERRORSTOP(.not. size(merge_map, 1) == size(merged_net_result, 2),'Merge map different amount of rows than amount of merged result columns')
      if (present(merged_net_eb)) then
        calceb = .true.
        ERRORSTOP(.not. all(shape(merged_net_result) == shape(merged_net_eb)),'Merged committee errorbound array should be the same shape as out array')
        ERRORSTOP(.not. all(shape(net_result) == shape(net_eb)),'Net result given to merge modes should be same shape as error bound array')
      else
        calceb = .false.
      endif

      n_rho = size(net_result, 1)
      n_merged_out = size(merged_net_result, 2)
      if (present(dqlknn_out_dinput)) then
        if (present(dqlknn_out_merged_dinput)) then
          calcder = .true.
          n_outputs = size(dqlknn_out_dinput, 1)
          n_inputs = size(dqlknn_out_dinput, 3)
          !allocate(dqlknn_out_merged_dinput(n_outputs, n_rho, n_inputs))
        else
          ERRORSTOP(.true., 'Also provide dqlknn_out_merged_dinput if dqlknn_out_dinput is provided')
          calcder = .false.
        endif
      else
        calcder = .false.
      endif
      do ii = 1, n_rho
        do jj = 1, n_merged_out
          allocate(map(count(merge_map(jj, :) /= 0)))
          map = pack(merge_map(jj, :), merge_map(jj, :) /= 0)
          merged_net_result(ii, jj) = sum(net_result(ii, map))
          if (calceb) then
            merged_net_eb(ii, jj) = sqrt(sum(net_eb(ii, map)**2))
          endif
          if (calcder) then
            dqlknn_out_merged_dinput(jj, ii, :) = sum(dqlknn_out_dinput(map, ii, :), 1)
          endif
          deallocate(map)
        enddo
      enddo
    end subroutine merge_modes

    subroutine merge_committee(net_result, n_members, merged_net_result, merged_net_eb, verbosity, dqlknn_out_dinput, dqlknn_out_merged_dinput)
      !! Combine predictions of committee members

      !! We assume the committee results are stored in consecutive columns and
      !! each variable has the same amount of members per committee. We use the
      !! uncorrected sample standard deviation as error bound, e.g. for samples
      !! \( x_i \) with mean
      !! $$ \mu = \frac{1}{N} \sum^N_{i=1} x_i $$
      !! We get error bound \(  \text{EB} \)
      !! $$ \text{EB} = \sigma = \sqrt{\left[ \frac{1}{N} \sum^N_{i=1} \left( x_i - \mu \right)^2 \right]} $$
      real(qlknn_dp), dimension(:,:), intent(in):: net_result
      !! The separate member predictions
      integer(lli), intent(in) :: n_members
      !! The number of members per committee
      real(qlknn_dp), dimension(:,:), intent(out) :: merged_net_result
      !! The prediction of the full committee
      real(qlknn_dp), dimension(:,:), intent(out) :: merged_net_eb
      !! The error bound on the prediction of the full committee
      integer(lli), intent(in) :: verbosity
      !! Verbosity of this function
      real(qlknn_dp), dimension(:,:,:), optional, intent(in) :: dqlknn_out_dinput
      !! The Jacobian of the separate member predictions
      real(qlknn_dp), dimension(:,:,:), optional, intent(inout) :: dqlknn_out_merged_dinput
      !! The Jacobian of the full committee
      integer(lli) :: n_rho, n_inputs, n_outputs, ii, jj, start, n_post_committee_outputs
      logical :: calcder
      !character(len=200) :: error_msg

      if (verbosity >= 3) then
        write(*,*) 'Merging committee members'
      endif

      ERRORSTOP(.not. all(shape(merged_net_result) == shape(merged_net_eb)), 'Merged committee errorbound array should be the same size as out array')

      n_outputs = int(size(net_result, 2), li)
      n_post_committee_outputs = int(size(merged_net_result, 2), li)
      ERRORSTOP(mod(n_outputs, n_members) /= 0, 'Nets cannot be equally split between committee members')
      ERRORSTOP(n_outputs / n_members /= n_post_committee_outputs, 'Outputs divided by members not the same as passed output array')
      n_rho = size(net_result, 1)
      if (present(dqlknn_out_dinput)) then
        if (present(dqlknn_out_merged_dinput)) then
          calcder = .true.
          ERRORSTOP(n_outputs /= size(dqlknn_out_dinput, 1), 'Jacobian array has different shape from output array!')
          n_inputs = size(dqlknn_out_dinput, 3)
          !allocate(dqlknn_out_merged_dinput(n_outputs, n_rho, n_inputs))
        else
          ERRORSTOP(.true., 'Also provide dqlknn_out_merged_dinput if dqlknn_out_dinput is provided')
          calcder = .false.
        endif
      else
        calcder = .false.
      endif
      ! Assume committee members are next to each other in the arrays
      do ii = 1, n_rho
        do jj = 1, n_post_committee_outputs
          start = n_members * (jj - 1) + 1
          !print *, jj, start, start + n_members - 1
          !print *, net_result(ii, start:start + n_members - 1)
          merged_net_result(ii, jj) = sum(net_result(ii, start:start + n_members - 1)) / n_members
          ! Assuming merged_net_result contains the mean
          ! Use uncorrected sample standard deviation as error bound
          merged_net_eb(ii, jj) = sqrt(sum((net_result(ii, start:start + n_members - 1) - merged_net_result(ii, jj))**2)/n_members)
          if (calcder) then
            dqlknn_out_merged_dinput(jj, ii, :) = sum(dqlknn_out_dinput(start:start + n_members - 1, ii, :)) / n_members
          endif
        enddo
      enddo
    end subroutine merge_committee

    subroutine matr_mult_elemwise(n, a, b, y)
      !! Multiply two matrices element wise
      integer(lli), intent(in) :: n
      real(qlknn_dp), dimension(:,:), intent(in) :: a, b
      real(qlknn_dp), dimension(:,:), intent(out) :: y
      integer(lli) :: i, n_vec
      ERRORSTOP((size(a, 1) /= size(b, 1)) .or. (size(a, 2) /= size(b, 2)), 'a and b different shapes')
      n_vec = n / size(a, 2)
      do i = 1, size(a, 2)
        call vdmul(n_vec, a(:, i), b(:, i), y(:, i))
      end do
    end subroutine matr_mult_elemwise

    subroutine matr_vec_mult_elemwise(n, a, b, y)
      !! Multiply a vector with a matrix element wise
      integer(lli), intent(in) :: n
      real(qlknn_dp), dimension(:,:), intent(in) :: a
      real(qlknn_dp), dimension(:), intent(in) :: b
      real(qlknn_dp), dimension(:,:), intent(out) :: y
      integer(lli) :: i, n_vec
      ERRORSTOP((size(a, 1) /= size(b)), 'a and b different shapes')
      n_vec = n / size(a, 2)
      do i = 1, size(a, 2)
        call vdmul(n_vec, a(:, i), b(:), y(:, i))
      end do
    end subroutine matr_vec_mult_elemwise
#ifndef USE_MKL
    subroutine vdmul(n, a, b, y)
      !! Multiply a vector with a vector element wise
      !!
      !! Drop-in replacement for Intel's https://software.intel.com/en-us/mkl-developer-reference-fortran-v-mul
      integer(lli), intent(in) :: n
      real(qlknn_dp), dimension(:), intent(in) :: a, b
      real(qlknn_dp), dimension(:), intent(out) :: y
      if (size(a) /= n) then
        write(stderr,*) 'Warning! Argument a in vdmul has different size than n'
      endif
      y = a * b
    end subroutine vdmul

    subroutine dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc)
      !! Perform \( A B + C \) in-place
      !!
      !! Drop-in replacement for Intel's https://software.intel.com/en-us/mkl-developer-reference-fortran-gemm
      character(len=1), intent(in) :: transa, transb
      integer(lli), intent(in) :: m, n, k, lda, ldb, ldc
      real(qlknn_dp), intent(in) :: alpha, beta
      real(qlknn_dp), dimension(:,:), intent(in) :: a, b
      real(qlknn_dp), dimension(:,:), intent(inout) :: c
      real(qlknn_dp), dimension(:,:), allocatable :: c_tmp
      if ((size(a, 1) /= m) .or. (size(a, 2) /= k)) then
        write(stderr,*) 'Warning! Argument a in dgemm is not m x k'
        write(stderr,'(A,2I3,A,I3,A,I3,A)') 'shape(a) =', shape(a), ', m=', m, ', k=', k, &
             ', callsig(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc)'
      endif
      if (size(a, 1) /= lda) then
        write(stderr,*) 'Warning! Argument a in dgemm does not have lda rows'
        write(stderr,'(A,I3,A,I3)') 'rows(a) =', size(a, 1), ', lda=', lda
      endif
      if ((size(b, 1) /= k) .or. (size(b, 2) /= n)) then
        write(stderr,*) 'Warning! Argument b in dgemm is not k x n'
        write(stderr,'(A,2I3,A,I3,A,I3,A)') 'shape(b) =', shape(b), ', k=', k, ', n=', n, &
             ', callsig(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc)'
      endif
      if (size(b, 1) /= ldb) then
        write(stderr,*) 'Warning! Argument b in dgemm does not have ldb rows'
        write(stderr,'(A,I3,A,I3)') 'rows(b) =', size(b, 1), ', ldb=', ldb
      endif
      if ((size(c, 1) /= m) .or. (size(c, 2) /= n)) then
        write(stderr,*) 'Warning! Argument c in dgemm is not m x n'
        write(stderr,'(A,2I3,A,I3,A,I3,A)') 'shape(c) =', shape(c), ', m=', m, ', n=', n, &
             ', callsig(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc)'
      endif
      if (size(c, 1) /= ldc) then
        write(stderr,*) 'Warning! Argument c in dgemm does not have ldc rows'
        write(stderr,'(A,I3,A,I3)') 'rows(c) =', size(c, 1), ', ldc=', ldc
      endif
      ERRORSTOP((transa /= 'N') .or. (transb /= 'N'), 'trans /= N not implemented yet')
      allocate(c_tmp(size(c,1), size(c,2)))
      c_tmp = alpha * matmul(a, b)
      c = c_tmp + beta * c
      deallocate(c_tmp)
    end subroutine

    subroutine vdtanh(n, a, y)
      !! Calculate the tanh on each vector element
      !!
      !! Drop-in replacement for Intel's https://software.intel.com/en-us/mkl-developer-reference-fortran-v-tanh
      integer(lli), intent(in) :: n
      real(qlknn_dp), dimension(:,:), intent(in) :: a
      real(qlknn_dp), dimension(:,:), intent(out) :: y
      if (size(a) /= n) then
        write(stderr,*) 'Warning! Argument a in vdtanh has different size than n'
      endif
      y = tanh(a)
    end subroutine
#endif
    subroutine relu(n, a, y)
      integer(lli), intent(in) :: n
      real(qlknn_dp), dimension(:), intent(in) :: a
      real(qlknn_dp), dimension(:), intent(out) :: y
      if (size(a) /= n) then
        write(stderr,*) 'Warning! Argument a in relu has different size than n'
      endif
      y = a
      where (a < 0)
        y = 0
      endwhere
    end subroutine

    subroutine calc_length_lli(start, end, step, length)
      !! Calculate the length of a job array
      integer(lli), intent(in) :: start, end, step
      integer(lli), intent(out) :: length
      real(qlknn_dp) :: length_rl
      length_rl = (end - start - 0) / real(step, qlknn_dp) + 1
      length = int(floor(length_rl), li)
    end subroutine

    subroutine calc_length_li(start, end, step, length)
      !! Calculate the length of a job array
      integer(li), intent(in) :: start, end, step
      integer(li), intent(out) :: length
      real(qlknn_dp) :: length_rl
      length_rl = (end - start - 0) / real(step, qlknn_dp) + 1
      length = int(floor(length_rl), li)
    end subroutine

    subroutine calc_length_mixed1(start, end, step, length)
      !! Calculate the length of a job array
      integer(li), intent(in) :: start, step
      integer(lli), intent(in) :: end
      integer(li), intent(out) :: length
      real(qlknn_dp) :: length_rl
      length_rl = (end - start - 0) / real(step, qlknn_dp) + 1
      length = int(floor(length_rl), li)
    end subroutine

    subroutine calc_length_mixed2(start, end, step, length)
      !! Calculate the length of a job array
      integer(li), intent(in) :: start
      integer(lli), intent(in) :: step, end
      integer(li), intent(out) :: length
      real(qlknn_dp) :: length_rl
      length_rl = (end - start - 0) / real(step, qlknn_dp) + 1
      length = int(floor(length_rl), li)
    end subroutine

    subroutine double_1d_0d_is_not_close(arr1, arr2, is_not_close, boundin)
      real(qlknn_dp), dimension(:), intent(in) :: arr1
      real(qlknn_dp), intent(in) :: arr2
      real(qlknn_dp), intent(in), optional :: boundin
      logical, dimension(:), intent(out) :: is_not_close

      real(qlknn_dp) :: bound

      if (present(boundin)) then
        bound = boundin
      else
        bound = 10*epsilon(arr2)
      endif
      is_not_close = arr1 < arr2 - bound .or. arr1 > arr2 + bound
    end subroutine double_1d_0d_is_not_close


    subroutine double_1d_1d_is_not_close(arr1, arr2, is_not_close, boundin)
      real(qlknn_dp), dimension(:), intent(in) :: arr1
      real(qlknn_dp), dimension(:), intent(in) :: arr2
      real(qlknn_dp), intent(in), optional :: boundin
      logical, dimension(:), intent(out) :: is_not_close

      real(qlknn_dp) :: bound

      if (present(boundin)) then
        bound = boundin
      else
        bound = 10*epsilon(arr2)
      endif
      is_not_close = arr1 < arr2 - bound .or. arr1 > arr2 + bound
    end subroutine double_1d_1d_is_not_close

    subroutine double_2d_2d_is_not_close(arr1, arr2, is_not_close, boundin)
      real(qlknn_dp), dimension(:,:), intent(in) :: arr1
      real(qlknn_dp), dimension(:,:), intent(in) :: arr2
      real(qlknn_dp), intent(in), optional :: boundin
      logical, dimension(:,:), intent(out) :: is_not_close

      real(qlknn_dp) :: bound

      if (present(boundin)) then
        bound = boundin
      else
        bound = 10*epsilon(arr2)
      endif
      is_not_close = arr1 < arr2 - bound .or. arr1 > arr2 + bound
    end subroutine double_2d_2d_is_not_close
  end module qlknn_primitives

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module setup_mpi
  use qlknn_types
#ifdef MPI
  use mpi
#endif
contains
  subroutine setup
#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) my_world_rank
#else
    integer(li) my_world_rank
#endif
#ifdef MPI
#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) mpi_ierr, world_size
#else
    integer(li) mpi_ierr, world_size
#endif
#endif

#ifdef MPI
      call MPI_INIT(mpi_ierr)
      call MPI_COMM_SIZE(MPI_COMM_WORLD, world_size, mpi_ierr)
      call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
      if (int(my_world_rank, li) == 0_li) then
        print *, 'World size is         ', int(world_size, li)
      end if
      write(*, '(A, I3)') 'Hello world from rank ', int(my_world_rank, li)
#else
      my_world_rank = 0
#endif
    end subroutine setup
  end module setup_mpi

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
program qlknn_hyper
#include "core/preprocessor.inc"
  use qlknn_evaluate_nets
#ifdef QLKNN_10D_SOURCE_NET
  use qlknn_10d_source_net
#else
  use qlknn_disk_io
#endif
  use cla
  use kinds
#ifdef MPI
  use mpi
#endif
  implicit none
  integer(lli) :: n_trails, trial, verbosity, n_rho, n_in, n_out, n_outputs, n_nets, n_total_inputs
  type (qlknn_options) :: opts
  type (qlknn_normpars) :: qlknn_norms
  real(qlknn_dp), dimension(:,:), allocatable :: input
  real(qlknn_dp) :: start, finish
  real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out
  real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput
  character(len=4096) :: nn_path = '', input_path = '', output_path = ''
  character(len=11) :: cmd_name = 'qlknn_hyper'
  character(len=STRLEN) :: key, arg
  logical :: calculate_jacobian, dump_to_disk

#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) my_world_rank
#else
    integer(li) my_world_rank
#endif
#ifdef MPI
#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) mpi_ierr, world_size
#else
    integer(li) mpi_ierr, world_size
#endif
#endif

  namelist /sizes/ n_rho, n_in
  namelist /test/ input
  namelist /outp_sizes/ n_rho, n_in, n_out
  namelist /outp/ qlknn_out
  namelist /outp_jacobian/ dqlknn_out_dinput

  ! Command line argument parsing
  call cla_init


  call cla_register('-n', '--nn-path', 'Path to NN namelist folder', cla_char, 'data/qlknn-hyper-namelists')
  call cla_register('-i', '--input', 'Path to input namelist file', cla_char, 'tests/test.nml')
  call cla_register('-o', '--output', 'Path to output namelist file', cla_char, 'tests/output.nml')
  call cla_register('-d', '--dump-to-disk', 'Dump output to disk', cla_flag, 'f')
  call cla_register('-j', '--jacobian', 'Calculate Jacobian', cla_flag, 'f')
  call cla_register('-m', '--merge-modes', 'Merge modes (ITG/TEM) together', cla_flag, 'f')
  call cla_register('-r', '--victor-rule', 'Apply "victor rule" rotation rule in postprocessing', cla_flag, 'f')
  call cla_register('-t', '--trails', 'Run the network calculation the specified amount of times', cla_int, '1')
  call cla_register('-v', '--verbosity', 'Set verbosity', cla_int, '1')
  call cla_register('-a', '--force-evaluate-all', 'Force to calculate all networks irrespective of settings', cla_flag, 'f')
  call cla_register('-e', '--use-effective-diffusivity', 'Use effective diffusivity instead of D and V', cla_flag, 'f')

  ! Look for help-like arguments
  call cla_get_command_argument(1, arg)
  key = trim(arg)
  if (cla_str_eq(trim(key),'-h')      .or. &
      cla_str_eq(trim(key),'-?')      .or. &
      cla_str_eq(trim(key),'/?')      .or. &
      cla_str_eq(trim(key),'-H')      .or. &
      cla_str_eq(trim(key),'help')    .or. &
      cla_str_eq(trim(key),'-help')   .or. &
      cla_str_eq(trim(key),'--help')  .or. &
      cla_str_eq(trim(key),'--usage')      &
      ) then
     call cla_help(cmd_name)
     stop
  endif

  !call cla_validate(cmd_name)

  call cla_get('--nn-path', nn_path)
  call cla_get('--input', input_path)
  call cla_get('--output', output_path)
  calculate_jacobian = cla_key_present('--jacobian')
  dump_to_disk = cla_key_present('--dump-to-disk')
  call cla_get('--trails', n_trails)
  call cla_get('--verbosity', verbosity)

  call default_qlknn_hyper_options(opts)

  opts%merge_modes = cla_key_present('--merge-modes')
  opts%apply_victor_rule = cla_key_present('--victor-rule')
  opts%force_evaluate_all = cla_key_present('--force-evaluate-all')
  opts%use_effective_diffusivity = cla_key_present('--use-effective-diffusivity')

  ! Read input namelist
  open(10,file=input_path,action='READ')
  read(10,nml=sizes)
  allocate(input(n_in, n_rho))
  read(10,nml=test)
  close(10)

  n_outputs = 10
  n_nets = 20
  n_total_inputs = int(size(input, 1), li)

  if (opts%merge_modes) then
    n_out = n_outputs
  else
    n_out = n_nets
  end if
  allocate(qlknn_out(n_rho, n_out))
  allocate(dqlknn_out_dinput(n_out, n_rho, n_total_inputs))

  ! Variables for Victor rule
  ALLOCATE(qlknn_norms%A1(n_rho))
  qlknn_norms%A1 = 2.
  qlknn_norms%R0 = 3.
  qlknn_norms%a = 1.


#ifdef QLKNN_10D_SOURCE_NET
  call init_all_nets()
#else
  call load_qlknn_hyper_nets_from_disk(nn_path, verbosity)
#endif

#ifdef MPI
    call MPI_INIT(mpi_ierr)
    call MPI_COMM_SIZE(MPI_COMM_WORLD, world_size, mpi_ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
    if (verbosity >= 1) then
      if (my_world_rank == 0) then
        print *, 'World size is         ', world_size
      end if
      print *, 'Hello world from rank ', my_world_rank
    endif
#else
    my_world_rank = 0
#endif

  call cpu_time(start)
  do trial = 1,n_trails
    if (.not. calculate_jacobian) then
      call evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts, qlknn_norms)
    else
      call evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts, qlknn_norms, dqlknn_out_dinput)
    endif
  end do
  call cpu_time(finish)
  if (my_world_rank == 0) then
    print '("Trials = ",i9)',n_trails
    print '("Time   = ",f9.3," milliseconds.")',1e3*(finish-start)/n_trails
  endif

  if (dump_to_disk) then
    open(10,file=output_path,action='WRITE')
    write(10,nml=outp_sizes)
    write(10,nml=outp)
    if (calculate_jacobian) then
      write(10,nml=outp_jacobian)
    endif
    close(10)
  endif

#ifdef MPI
  call MPI_FINALIZE(mpi_ierr)
#endif
  call all_networktype_deallocate(nets)

end program qlknn_hyper

! Module qlknn_evaluate_nets defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_evaluate_nets.f90

subroutine f90wrap_evaluate_qlknn_10d(input, nets, qlknn_out, verbosityin, optsin, qlknn_normsin, dqlknn_out_dinput, n0, &
    n1, n2, n3, n4, n5, n6)
    use qlknn_types, only: net_collection, qlknn_options, qlknn_normpars
    use qlknn_evaluate_nets, only: evaluate_qlknn_10d
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(net_collection_ptr_type) :: nets_ptr
    integer, intent(in), dimension(2) :: nets
    real(8), intent(inout), dimension(n2,n3) :: qlknn_out
    integer(8), optional, intent(in) :: verbosityin
    type(qlknn_options_ptr_type) :: optsin_ptr
    integer, optional, intent(in), dimension(2) :: optsin
    type(qlknn_normpars_ptr_type) :: qlknn_normsin_ptr
    integer, optional, intent(in), dimension(2) :: qlknn_normsin
    real(8), optional, intent(inout), dimension(n4,n5,n6) :: dqlknn_out_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(qlknn_out) :: n2 = shape(qlknn_out,0)
    integer :: n3
    !f2py intent(hide), depend(qlknn_out) :: n3 = shape(qlknn_out,1)
    integer :: n4
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n4 = shape(dqlknn_out_dinput,0)
    integer :: n5
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n5 = shape(dqlknn_out_dinput,1)
    integer :: n6
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n6 = shape(dqlknn_out_dinput,2)
    nets_ptr = transfer(nets, nets_ptr)
    if (present(optsin)) then
        optsin_ptr = transfer(optsin, optsin_ptr)
    else
        optsin_ptr%p => null()
    end if
    if (present(qlknn_normsin)) then
        qlknn_normsin_ptr = transfer(qlknn_normsin, qlknn_normsin_ptr)
    else
        qlknn_normsin_ptr%p => null()
    end if
    call evaluate_qlknn_10d(input=input, nets=nets_ptr%p, qlknn_out=qlknn_out, verbosityin=verbosityin, optsin=optsin_ptr%p, &
        qlknn_normsin=qlknn_normsin_ptr%p, dqlknn_out_dinput=dqlknn_out_dinput)
end subroutine f90wrap_evaluate_qlknn_10d

subroutine f90wrap_evaluate_fullflux_net(input, nets, qlknn_out, verbosityin, optsin, dqlknn_out_dinput, n0, n1, n2, n3, &
    n4, n5, n6)
    use qlknn_types, only: net_collection, qlknn_options
    use qlknn_evaluate_nets, only: evaluate_fullflux_net
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(net_collection_ptr_type) :: nets_ptr
    integer, intent(in), dimension(2) :: nets
    real(8), intent(inout), dimension(n2,n3) :: qlknn_out
    integer(8), optional, intent(in) :: verbosityin
    type(qlknn_options_ptr_type) :: optsin_ptr
    integer, optional, intent(in), dimension(2) :: optsin
    real(8), optional, intent(inout), dimension(n4,n5,n6) :: dqlknn_out_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(qlknn_out) :: n2 = shape(qlknn_out,0)
    integer :: n3
    !f2py intent(hide), depend(qlknn_out) :: n3 = shape(qlknn_out,1)
    integer :: n4
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n4 = shape(dqlknn_out_dinput,0)
    integer :: n5
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n5 = shape(dqlknn_out_dinput,1)
    integer :: n6
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n6 = shape(dqlknn_out_dinput,2)
    nets_ptr = transfer(nets, nets_ptr)
    if (present(optsin)) then
        optsin_ptr = transfer(optsin, optsin_ptr)
    else
        optsin_ptr%p => null()
    end if
    call evaluate_fullflux_net(input=input, nets=nets_ptr%p, qlknn_out=qlknn_out, verbosityin=verbosityin, &
        optsin=optsin_ptr%p, dqlknn_out_dinput=dqlknn_out_dinput)
end subroutine f90wrap_evaluate_fullflux_net

subroutine f90wrap_evaluate_jetexp_net(input, nets, n_members, qlknn_out, qlknn_eb, verbosityin, optsin, &
    dqlknn_out_dinput, qlknn_validity, n0, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10)
    use qlknn_types, only: net_collection, qlknn_options
    use qlknn_evaluate_nets, only: evaluate_jetexp_net
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(net_collection_ptr_type) :: nets_ptr
    integer, intent(in), dimension(2) :: nets
    integer(8), intent(in) :: n_members
    real(8), intent(inout), dimension(n2,n3) :: qlknn_out
    real(8), intent(inout), dimension(n4,n5) :: qlknn_eb
    integer(8), optional, intent(in) :: verbosityin
    type(qlknn_options_ptr_type) :: optsin_ptr
    integer, optional, intent(in), dimension(2) :: optsin
    real(8), optional, intent(inout), dimension(n6,n7,n8) :: dqlknn_out_dinput
    logical, optional, intent(inout), dimension(n9,n10) :: qlknn_validity
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(qlknn_out) :: n2 = shape(qlknn_out,0)
    integer :: n3
    !f2py intent(hide), depend(qlknn_out) :: n3 = shape(qlknn_out,1)
    integer :: n4
    !f2py intent(hide), depend(qlknn_eb) :: n4 = shape(qlknn_eb,0)
    integer :: n5
    !f2py intent(hide), depend(qlknn_eb) :: n5 = shape(qlknn_eb,1)
    integer :: n6
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n6 = shape(dqlknn_out_dinput,0)
    integer :: n7
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n7 = shape(dqlknn_out_dinput,1)
    integer :: n8
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n8 = shape(dqlknn_out_dinput,2)
    integer :: n9
    !f2py intent(hide), depend(qlknn_validity) :: n9 = shape(qlknn_validity,0)
    integer :: n10
    !f2py intent(hide), depend(qlknn_validity) :: n10 = shape(qlknn_validity,1)
    nets_ptr = transfer(nets, nets_ptr)
    if (present(optsin)) then
        optsin_ptr = transfer(optsin, optsin_ptr)
    else
        optsin_ptr%p => null()
    end if
    call evaluate_jetexp_net(input=input, nets=nets_ptr%p, n_members=n_members, qlknn_out=qlknn_out, qlknn_eb=qlknn_eb, &
        verbosityin=verbosityin, optsin=optsin_ptr%p, dqlknn_out_dinput=dqlknn_out_dinput, qlknn_validity=qlknn_validity)
end subroutine f90wrap_evaluate_jetexp_net

subroutine f90wrap_hornnet_flux_from_constants(input, blocks, hornnet_constants, flux_out, verbosityin, optsin, &
    qlknn_normsin, dflux_dhornnet_constants, dflux_dinput, n0, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11)
    use qlknn_types, only: block_collection, qlknn_options, qlknn_normpars
    use qlknn_evaluate_nets, only: hornnet_flux_from_constants
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(block_collection_ptr_type) :: blocks_ptr
    integer, intent(in), dimension(2) :: blocks
    real(8), intent(in), dimension(n2,n3) :: hornnet_constants
    real(8), intent(inout), dimension(n4,n5) :: flux_out
    integer(8), optional, intent(in) :: verbosityin
    type(qlknn_options_ptr_type) :: optsin_ptr
    integer, optional, intent(in), dimension(2) :: optsin
    type(qlknn_normpars_ptr_type) :: qlknn_normsin_ptr
    integer, optional, intent(in), dimension(2) :: qlknn_normsin
    real(8), optional, intent(inout), dimension(n6,n7,n8) :: dflux_dhornnet_constants
    real(8), optional, intent(inout), dimension(n9,n10,n11) :: dflux_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(hornnet_constants) :: n2 = shape(hornnet_constants,0)
    integer :: n3
    !f2py intent(hide), depend(hornnet_constants) :: n3 = shape(hornnet_constants,1)
    integer :: n4
    !f2py intent(hide), depend(flux_out) :: n4 = shape(flux_out,0)
    integer :: n5
    !f2py intent(hide), depend(flux_out) :: n5 = shape(flux_out,1)
    integer :: n6
    !f2py intent(hide), depend(dflux_dhornnet_constants) :: n6 = shape(dflux_dhornnet_constants,0)
    integer :: n7
    !f2py intent(hide), depend(dflux_dhornnet_constants) :: n7 = shape(dflux_dhornnet_constants,1)
    integer :: n8
    !f2py intent(hide), depend(dflux_dhornnet_constants) :: n8 = shape(dflux_dhornnet_constants,2)
    integer :: n9
    !f2py intent(hide), depend(dflux_dinput) :: n9 = shape(dflux_dinput,0)
    integer :: n10
    !f2py intent(hide), depend(dflux_dinput) :: n10 = shape(dflux_dinput,1)
    integer :: n11
    !f2py intent(hide), depend(dflux_dinput) :: n11 = shape(dflux_dinput,2)
    blocks_ptr = transfer(blocks, blocks_ptr)
    if (present(optsin)) then
        optsin_ptr = transfer(optsin, optsin_ptr)
    else
        optsin_ptr%p => null()
    end if
    if (present(qlknn_normsin)) then
        qlknn_normsin_ptr = transfer(qlknn_normsin, qlknn_normsin_ptr)
    else
        qlknn_normsin_ptr%p => null()
    end if
    call hornnet_flux_from_constants(input=input, blocks=blocks_ptr%p, hornnet_constants=hornnet_constants, &
        flux_out=flux_out, verbosityin=verbosityin, optsin=optsin_ptr%p, qlknn_normsin=qlknn_normsin_ptr%p, &
        dflux_dhornnet_constants=dflux_dhornnet_constants, dflux_dinput=dflux_dinput)
end subroutine f90wrap_hornnet_flux_from_constants

subroutine f90wrap_hornnet_multiply_jacobians(dhornnet_constants_dinput, dflux_dhornnet_constants, dflux_dinput, &
    dqlknn_out_dinput, verbosityin, n0, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11)
    use qlknn_evaluate_nets, only: hornnet_multiply_jacobians
    implicit none
    
    real(8), intent(in), dimension(n0,n1,n2) :: dhornnet_constants_dinput
    real(8), intent(in), dimension(n3,n4,n5) :: dflux_dhornnet_constants
    real(8), intent(in), dimension(n6,n7,n8) :: dflux_dinput
    real(8), intent(inout), dimension(n9,n10,n11) :: dqlknn_out_dinput
    integer(8), intent(in), optional :: verbosityin
    integer :: n0
    !f2py intent(hide), depend(dhornnet_constants_dinput) :: n0 = shape(dhornnet_constants_dinput,0)
    integer :: n1
    !f2py intent(hide), depend(dhornnet_constants_dinput) :: n1 = shape(dhornnet_constants_dinput,1)
    integer :: n2
    !f2py intent(hide), depend(dhornnet_constants_dinput) :: n2 = shape(dhornnet_constants_dinput,2)
    integer :: n3
    !f2py intent(hide), depend(dflux_dhornnet_constants) :: n3 = shape(dflux_dhornnet_constants,0)
    integer :: n4
    !f2py intent(hide), depend(dflux_dhornnet_constants) :: n4 = shape(dflux_dhornnet_constants,1)
    integer :: n5
    !f2py intent(hide), depend(dflux_dhornnet_constants) :: n5 = shape(dflux_dhornnet_constants,2)
    integer :: n6
    !f2py intent(hide), depend(dflux_dinput) :: n6 = shape(dflux_dinput,0)
    integer :: n7
    !f2py intent(hide), depend(dflux_dinput) :: n7 = shape(dflux_dinput,1)
    integer :: n8
    !f2py intent(hide), depend(dflux_dinput) :: n8 = shape(dflux_dinput,2)
    integer :: n9
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n9 = shape(dqlknn_out_dinput,0)
    integer :: n10
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n10 = shape(dqlknn_out_dinput,1)
    integer :: n11
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n11 = shape(dqlknn_out_dinput,2)
    call hornnet_multiply_jacobians(dhornnet_constants_dinput=dhornnet_constants_dinput, &
        dflux_dhornnet_constants=dflux_dhornnet_constants, dflux_dinput=dflux_dinput, dqlknn_out_dinput=dqlknn_out_dinput, &
        verbosityin=verbosityin)
end subroutine f90wrap_hornnet_multiply_jacobians

subroutine f90wrap_hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, &
    pow_idx, block_idx, slope_idx, f, g, h, drelu_dhornnet_constants, drelu_dinput, dclip_by_value_dhornnet_constants, &
    dclip_by_value_dinput, df_dhornnet_constants, df_dinput, dg_dhornnet_constants, dg_dinput, dh_dhornnet_constants, &
    n0, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, n15, n16, n17, n18, n19, n20, n21, n22, n23, n24, &
    n25, n26, n27, n28, n29, n30, n31, n32, n33, n34, n35, n36, n37, n38, n39, n40)
    use qlknn_evaluate_nets, only: hornnet_multiplier
    implicit none
    
    real(8), intent(in), dimension(n0,n1) :: heaviside_function_times
    real(8), intent(in), dimension(n2,n3) :: clip_by_value
    real(8), intent(in), dimension(n4,n5) :: hornnet_constants
    real(8), intent(inout), dimension(n6,n7) :: sepflux_out
    integer(8), intent(in) :: outp
    integer(8), intent(in) :: pow_idx
    integer(8), intent(in) :: block_idx
    integer(8), intent(in) :: slope_idx
    real(8), intent(inout), dimension(n8,n9) :: f
    real(8), intent(inout), dimension(n10,n11) :: g
    real(8), intent(inout), dimension(n12,n13) :: h
    real(8), intent(in), optional, dimension(n14,n15,n16) :: drelu_dhornnet_constants
    real(8), intent(in), optional, dimension(n17,n18,n19) :: drelu_dinput
    real(8), intent(in), optional, dimension(n20,n21,n22) :: dclip_by_value_dhornnet_constants
    real(8), intent(in), optional, dimension(n23,n24,n25) :: dclip_by_value_dinput
    real(8), intent(inout), optional, dimension(n26,n27,n28) :: df_dhornnet_constants
    real(8), intent(inout), optional, dimension(n29,n30,n31) :: df_dinput
    real(8), intent(inout), optional, dimension(n32,n33,n34) :: dg_dhornnet_constants
    real(8), intent(inout), optional, dimension(n35,n36,n37) :: dg_dinput
    real(8), intent(inout), optional, dimension(n38,n39,n40) :: dh_dhornnet_constants
    integer :: n0
    !f2py intent(hide), depend(heaviside_function_times) :: n0 = shape(heaviside_function_times,0)
    integer :: n1
    !f2py intent(hide), depend(heaviside_function_times) :: n1 = shape(heaviside_function_times,1)
    integer :: n2
    !f2py intent(hide), depend(clip_by_value) :: n2 = shape(clip_by_value,0)
    integer :: n3
    !f2py intent(hide), depend(clip_by_value) :: n3 = shape(clip_by_value,1)
    integer :: n4
    !f2py intent(hide), depend(hornnet_constants) :: n4 = shape(hornnet_constants,0)
    integer :: n5
    !f2py intent(hide), depend(hornnet_constants) :: n5 = shape(hornnet_constants,1)
    integer :: n6
    !f2py intent(hide), depend(sepflux_out) :: n6 = shape(sepflux_out,0)
    integer :: n7
    !f2py intent(hide), depend(sepflux_out) :: n7 = shape(sepflux_out,1)
    integer :: n8
    !f2py intent(hide), depend(f) :: n8 = shape(f,0)
    integer :: n9
    !f2py intent(hide), depend(f) :: n9 = shape(f,1)
    integer :: n10
    !f2py intent(hide), depend(g) :: n10 = shape(g,0)
    integer :: n11
    !f2py intent(hide), depend(g) :: n11 = shape(g,1)
    integer :: n12
    !f2py intent(hide), depend(h) :: n12 = shape(h,0)
    integer :: n13
    !f2py intent(hide), depend(h) :: n13 = shape(h,1)
    integer :: n14
    !f2py intent(hide), depend(drelu_dhornnet_constants) :: n14 = shape(drelu_dhornnet_constants,0)
    integer :: n15
    !f2py intent(hide), depend(drelu_dhornnet_constants) :: n15 = shape(drelu_dhornnet_constants,1)
    integer :: n16
    !f2py intent(hide), depend(drelu_dhornnet_constants) :: n16 = shape(drelu_dhornnet_constants,2)
    integer :: n17
    !f2py intent(hide), depend(drelu_dinput) :: n17 = shape(drelu_dinput,0)
    integer :: n18
    !f2py intent(hide), depend(drelu_dinput) :: n18 = shape(drelu_dinput,1)
    integer :: n19
    !f2py intent(hide), depend(drelu_dinput) :: n19 = shape(drelu_dinput,2)
    integer :: n20
    !f2py intent(hide), depend(dclip_by_value_dhornnet_constants) :: n20 = shape(dclip_by_value_dhornnet_constants,0)
    integer :: n21
    !f2py intent(hide), depend(dclip_by_value_dhornnet_constants) :: n21 = shape(dclip_by_value_dhornnet_constants,1)
    integer :: n22
    !f2py intent(hide), depend(dclip_by_value_dhornnet_constants) :: n22 = shape(dclip_by_value_dhornnet_constants,2)
    integer :: n23
    !f2py intent(hide), depend(dclip_by_value_dinput) :: n23 = shape(dclip_by_value_dinput,0)
    integer :: n24
    !f2py intent(hide), depend(dclip_by_value_dinput) :: n24 = shape(dclip_by_value_dinput,1)
    integer :: n25
    !f2py intent(hide), depend(dclip_by_value_dinput) :: n25 = shape(dclip_by_value_dinput,2)
    integer :: n26
    !f2py intent(hide), depend(df_dhornnet_constants) :: n26 = shape(df_dhornnet_constants,0)
    integer :: n27
    !f2py intent(hide), depend(df_dhornnet_constants) :: n27 = shape(df_dhornnet_constants,1)
    integer :: n28
    !f2py intent(hide), depend(df_dhornnet_constants) :: n28 = shape(df_dhornnet_constants,2)
    integer :: n29
    !f2py intent(hide), depend(df_dinput) :: n29 = shape(df_dinput,0)
    integer :: n30
    !f2py intent(hide), depend(df_dinput) :: n30 = shape(df_dinput,1)
    integer :: n31
    !f2py intent(hide), depend(df_dinput) :: n31 = shape(df_dinput,2)
    integer :: n32
    !f2py intent(hide), depend(dg_dhornnet_constants) :: n32 = shape(dg_dhornnet_constants,0)
    integer :: n33
    !f2py intent(hide), depend(dg_dhornnet_constants) :: n33 = shape(dg_dhornnet_constants,1)
    integer :: n34
    !f2py intent(hide), depend(dg_dhornnet_constants) :: n34 = shape(dg_dhornnet_constants,2)
    integer :: n35
    !f2py intent(hide), depend(dg_dinput) :: n35 = shape(dg_dinput,0)
    integer :: n36
    !f2py intent(hide), depend(dg_dinput) :: n36 = shape(dg_dinput,1)
    integer :: n37
    !f2py intent(hide), depend(dg_dinput) :: n37 = shape(dg_dinput,2)
    integer :: n38
    !f2py intent(hide), depend(dh_dhornnet_constants) :: n38 = shape(dh_dhornnet_constants,0)
    integer :: n39
    !f2py intent(hide), depend(dh_dhornnet_constants) :: n39 = shape(dh_dhornnet_constants,1)
    integer :: n40
    !f2py intent(hide), depend(dh_dhornnet_constants) :: n40 = shape(dh_dhornnet_constants,2)
    call hornnet_multiplier(heaviside_function_times=heaviside_function_times, clip_by_value=clip_by_value, &
        hornnet_constants=hornnet_constants, sepflux_out=sepflux_out, outp=outp, pow_idx=pow_idx, block_idx=block_idx, &
        slope_idx=slope_idx, f=f, g=g, h=h, drelu_dhornnet_constants=drelu_dhornnet_constants, drelu_dinput=drelu_dinput, &
        dclip_by_value_dhornnet_constants=dclip_by_value_dhornnet_constants, dclip_by_value_dinput=dclip_by_value_dinput, &
        df_dhornnet_constants=df_dhornnet_constants, df_dinput=df_dinput, dg_dhornnet_constants=dg_dhornnet_constants, &
        dg_dinput=dg_dinput, dh_dhornnet_constants=dh_dhornnet_constants)
end subroutine f90wrap_hornnet_multiplier

subroutine f90wrap_evaluate_hornnet_constants(input, blocks, qlknn_out, verbosityin, optsin, qlknn_normsin, &
    dqlknn_out_dinput, n0, n1, n2, n3, n4, n5, n6)
    use qlknn_types, only: block_collection, qlknn_options, qlknn_normpars
    use qlknn_evaluate_nets, only: evaluate_hornnet_constants
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(block_collection_ptr_type) :: blocks_ptr
    integer, intent(in), dimension(2) :: blocks
    real(8), intent(inout), dimension(n2,n3) :: qlknn_out
    integer(8), optional, intent(in) :: verbosityin
    type(qlknn_options_ptr_type) :: optsin_ptr
    integer, optional, intent(in), dimension(2) :: optsin
    type(qlknn_normpars_ptr_type) :: qlknn_normsin_ptr
    integer, optional, intent(in), dimension(2) :: qlknn_normsin
    real(8), optional, intent(inout), dimension(n4,n5,n6) :: dqlknn_out_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(qlknn_out) :: n2 = shape(qlknn_out,0)
    integer :: n3
    !f2py intent(hide), depend(qlknn_out) :: n3 = shape(qlknn_out,1)
    integer :: n4
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n4 = shape(dqlknn_out_dinput,0)
    integer :: n5
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n5 = shape(dqlknn_out_dinput,1)
    integer :: n6
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n6 = shape(dqlknn_out_dinput,2)
    blocks_ptr = transfer(blocks, blocks_ptr)
    if (present(optsin)) then
        optsin_ptr = transfer(optsin, optsin_ptr)
    else
        optsin_ptr%p => null()
    end if
    if (present(qlknn_normsin)) then
        qlknn_normsin_ptr = transfer(qlknn_normsin, qlknn_normsin_ptr)
    else
        qlknn_normsin_ptr%p => null()
    end if
    call evaluate_hornnet_constants(input=input, blocks=blocks_ptr%p, qlknn_out=qlknn_out, verbosityin=verbosityin, &
        optsin=optsin_ptr%p, qlknn_normsin=qlknn_normsin_ptr%p, dqlknn_out_dinput=dqlknn_out_dinput)
end subroutine f90wrap_evaluate_hornnet_constants

subroutine f90wrap_evaluate_multinet(net_input, nets, net_evaluate, net_result, verbosityin, dnet_out_dnet_in, n0, n1, &
    n2, n3, n4, n5, n6, n7)
    use qlknn_types, only: net_collection
    use qlknn_evaluate_nets, only: evaluate_multinet
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    real(8), intent(in), dimension(n0,n1) :: net_input
    type(net_collection_ptr_type) :: nets_ptr
    integer, intent(in), dimension(2) :: nets
    logical, intent(in), dimension(n2) :: net_evaluate
    real(8), intent(inout), dimension(n3,n4) :: net_result
    integer(8), intent(in), optional :: verbosityin
    real(8), optional, intent(inout), dimension(n5,n6,n7) :: dnet_out_dnet_in
    integer :: n0
    !f2py intent(hide), depend(net_input) :: n0 = shape(net_input,0)
    integer :: n1
    !f2py intent(hide), depend(net_input) :: n1 = shape(net_input,1)
    integer :: n2
    !f2py intent(hide), depend(net_evaluate) :: n2 = shape(net_evaluate,0)
    integer :: n3
    !f2py intent(hide), depend(net_result) :: n3 = shape(net_result,0)
    integer :: n4
    !f2py intent(hide), depend(net_result) :: n4 = shape(net_result,1)
    integer :: n5
    !f2py intent(hide), depend(dnet_out_dnet_in) :: n5 = shape(dnet_out_dnet_in,0)
    integer :: n6
    !f2py intent(hide), depend(dnet_out_dnet_in) :: n6 = shape(dnet_out_dnet_in,1)
    integer :: n7
    !f2py intent(hide), depend(dnet_out_dnet_in) :: n7 = shape(dnet_out_dnet_in,2)
    nets_ptr = transfer(nets, nets_ptr)
    call evaluate_multinet(net_input=net_input, nets=nets_ptr%p, net_evaluate=net_evaluate, net_result=net_result, &
        verbosityin=verbosityin, dnet_out_dnet_in=dnet_out_dnet_in)
end subroutine f90wrap_evaluate_multinet

! End of module qlknn_evaluate_nets defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_evaluate_nets.f90

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
#include "fintrf.h"
module qlknn_mex_struct
  implicit none
  contains
    subroutine set_logical_struct(opts_ptr, field_name, opts_field, verbosity)
      use qlknn_types
      mwPointer, intent(in) :: opts_ptr ! Pointer to the option mxArray
      integer(lli), intent(in) :: verbosity
      character(len=*), intent(in) :: field_name
      logical, intent(inout) :: opts_field

      integer mxIsStruct, mxIsLogical, mxGetNumberOfElements
      mwPointer :: mxGetField
      mwPointer :: field_ptr !Pointer to mxArray in the specified field at the specified fieldname
      character(len=80) :: line
      real*8 :: struct_val, mxGetScalar

      if (mxIsStruct(opts_ptr) == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:opts_ptr', &
             'Passed non-structure pointer to set_logical_struct!')
      endif

      field_ptr = mxGetField(opts_ptr, 1, field_name)
      not_has_field: if (field_ptr == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:OptField', &
             'field ' // field_name // ' not in opts struct. Please supply.')
      else not_has_field
        if (field_ptr == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:ReadField', &
               'problem reading field ' // field_name)
        elseif (mxIsLogical(field_ptr) == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:LogicalField', &
               field_name // ' should be logical (true/false)')
        elseif (mxGetNumberOfElements(field_ptr) /= 1) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:LogicalScalar', &
               field_name // ' should be a single logical (true/false)')
        endif
        struct_val = mxGetScalar(field_ptr)
        if (verbosity >= 4) then
          write(line,*) "opt field = ", opts_field
          call mexPrintf(line // achar(10))
          write(line,*) "field_ptr = ", field_ptr
          call mexPrintf(line // achar(10))
          write(line,*) "data      = ", struct_val
          call mexPrintf(line // achar(10))
        endif
        if (struct_val == 0) then
          opts_field = .false.
        else
          opts_field = .true.
        endif
        if (verbosity >= 1) then
          write(line,*) 'set type opt ', field_name, ' to ', opts_field
          call mexPrintf(line // achar(10))
        endif
      endif not_has_field
    end subroutine set_logical_struct

    subroutine set_logical_array_struct(opts_ptr, field_name, opts_field, verbosity)
      use qlknn_types
      mwPointer, intent(in) :: opts_ptr ! Pointer to the option mxArray
      integer(lli), intent(in) :: verbosity
      character(len=*), intent(in) :: field_name
      logical, dimension(:), intent(inout) :: opts_field

      integer mxIsStruct, mxIsLogical, mxGetNumberOfElements
      mwPointer :: mxGetField
      mwPointer :: field_ptr !Pointer to mxArray in the specified field at the specified fieldname
      character(len=80) :: line
      real*8 :: struct_val, mxgetscalar

      if (mxIsStruct(opts_ptr) == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:opts_ptr', &
             'Passed non-structure pointer to set_logical_struct!')
      endif

      field_ptr = mxGetField(opts_ptr, 1, field_name)
      not_has_field: if (field_ptr == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:OptField', &
             'field ' // field_name // ' not in opts struct. Please supply.')
      else not_has_field
        if (field_ptr == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:ReadField', &
               'problem reading field ' // field_name)
        elseif (mxIsLogical(field_ptr) == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:LogicalField', &
               field_name // ' should be logical (true/false)')
        elseif (mxGetNumberOfElements(field_ptr) /= 1) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:LogicalScalar', &
               field_name // ' should be a single logical (true/false)')
        endif
        struct_val = mxGetScalar(field_ptr)

        if (verbosity >= 4) then
          write(line,*) "opt field = ", opts_field
          call mexPrintf(line // achar(10))
          write(line,*) "field_ptr = ", field_ptr
          call mexPrintf(line // achar(10))
          write(line,*) "data      = ", struct_val
          call mexPrintf(line // achar(10))
        endif
        if (struct_val == 0) then
          opts_field = .false.
        else
          opts_field = .true.
        endif
        if (verbosity >= 1) then
          write(line,*) 'set type opt ', field_name, ' to ', opts_field
          call mexPrintf(line // achar(10))
        endif
      endif not_has_field
    end subroutine set_logical_array_struct

    subroutine set_real_struct(opts_ptr, field_name, opts_field, verbosity)
      use qlknn_types
      mwPointer, intent(in) :: opts_ptr ! Pointer to the option mxArray
      integer(lli), intent(in) :: verbosity
      character(len=*), intent(in) :: field_name
      real(qlknn_dp), intent(inout) :: opts_field

      integer mxIsNumeric, mxIsStruct, mxGetNumberOfElements
      mwPointer :: mxGetField
      mwPointer :: field_ptr !Pointer to mxArray in the specified field at the specified fieldname
      character(len=80) :: line
      real*8 :: struct_val, mxGetScalar

      if (mxIsStruct(opts_ptr) == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:opts_ptr', &
             'Passed non-structure pointer to set_real_struct!')
      endif

      field_ptr = mxGetField(opts_ptr, 1, field_name)
      not_has_field: if (field_ptr == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:OptField', &
             'field ' // field_name // ' not in struct. Please supply.')
      else not_has_field
        if (field_ptr == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:ReadField', &
               'problem reading field ' // field_name)
        elseif (mxIsNumeric(field_ptr) == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:NumericField', &
               field_name // ' should be numeric')
        elseif (mxGetNumberOfElements(field_ptr) /= 1) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:NumericScalar', &
               field_name // ' should be a single number')
        endif
        struct_val = mxGetScalar(field_ptr)
        if (verbosity >= 4) then
          write(line,*) "opt field = ", opts_field
          call mexPrintf(line // achar(10))
          write(line,*) "field_ptr = ", field_ptr
          call mexPrintf(line // achar(10))
          write(line,*) "data      = ", struct_val
          call mexPrintf(line // achar(10))
        endif
        opts_field = struct_val
        if (verbosity >= 1) then
          write(line,*) 'set type opt ', field_name, ' to ', opts_field
          call mexPrintf(line // achar(10))
        endif
      endif not_has_field
    end subroutine set_real_struct

    subroutine set_real_array_struct(opts_ptr, field_name, opts_field, verbosity)
      use qlknn_types
      mwPointer, intent(in) :: opts_ptr ! Pointer to the option mxArray
      integer(lli), intent(in) :: verbosity
      character(len=*), intent(in) :: field_name
      real(qlknn_dp), dimension(:), intent(inout) :: opts_field

      integer mxIsNumeric, mxIsStruct, mxGetNumberOfElements, mxIsEmpty
      mwPointer :: mxGetField, mxGetPr
      mwPointer :: field_ptr !Pointer to mxArray in the specified field at the specified fieldname
      mwPointer :: data_ptr

      character(len=4096) :: line
      real*8, dimension(:), allocatable :: struct_vals

      if (mxIsStruct(opts_ptr) == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:opts_ptr', &
             'Passed non-structure pointer to set_logical_struct!')
      endif

      field_ptr = mxGetField(opts_ptr, 1, field_name)
      not_has_field: if (field_ptr == 0) then
        call mexErrMsgIdAndTxt('MATLAB:qlknn:OptField', &
             'field ' // field_name // ' not in opts struct. Please supply.')
      else not_has_field
        if (field_ptr == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:ReadField', &
               'problem reading field ' // field_name)
        elseif (mxIsNumeric(field_ptr) == 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:NumericField', &
               field_name // ' should be numeric')
        elseif (mxIsEmpty(field_ptr) /= 0) then
          call mexErrMsgIdAndTxt('MATLAB:qlknn:EmptyField', &
               field_name // ' should not be empty')
        elseif (mxGetNumberOfElements(field_ptr) /= 1 .AND. &
               mxGetNumberOfElements(field_ptr) /= SIZE(opts_field)) then
          write(line, '(A,A,A,A,I0,A,I0)') field_name , ' should be either a single number or have the same length as the default. len(', field_name, ')=', mxGetNumberOfElements(field_ptr), ', len(default)=', SIZE(opts_field)
          call mexErrMsgIdAndTxt('MATLAB:qlknn:LogicalScalar', line)
        endif
        data_ptr = mxGetPr(field_ptr)
        if (verbosity >= 4) then
          write(line, '(A,*(F7.2 X))') "opts field = ", opts_field
          call mexPrintf(trim(line) // achar(10))
          write(line,*) "field_ptr = ", field_ptr
          call mexPrintf(trim(line) // achar(10))
          write(line,*) "data_ptr = ", data_ptr
          call mexPrintf(trim(line) // achar(10))
        endif
        if (mxGetNumberOfElements(field_ptr) == 1) then
          allocate(struct_vals(1))
          call mxCopyPtrToReal8(data_ptr, struct_vals, 1)
          opts_field = struct_vals(1)
        else
          allocate(struct_vals(SIZE(opts_field)))
          call mxCopyPtrToReal8(data_ptr, struct_vals, SIZE(opts_field))
          opts_field = struct_vals
        endif
        if (verbosity >= 1) then
          write(line,'(A,A,A,*(F7.2 X))') 'set type opt ', field_name, ' to ', opts_field
          call mexPrintf(trim(line) // achar(10))
        endif
      endif not_has_field
    end subroutine set_real_array_struct
      end module qlknn_mex_struct

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_disk_io
#include "preprocessor.inc"
    use qlknn_types

    implicit none
    character(len=32), dimension(20), parameter, private :: qlknn_hyper_names = &
        (/ 'net_efeetg_gb                   ', &
           'net_efeitg_gb_div_efiitg_gb     ', &
           'net_efetem_gb                   ', &
           'net_efiitg_gb                   ', &
           'net_efitem_gb_div_efetem_gb     ', &
           'net_pfeitg_gb_div_efiitg_gb     ', &
           'net_pfetem_gb_div_efetem_gb     ', &
           'net_dfeitg_gb_div_efiitg_gb     ', &
           'net_dfetem_gb_div_efetem_gb     ', &
           'net_vteitg_gb_div_efiitg_gb     ', &
           'net_vtetem_gb_div_efetem_gb     ', &
           'net_vceitg_gb_div_efiitg_gb     ', &
           'net_vcetem_gb_div_efetem_gb     ', &
           'net_dfiitg_gb_div_efiitg_gb     ', &
           'net_dfitem_gb_div_efetem_gb     ', &
           'net_vtiitg_gb_div_efiitg_gb     ', &
           'net_vtitem_gb_div_efetem_gb     ', &
           'net_vciitg_gb_div_efiitg_gb     ', &
           'net_vcitem_gb_div_efetem_gb     ', &
           'net_gam_leq_gb                  ' /)

    character(len=13), dimension(3), parameter, private :: fullflux_names = &
        (/ 'net_efe_gb', &
           'net_efi_gb', &
           'net_pfe_gb' /)

    character(len=32), dimension(25), parameter, private :: qlknn_jetexp_names = &
        (/ 'net_efeetg_gb                   ', &
           'net_efeitg_gb_div_efiitg_gb     ', &
           'net_efetem_gb                   ', &
           'net_efiitg_gb                   ', &
           'net_efitem_gb_div_efetem_gb     ', &
           'net_pfeitg_gb_div_efiitg_gb     ', &
           'net_pfetem_gb_div_efetem_gb     ', &
           'net_pfiitg_gb_div_efiitg_gb     ', &
           'net_pfitem_gb_div_efetem_gb     ', &
           'net_vfiitg_gb_div_efiitg_gb     ', &
           'net_vfitem_gb_div_efetem_gb     ', &
           'net_dfeitg_gb_div_efiitg_gb     ', &
           'net_dfetem_gb_div_efetem_gb     ', &
           'net_vteitg_gb_div_efiitg_gb     ', &
           'net_vtetem_gb_div_efetem_gb     ', &
           'net_vceitg_gb_div_efiitg_gb     ', &
           'net_vcetem_gb_div_efetem_gb     ', &
           'net_dfiitg_gb_div_efiitg_gb     ', &
           'net_dfitem_gb_div_efetem_gb     ', &
           'net_vtiitg_gb_div_efiitg_gb     ', &
           'net_vtitem_gb_div_efetem_gb     ', &
           'net_vciitg_gb_div_efiitg_gb     ', &
           'net_vcitem_gb_div_efetem_gb     ', &
           'net_vriitg_gb_div_efiitg_gb     ', &
           'net_vritem_gb_div_efetem_gb     ' /)

    character(len=12), dimension(15), parameter, private :: qlknn_hornnet_output_blocks = &
        (/ 'c1_etg      ', & ! 1
           'c1_itg      ', & ! 2
           'c1_tem      ', & ! 3
           'c2_efeetg_gb', & ! 4
           'c2_efeitg_gb', & ! 5
           'c2_efetem_gb', & ! 6
           'c2_efiitg_gb', & ! 7
           'c2_efitem_gb', & ! 8
           'c3_efeetg_gb', & ! 9
           'c3_efeitg_gb', & ! 10
           'c3_efetem_gb', & ! 11
           'c3_efiitg_gb', & ! 12
           'c3_efitem_gb', & ! 13
           'pfeitg_gb   ', & ! 14
           'pfetem_gb   ' /) ! 15

    character(len=7), dimension(5), parameter, private :: qlknn_hornnet_input_blocks = &
        (/ 'etg    ', &
           'itg    ', &
           'tem    ', &
           'itg_pfe', &
           'tem_pfe' /)

    type(net_collection), save, target :: nets
    type(block_collection), save, target :: blocks
contains
    subroutine load_qlknn_hyper_nets_from_disk(folder, verbosityin)
        character(len=*), intent(in) :: folder
        integer(lli), optional, intent(in) :: verbosityin
        integer(lli) :: verbosity

        if(present(verbosityin)) then
            verbosity=verbosityin
        else
            verbosity = 0
        end if

        ! Constant for all 9D networks
        nets%Zeff_ind = 1
        nets%Ati_ind = 2
        nets%Ate_ind = 3
        nets%An_ind = 4
        nets%q_ind = 5
        nets%smag_ind = 6
        nets%x_ind = 7
        nets%Ti_Te_ind = 8
        nets%logNustar_ind = 9
        nets%gammaE_ind = 10
        nets%Te_ind = 11

        nets%Ane_ind = INTNAN
        nets%Autor_ind = INTNAN
        nets%Machtor_ind = INTNAN
        nets%alpha_ind = INTNAN
        nets%Ani0_ind = INTNAN
        nets%Ani1_ind = INTNAN
        nets%Ati0_ind = INTNAN
        nets%normni0_ind = INTNAN
        nets%normni1_ind = INTNAN
        nets%Ti_Te0_ind = INTNAN

        nets%a = 1.
        nets%R_0 = 3.

        allocate(nets%nets(20))
        call load_multinet_from_disk(qlknn_hyper_names, folder, verbosity)
    end subroutine load_qlknn_hyper_nets_from_disk

    subroutine load_fullflux_nets_from_disk(folder, verbosityin)
        character(len=*), intent(in) :: folder
        integer(lli), optional, intent(in) :: verbosityin
        integer(lli) :: verbosity

        if(present(verbosityin)) then
            verbosity=verbosityin
        else
            verbosity = 0
        end if

        ! Constant for all 9D networks
        nets%Zeff_ind = 1
        nets%Ati_ind = 2
        nets%Ate_ind = 3
        nets%An_ind = 4
        nets%q_ind = 5
        nets%smag_ind = 6
        nets%x_ind = 7
        nets%Ti_Te_ind = 8
        nets%logNustar_ind = 9
        nets%gammaE_ind = 10
        nets%Te_ind = 11

        nets%Ane_ind = INTNAN
        nets%Autor_ind = INTNAN
        nets%Machtor_ind = INTNAN
        nets%alpha_ind = INTNAN
        nets%Ani0_ind = INTNAN
        nets%Ani1_ind = INTNAN
        nets%Ati0_ind = INTNAN
        nets%normni0_ind = INTNAN
        nets%normni1_ind = INTNAN
        nets%Ti_Te0_ind = INTNAN

        nets%a = 1.
        nets%R_0 = 3.

        allocate(nets%nets(3))
        call load_multinet_from_disk(fullflux_names, folder, verbosity)
    end subroutine load_fullflux_nets_from_disk

    subroutine load_jetexp_nets_from_disk(folder, n_members, verbosityin)
        character(len=*), intent(in) :: folder
        integer(lli), intent(in) :: n_members
        integer(lli), optional, intent(in) :: verbosityin
        integer(lli) :: verbosity, n_nets, ii, jj
        character(len=32+1+2) :: filename
        character(len=32+1+2), dimension(:), allocatable :: member_filenames
        character(len=2) :: file_tag

        if(present(verbosityin)) then
            verbosity=verbosityin
        else
            verbosity = 0
        end if

        nets%Ane_ind = 1
        nets%Ate_ind = 2
        nets%Autor_ind = 3
        nets%Machtor_ind = 4
        nets%x_ind = 5
        nets%Zeff_ind = 6
        nets%gammaE_ind = 7
        nets%q_ind = 8
        nets%smag_ind = 9
        nets%alpha_ind = 10
        nets%Ani1_ind = 11
        nets%Ati0_ind = 12
        nets%normni1_ind = 13
        nets%Ti_Te0_ind = 14
        nets%logNustar_ind = 15

        nets%Ani0_ind = INTNAN
        nets%normni0_ind = INTNAN

        nets%a = INTNAN
        nets%R_0 = INTNAN

        ERRORSTOP(n_members > 100, 'Amount of members result in too long filenames, abort')
        n_nets = size(qlknn_jetexp_names)
        allocate(nets%nets(n_nets * n_members))
        allocate(member_filenames(n_nets * n_members))
        do ii = 1, n_nets
          do jj = 1, n_members
            write (file_tag,'(I2.2)') jj
            filename = trim(qlknn_jetexp_names(ii)) // '_' // adjustl(file_tag)
            member_filenames(n_members * (ii - 1) + jj) = filename
            if (verbosity > 4) then
              print *, n_members * (ii - 1) + jj, filename
            endif
          enddo
        enddo
        if (verbosity > 3) then
          do ii = 1, n_nets * n_members
            print *, member_filenames(ii)
          enddo
        endif
        call load_multinet_from_disk(member_filenames, folder, verbosity)
    end subroutine load_jetexp_nets_from_disk

    subroutine load_hornnet_nets_from_disk(folder, verbosityin)
        character(len=*), intent(in) :: folder
        integer(lli), optional, intent(in) :: verbosityin
        integer(lli) :: verbosity

        if(present(verbosityin)) then
            verbosity=verbosityin
        else
            verbosity = 0
        end if

        !! Constant for all 9D networks
        nets%Zeff_ind = 1
        nets%Ati_ind = 2
        nets%Ate_ind = 3
        nets%An_ind = 4
        nets%q_ind = 5
        nets%smag_ind = 6
        nets%x_ind = 7
        nets%Ti_Te_ind = 8
        nets%logNustar_ind = 9
        nets%gammaE_ind = 10
        nets%Te_ind = 11

        !nets%Ane_ind = INTNAN
        !nets%Autor_ind = INTNAN
        !nets%Machtor_ind = INTNAN
        !nets%alpha_ind = INTNAN
        !nets%Ani0_ind = INTNAN
        !nets%Ani1_ind = INTNAN
        !nets%Ati0_imd = INTNAN
        !nets%normni0_ind = INTNAN
        !nets%normni1_ind = INTNAN
        !nets%Ti_Te0 = INTNAN

        !nets%a = 1.
        !nets%R_0 = 3.

        !allocate(nets%nets(3))
        allocate(blocks%output_blocks(15))
        call load_multinet_from_disk(qlknn_hornnet_output_blocks, folder, verbosity, 1_lli)
        allocate(blocks%input_blocks(5))
        call load_multinet_from_disk(qlknn_hornnet_input_blocks, folder, verbosity, 2_lli)
    end subroutine load_hornnet_nets_from_disk

    subroutine load_multinet_from_disk(netlist, folder, verbosityin, stylein)
        character(len=*), intent(in) :: folder
        !! Folder  networe files reside in
        character(len=*), dimension(:), intent(in) :: netlist
        !! List of network files to be loaded
        integer(lli), optional, intent(in) :: verbosityin
        !! Verbosity of this function
        integer(lli), optional, intent(in) :: stylein
        !! Style of NN. 0: regular FFNN, 1: late-fusion NN output block, 2: late-fusion NN input block
        integer(lli) :: style
        character(len=32) :: net_name
        character(len=4096) :: filepath
        integer(lli) :: ii
        integer(lli) :: verbosity
        logical :: file_exists

        if (present(verbosityin)) then
            verbosity=verbosityin
        else
            verbosity = 0
        endif

        if (present(stylein)) then
          style = stylein
        else
          style = 0
        endif

        do ii = 1,size(netlist)
            net_name = netlist(ii)
            filepath = trim(folder) // '/' // trim(net_name) // '.nml'
            inquire(file=filepath, exist=file_exists)
            if (file_exists) then
              if (verbosity >= 1) write(*,*) 'Loading ', trim(filepath)
              select case (style)
              case (0)
                call load_net_from_disk(filepath, nets%nets(ii))
              case (1)
                call load_hornnet_output_block_from_disk(filepath, blocks%output_blocks(ii))
              case (2)
                call load_hornnet_input_block_from_disk(filepath, blocks%input_blocks(ii))
              !case (3)
              !  call load_shaped_net_from_disk(filepath, nets%nets(ii))
              end select
            else
              write(stderr,*) 'Cannot load ', trim(filepath)
              ERRORSTOP(.true., 'NN namelist does not exists')
            endif
        end do
    end subroutine load_multinet_from_disk

    subroutine load_net_from_disk(filename, net)
        integer(lli) :: n_hidden_layers, n_hidden_nodes = 0, n_inputs, n_outputs
        integer(lli), dimension(:), allocatable :: n_hidden_node_vector
        character(len=*), intent(in) :: filename

        real(qlknn_dp), dimension(:,:), allocatable ::   weights_input
        real(qlknn_dp), dimension(:), allocatable ::     biases_input
        real(qlknn_dp), dimension(:,:,:), allocatable :: weights_hidden
        real(qlknn_dp), dimension(:,:), allocatable ::   biases_hidden
        real(qlknn_dp), dimension(:,:), allocatable ::   weights_output
        real(qlknn_dp), dimension(:), allocatable :: biases_output

        character(len=4), dimension(:), allocatable ::      hidden_activation

        real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_bias
        real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_factor
        real(qlknn_dp), dimension(:), allocatable ::   target_prescale_bias
        real(qlknn_dp), dimension(:), allocatable ::   target_prescale_factor

        ! Generate non-uniform dynamically-size arrays
        ! Columns (first index) are neurons in current layer, rows (second index) are neurons in previous layer
        logical :: shaped = .false.
        integer(lli) :: ii, layer_max_cols = 0, layer_max_rows = 0
        type(ragged_weights_array), dimension(:), allocatable :: shaped_weights_hidden
        type(ragged_biases_array), dimension(:), allocatable :: shaped_biases_hidden

        type(networktype), intent(out) :: net
        namelist /sizes/ n_hidden_layers, n_hidden_nodes, n_inputs, n_outputs
        namelist /nodes/ n_hidden_node_vector
        namelist /netfile/ biases_hidden, hidden_activation, weights_input, biases_input, &
            weights_hidden, weights_output, biases_output, &
            feature_prescale_bias, feature_prescale_factor, target_prescale_bias,&
            target_prescale_factor
        open(10,file=filename,ACTION='READ')
        read(10,nml=sizes)

        ! Shaped network detected by having n_hidden_nodes=0 in sizes
        allocate(n_hidden_node_vector(n_hidden_layers))
        if (n_hidden_nodes == 0) then
          shaped = .true.
          read(10,nml=nodes)
        else
          n_hidden_node_vector = n_hidden_nodes
        endif
        if (shaped) then
          do ii = 2, n_hidden_layers
            if (n_hidden_node_vector(ii) == 0) then
              write(stderr,*) 'Cannot load ', trim(filename)
              ERRORSTOP(.true., 'Something went wrong in IO')
            endif
            if (n_hidden_node_vector(ii-1) > layer_max_rows) then
              layer_max_rows = n_hidden_node_vector(ii-1)
            endif
            if (n_hidden_node_vector(ii) > layer_max_cols) then
              layer_max_cols = n_hidden_node_vector(ii)
            endif
          enddo
          if (n_outputs > layer_max_cols) then
            layer_max_cols = n_outputs
          endif
        else
          if (n_hidden_nodes == 0) then
            write(stderr,*) 'Cannot load ', trim(filename)
            ERRORSTOP(.true., 'Something went wrong in IO')
          endif
          layer_max_rows = n_hidden_nodes
          layer_max_cols = n_hidden_nodes
        endif
        !write(*, *) 'n_hidden_layers', n_hidden_layers
        !write(*, *) 'n_hidden_nodes', n_hidden_nodes
        !write(*, *) 'n_inputs', n_inputs
        !write(*, *) 'n_outputs', n_outputs

        allocate(weights_input(n_hidden_node_vector(1), n_inputs))
        allocate(biases_input(n_hidden_node_vector(1)))
        allocate(weights_hidden(layer_max_cols, layer_max_rows, n_hidden_layers-1))
        allocate(biases_hidden(layer_max_cols, n_hidden_layers-1))
        allocate(weights_output(n_outputs, n_hidden_node_vector(n_hidden_layers)))
        allocate(biases_output(n_outputs))
        allocate(hidden_activation(n_hidden_layers))
        allocate(feature_prescale_bias(n_inputs))
        allocate(feature_prescale_factor(n_inputs))
        allocate(target_prescale_bias(n_outputs))
        allocate(target_prescale_factor(n_outputs))
        ! Initialization required for minimal storage solution in .nml files
        weights_input = 0
        biases_input = 0
        weights_hidden = 0
        biases_hidden = 0
        weights_output = 0
        biases_output = 0
        ! Explicitly allocate net structure, needed for ifort
        allocate(net%weights_input(n_hidden_node_vector(1), n_inputs))
        allocate(net%biases_input(n_hidden_node_vector(1)))
        allocate(net%weights_hidden(n_hidden_layers-1))
        allocate(net%biases_hidden(n_hidden_layers-1))
        allocate(net%weights_output(n_outputs, n_hidden_node_vector(n_hidden_layers)))
        allocate(net%biases_output(n_outputs))
        allocate(net%hidden_activation(n_hidden_layers))
        allocate(net%feature_prescale_bias(n_inputs))
        allocate(net%feature_prescale_factor(n_inputs))
        allocate(net%target_prescale_bias(n_outputs))
        allocate(net%target_prescale_factor(n_outputs))
        read(10,nml=netfile)
        close(10)

        ! Allocate and fill shaped hidden layer weights and biases
        allocate(shaped_weights_hidden(n_hidden_layers-1))
        allocate(shaped_biases_hidden(n_hidden_layers-1))
        do ii = 2, n_hidden_layers
          allocate(shaped_weights_hidden(ii-1)%weight_layer(n_hidden_node_vector(ii), n_hidden_node_vector(ii-1)))
          allocate(shaped_biases_hidden(ii-1)%bias_layer(n_hidden_node_vector(ii)))
          ! Explicitly allocate net structure, same as above
          allocate(net%weights_hidden(ii-1)%weight_layer(n_hidden_node_vector(ii),n_hidden_node_vector(ii-1)))
          allocate(net%biases_hidden(ii-1)%bias_layer(n_hidden_node_vector(ii)))
          shaped_weights_hidden(ii-1)%weight_layer = weights_hidden(:n_hidden_node_vector(ii), :n_hidden_node_vector(ii-1), ii-1)
          shaped_biases_hidden(ii-1)%bias_layer = biases_hidden(:n_hidden_node_vector(ii), ii-1)
        enddo

        ! New fields for ease of processing in network evaluation
        net%n_hidden_layers = n_hidden_layers
        net%n_max_nodes = layer_max_cols
        if (layer_max_rows > layer_max_cols) then
          net%n_max_nodes = layer_max_rows
        endif

        !write(*,nml=net)
        net%weights_input = weights_input
        net%biases_input = biases_input
        net%weights_hidden = shaped_weights_hidden
        net%biases_hidden = shaped_biases_hidden
        net%weights_output = weights_output
        net%biases_output = biases_output

        net%hidden_activation = hidden_activation

        net%target_prescale_bias = target_prescale_bias
        net%target_prescale_factor = target_prescale_factor
        net%feature_prescale_bias = feature_prescale_bias
        net%feature_prescale_factor = feature_prescale_factor

        deallocate(weights_hidden)
        deallocate(biases_hidden)

    end subroutine load_net_from_disk

    subroutine load_hornnet_output_block_from_disk(filename, output_block)
      character(len=*), intent(in) :: filename

      integer(lli) :: n_hidden_layers, n_hidden_nodes = 0, n_outputs, slash_idx, lay

      real(qlknn_dp), dimension(:,:,:), allocatable :: weights_hidden
      real(qlknn_dp), dimension(:,:), allocatable ::   biases_hidden
      real(qlknn_dp), dimension(:,:), allocatable ::   weights_output
      real(qlknn_dp), dimension(:), allocatable :: biases_output
      character(len=20) :: blockname

      character(len=4), dimension(:), allocatable ::      hidden_activation

      type(hornnet_output_block), intent(out) :: output_block

      namelist /sizes/ n_hidden_layers, n_hidden_nodes, n_outputs
      namelist /netfile/ biases_hidden, hidden_activation, &
          weights_hidden, weights_output, biases_output
      open(10,file=filename,ACTION='READ')
      read(10,nml=sizes)
      if (n_hidden_nodes == 0) then
        write(stderr,*) 'Cannot load ', trim(filename)
        ERRORSTOP(.true., 'Something went wrong in IO')
      endif
      slash_idx = index(filename,'/',BACK=.TRUE.)
      if (slash_idx /= 0) then
        if (len(blockname) <= len(trim(filename(slash_idx+1:)))) then
          write(stderr,*) 'Warning! blockname too long for saving. Trimming..'
        endif
        blockname = trim(filename(slash_idx+1:))
      else
        if (len(blockname) <= len(trim(filename))) then
          write(stderr,*) 'Warning! blockname too long for saving. Trimming..'
        endif
        blockname = trim(filename)
      endif
      output_block%blockname = blockname
      !write(*, *) 'n_hidden_layers', n_hidden_layers
      !write(*, *) 'n_hidden_nodes', n_hidden_nodes
      !write(*, *) 'n_inputs', n_inputs
      !write(*, *) 'n_outputs', n_outputs
      !write(*,*) n_hidden_layers, n_hidden_nodes
      allocate(weights_hidden(n_hidden_nodes, n_hidden_nodes, n_hidden_layers))
      allocate(biases_hidden(n_hidden_nodes, n_hidden_layers))
      allocate(weights_output(1, n_hidden_nodes))
      allocate(biases_output(n_outputs))
      allocate(hidden_activation(n_hidden_layers))
      ! Explicitly allocate output_block structure, needed for ifort
      allocate(output_block%weights_hidden(n_hidden_layers))
      allocate(output_block%biases_hidden(n_hidden_layers))
      allocate(output_block%weights_output(1, n_hidden_nodes))
      allocate(output_block%biases_output(n_outputs))
      allocate(output_block%hidden_activation(n_hidden_layers))
      read(10,nml=netfile)
      close(10)
      !write(*,nml=output_block)
      do lay = 1, n_hidden_layers
        output_block%biases_hidden(lay)%bias_layer = biases_hidden(:, lay)
        output_block%weights_hidden(lay)%weight_layer = weights_hidden(:, :, lay)
      enddo
      output_block%weights_output = weights_output
      output_block%biases_output = biases_output

      output_block%hidden_activation = hidden_activation

    end subroutine load_hornnet_output_block_from_disk

    subroutine load_hornnet_input_block_from_disk(filename, input_block)
      character(len=*), intent(in) :: filename

      integer(lli) :: n_inputs = 0, n_hidden_nodes, n_target_prescale, n_feature_prescale

      real(qlknn_dp), dimension(:,:), allocatable ::   weights_input
      real(qlknn_dp), dimension(:), allocatable :: biases_input

      real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_bias
      real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_factor
      real(qlknn_dp), dimension(:), allocatable ::   target_prescale_bias
      real(qlknn_dp), dimension(:), allocatable ::   target_prescale_factor


      type(hornnet_input_block), intent(out) :: input_block

      namelist /sizes/ n_inputs, n_hidden_nodes, n_target_prescale, n_feature_prescale
      namelist /netfile/ weights_input, biases_input, &
           target_prescale_factor, target_prescale_bias, feature_prescale_factor, feature_prescale_bias
      open(10,file=filename,ACTION='READ')
      read(10,nml=sizes)
      if (n_inputs == 0) then
        write(stderr,*) 'Cannot load ', trim(filename)
        ERRORSTOP(.true., 'Something went wrong in IO')
      endif

      allocate(weights_input(n_hidden_nodes, n_inputs))
      allocate(biases_input(n_hidden_nodes))
      allocate(feature_prescale_bias(n_feature_prescale))
      allocate(feature_prescale_factor(n_feature_prescale))
      allocate(target_prescale_bias(n_target_prescale))
      allocate(target_prescale_factor(n_target_prescale))
      ! Explicitly allocate net structure, needed for ifort
      allocate(input_block%weights_input(n_hidden_nodes, n_inputs))
      allocate(input_block%biases_input(n_hidden_nodes))
      allocate(input_block%feature_prescale_bias(n_feature_prescale))
      allocate(input_block%feature_prescale_factor(n_feature_prescale))
      allocate(input_block%target_prescale_bias(n_target_prescale))
      allocate(input_block%target_prescale_factor(n_target_prescale))
      read(10,nml=netfile)
      close(10)
      input_block%weights_input = weights_input
      input_block%biases_input = biases_input

      input_block%target_prescale_bias = target_prescale_bias
      input_block%target_prescale_factor = target_prescale_factor
      input_block%feature_prescale_bias = feature_prescale_bias
      input_block%feature_prescale_factor = feature_prescale_factor

    end subroutine load_hornnet_input_block_from_disk
end module qlknn_disk_io

! Module qlknn_error_filter defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_error_filter.f90

subroutine f90wrap_determine_validity_with_eb(abs_limits, rel_limits, net_out, net_eb, validity, verbosity, mask, n0, &
    n1, n2, n3, n4, n5, n6, n7, n8)
    use qlknn_error_filter, only: determine_validity_with_eb
    implicit none
    
    real(8), intent(in), dimension(n0) :: abs_limits
    real(8), intent(in), dimension(n1) :: rel_limits
    real(8), intent(in), dimension(n2,n3) :: net_out
    real(8), intent(in), dimension(n4,n5) :: net_eb
    logical, intent(inout), dimension(n6,n7) :: validity
    integer(8), intent(in) :: verbosity
    logical, optional, intent(in), dimension(n8) :: mask
    integer :: n0
    !f2py intent(hide), depend(abs_limits) :: n0 = shape(abs_limits,0)
    integer :: n1
    !f2py intent(hide), depend(rel_limits) :: n1 = shape(rel_limits,0)
    integer :: n2
    !f2py intent(hide), depend(net_out) :: n2 = shape(net_out,0)
    integer :: n3
    !f2py intent(hide), depend(net_out) :: n3 = shape(net_out,1)
    integer :: n4
    !f2py intent(hide), depend(net_eb) :: n4 = shape(net_eb,0)
    integer :: n5
    !f2py intent(hide), depend(net_eb) :: n5 = shape(net_eb,1)
    integer :: n6
    !f2py intent(hide), depend(validity) :: n6 = shape(validity,0)
    integer :: n7
    !f2py intent(hide), depend(validity) :: n7 = shape(validity,1)
    integer :: n8
    !f2py intent(hide), depend(mask) :: n8 = shape(mask,0)
    call determine_validity_with_eb(abs_limits=abs_limits, rel_limits=rel_limits, net_out=net_out, net_eb=net_eb, &
        validity=validity, verbosity=verbosity, mask=mask)
end subroutine f90wrap_determine_validity_with_eb

subroutine f90wrap_determine_validity_multiplied_networks(leading_map, validity, verbosity, n0, n1, n2, n3)
    use qlknn_error_filter, only: determine_validity_multiplied_networks
    implicit none
    
    integer(8), intent(in), dimension(n0,n1) :: leading_map
    logical, intent(inout), dimension(n2,n3) :: validity
    integer(8), intent(in) :: verbosity
    integer :: n0
    !f2py intent(hide), depend(leading_map) :: n0 = shape(leading_map,0)
    integer :: n1
    !f2py intent(hide), depend(leading_map) :: n1 = shape(leading_map,1)
    integer :: n2
    !f2py intent(hide), depend(validity) :: n2 = shape(validity,0)
    integer :: n3
    !f2py intent(hide), depend(validity) :: n3 = shape(validity,1)
    call determine_validity_multiplied_networks(leading_map=leading_map, validity=validity, verbosity=verbosity)
end subroutine f90wrap_determine_validity_multiplied_networks

subroutine f90wrap_determine_validity_merged_modes(merge_map, validity, merged_validity, verbosity, n0, n1, n2, n3, n4, &
    n5)
    use qlknn_error_filter, only: determine_validity_merged_modes
    implicit none
    
    integer(8), intent(in), dimension(n0,n1) :: merge_map
    logical, intent(in), dimension(n2,n3) :: validity
    logical, intent(inout), dimension(n4,n5) :: merged_validity
    integer(8), intent(in) :: verbosity
    integer :: n0
    !f2py intent(hide), depend(merge_map) :: n0 = shape(merge_map,0)
    integer :: n1
    !f2py intent(hide), depend(merge_map) :: n1 = shape(merge_map,1)
    integer :: n2
    !f2py intent(hide), depend(validity) :: n2 = shape(validity,0)
    integer :: n3
    !f2py intent(hide), depend(validity) :: n3 = shape(validity,1)
    integer :: n4
    !f2py intent(hide), depend(merged_validity) :: n4 = shape(merged_validity,0)
    integer :: n5
    !f2py intent(hide), depend(merged_validity) :: n5 = shape(merged_validity,1)
    call determine_validity_merged_modes(merge_map=merge_map, validity=validity, merged_validity=merged_validity, &
        verbosity=verbosity)
end subroutine f90wrap_determine_validity_merged_modes

! End of module qlknn_error_filter defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_error_filter.f90

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_types
  use iso_c_binding
  implicit none

  integer, parameter :: qlknn_dp=c_double
  integer, parameter :: lli=c_int64_t
  integer, parameter :: li=c_int32_t

  integer(lli), parameter :: stderr = 0

  real(qlknn_dp), parameter :: qe = 1.602176565e-19 !SI electron charge
  real(qlknn_dp), parameter :: mp = 1.672621777e-27 !SI protonmass
  real(qlknn_dp), parameter :: c_qlk_ref = sqrt(qe*1e3/mp)

  type ragged_weights_array
     real(qlknn_dp), dimension(:,:), allocatable :: weight_layer
  end type ragged_weights_array

  type ragged_biases_array
     real(qlknn_dp), dimension(:), allocatable :: bias_layer
  end type ragged_biases_array

!  type networktype
!    !! Type that defines a single feed-forward neural network.
!
!    !! Assumes the input vector \( x_{in} \) first has to be scaled with
!    !! \( a_{in} x_{in} + b_{in} \) and the network output \( y_{out} \)
!    !! has to be de-scaled using \( \frac{1}{a_{out}} y_{out} - b_{out} \)
!     real(qlknn_dp), dimension(:,:), allocatable :: weights_input
!     !! Input layer weights
!     real(qlknn_dp), dimension(:), allocatable ::   biases_input
!     !! Input layer biases
!     real(qlknn_dp), dimension(:,:,:), allocatable :: weights_hidden
!     !! Hidden layer weights
!     real(qlknn_dp), dimension(:,:), allocatable ::  biases_hidden
!     !! Hidden layer biases
!     real(qlknn_dp), dimension(:,:), allocatable :: weights_output
!     !! Output layer weights
!     real(qlknn_dp), dimension(:), allocatable ::   biases_output
!     !! Output layer biases
!
!     character(len=4), dimension(:), allocatable :: hidden_activation
!     !! Activation function of the activation layers. Can be only tanh
!
!     real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_bias
!     !! Standardization bias \( b_{in} \) of the input features
!     real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_factor
!     !! Standardization factor \( a_{in} \) of the input features
!     real(qlknn_dp), dimension(:), allocatable ::   target_prescale_bias
!     !! Standardization bias \( b_{out} \) of the output targets
!     real(qlknn_dp), dimension(:), allocatable ::   target_prescale_factor
!     !! Standardization factor \( a_{out} \) of the output targets
!  end type networktype

  type networktype
    !! Type that defines a single feed-forward neural network.

     integer(lli) :: n_hidden_layers
     !! Number of hidden layers (includes input layer)
     integer(lli) :: n_max_nodes
     !! Maximum number of layer nodes in NN, for easy memory allocation

    !! Assumes the input vector \( x_{in} \) first has to be scaled with
    !! \( a_{in} x_{in} + b_{in} \) and the network output \( y_{out} \)
    !! has to be de-scaled using \( \frac{1}{a_{out}} y_{out} - b_{out} \)
     real(qlknn_dp), dimension(:,:), allocatable :: weights_input
     !! Input layer weights
     real(qlknn_dp), dimension(:), allocatable ::   biases_input
     !! Input layer biases
     type(ragged_weights_array), dimension(:), allocatable :: weights_hidden
     !! Hidden layer weights
     type(ragged_biases_array), dimension(:), allocatable ::  biases_hidden
     !! Hidden layer biases
     real(qlknn_dp), dimension(:,:), allocatable :: weights_output
     !! Output layer weights
     real(qlknn_dp), dimension(:), allocatable ::   biases_output
     !! Output layer biases

     character(len=4), dimension(:), allocatable :: hidden_activation
     !! Activation function of the activation layers. Can be only tanh

     real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_bias
     !! Standardization bias \( b_{in} \) of the input features
     real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_factor
     !! Standardization factor \( a_{in} \) of the input features
     real(qlknn_dp), dimension(:), allocatable ::   target_prescale_bias
     !! Standardization bias \( b_{out} \) of the output targets
     real(qlknn_dp), dimension(:), allocatable ::   target_prescale_factor
     !! Standardization factor \( a_{out} \) of the output targets
  end type networktype

  type net_collection
    !! Type to collect multiple similar networks in a single structure
    !!
    !! Assumes all networks have the same input variables at the same
    !! index in the input array. Can be INTNAN if the index is not used
    !! for these networks. For normalizations, see qualikiz.com
     type(networktype), dimension(:), allocatable :: nets
     !! Array with feed-forward neural networks
     integer(lli) :: Zeff_ind
     !! Index of the effective charge \( Z_{eff} \)
     integer(lli) :: Ati_ind
     !! Index of the normalized logarithmic ion temperature gradient \( R/L_{T_i} \)
     integer(lli) :: Ate_ind
     !! Index of the normalized logarithmic electron temperature gradient \( R/L_{T_e} \)
     integer(lli) :: An_ind
     !! Index of the normalized logarithmic density gradient \( R/L_{n_e} = R/L_{n_i} \)
     integer(lli) :: q_ind
     !! Index of the safety factor \( q \)
     integer(lli) :: smag_ind
     !! Index of the normalized magnetic shear \( \hat{s} \)
     integer(lli) :: x_ind
     !! Index of the inverse aspect ratio \( r_{minor} / R_0 \)
     integer(lli) :: Ti_Te_ind
     !! Index of the temperature ratio \( T_i / T_e \)
     integer(lli) :: logNustar_ind
     !! Index of the logarithmic collision frequency \( \nu^* \)
     integer(lli) :: gammaE_ind
     !! Index of the ExB shearing rate \( \gamma_{E \times B} \)
     integer(lli) :: Te_ind
     !! Index of the electron temperature \( T_e \)
     integer(lli) :: Ane_ind
     !! Index of the normalized logarithmic electron density gradient \( R/L_{n_e} \neq R/L_{n_i} \)
     integer(lli) :: Machtor_ind
     !! Index of the normalized toroidal velocity \( v_{tor} / c_{ref} \)
     integer(lli) :: Autor_ind
     !! Index of the normalized toroidal velocity gradient \( R/L_{u_{tor}} \)
     integer(lli) :: alpha_ind
     !! Index of the MHD alpha \( \alpha_{MHD} \)
     integer(lli) :: Ani0_ind
     !! Index of the normalized logarithmic density gradient of the main ion \( R/L_{n_{i,0}} \)
     integer(lli) :: Ani1_ind
     !! Index of the normalized logarithmic density gradient of the main impurity \( R/L_{n_{i,1}} \)
     integer(lli) :: Ati0_ind
     !! Index of the normalized temperature gradient of the main ion \( R/L_{T_{i,0}} \)
     integer(lli) :: normni0_ind
     !! Index of the normalized density of the main ion \( n_{i,0} / n_e \)
     integer(lli) :: normni1_ind
     !! Index of the normalized density of the main impurity \( n_{i,1} / n_e \)
     integer(lli) :: Ti_Te0_ind
     !! Index of the temperature ratio (renamed, pending removal) \( T_i / T_e \)
     real(qlknn_dp) :: a
     !! Midplane-averaged minor radius of last-closed-flux-surface of the trained networks \( R_{min} \)
     real(qlknn_dp) :: R_0
     !! Midplane-averaged major radius of last-closed-flux-surface of the trained networks \( R_0 \)
  end type net_collection

  type hornnet_output_block
    !! Type representing a common block inside a late-fusion NN
    !!
    !! Collects hidden layers and output layers with similar shapes
    !! A single late-fusion net typically consists of multiples of
    !! these blocks, and a differently shaped input block
    type(ragged_weights_array), dimension(:), allocatable :: weights_hidden
    !! Hidden layer weights in ragged array
    type(ragged_biases_array), dimension(:), allocatable :: biases_hidden
    !! Hidden layer biases in ragged array
    real(qlknn_dp), dimension(:,:), allocatable ::   weights_output
    !! Output layer weights
    real(qlknn_dp), dimension(:), allocatable :: biases_output
    !! Output layer biases

    character(len=4), dimension(:), allocatable :: hidden_activation
    !! Activation function of the activation layers. Can be only tanh

    character(len=20) :: blockname
    !! Name of the block, useful for debugging
  end type hornnet_output_block

  type hornnet_input_block
    !! Type representing a common block inside a late-fusion NN
    !!
    !! Collects input layers and hidden layers with similar shapes
    !! A single late-fusion net typically consists of one of
    !! these blocks, and multile differently shaped output blocks
    real(qlknn_dp), dimension(:,:), allocatable ::   weights_input
    !! Input layer weights
    real(qlknn_dp), dimension(:), allocatable ::     biases_input
    !! Input layer biases

    real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_bias
    !! Standardization bias \( b_{in} \) of the input features
    real(qlknn_dp), dimension(:), allocatable ::   feature_prescale_factor
    !! Standardization factor \( a_{in} \) of the input features
    real(qlknn_dp), dimension(:), allocatable ::   target_prescale_bias
    !! Standardization bias \( b_{out} \) of the output targets
    real(qlknn_dp), dimension(:), allocatable ::   target_prescale_factor
    !! Standardization factor \( a_{out} \) of the output targets
  end type hornnet_input_block

  type block_collection
    !! Type to collect late-fusion blocks
    type(hornnet_output_block), dimension(:), allocatable :: output_blocks
    type(hornnet_input_block), dimension(:), allocatable :: input_blocks
  end type block_collection

  type qlknn_options
    !! Common options for QLKNN
     logical :: use_ion_diffusivity_networks
     !! Use the networks predicting \( D_i, V_i \) instead of \( D_e, V_e \)
     logical :: apply_victor_rule
     !! Apply the 'victor rule' to include rotation
     logical :: use_effective_diffusivity
     !! Use the networks predicting \( \Gamma \) instead of \( D, V \)
     logical :: calc_heat_transport
     !! Evaluate the heat-predicting networks
     logical :: calc_part_transport
     !! Evaluate the particle-predicting networks
     logical :: use_ETG
     !! Evaluate the ETG-predicting networks
     logical :: use_ITG
     !! Evaluate the ITG-predicting networks
     logical :: use_TEM
     !! Evaluate the TEM-predicting networks
     logical :: apply_stability_clipping
     !! Clip all transport if leading flux is 0, see [apply_stability_clipping](|url|/proc/apply_stability_clipping.html)
     logical, dimension(:), allocatable :: constrain_inputs
     !! Clip inputs to given bounds if True, see [impose_input_constraints](|url|/proc/impose_input_constraints.html)
     real(qlknn_dp), dimension(:), allocatable :: min_input
     !! Input minimum \( c_{min} \), see [impose_input_constraints](|url|/proc/impose_input_constraints.html)
     real(qlknn_dp), dimension(:), allocatable :: max_input
     !! Input maximum \( c_{max} \), see [impose_input_constraints](|url|/proc/impose_input_constraints.html)
     real(qlknn_dp), dimension(:), allocatable :: margin_input
     !! Input bound margin \( c_{margin} \), see [impose_input_constraints](|url|/proc/impose_input_constraints.html)
     logical, dimension(:), allocatable :: constrain_outputs
     !! Clip outputs to given bounds if True, see [impose_output_constraints](|url|/proc/impose_output_constraints.html)
     real(qlknn_dp), dimension(:), allocatable :: min_output
     !! Output minimum \( c_{min} \), see [impose_output_constraints](|url|/proc/impose_output_constraints.html)
     real(qlknn_dp), dimension(:), allocatable :: max_output
     !! Output maximum \( c_{max} \), see [impose_output_constraints](|url|/proc/impose_output_constraints.html)
     real(qlknn_dp), dimension(:), allocatable :: margin_output
     !! Output bound margin \( c_{margin} \), see [impose_output_constraints](|url|/proc/impose_output_constraints.html)
     logical :: merge_modes
     !! Merge ETG/ITG/TEM of the same transport variable together, see [merge_modes](|url|/proc/merge_modes.html)
     logical :: force_evaluate_all
     !! Force evaluation of all networks regardless of other settings
  end type qlknn_options

  type qlknn_normpars
    !! Normalisation parameters for rotation shear conversion
    !!
    !! Needed to apply the [victor rule](|url|/proc/scale_with_victor.html)
     real(qlknn_dp) :: a
     !! Current midplane-averaged minor radius of last-closed-flux-surface \( R_{min} \)
     real(qlknn_dp) :: R0
     !! Current midplane-averaged major radius of last-closed-flux-surface \( R_{0} \)
     real(qlknn_dp), dimension(:), allocatable :: A1
     !! Main ion mass in amu
  end type qlknn_normpars

contains
  subroutine default_qlknn_hyper_options(opts)
    type (qlknn_options), intent(out) :: opts

    allocate(opts%constrain_inputs(11))
    allocate(opts%min_input(11))
    allocate(opts%max_input(11))
    allocate(opts%margin_input(11))
    allocate(opts%constrain_outputs(20))
    allocate(opts%min_output(20))
    allocate(opts%max_output(20))
    allocate(opts%margin_output(20))

    opts%use_ion_diffusivity_networks = .false.
    opts%apply_victor_rule = .false.
    opts%use_effective_diffusivity = .false.
    opts%calc_heat_transport = .true.
    opts%calc_part_transport = .true.
    opts%use_etg = .true.
    opts%use_itg = .true.
    opts%use_tem = .true.
    opts%apply_stability_clipping = .true.
    opts%constrain_inputs = .true.
    opts%min_input = (/1., 0., 0., -5., 0.66, -1., .09, 0.25, -5., -100., -100./)
    opts%max_input = (/3., 14., 14., 6., 15., 5., .99, 2.5, 0., 100., 100./)
    opts%margin_input = 0.95
    opts%constrain_outputs = .true.
    opts%min_output = -300
    opts%max_output = 300
    opts%margin_output = 1.
    opts%merge_modes = .true.
    opts%force_evaluate_all = .false.
  end subroutine default_qlknn_hyper_options

  subroutine default_qlknn_fullflux_options(opts)
    type (qlknn_options), intent(out) :: opts

    allocate(opts%constrain_inputs(11))
    allocate(opts%min_input(11))
    allocate(opts%max_input(11))
    allocate(opts%margin_input(11))
    allocate(opts%constrain_outputs(3))
    allocate(opts%min_output(3))
    allocate(opts%max_output(3))
    allocate(opts%margin_output(3))

    opts%use_ion_diffusivity_networks = .false. ! Does not exists for fullflux nets
    opts%apply_victor_rule = .false. ! Cannot apply for fullflux nets
    opts%use_effective_diffusivity = .true. ! Always true for fullflux nets
    opts%calc_heat_transport = .true.
    opts%calc_part_transport = .true.
    opts%use_etg = .true. ! Always true for fullflux nets
    opts%use_itg = .true. ! Always true for fullflux nets
    opts%use_tem = .true. ! Always true for fullflux nets
    opts%apply_stability_clipping = .false. ! Does not exists for fullflux nets
    opts%constrain_inputs = .true.
    opts%min_input = (/1., 0., 0., -5., 0.66, -1., .09, 0.25, -5., -100., -100./)
    opts%max_input = (/3., 14., 14., 6., 15., 5., .99, 2.5, 0., 100., 100./)
    opts%margin_input = 0.95
    opts%constrain_outputs = .true.
    opts%min_output = -300
    opts%max_output = 300
    opts%margin_output = 1.
    opts%merge_modes = .true.
    opts%force_evaluate_all = .false.
  end subroutine default_qlknn_fullflux_options

  subroutine default_qlknn_jetexp_options(opts)
    type (qlknn_options), intent(out) :: opts

    allocate(opts%constrain_inputs(15))
    allocate(opts%min_input(15))
    allocate(opts%max_input(15))
    allocate(opts%margin_input(15))
    allocate(opts%constrain_outputs(25))
    allocate(opts%min_output(25))
    allocate(opts%max_output(25))
    allocate(opts%margin_output(25))

    opts%use_ion_diffusivity_networks = .false.
    opts%apply_victor_rule = .false. ! Cannot apply for jetexp nets
    opts%use_effective_diffusivity = .true.
    opts%calc_heat_transport = .true.
    opts%calc_part_transport = .true.
    opts%use_etg = .true.
    opts%use_itg = .true.
    opts%use_tem = .true.
    opts%apply_stability_clipping = .false. ! Does not exists for jetexp nets
    opts%constrain_inputs = .true.
    opts%min_input = -99999
    opts%max_input = 99999
    opts%margin_input = 0.95
    opts%constrain_outputs = .true.
    opts%min_output = -300
    opts%max_output = 300
    opts%margin_output = 1.
    opts%merge_modes = .true.
    opts%force_evaluate_all = .false.
  end subroutine default_qlknn_jetexp_options

  subroutine default_qlknn_hornnet_options(opts)
    type (qlknn_options), intent(out) :: opts

    allocate(opts%constrain_inputs(11))
    allocate(opts%min_input(11))
    allocate(opts%max_input(11))
    allocate(opts%margin_input(11))
    allocate(opts%constrain_outputs(7))
    allocate(opts%min_output(7))
    allocate(opts%max_output(7))
    allocate(opts%margin_output(7))

    opts%use_ion_diffusivity_networks = .false. ! Only have Gamma_e
    opts%apply_victor_rule = .false.
    opts%use_effective_diffusivity = .true. ! Only have Gamma_e
    opts%calc_heat_transport = .true.
    opts%calc_part_transport = .true.
    opts%use_etg = .true.
    opts%use_itg = .true.
    opts%use_tem = .true.
    opts%apply_stability_clipping = .false. ! Does not exists for fusion nets
    opts%constrain_inputs = .true.
    opts%min_input = -999
    opts%max_input = 999
    opts%margin_input = 0.95
    opts%constrain_outputs = .true.
    opts%min_output = -300
    opts%max_output = 300
    opts%margin_output = 1.
    opts%merge_modes = .true.
    opts%force_evaluate_all = .false.
  end subroutine default_qlknn_hornnet_options

  subroutine print_qlknn_options(opts)
    type (qlknn_options), intent(in) :: opts
    integer(lli) :: i, n_in, n_out

    n_in = size(opts%min_input)
    n_out = size(opts%min_output)
    WRITE(*,*) 'use_ion_diffusivity_networks', opts%use_ion_diffusivity_networks
    WRITE(*,*) 'apply_victor_rule'           , opts%apply_victor_rule
    WRITE(*,*) 'use_effective_diffusivity'   , opts%use_effective_diffusivity
    WRITE(*,*) 'calc_heat_transport'         , opts%calc_heat_transport
    WRITE(*,*) 'calc_part_transport'         , opts%calc_part_transport
    WRITE(*,*) 'use_etg'                     , opts%use_etg
    WRITE(*,*) 'use_itg'                     , opts%use_itg
    WRITE(*,*) 'use_tem'                     , opts%use_tem
    WRITE(*,*) 'apply_stability_clipping'    , opts%apply_stability_clipping
    WRITE(*,*) 'constrain_inputs'            , opts%constrain_inputs
    WRITE(*,'(A,14(F8.3, 1X))') 'min_input'   , (opts%min_input(i), i=1,n_in)
    WRITE(*,'(A,14(F8.3, 1X))') 'max_input'   , (opts%max_input(i), i=1,n_in)
    WRITE(*,'(A,14(F8.3, 1X))') 'margin_input', (opts%margin_input(i), i=1,n_in)
    WRITE(*,*) 'constrain_outputs'           , opts%constrain_outputs
    WRITE(*,'(A,25(F6.1, 1X))') 'min_output'  , (opts%min_output(i), i=1,n_out)
    WRITE(*,'(A,25(F6.1, 1X))') 'max_output'  , (opts%max_output(i), i=1,n_out)
    WRITE(*,'(A,25(F6.1, 1X))') 'margin_output', (opts%margin_output(i), i=1,n_out)
    WRITE(*,*) 'merge_modes'                  , opts%merge_modes
    WRITE(*,*) 'force_evaluate_all'           , opts%force_evaluate_all
  end subroutine print_qlknn_options

  subroutine get_networks_to_evaluate(opts, net_evaluate)
    type (qlknn_options), intent(in) :: opts
    logical, dimension(20), intent(out) :: net_evaluate
    if (opts%force_evaluate_all) then
       net_evaluate(:) = .TRUE.
    else
       net_evaluate(:) = .FALSE.
       if (opts%use_etg) then
          net_evaluate(1) = .TRUE.
       end if
       if (opts%use_itg) then
          net_evaluate(2:4:2) = .TRUE.
       end if
       if (opts%use_tem) then
          net_evaluate(3:5:2) = .TRUE.
       end if

       if (opts%use_itg) then
          net_evaluate(6) = .TRUE.
       end if
       if (opts%use_tem) then
          net_evaluate(7) = .TRUE.
       end if

       if (.not. opts%use_effective_diffusivity) then
          if (opts%use_ion_diffusivity_networks) then
             if (opts%use_itg) then
                net_evaluate(14) = .TRUE.
             end if
             if (opts%use_tem) then
                net_evaluate(15) = .TRUE.
             end if
          else ! if not use_ion_diffusivity_networks
             if (opts%use_itg) then
                net_evaluate(8) = .TRUE.
             end if
             if (opts%use_tem) then
                net_evaluate(9) = .TRUE.
             end if
          end if !opts%use_ion_diffusivity_networks
       end if ! opts%use_effective_diffusivity

       if (opts%apply_victor_rule) then
          net_evaluate(20) = .TRUE.
       end if
    end if ! Force evaluate all
  end subroutine get_networks_to_evaluate

  subroutine networktype_deallocate(net)
    type(networktype), INTENT(inout) :: net
    integer :: ii
    if (allocated(net%weights_input)) deallocate(net%weights_input)
    if (allocated(net%biases_input)) deallocate(net%biases_input)
    if (allocated(net%weights_hidden)) then
      do ii = 1, size(net%weights_hidden)
        if (allocated(net%weights_hidden(ii)%weight_layer)) deallocate(net%weights_hidden(ii)%weight_layer)
      end do
      deallocate(net%weights_hidden)
    end if
    if (allocated(net%biases_hidden)) then
      do ii = 1, size(net%biases_hidden)
        if (allocated(net%biases_hidden(ii)%bias_layer)) deallocate(net%biases_hidden(ii)%bias_layer)
      end do
      deallocate(net%biases_hidden)
    end if
    if (allocated(net%weights_output)) deallocate(net%weights_output)
    if (allocated(net%biases_output)) deallocate(net%biases_output)

    if (allocated(net%hidden_activation)) deallocate(net%hidden_activation)

    if (allocated(net%feature_prescale_bias)) deallocate(net%feature_prescale_bias)
    if (allocated(net%feature_prescale_factor)) deallocate(net%feature_prescale_factor)
    if (allocated(net%target_prescale_bias)) deallocate(net%target_prescale_bias)
    if (allocated(net%target_prescale_factor)) deallocate(net%target_prescale_factor)
  end subroutine networktype_deallocate

  subroutine all_networktype_deallocate(net_coll)
    type(net_collection), intent(inout) :: net_coll
    integer :: ii
    do ii = 1, size(net_coll%nets)
       call networktype_deallocate(net_coll%nets(ii))
    end do
    deallocate(net_coll%nets)
  end subroutine all_networktype_deallocate

  subroutine qlknn_normpars_allocate(qlknn_norms, nrho)
    type(qlknn_normpars), intent(inout) :: qlknn_norms
    integer :: nrho
    allocate(qlknn_norms%A1(nrho))
  end subroutine qlknn_normpars_allocate

  subroutine qlknn_normpars_deallocate(qlknn_norms)
    type(qlknn_normpars), intent(inout) :: qlknn_norms
    if (allocated(qlknn_norms%A1)) deallocate(qlknn_norms%A1)
  end subroutine qlknn_normpars_deallocate

end module qlknn_types

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module test_jacobian_hornnet
#include "../src/core/preprocessor.inc"
  use fruit
  use fruit_util
  use qlknn_types
  use test_jacobian, only: calc_error

contains
  subroutine test_jacobian_hornnet_case_one
    call jacobian_hornnet_multi_fruit(1)
  end subroutine test_jacobian_hornnet_case_one

  subroutine test_jacobian_hornnet_case_two
    call jacobian_hornnet_multi_fruit(2)
  end subroutine test_jacobian_hornnet_case_two

  subroutine test_jacobian_hornnet_case_three
    call jacobian_hornnet_multi_fruit(3)
  end subroutine test_jacobian_hornnet_case_three

  subroutine test_jacobian_hornnet_case_four
    call jacobian_hornnet_multi_fruit(4)
  end subroutine test_jacobian_hornnet_case_four

  subroutine test_jacobian_hornnet_case_five
    call jacobian_hornnet_multi_fruit(5)
  end subroutine test_jacobian_hornnet_case_five

  subroutine test_jacobian_hornnet_case_six
    call jacobian_hornnet_multi_fruit(6)
  end subroutine test_jacobian_hornnet_case_six

  subroutine jacobian_hornnet_multi_fruit(casenum)
    use fruit
    use fruit_util
    use qlknn_evaluate_nets
    use qlknn_disk_io
    use test_jacobian

    implicit none

    integer, intent(in) :: casenum
    integer(lli) :: verbosity, n_in, n_rho=24
    integer :: inp, outp
    real(qlknn_dp), dimension(:,:), allocatable :: input
    !real(qlknn_dp) :: start, finish
    real(qlknn_dp), dimension(:), allocatable :: err
    real(qlknn_dp) :: max_err
    logical, dimension(:), allocatable :: this_err_okay
    character(len=4096) :: nn_path, input_path
    real(qlknn_dp) :: stepsize
    character(len=512) :: ci_msg
    real(qlknn_dp), dimension(:,:,:), allocatable :: err_out
    logical, dimension(:,:,:), allocatable :: err_okay

    namelist /sizes/ n_rho, n_in
    namelist /test/ input

    input_path = 'tests/test.nml'
    nn_path = 'data/qlknn-hornnet-namelists'
    verbosity = 0

    if (.not. allocated(blocks%input_blocks)) then
      call load_hornnet_nets_from_disk(nn_path, verbosity - 1)
    endif


    ! Read input namelist
    open(10,file=input_path,action='READ')
    read(10,nml=sizes)
    allocate(input(n_in, n_rho))
    read(10,nml=test)
    close(10)

    allocate(this_err_okay(n_rho))
    allocate(err(n_rho))

    stepsize = stepsize_hornnet
    max_err = max_err_hornnet(casenum)
    call jacobian_hornnet_multi(casenum, input, stepsize, err_out, verbosity)
    call passed_test(err_out, max_err, err_okay)

    do inp = 1, size(err_out, 3)
      do outp = 1, size(err_out, 1)
        !write(ci_msg, '(*(E7.2, A2))') (err(ii), ",", ii=1,n_rho)
        err = err_out(outp, :, inp)
        this_err_okay = err_okay(outp, :, inp)
        write(ci_msg, *) 'max abs err = ', maxval(abs(err))
        call assert_true(all(this_err_okay), trim(ci_msg))
      enddo
    enddo
  end subroutine jacobian_hornnet_multi_fruit
end module test_jacobian_hornnet

module daan_correction
  use karel_types
  !! Contains improvement term for 'Karel model' to take into account
  !! users trying to do Monte Carlo sampling
contains
  subroutine correct_transport_prediction(transport_prediction)
    real(karel_dp), dimension(:,:), intent(inout) :: transport_prediction
    !! The transport prediction. Will be corrected by Daan model.
    !! Columns are \(\chi_e\), \(\chi_i\).
    integer n_rho
    real(karel_dp), dimension(:,:), allocatable :: correction

    n_rho = size(transport_prediction, 1)


    ! Allocate memory to store transport prediction
    allocate(correction(n_rho, 3))

    ! Use Daan et al. correction model
    call random_number(correction)
    correction = (correction - 0.5) / 10
    transport_prediction = transport_prediction * (1 + correction)
  end subroutine correct_transport_prediction
end module daan_correction

! Module qlknn_primitives defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_primitives.f90

subroutine f90wrap_evaluate_network(input, net, output_1d, verbosityin, dnet_out1d_dinput, n0, n1, n2, n3, n4)
    use qlknn_types, only: networktype
    use qlknn_primitives, only: evaluate_network
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(networktype_ptr_type) :: net_ptr
    integer, intent(in), dimension(2) :: net
    real(8), intent(inout), dimension(n2) :: output_1d
    integer(8), optional, intent(in) :: verbosityin
    real(8), optional, intent(inout), dimension(n3,n4) :: dnet_out1d_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(output_1d) :: n2 = shape(output_1d,0)
    integer :: n3
    !f2py intent(hide), depend(dnet_out1d_dinput) :: n3 = shape(dnet_out1d_dinput,0)
    integer :: n4
    !f2py intent(hide), depend(dnet_out1d_dinput) :: n4 = shape(dnet_out1d_dinput,1)
    net_ptr = transfer(net, net_ptr)
    call evaluate_network(input=input, net=net_ptr%p, output_1d=output_1d, verbosityin=verbosityin, &
        dnet_out1d_dinput=dnet_out1d_dinput)
end subroutine f90wrap_evaluate_network

subroutine f90wrap_evaluate_layer(input, weights, biases, activation_func, output, verbosityin, doutput_dinput, n0, n1, &
    n2, n3, n4, n5, n6, n7, n8, n9)
    use qlknn_primitives, only: evaluate_layer
    implicit none
    
    real(8), intent(in), dimension(n0,n1) :: input
    real(8), intent(in), dimension(n2,n3) :: weights
    real(8), intent(in), dimension(n4) :: biases
    character(4), intent(in) :: activation_func
    real(8), intent(inout), dimension(n5,n6) :: output
    integer(8), optional, intent(in) :: verbosityin
    real(8), optional, intent(inout), dimension(n7,n8,n9) :: doutput_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(weights) :: n2 = shape(weights,0)
    integer :: n3
    !f2py intent(hide), depend(weights) :: n3 = shape(weights,1)
    integer :: n4
    !f2py intent(hide), depend(biases) :: n4 = shape(biases,0)
    integer :: n5
    !f2py intent(hide), depend(output) :: n5 = shape(output,0)
    integer :: n6
    !f2py intent(hide), depend(output) :: n6 = shape(output,1)
    integer :: n7
    !f2py intent(hide), depend(doutput_dinput) :: n7 = shape(doutput_dinput,0)
    integer :: n8
    !f2py intent(hide), depend(doutput_dinput) :: n8 = shape(doutput_dinput,1)
    integer :: n9
    !f2py intent(hide), depend(doutput_dinput) :: n9 = shape(doutput_dinput,2)
    call evaluate_layer(input=input, weights=weights, biases=biases, activation_func=activation_func, output=output, &
        verbosityin=verbosityin, doutput_dinput=doutput_dinput)
end subroutine f90wrap_evaluate_layer

subroutine f90wrap_impose_output_constraints(output, opts, verbosity, dnet_out_dinput, output_eb, n0, n1, n2, n3, n4, &
    n5, n6)
    use qlknn_types, only: qlknn_options
    use qlknn_primitives, only: impose_output_constraints
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    real(8), intent(inout), dimension(n0,n1) :: output
    type(qlknn_options_ptr_type) :: opts_ptr
    integer, intent(in), dimension(2) :: opts
    integer(8), intent(in) :: verbosity
    real(8), optional, intent(inout), dimension(n2,n3,n4) :: dnet_out_dinput
    real(8), optional, intent(inout), dimension(n5,n6) :: output_eb
    integer :: n0
    !f2py intent(hide), depend(output) :: n0 = shape(output,0)
    integer :: n1
    !f2py intent(hide), depend(output) :: n1 = shape(output,1)
    integer :: n2
    !f2py intent(hide), depend(dnet_out_dinput) :: n2 = shape(dnet_out_dinput,0)
    integer :: n3
    !f2py intent(hide), depend(dnet_out_dinput) :: n3 = shape(dnet_out_dinput,1)
    integer :: n4
    !f2py intent(hide), depend(dnet_out_dinput) :: n4 = shape(dnet_out_dinput,2)
    integer :: n5
    !f2py intent(hide), depend(output_eb) :: n5 = shape(output_eb,0)
    integer :: n6
    !f2py intent(hide), depend(output_eb) :: n6 = shape(output_eb,1)
    opts_ptr = transfer(opts, opts_ptr)
    call impose_output_constraints(output=output, opts=opts_ptr%p, verbosity=verbosity, dnet_out_dinput=dnet_out_dinput, &
        output_eb=output_eb)
end subroutine f90wrap_impose_output_constraints

subroutine f90wrap_apply_stability_clipping(leading_map, net_result, verbosity, n0, n1, n2, n3)
    use qlknn_primitives, only: apply_stability_clipping
    implicit none
    
    integer(8), intent(in), dimension(n0,n1) :: leading_map
    real(8), intent(inout), dimension(n2,n3) :: net_result
    integer(8), intent(in) :: verbosity
    integer :: n0
    !f2py intent(hide), depend(leading_map) :: n0 = shape(leading_map,0)
    integer :: n1
    !f2py intent(hide), depend(leading_map) :: n1 = shape(leading_map,1)
    integer :: n2
    !f2py intent(hide), depend(net_result) :: n2 = shape(net_result,0)
    integer :: n3
    !f2py intent(hide), depend(net_result) :: n3 = shape(net_result,1)
    call apply_stability_clipping(leading_map=leading_map, net_result=net_result, verbosity=verbosity)
end subroutine f90wrap_apply_stability_clipping

subroutine f90wrap_impose_leading_flux_constraints(leading_map, net_result, verbosity, dnet_out_dnet_in, net_eb, n0, n1, &
    n2, n3, n4, n5, n6, n7, n8)
    use qlknn_primitives, only: impose_leading_flux_constraints
    implicit none
    
    integer(8), intent(in), dimension(n0,n1) :: leading_map
    real(8), intent(inout), dimension(n2,n3) :: net_result
    integer(8), intent(in) :: verbosity
    real(8), optional, intent(inout), dimension(n4,n5,n6) :: dnet_out_dnet_in
    real(8), optional, intent(inout), dimension(n7,n8) :: net_eb
    integer :: n0
    !f2py intent(hide), depend(leading_map) :: n0 = shape(leading_map,0)
    integer :: n1
    !f2py intent(hide), depend(leading_map) :: n1 = shape(leading_map,1)
    integer :: n2
    !f2py intent(hide), depend(net_result) :: n2 = shape(net_result,0)
    integer :: n3
    !f2py intent(hide), depend(net_result) :: n3 = shape(net_result,1)
    integer :: n4
    !f2py intent(hide), depend(dnet_out_dnet_in) :: n4 = shape(dnet_out_dnet_in,0)
    integer :: n5
    !f2py intent(hide), depend(dnet_out_dnet_in) :: n5 = shape(dnet_out_dnet_in,1)
    integer :: n6
    !f2py intent(hide), depend(dnet_out_dnet_in) :: n6 = shape(dnet_out_dnet_in,2)
    integer :: n7
    !f2py intent(hide), depend(net_eb) :: n7 = shape(net_eb,0)
    integer :: n8
    !f2py intent(hide), depend(net_eb) :: n8 = shape(net_eb,1)
    call impose_leading_flux_constraints(leading_map=leading_map, net_result=net_result, verbosity=verbosity, &
        dnet_out_dnet_in=dnet_out_dnet_in, net_eb=net_eb)
end subroutine f90wrap_impose_leading_flux_constraints

subroutine f90wrap_multiply_div_networks(leading_map, net_result, verbosity, dqlknn_out_dinput, net_eb, n0, n1, n2, n3, &
    n4, n5, n6, n7, n8)
    use qlknn_primitives, only: multiply_div_networks
    implicit none
    
    integer(8), intent(in), dimension(n0,n1) :: leading_map
    real(8), intent(inout), dimension(n2,n3) :: net_result
    integer(8), intent(in) :: verbosity
    real(8), optional, intent(inout), dimension(n4,n5,n6) :: dqlknn_out_dinput
    real(8), optional, intent(inout), dimension(n7,n8) :: net_eb
    integer :: n0
    !f2py intent(hide), depend(leading_map) :: n0 = shape(leading_map,0)
    integer :: n1
    !f2py intent(hide), depend(leading_map) :: n1 = shape(leading_map,1)
    integer :: n2
    !f2py intent(hide), depend(net_result) :: n2 = shape(net_result,0)
    integer :: n3
    !f2py intent(hide), depend(net_result) :: n3 = shape(net_result,1)
    integer :: n4
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n4 = shape(dqlknn_out_dinput,0)
    integer :: n5
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n5 = shape(dqlknn_out_dinput,1)
    integer :: n6
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n6 = shape(dqlknn_out_dinput,2)
    integer :: n7
    !f2py intent(hide), depend(net_eb) :: n7 = shape(net_eb,0)
    integer :: n8
    !f2py intent(hide), depend(net_eb) :: n8 = shape(net_eb,1)
    call multiply_div_networks(leading_map=leading_map, net_result=net_result, verbosity=verbosity, &
        dqlknn_out_dinput=dqlknn_out_dinput, net_eb=net_eb)
end subroutine f90wrap_multiply_div_networks

subroutine f90wrap_merge_modes(merge_map, net_result, merged_net_result, verbosity, dqlknn_out_dinput, &
    dqlknn_out_merged_dinput, net_eb, merged_net_eb, n0, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11, n12, n13, n14, &
    n15)
    use qlknn_primitives, only: merge_modes
    implicit none
    
    integer(8), intent(in), dimension(n0,n1) :: merge_map
    real(8), intent(in), dimension(n2,n3) :: net_result
    real(8), intent(inout), dimension(n4,n5) :: merged_net_result
    integer(8), intent(in) :: verbosity
    real(8), optional, intent(in), dimension(n6,n7,n8) :: dqlknn_out_dinput
    real(8), optional, intent(inout), dimension(n9,n10,n11) :: dqlknn_out_merged_dinput
    real(8), optional, intent(in), dimension(n12,n13) :: net_eb
    real(8), optional, intent(inout), dimension(n14,n15) :: merged_net_eb
    integer :: n0
    !f2py intent(hide), depend(merge_map) :: n0 = shape(merge_map,0)
    integer :: n1
    !f2py intent(hide), depend(merge_map) :: n1 = shape(merge_map,1)
    integer :: n2
    !f2py intent(hide), depend(net_result) :: n2 = shape(net_result,0)
    integer :: n3
    !f2py intent(hide), depend(net_result) :: n3 = shape(net_result,1)
    integer :: n4
    !f2py intent(hide), depend(merged_net_result) :: n4 = shape(merged_net_result,0)
    integer :: n5
    !f2py intent(hide), depend(merged_net_result) :: n5 = shape(merged_net_result,1)
    integer :: n6
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n6 = shape(dqlknn_out_dinput,0)
    integer :: n7
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n7 = shape(dqlknn_out_dinput,1)
    integer :: n8
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n8 = shape(dqlknn_out_dinput,2)
    integer :: n9
    !f2py intent(hide), depend(dqlknn_out_merged_dinput) :: n9 = shape(dqlknn_out_merged_dinput,0)
    integer :: n10
    !f2py intent(hide), depend(dqlknn_out_merged_dinput) :: n10 = shape(dqlknn_out_merged_dinput,1)
    integer :: n11
    !f2py intent(hide), depend(dqlknn_out_merged_dinput) :: n11 = shape(dqlknn_out_merged_dinput,2)
    integer :: n12
    !f2py intent(hide), depend(net_eb) :: n12 = shape(net_eb,0)
    integer :: n13
    !f2py intent(hide), depend(net_eb) :: n13 = shape(net_eb,1)
    integer :: n14
    !f2py intent(hide), depend(merged_net_eb) :: n14 = shape(merged_net_eb,0)
    integer :: n15
    !f2py intent(hide), depend(merged_net_eb) :: n15 = shape(merged_net_eb,1)
    call merge_modes(merge_map=merge_map, net_result=net_result, merged_net_result=merged_net_result, verbosity=verbosity, &
        dqlknn_out_dinput=dqlknn_out_dinput, dqlknn_out_merged_dinput=dqlknn_out_merged_dinput, net_eb=net_eb, &
        merged_net_eb=merged_net_eb)
end subroutine f90wrap_merge_modes

subroutine f90wrap_merge_committee(net_result, n_members, merged_net_result, merged_net_eb, verbosity, &
    dqlknn_out_dinput, dqlknn_out_merged_dinput, n0, n1, n2, n3, n4, n5, n6, n7, n8, n9, n10, n11)
    use qlknn_primitives, only: merge_committee
    implicit none
    
    real(8), intent(in), dimension(n0,n1) :: net_result
    integer(8), intent(in) :: n_members
    real(8), intent(inout), dimension(n2,n3) :: merged_net_result
    real(8), intent(inout), dimension(n4,n5) :: merged_net_eb
    integer(8), intent(in) :: verbosity
    real(8), optional, intent(in), dimension(n6,n7,n8) :: dqlknn_out_dinput
    real(8), optional, intent(inout), dimension(n9,n10,n11) :: dqlknn_out_merged_dinput
    integer :: n0
    !f2py intent(hide), depend(net_result) :: n0 = shape(net_result,0)
    integer :: n1
    !f2py intent(hide), depend(net_result) :: n1 = shape(net_result,1)
    integer :: n2
    !f2py intent(hide), depend(merged_net_result) :: n2 = shape(merged_net_result,0)
    integer :: n3
    !f2py intent(hide), depend(merged_net_result) :: n3 = shape(merged_net_result,1)
    integer :: n4
    !f2py intent(hide), depend(merged_net_eb) :: n4 = shape(merged_net_eb,0)
    integer :: n5
    !f2py intent(hide), depend(merged_net_eb) :: n5 = shape(merged_net_eb,1)
    integer :: n6
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n6 = shape(dqlknn_out_dinput,0)
    integer :: n7
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n7 = shape(dqlknn_out_dinput,1)
    integer :: n8
    !f2py intent(hide), depend(dqlknn_out_dinput) :: n8 = shape(dqlknn_out_dinput,2)
    integer :: n9
    !f2py intent(hide), depend(dqlknn_out_merged_dinput) :: n9 = shape(dqlknn_out_merged_dinput,0)
    integer :: n10
    !f2py intent(hide), depend(dqlknn_out_merged_dinput) :: n10 = shape(dqlknn_out_merged_dinput,1)
    integer :: n11
    !f2py intent(hide), depend(dqlknn_out_merged_dinput) :: n11 = shape(dqlknn_out_merged_dinput,2)
    call merge_committee(net_result=net_result, n_members=n_members, merged_net_result=merged_net_result, &
        merged_net_eb=merged_net_eb, verbosity=verbosity, dqlknn_out_dinput=dqlknn_out_dinput, &
        dqlknn_out_merged_dinput=dqlknn_out_merged_dinput)
end subroutine f90wrap_merge_committee

subroutine f90wrap_matr_mult_elemwise(n, a, b, y, n0, n1, n2, n3, n4, n5)
    use qlknn_primitives, only: matr_mult_elemwise
    implicit none
    
    integer(8), intent(in) :: n
    real(8), intent(in), dimension(n0,n1) :: a
    real(8), intent(in), dimension(n2,n3) :: b
    real(8), intent(inout), dimension(n4,n5) :: y
    integer :: n0
    !f2py intent(hide), depend(a) :: n0 = shape(a,0)
    integer :: n1
    !f2py intent(hide), depend(a) :: n1 = shape(a,1)
    integer :: n2
    !f2py intent(hide), depend(b) :: n2 = shape(b,0)
    integer :: n3
    !f2py intent(hide), depend(b) :: n3 = shape(b,1)
    integer :: n4
    !f2py intent(hide), depend(y) :: n4 = shape(y,0)
    integer :: n5
    !f2py intent(hide), depend(y) :: n5 = shape(y,1)
    call matr_mult_elemwise(n=n, a=a, b=b, y=y)
end subroutine f90wrap_matr_mult_elemwise

subroutine f90wrap_matr_vec_mult_elemwise(n, a, b, y, n0, n1, n2, n3, n4)
    use qlknn_primitives, only: matr_vec_mult_elemwise
    implicit none
    
    integer(8), intent(in) :: n
    real(8), intent(in), dimension(n0,n1) :: a
    real(8), intent(in), dimension(n2) :: b
    real(8), intent(inout), dimension(n3,n4) :: y
    integer :: n0
    !f2py intent(hide), depend(a) :: n0 = shape(a,0)
    integer :: n1
    !f2py intent(hide), depend(a) :: n1 = shape(a,1)
    integer :: n2
    !f2py intent(hide), depend(b) :: n2 = shape(b,0)
    integer :: n3
    !f2py intent(hide), depend(y) :: n3 = shape(y,0)
    integer :: n4
    !f2py intent(hide), depend(y) :: n4 = shape(y,1)
    call matr_vec_mult_elemwise(n=n, a=a, b=b, y=y)
end subroutine f90wrap_matr_vec_mult_elemwise

subroutine f90wrap_vdmul(n, a, b, y, n0, n1, n2)
    use qlknn_primitives, only: vdmul
    implicit none
    
    integer(8), intent(in) :: n
    real(8), intent(in), dimension(n0) :: a
    real(8), intent(in), dimension(n1) :: b
    real(8), intent(inout), dimension(n2) :: y
    integer :: n0
    !f2py intent(hide), depend(a) :: n0 = shape(a,0)
    integer :: n1
    !f2py intent(hide), depend(b) :: n1 = shape(b,0)
    integer :: n2
    !f2py intent(hide), depend(y) :: n2 = shape(y,0)
    call vdmul(n=n, a=a, b=b, y=y)
end subroutine f90wrap_vdmul

subroutine f90wrap_dgemm(transa, transb, m, n, k, alpha, a, lda, b, ldb, beta, c, ldc, n0, n1, n2, n3, n4, n5)
    use qlknn_primitives, only: dgemm
    implicit none
    
    character(1), intent(in) :: transa
    character(1), intent(in) :: transb
    integer(8), intent(in) :: m
    integer(8), intent(in) :: n
    integer(8), intent(in) :: k
    real(8), intent(in) :: alpha
    real(8), intent(in), dimension(n0,n1) :: a
    integer(8), intent(in) :: lda
    real(8), intent(in), dimension(n2,n3) :: b
    integer(8), intent(in) :: ldb
    real(8), intent(in) :: beta
    real(8), intent(inout), dimension(n4,n5) :: c
    integer(8), intent(in) :: ldc
    integer :: n0
    !f2py intent(hide), depend(a) :: n0 = shape(a,0)
    integer :: n1
    !f2py intent(hide), depend(a) :: n1 = shape(a,1)
    integer :: n2
    !f2py intent(hide), depend(b) :: n2 = shape(b,0)
    integer :: n3
    !f2py intent(hide), depend(b) :: n3 = shape(b,1)
    integer :: n4
    !f2py intent(hide), depend(c) :: n4 = shape(c,0)
    integer :: n5
    !f2py intent(hide), depend(c) :: n5 = shape(c,1)
    call dgemm(transa=transa, transb=transb, m=m, n=n, k=k, alpha=alpha, a=a, lda=lda, b=b, ldb=ldb, beta=beta, c=c, &
        ldc=ldc)
end subroutine f90wrap_dgemm

subroutine f90wrap_vdtanh(n, a, y, n0, n1, n2, n3)
    use qlknn_primitives, only: vdtanh
    implicit none
    
    integer(8), intent(in) :: n
    real(8), intent(in), dimension(n0,n1) :: a
    real(8), intent(inout), dimension(n2,n3) :: y
    integer :: n0
    !f2py intent(hide), depend(a) :: n0 = shape(a,0)
    integer :: n1
    !f2py intent(hide), depend(a) :: n1 = shape(a,1)
    integer :: n2
    !f2py intent(hide), depend(y) :: n2 = shape(y,0)
    integer :: n3
    !f2py intent(hide), depend(y) :: n3 = shape(y,1)
    call vdtanh(n=n, a=a, y=y)
end subroutine f90wrap_vdtanh

subroutine f90wrap_relu(n, a, y, n0, n1)
    use qlknn_primitives, only: relu
    implicit none
    
    integer(8), intent(in) :: n
    real(8), intent(in), dimension(n0) :: a
    real(8), intent(inout), dimension(n1) :: y
    integer :: n0
    !f2py intent(hide), depend(a) :: n0 = shape(a,0)
    integer :: n1
    !f2py intent(hide), depend(y) :: n1 = shape(y,0)
    call relu(n=n, a=a, y=y)
end subroutine f90wrap_relu

subroutine f90wrap_calc_length_lli(start, end, step, length)
    use qlknn_primitives, only: calc_length_lli
    implicit none
    
    integer(8), intent(in) :: start
    integer(8), intent(in) :: end
    integer(8), intent(in) :: step
    integer(8), intent(out) :: length
    call calc_length_lli(start=start, end=end, step=step, length=length)
end subroutine f90wrap_calc_length_lli

subroutine f90wrap_calc_length_li(start, end, step, length)
    use qlknn_primitives, only: calc_length_li
    implicit none
    
    integer(4), intent(in) :: start
    integer(4), intent(in) :: end
    integer(4), intent(in) :: step
    integer(4), intent(out) :: length
    call calc_length_li(start=start, end=end, step=step, length=length)
end subroutine f90wrap_calc_length_li

subroutine f90wrap_calc_length_mixed1(start, end, step, length)
    use qlknn_primitives, only: calc_length_mixed1
    implicit none
    
    integer(4), intent(in) :: start
    integer(8), intent(in) :: end
    integer(4), intent(in) :: step
    integer(4), intent(out) :: length
    call calc_length_mixed1(start=start, end=end, step=step, length=length)
end subroutine f90wrap_calc_length_mixed1

subroutine f90wrap_calc_length_mixed2(start, end, step, length)
    use qlknn_primitives, only: calc_length_mixed2
    implicit none
    
    integer(4), intent(in) :: start
    integer(8), intent(in) :: end
    integer(8), intent(in) :: step
    integer(4), intent(out) :: length
    call calc_length_mixed2(start=start, end=end, step=step, length=length)
end subroutine f90wrap_calc_length_mixed2

subroutine f90wrap_double_1d_0d_is_not_close(arr1, arr2, is_not_close, boundin, n0, n1)
    use qlknn_primitives, only: double_1d_0d_is_not_close
    implicit none
    
    real(8), intent(in), dimension(n0) :: arr1
    real(8), intent(in) :: arr2
    logical, intent(inout), dimension(n1) :: is_not_close
    real(8), intent(in), optional :: boundin
    integer :: n0
    !f2py intent(hide), depend(arr1) :: n0 = shape(arr1,0)
    integer :: n1
    !f2py intent(hide), depend(is_not_close) :: n1 = shape(is_not_close,0)
    call double_1d_0d_is_not_close(arr1=arr1, arr2=arr2, is_not_close=is_not_close, boundin=boundin)
end subroutine f90wrap_double_1d_0d_is_not_close

subroutine f90wrap_double_1d_1d_is_not_close(arr1, arr2, is_not_close, boundin, n0, n1, n2)
    use qlknn_primitives, only: double_1d_1d_is_not_close
    implicit none
    
    real(8), intent(in), dimension(n0) :: arr1
    real(8), intent(in), dimension(n1) :: arr2
    logical, intent(inout), dimension(n2) :: is_not_close
    real(8), intent(in), optional :: boundin
    integer :: n0
    !f2py intent(hide), depend(arr1) :: n0 = shape(arr1,0)
    integer :: n1
    !f2py intent(hide), depend(arr2) :: n1 = shape(arr2,0)
    integer :: n2
    !f2py intent(hide), depend(is_not_close) :: n2 = shape(is_not_close,0)
    call double_1d_1d_is_not_close(arr1=arr1, arr2=arr2, is_not_close=is_not_close, boundin=boundin)
end subroutine f90wrap_double_1d_1d_is_not_close

subroutine f90wrap_double_2d_2d_is_not_close(arr1, arr2, is_not_close, boundin, n0, n1, n2, n3, n4, n5)
    use qlknn_primitives, only: double_2d_2d_is_not_close
    implicit none
    
    real(8), intent(in), dimension(n0,n1) :: arr1
    real(8), intent(in), dimension(n2,n3) :: arr2
    logical, intent(inout), dimension(n4,n5) :: is_not_close
    real(8), intent(in), optional :: boundin
    integer :: n0
    !f2py intent(hide), depend(arr1) :: n0 = shape(arr1,0)
    integer :: n1
    !f2py intent(hide), depend(arr1) :: n1 = shape(arr1,1)
    integer :: n2
    !f2py intent(hide), depend(arr2) :: n2 = shape(arr2,0)
    integer :: n3
    !f2py intent(hide), depend(arr2) :: n3 = shape(arr2,1)
    integer :: n4
    !f2py intent(hide), depend(is_not_close) :: n4 = shape(is_not_close,0)
    integer :: n5
    !f2py intent(hide), depend(is_not_close) :: n5 = shape(is_not_close,1)
    call double_2d_2d_is_not_close(arr1=arr1, arr2=arr2, is_not_close=is_not_close, boundin=boundin)
end subroutine f90wrap_double_2d_2d_is_not_close

! End of module qlknn_primitives defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_primitives.f90

program karel_standalone
  use karel_model, only: predict_transport
  use karel_types, only: karel_dp
  implicit none

  integer :: n_rho
  integer :: ii
  integer :: verbosity
  real(karel_dp), dimension(:), allocatable :: rhotorn, te, ti
  real(karel_dp), dimension(:,:), allocatable :: plasma_state
  real(karel_dp), dimension(:,:), allocatable :: transport_prediction

  print *, 'Running binary karel_standalone'

  ! Define the plasma state.
  n_rho = 24
  allocate(rhotorn(n_rho), te(n_rho), ti(n_rho))
  rhotorn(:) = (/ (real(ii, karel_dp)/(n_rho-1), ii=0, n_rho) /)
  te = 8 ! keV
  ti = 8 ! keV

  allocate(plasma_state(24, 3))
  plasma_state(:, 1) = rhotorn
  plasma_state(:, 2) = te
  plasma_state(:, 3) = ti

  verbosity = 1
  ! Optionally print plasma state
  if (verbosity >= 1) then
    print *, 'Plasma state is: [rhotorn, te, ti]'
    do ii = 1, n_rho
      print *, plasma_state(ii, :)
    enddo
  endif

  ! Get transport prediction
  call predict_transport(plasma_state, transport_prediction)

  ! Optionally report result to user
  if (verbosity >= 1) then
    print *, 'Transport result is: [chi_e, chi_i, Gamma_e]'
    do ii = 1, n_rho
      print *, transport_prediction(ii, :)
    enddo
  endif

  print *, 'Done running binary karel_standalone'

end program karel_standalone

!
! To compile:
!
!   Pre-processor now required:
!   /opt/local/bin/gfortran-mp-4.8 -cpp kinds.f90 cla.f90 cla_test.f90 -o cla_test
!
! To run:
!   ./cla_test -h                             : -h is a command line flag
!   ./cla_test --jello 999                    : --jello is long form key, matched with value 999
!   ./cla_test --jello=999                    : --jello is long form key, matched with value 999, alternate syntax
!   ./cla_test -j 999                         : -j is short form key, matched with value 999
!
! Copyright (c) 2015 Edward D. Zaron, Portland, Oregon, USA
!
! Permission is hereby granted, free of charge, to any person obtaining a copy of this
! software and associated documentation files (the "Software"), to deal in the Software
! without restriction, including without limitation the rights to use, copy, modify, merge,
! publish, distribute, sublicense, and/or sell copies of the Software, and to permit
! persons to whom the Software is furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in all copies or
! substantial portions of the Software.
!
! Except as contained in this notice, the name(s) of the above copyright holders shall not
! be used in advertising or otherwise to promote the sale, use or other dealings in this
! Software without prior written authorization.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
! INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
! PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
! FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
! OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
! DEALINGS IN THE SOFTWARE.
!

  program cla_test

    use kinds
    use cla

    implicit none
    character(len=STRLEN)  :: shortkey
    character(len=STRLEN)  :: longkey
    character(len=XSTRLEN) :: description
    integer(kind=int_kind) :: kkind
    character(len=STRLEN)  :: default

    integer(kind=int_kind) :: i
    integer(kind=8)        :: j, jello
    real(kind=real_kind)   :: x
    real(kind=4)           :: y4
    real(kind=8)           :: y8, arg4
    character(len=STRLEN)  :: a
    !character(len=XSTRLEN) :: b
    logical                :: l, ll, arg1, f, s
    character(len=STRLEN)  :: arg2, arg3

    ! Test using command line arguments:
    call cla_init
    
    ! Register your keys for key/value pairs.
    ! EACH KEY MUST BEGIN WITH -
    ! (long form, maybe more readable)
    shortkey    = '-i'
    longkey     = '--integer'
    description = 'an integer parameter'
    kkind       = cla_int
    default     = '0'
    call cla_register(shortkey,longkey,description,kkind,default)
    ! (compact form)
    call cla_register('-j',  '--jello',               'another int',     cla_int,'72')
    call cla_register('-x', '--xcrypt',                      'real',   cla_float,'3.14159')
    call cla_register('-y', '--yellow', 'a real for testing r4, r8',   cla_float,'3.14159')
    call cla_register('-a', '--author',                       'str',    cla_char,'Ed Zaron')
    call cla_register('-f','--theflag',                    'a flag',    cla_flag,'f')
    call cla_register('-s', '--second',              'another flag',    cla_flag,'f')    
    call cla_register('-l','--logical',                      'bool', cla_logical,'t')

    ! Register positional parameters in the order they appear on the
    ! command line.
    call cla_posarg_register('arg1', 'first positional',  cla_logical,'t')    
    call cla_posarg_register('arg2', 'second positional',  cla_char,'Eli S')  
    call cla_posarg_register('arg3', 'third positional',  cla_char,'posthree') 
    call cla_posarg_register('arg4', 'fourth positional',  cla_float,'3.14159265358') 
    
    ! These can be called in any order:
    print *,'*********************************************************'
    print *,'Calling cla_help:'
    call cla_help("cla_test")
    print *,'-------> Returned from cla_help.'
    print *,'*********************************************************'

    print *,'*********************************************************'
    print *,'Calling cla_show:'
    call cla_show
    print *,'-------> Returned from cla_show.'
    print *,'*********************************************************'

    print *,'*********************************************************'
    print *,'Calling cla_validate:'
    call cla_validate("cla_test")
    print *,'-------> Returned from cla_validate.'
    print *,'*********************************************************'
    stop
    
    ! Test to see if the --jello key is present using short and long key:
    ll = cla_key_present('--jello')
    if (ll) then
       print *,' --jello is present'
    else
       print *,' --jello is not present'
    endif

    ll = cla_key_present('-j')
    if (ll) then
       print *,' -j is present'
    else
       print *,' -j is not present'
    endif    
    
    ! Test to see if the -f flag is present:
    ll = cla_key_present('-f')
    if (ll) then
       print *,' -f is present'
    else
       print *,' -f is not present'
    endif

    ll = cla_key_present('-s')
    if (ll) then
       print *,' -s is present'
    else
       print *,' -s is not present'
    endif

    print*,"***********************"
    ! Get values:
    call cla_get('-i',i)
    call cla_get('-j',j)
    call cla_get('--jello',jello)
    call cla_get('-x',x)
    call cla_get('-y',y4)
    call cla_get('-y',y8)
    call cla_get('-a',a)
    ! call cla_get_xchar('-b',b) ! Looks like extended character strings not implemented.
    call cla_get('-l',l)
    call cla_get('-f',f)
    call cla_get('-s',s)
    print*,"***********************"
    ! Code crashes if no positional arguments are present --> fixed
    print*,"Get positional arguments"
    call cla_get('arg1',arg1)
    call cla_get('arg2',arg2)
    call cla_get('arg3',arg3)
    call cla_get('arg4',arg4)
    print*,"***********************"
    
    print *,'After processing command line arguments:'
    print *,' i     = ',i
    print *,' j     = ',j,' should equal jello:'
    print *,' jello = ',jello
    print *,' x     = ',x
    print *,' y (r4)= ',y4
    print *,' y (r8)= ',y8
    print *,' a     = ',trim(a)
    print *,' l     = ',l
    print *,' f     = ',f
    print *,' s     = ',s    
    print *,' arg1  = ',arg1
    print *,' arg2  = ',arg2
    print *,' arg3  = ',arg3
    print *,' arg4  = ',arg4    
  end program cla_test

!
! Copyright (c) 2015 Edward D. Zaron, Portland, Oregon, USA
!
! Permission is hereby granted, free of charge, to any person obtaining a copy of this
! software and associated documentation files (the "Software"), to deal in the Software
! without restriction, including without limitation the rights to use, copy, modify, merge,
! publish, distribute, sublicense, and/or sell copies of the Software, and to permit
! persons to whom the Software is furnished to do so, subject to the following conditions:
!
! The above copyright notice and this permission notice shall be included in all copies or
! substantial portions of the Software.
!
! Except as contained in this notice, the name(s) of the above copyright holders shall not
! be used in advertising or otherwise to promote the sale, use or other dealings in this
! Software without prior written authorization.
!
! THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
! INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
! PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE
! FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
! OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
! DEALINGS IN THE SOFTWARE.
!

module kinds
  implicit none
  
  integer(kind=4), public, parameter :: int_kind = 4
  integer(kind=4), public, parameter :: real_kind = 4
  integer(kind=4), public, parameter :: ptr_kind = 8
  
  integer(kind=4), public, parameter :: STRLEN = 4096
  integer(kind=4), public, parameter :: XSTRLEN = 4096
  
end module kinds

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module teardown_mpi
  use qlknn_types
#ifdef MPI
  use mpi
#endif
contains
  subroutine teardown
#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) my_world_rank
#else
    integer(li) my_world_rank
#endif
#ifdef MPI
#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) mpi_ierr, world_size
#else
    integer(li) mpi_ierr, world_size
#endif
#endif

#ifdef MPI
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
#else
    my_world_rank = 0
#endif
    write(*, '(A, I3)') 'Byebye from rank ', int(my_world_rank, li)

#ifdef MPI
    call MPI_FINALIZE(mpi_ierr)
#endif

  end subroutine teardown
end module teardown_mpi

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_error_filter
#include "preprocessor.inc"
    use qlknn_types
    use qlknn_primitives

    ! This file should contain the acceptable variance thresholds for committee NNs
    ! Also provides the function required to evaluate and return pass/fail
    implicit none

contains

    subroutine determine_validity_with_eb(abs_limits, rel_limits, net_out, net_eb, validity, verbosity, mask)
        !! This program is meant to accept direct outputs from committee NNs, without additional processing
        !! First dimension is radial points
        !! Second dimension is the individual networks
        real(qlknn_dp), dimension(:), intent(in) :: abs_limits, rel_limits
        real(qlknn_dp), dimension(:,:), intent(in) :: net_out, net_eb
        integer(lli), intent(in) :: verbosity
        !logical(qlknn_bool), dimension(:), optional, intent(in) :: mask
        logical, dimension(:), optional, intent(in) :: mask

        !logical(qlknn_bool), dimension(:,:), intent(out) :: validity
        logical, dimension(:,:), intent(out) :: validity

        integer(lli) :: n_rho, ii
        !logical(qlknn_bool), dimension(:), allocatable :: rel_result
        logical, dimension(:), allocatable :: rel_result
        logical, dimension(:), allocatable :: is_nonzero

        ERRORSTOP(.not. all(shape(net_out) .eq. shape(net_eb)), 'NN outputs not same size as NN errors')
        ERRORSTOP(size(abs_limits) .ne. size(net_eb, 2), 'NN absolute limits not same size as NN vector')
        ERRORSTOP(size(rel_limits) .ne. size(net_eb, 2), 'NN relative limits not same size as NN vector')
        if (present(mask)) then
            ERRORSTOP(size(mask) .ne. size(net_eb, 2), 'NN mask not same size as NN error vector')
        endif

        if (verbosity >= 3) then
            write(*,*) 'Determining validity of NN on input space'
        endif

        n_rho = size(net_eb, 1)
        allocate(rel_result(size(net_eb,2)))
        allocate(is_nonzero(size(net_eb,2)))
        validity = .true.
        do ii = 1, n_rho
            rel_result = .true.
            call is_not_close(net_out(ii,:), 0._qlknn_dp, is_nonzero)
            where (is_nonzero) rel_result = net_eb(ii,:) <= (rel_limits * net_out(ii,:))
            validity(ii,:) = (net_eb(ii,:) <= abs_limits) .or. rel_result
            if (present(mask)) then
                where (mask .eqv. .false.) validity(ii,:) = .true.
            end if
        enddo
        deallocate(rel_result)
    end subroutine determine_validity_with_eb


    subroutine determine_validity_multiplied_networks(leading_map, validity, verbosity)
      !! Determines validity of post-multiplication results by applying
      !! logical .and. to validity of pre-multiplication networks

      integer(lli), dimension(:,:), intent(in) :: leading_map
      !! Map with 3 columns representing ETG, TEM, and ITG. The first row
      !! contains the indices of net_result containing the leading flux and
      !! the other rows containing non-leading flux indices padded with 0's
      !logical(qlknn_bool), dimension(:,:), intent(inout):: validity
      logical, dimension(:,:), intent(inout):: validity
      integer(lli), intent(in) :: verbosity
      !! Verbosity of this function
      integer(lli) :: ii, jj, idx, n_rho, leading_ITG, leading_TEM

      if (verbosity >= 3) then
        write(*,*) 'Determining validity of multiplied div results'
      endif

      leading_TEM = leading_map(1, 2)
      leading_ITG = leading_map(1, 3)
      n_rho = size(validity, 1)
      do ii = 2, size(leading_map,1)
        idx = leading_map(ii, 3)
        if (idx == 0) then
          cycle
        endif
        do jj = 1, n_rho
          validity(jj,idx) = validity(jj,idx) .and. validity(jj,leading_ITG)
        enddo
      enddo
      do ii = 2, size(leading_map,1)
        idx = leading_map(ii, 2)
        if (idx == 0) then
          cycle
        endif
        do jj = 1, n_rho
          validity(jj,idx) = validity(jj,idx) .and. validity(jj,leading_TEM)
        enddo
      enddo
    end subroutine determine_validity_multiplied_networks


    subroutine determine_validity_merged_modes(merge_map, validity, merged_validity, verbosity)
      !! Determine validity after merging columns of the same variable and same mode together
      !! by applying logical .and. to the individual validity flags

      integer(lli), dimension(:,:), intent(in) :: merge_map
      !! Map with the columns to be merged together. Each column of the map
      !! represents the column of merged_net_result the result will be stored
      !! in. Each index in the column, padded with 0's, will be merged together
      !logical(qlknn_bool), dimension(:,:), intent(in):: validity
      logical, dimension(:,:), intent(in):: validity
      !! The original to-be-merged data
      !logical(qlknn_bool), dimension(:,:), intent(out) :: merged_validity
      logical, dimension(:,:), intent(out) :: merged_validity
      !! The merged togethed data
      integer(lli), intent(in) :: verbosity
      integer(lli) :: n_rho, n_merged_out, ii, jj
      integer(lli), dimension(:), allocatable :: map

      if (verbosity >= 3) then
        write(*,*) 'Determining validity of merged modes'
      endif

      ERRORSTOP(.not. size(merge_map, 1) == size(merged_validity, 2),'Merge map n_rows different than merged result n_cols')

      n_rho = size(validity, 1)
      n_merged_out = size(merged_validity, 2)
      do ii = 1, n_rho
        do jj = 1, n_merged_out
          allocate(map(count(merge_map(jj, :) /= 0)))
          map = pack(merge_map(jj, :), merge_map(jj, :) /= 0)
          merged_validity(ii, jj) = all(validity(ii, map))
          deallocate(map)
        enddo
      enddo
    end subroutine determine_validity_merged_modes

end module qlknn_error_filter

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
program qlknn_hyper
#include "core/preprocessor.inc"
  use cla
  use kinds
  use qlknn_types
  use qlknn_disk_io
  use test_jacobian

  use ieee_arithmetic
  implicit none
  integer(lli) :: verbosity, n_rho, n_in, n_out
  real(qlknn_dp), dimension(:,:), allocatable :: input
  real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput
  character(len=4096) :: nn_path = '', input_path = '', output_path = ''
  character(len=23) :: cmd_name = 'qlknn_jacobian_test_cli'
  character(len=STRLEN) :: key, arg
  logical :: dump_to_disk

  logical, dimension(:,:,:), allocatable :: err_okay
  real(qlknn_dp) :: max_err

  real(qlknn_dp) :: stepsize
  real(qlknn_dp), dimension(:,:,:), allocatable :: err_out
  integer(lli) :: net
  character(len=4096) :: nettype = ''
  integer :: casenum

  namelist /sizes/ n_rho, n_in
  namelist /test/ input
  namelist /outp_sizes/ n_rho, n_in, n_out
  namelist /outp/ err_out
  namelist /outp_jacobian/ dqlknn_out_dinput

  ! Command line argument parsing
  call cla_init


  call cla_register('-n', '--nn-path', 'Path to NN namelist folder', cla_char, '')
  call cla_register('-i', '--input', 'Path to input namelist file', cla_char, 'tests/test.nml')
  call cla_register('-o', '--output', 'Path to output namelist file', cla_char, 'tests/output.nml')
  call cla_register('-t', '--nettype', 'Type of the NN to run', cla_char, 'hyper')
  call cla_register('-c', '--casenum', 'Number of the testcase to run', cla_int, '1')
  call cla_register('-s', '--stepsize', 'Size of the step to be taken for Jacobian test', cla_float, 'NaN')
  call cla_register('-e', '--maxerr', 'Maximum error that constitutes a failed test"', cla_float, 'NaN')
  call cla_register('-d', '--dump-to-disk', 'Dump output to disk', cla_flag, 'f')
  call cla_register('-v', '--verbosity', 'Set verbosity', cla_int, '1')

  ! Look for help-like arguments
  call cla_get_command_argument(1, arg)
  key = trim(arg)
  if (cla_str_eq(trim(key),'-h')      .or. &
      cla_str_eq(trim(key),'-?')      .or. &
      cla_str_eq(trim(key),'/?')      .or. &
      cla_str_eq(trim(key),'-H')      .or. &
      cla_str_eq(trim(key),'help')    .or. &
      cla_str_eq(trim(key),'-help')   .or. &
      cla_str_eq(trim(key),'--help')  .or. &
      cla_str_eq(trim(key),'--usage')      &
      ) then
     call cla_help(cmd_name)
     stop
  endif

  !call cla_validate(cmd_name)

  call cla_get('--nn-path', nn_path)
  call cla_get('--input', input_path)
  call cla_get('--output', output_path)
  call cla_get('--nettype', nettype)
  call cla_get('--casenum', casenum)
  call cla_get('--stepsize', stepsize)
  call cla_get('--maxerr', max_err)
  call cla_get('--verbosity', verbosity)

  ! Read input namelist
  if (verbosity >= 1) then
    write(*,*) "Reading input path ", trim(input_path)
  endif
  open(10,file=input_path,action='READ')
  read(10,nml=sizes)
  allocate(input(n_in, n_rho))
  read(10,nml=test)
  close(10)
  if (verbosity >= 1) then
    write(*,"(A,I3,A,I3,A)") "Input is (n_in, rho)=(",n_in, ",", n_rho, ")"
  endif
  dump_to_disk = .true.

  if (trim(nettype) == "hyper") then
    if (nn_path == '') then
      nn_path = 'data/qlknn-hyper-namelists'
    endif
    if (.not. allocated(nets%nets)) then
      call load_qlknn_hyper_nets_from_disk(nn_path, verbosity - 1)
    endif
  elseif (trim(nettype) == "hornnet") then
    if (nn_path == '') then
      nn_path = 'data/qlknn-hornnet-namelists'
    endif
    if (.not. allocated(blocks%input_blocks)) then
      call load_hornnet_nets_from_disk(nn_path, verbosity - 1)
    endif
  else
    ERRORSTOP(.true., "Given --nettype not defined yet")
  endif

  if (ieee_is_nan(stepsize)) then
    ! The user didn't give it on the command line, grab defaults
    if (trim(nettype) == "hyper") then
      stepsize = stepsize_hyper
    elseif (trim(nettype) == "hornnet") then
      stepsize = stepsize_hornnet
    endif
  endif
  if (verbosity >= 0) then
    write(*,"(A,A,A,I2,A,E9.2)") "Running nettype '", trim(nettype), "', casenum=", casenum, " and stepsize h=", stepsize
  endif

  net = 4
  if (trim(nettype) == "hyper") then
    call jacobian_hyper_multi(casenum, input, stepsize, net, err_out, verbosity - 1)
  elseif (trim(nettype) == "hornnet") then
    call jacobian_hornnet_multi(casenum, input, stepsize, err_out, verbosity - 1)
  endif

  n_out = size(err_out, 1)
  n_rho = size(err_out, 2)
  n_in = size(err_out, 3)

  if (ieee_is_nan(max_err)) then
    ! The user didn't give it on the command line, grab defaults
    if (trim(nettype) == "hyper") then
      max_err = max_err_hyper(casenum)
    elseif (trim(nettype) == "hornnet") then
      max_err = max_err_hornnet(casenum)
    endif
  endif
  call passed_test(err_out, max_err, err_okay, verbosity)
  if (verbosity >= 0) then
    write(*,"(A,E9.2)") "Maximum error was ", maxval(abs(err_out))
  endif

  if (dump_to_disk) then
    if (verbosity >= 1) then
      write(*,"(A,A)") "Writing to ", trim(output_path)
    endif
    open(10,file=output_path,action='WRITE')
    write(10,nml=outp_sizes)
    write(10,nml=outp)
    close(10)
  endif

  if (trim(nettype) == "hyper") then
    call all_networktype_deallocate(nets)
  elseif (trim(nettype) == "hornnet") then
  endif

end program qlknn_hyper

module karel_model
  use karel_types
  use daan_correction
  !! Contains library implementation of the 'Karel model'.
  !! Always predicts the right transport, not matter what, within
  !! error margins. If this model does not predict experimental
  !! data well, please increase your error bars on any analysis you do.
contains
  subroutine predict_transport(plasma_state, transport_output)
    real(karel_dp), dimension(:,:), intent(in) :: plasma_state
    !! The state of the plasma, represented as a 2D array karel_model
    !! will use fancy machine learning based techniques to determine
    !! what the given array represents
    real(karel_dp), dimension(:,:), allocatable, intent(out) :: transport_output
    !! The transport prediction. Returns as columns \(\chi_e\), \(\chi_i\),
    !! and \(\Gamma_e\). By analysing the input, this prediction is valid
    !! in all geometries and coordinate systems
    integer n_rho

    ! Use fancy "garbage in-garbage out" detection algorithm to determine
    ! plasma state unequivocally
    n_rho = size(plasma_state, 1)

    ! Allocate memory to store transport prediction
    allocate(transport_output(n_rho, 3))

    ! Use Karel et al. model to predict transport fluxes. Via our machine learning
    ! We have determined that the user always wants [chi_e, chi_i, Gamma_e] back
    transport_output(:, 1) = 1
    transport_output(:, 2) = 1
    transport_output(:, 3) = 0.1

    call correct_transport_prediction(transport_output)
  end subroutine predict_transport
end module karel_model

!
!   Edward D. Zaron
!    ezaron@pdx.edu
!   
module cla

  use kinds
#ifdef f2003
  use, intrinsic :: iso_fortran_env, only : &
       input_unit  => stdin, &
       output_unit => stdout, &
       error_unit  => stderr
#else
#define stdin  5
#define stdout 6
#define stderr 0
#endif
  
  implicit none

  ! Command Line Arguments
  ! A key-value parser for the commandline

  integer(kind=int_kind), parameter :: &
       cla_int   = 1, &
       cla_float = 2, &
       cla_char  = 3, &
       cla_xchar = 4, & ! NOT IMPLEMENTED
       cla_logical=5, &
       cla_flag  = 6

  ! Optionally, these routines can parse a string contaning arguments, cla_cla,
  ! rather than the command line arguments.
  integer(kind=int_kind), parameter, private :: CLALEN=1024
  character(len=CLALEN), private  :: cla_cla
  integer(kind=int_kind), private :: cla_cla_len
  
  character(len=STRLEN), dimension(6) :: cla_kindstr
  character(len=STRLEN), private :: cla_empty
  character(len=STRLEN), dimension(6) :: cla_true_str
 
  type, private :: cla_t
     character(len=2)  :: key
     character(len=STRLEN)  :: longkey 
     character(len=XSTRLEN) :: description
     integer(kind=int_kind) :: kind
     character(len=STRLEN)  :: default
  end type cla_t

  type, private :: cla_posarg_t
     character(len=STRLEN)  :: key
     character(len=XSTRLEN) :: description
     integer(kind=int_kind) :: kind
     character(len=STRLEN)  :: default     
  end type cla_posarg_t
  
  
  type(cla_t), private, dimension(:), pointer :: cla_registry
  type(cla_posarg_t), private, dimension(:), pointer :: cla_posarg_registry
  
  
  integer(kind=int_kind), private :: cla_num
  integer(kind=int_kind), private :: cla_posarg_num  

  interface cla_init
     module procedure &
          cla_init_default, & ! no input parameters ==> read and parse the command line
          cla_init_str        ! string input parameter ==> read and parse the string instead of the command line
  end interface cla_init
     
  interface cla_get
     module procedure &
          cla_get_float_r4, &
          cla_get_float_r8, &
          cla_get_int_i4, &
          cla_get_int_i8, &
          cla_get_char, &
          cla_get_logical
  end interface

  contains

    integer(kind=int_kind) function cla_command_argument_count()
      ! Define these wrappers for these intrinsic functions because we want to implement
      ! a cla parser that can work with plain strings, read from stdin for example,
      ! not just from the command line.
      ! The purpose is to easily adapt a program that runs using command line inputs into
      ! a program that can run with string input it eats from a pipe.
      implicit none
      CHARACTER(len=CLALEN) :: outs
      INTEGER               :: i, k, n
           
      if (cla_cla_len == 0) then
         cla_command_argument_count = INT(command_argument_count(), int_kind)
      else
         ! Count number of spaces to get
         ! number of parameters minus 1:
         cla_command_argument_count = 0
         ! Now count arguments:
!         print *,'Counting arguments in :',trim(cla_cla)
         cla_cla_len = int(len_trim(cla_cla), int_kind)
         if (cla_cla_len == 0) then
            return
         end if
         do i=1,cla_cla_len
            if (cla_cla(i:i) == ' ') then
               cla_command_argument_count = cla_command_argument_count + 1_int_kind
            end if
         end do
         cla_command_argument_count = cla_command_argument_count + 1_int_kind
!         print *,'cla_command_argument_count found ',cla_command_argument_count
      end if
    end function cla_command_argument_count

    subroutine cla_get_command_argument(i,arg)
      implicit none
      integer, intent(in) :: i
      integer :: n
      integer(kind=int_kind) :: nm1,nn
      character(len=*), intent(out) :: arg
      if (cla_cla_len == 0) then
         call get_command_argument(i,arg)
      else
         nm1 = 0
         nn = 0
         do n=1,i
            nm1 = nn + nm1
            nn = int(index(cla_cla(nm1+1:),' '), int_kind)
         end do
         arg(1:nn) = cla_cla(nm1+1:nm1+nn-1)
         arg(nn:) = ' '
!         print *,'trim(cla_cla)=',trim(cla_cla)
!         print *,'get_command_argument got : arg=',i,' val=',trim(arg)
      end if
    end subroutine cla_get_command_argument

    subroutine cla_message(message)
    character(LEN=*) message
    ! Default stop with message without print or stop statements. 
    ! May need to be modified for, e.g. MPI codes 
    write(stdout,*)message
    end subroutine  
  
    subroutine cla_fatal(message)
    character(LEN=*) message
    ! Default stop with message without print or stop statements. 
    ! May need to be modified for, e.g. MPI codes 
    write(stderr,*)message
    stop 6
    end subroutine

    subroutine cla_read_str(cla_input_str)
      implicit none
      character(len=*) :: cla_input_str
      integer :: i,n,k
      character(CLALEN) :: outs
      cla_cla = trim(adjustl(cla_input_str))
      cla_cla_len = int(len_trim(cla_cla), int_kind)
      ! Replace whitespace with single space:
      outs = cla_cla
      n = 0  ; k=cla_cla_len                  ! k=index last non-blank (may be null)
      DO i = 1,k-1                            ! dont process last char yet
         n = n+1 ; outs(n:n) = cla_cla(i:i)
         IF (cla_cla(i:i+1) == '  ') n = n-1  ! backup/discard consecutive output blank
      END DO
      n = n+1  ; outs(n:n)  = cla_cla(k:k)    ! last non-blank char output (may be null)
      IF (n < k) outs(n+1:) = ' '             ! pad trailing blanks
      cla_cla = outs
      cla_cla_len = int(len_trim(cla_cla), int_kind)
    end subroutine cla_read_str
    
    subroutine cla_init_str(cla_input_str)
      implicit none
      character(len=*) :: cla_input_str
      integer :: i,n,k
      character(CLALEN) :: outs
      cla_cla = trim(adjustl(cla_input_str))
      cla_cla_len = int(len_trim(cla_cla), int_kind)
      ! Replace whitespace with single space:
      outs = cla_cla
      n = 0  ; k=cla_cla_len                  ! k=index last non-blank (may be null)
      DO i = 1,k-1                            ! dont process last char yet
         n = n+1 ; outs(n:n) = cla_cla(i:i)
         IF (cla_cla(i:i+1) == '  ') n = n-1  ! backup/discard consecutive output blank
      END DO
      n = n+1  ; outs(n:n)  = cla_cla(k:k)    ! last non-blank char output (may be null)
      IF (n < k) outs(n+1:) = ' '             ! pad trailing blanks
      cla_cla = outs
      cla_cla_len = int(len_trim(cla_cla), int_kind)

      ! Allocate a zero size registry, just so that it gets
      ! associated.
      cla_num = 0
      allocate(cla_registry(0))
      allocate(cla_posarg_registry(0))      
      cla_kindstr(cla_int)     = 'integer'
      cla_kindstr(cla_float)   = 'float'
      cla_kindstr(cla_char)    = 'character'
      cla_kindstr(cla_xchar)   = 'xcharacter' !NOT IMPLEMENTED
      cla_kindstr(cla_logical) = 'logical'
      cla_kindstr(cla_flag)    = 'flag'
      cla_empty='THIS_IS_THE_EMPTY_STRING'
      cla_true_str(1)='true'
      cla_true_str(2)='on'
      cla_true_str(3)='1'
      cla_true_str(4)='t'
      cla_true_str(5)='T'
      cla_true_str(6)='.true.'
    end subroutine cla_init_str
    
    subroutine cla_init_default
      ! Allocate a zero size registry, just so that it gets
      ! associated.
      cla_num = 0
      allocate(cla_registry(0))
      allocate(cla_posarg_registry(0))      
      cla_kindstr(cla_int)     = 'integer'
      cla_kindstr(cla_float)   = 'float'
      cla_kindstr(cla_char)    = 'character'
      cla_kindstr(cla_xchar)   = 'xcharacter' !NOT IMPLEMENTED
      cla_kindstr(cla_logical) = 'logical'
      cla_kindstr(cla_flag)    = 'flag'
      cla_empty='THIS_IS_THE_EMPTY_STRING'
      cla_true_str(1)='true'
      cla_true_str(2)='on'
      cla_true_str(3)='1'
      cla_true_str(4)='t'
      cla_true_str(5)='T'
      cla_true_str(6)='.true.'
      ! Set cla_cla_len = 0 in default case when command line is actually to be parsed
      ! rather than in input string:
      cla_cla_len = 0
    end subroutine cla_init_default

    subroutine cla_posarg_register(key,description,kkind,default)
      character(len=*) :: key
      character(len=*) :: description
      integer(kind=int_kind) :: kkind
      character(len=*) :: default
      type(cla_posarg_t), dimension(:), pointer :: cla_posarg_registry_tmp
      integer(kind=int_kind) :: i

      ! This is a dumb way to increase the size of the
      ! registry of command line arguments, but there
      ! should not be so many arguments that either speed
      ! or memory is an issue.
      allocate(cla_posarg_registry_tmp(cla_posarg_num+1))
      do i=1,cla_posarg_num
         cla_posarg_registry_tmp(i)%key         = cla_posarg_registry(i)%key
         cla_posarg_registry_tmp(i)%description = cla_posarg_registry(i)%description
         cla_posarg_registry_tmp(i)%kind        = cla_posarg_registry(i)%kind
         cla_posarg_registry_tmp(i)%default     = cla_posarg_registry(i)%default
         if (index(trim(key),' ') /= 0) then
            call cla_fatal('Error: cla_posarg key contains a space character.')
         end if
         if (cla_str_eq(trim(cla_posarg_registry(i)%key),trim(key))) then
            call cla_fatal('cla_posarg key already been registered' // &
                           cla_posarg_registry(i)%key)
         end if
      end do
      cla_posarg_num = cla_posarg_num + 1_int_kind
      deallocate(cla_posarg_registry)
      allocate(cla_posarg_registry(cla_posarg_num))
      do i=1,cla_posarg_num-1_int_kind
         cla_posarg_registry(i)%key         = cla_posarg_registry_tmp(i)%key
         cla_posarg_registry(i)%description = cla_posarg_registry_tmp(i)%description
         cla_posarg_registry(i)%kind        = cla_posarg_registry_tmp(i)%kind
         cla_posarg_registry(i)%default     = cla_posarg_registry_tmp(i)%default
      end do
      i = cla_posarg_num
      cla_posarg_registry(i)%key         = key
      cla_posarg_registry(i)%description = description
      cla_posarg_registry(i)%description = description
      cla_posarg_registry(i)%kind        = kkind
      cla_posarg_registry(i)%default     = default
      deallocate(cla_posarg_registry_tmp)
    end subroutine
    
    subroutine cla_register(key,longkey,description,kkind,default)
      character(len=2) :: key
      character(len=*) :: longkey
      character(len=*) :: description
      integer(kind=int_kind) :: kkind
      character(len=*) :: default
      type(cla_t), dimension(:), pointer :: cla_registry_tmp
      integer(kind=int_kind) :: i

      if (len(key) > 2)then
        call cla_fatal("The short key should be a dash plus one character (-e)")
      end if
      
      ! This is a dumb way to increase the size of the
      ! registry of command line arguments, but there
      ! should not be so many arguments that either speed
      ! or memory is an issue.
      allocate(cla_registry_tmp(cla_num+1))
      do i=1,cla_num
         cla_registry_tmp(i)%key         = cla_registry(i)%key
         cla_registry_tmp(i)%longkey     = cla_registry(i)%longkey
         cla_registry_tmp(i)%description = cla_registry(i)%description
         cla_registry_tmp(i)%kind        = cla_registry(i)%kind
         cla_registry_tmp(i)%default     = cla_registry(i)%default
         if (index(trim(key),' ') /= 0) then
            call cla_fatal('Attempt to register cla key containing a space.')
         end if
         if (index(trim(longkey),' ') /= 0) then
            call cla_fatal('Attempt to register long key containing space')
         end if         
         if (cla_str_eq(trim(cla_registry(i)%key),trim(key))) then
            call cla_fatal('Attempt to register cla key already registered'// &
                           trim(key))
         end if
      end do
      cla_num = cla_num + 1_int_kind
      deallocate(cla_registry)
      allocate(cla_registry(cla_num))
      do i=1,cla_num-1_int_kind
         cla_registry(i)%key         = cla_registry_tmp(i)%key
         cla_registry(i)%longkey     = cla_registry_tmp(i)%longkey
         cla_registry(i)%description = cla_registry_tmp(i)%description
         cla_registry(i)%kind        = cla_registry_tmp(i)%kind
         cla_registry(i)%default     = cla_registry_tmp(i)%default
      end do
      i = cla_num
      cla_registry(i)%key         = key
      cla_registry(i)%longkey     = longkey
      cla_registry(i)%description = description
      cla_registry(i)%kind        = kkind
      cla_registry(i)%default     = default
      deallocate(cla_registry_tmp)
    end subroutine

    subroutine cla_show
      integer(kind=int_kind) :: i
      character(len=STRLEN)  :: value
      character(len=STRLEN)  :: i_str
      call cla_message('General usage:')
      call cla_message('  command -[key] [value] --[longkey] [value] -[flag] [positional arguments]')
      call cla_message('  The key/value pairs must be matched if they appear.')
      call cla_message('  Key/value pairs and flags may be in any order.')
      call cla_message(' ')
      call cla_message('The following command line arguments and switches are expected:')
      do i=1,cla_num
         write(i_str,'(i5)')i
         call cla_message('---------- i: '// trim(i_str))
         call cla_message('         key: '// trim(cla_registry(i)%key))
         call cla_message('     longkey: '// trim(cla_registry(i)%longkey))
         call cla_message(' description: '// trim(cla_registry(i)%description))
         call cla_message('        kind: '// &
                          trim(cla_kindstr(cla_registry(i)%kind)))
         call cla_message('     default: '// trim(cla_registry(i)%default))
      end do
      call cla_message(' ')
      call cla_message('The following positional (non-keyword) arguments are expected:')
      do i=1,cla_posarg_num
         write(i_str,'(i5)')i
         call cla_message('---------- i: '// trim(i_str))
         call cla_message('         key: '// trim(cla_posarg_registry(i)%key))
         call cla_message(' description: '// trim(cla_posarg_registry(i)%description))
         call cla_message('        kind: '// &
                          trim(cla_kindstr(cla_posarg_registry(i)%kind)))
         call cla_message('     default: '// trim(cla_posarg_registry(i)%default))
         if ( cla_key_present(trim(cla_registry(i)%key)) ) then
            call cla_get_char(trim(cla_registry(i)%key),value)
            call cla_message('    present?: T')
            if (cla_registry(i)%kind == cla_flag) then
            else
               call cla_message('       value: '// trim(value))
            endif
         else
            call cla_message('    present?: F')
         endif
      end do
      
      call cla_message(' ')
      call cla_message('Also, -?, -h, -H, -help, --help, and --usage are recognized.')
      call cla_message(' ')
    end subroutine cla_show

    subroutine cla_help(cmd_name)
      character(len=*) :: cmd_name
      integer(kind=int_kind) :: i
      character(len=256) :: cmd_usage
      cmd_usage = ""
      do i=1,cla_num
        if (cla_registry(i)%kind == cla_flag) then
          cmd_usage = trim(cmd_usage) // " [" // trim(cla_registry(i)%key) // "]"
        else
          cmd_usage = trim(cmd_usage) // " [" // trim(cla_registry(i)%key) // "=" // &
          trim(cla_registry(i)%default) // "]"
        endif
      enddo
      do i=1,cla_posarg_num
        cmd_usage = trim(cmd_usage) // " " // trim(cla_posarg_registry(i)%key)
      enddo
      write(stdout,*)'General usage:'
      write(stdout,*)'  ',cmd_name, trim(cmd_usage)
      write(stdout,*)' '
      write(stdout,*)'Options and flags {default values}:'
      if (cla_num == 0) write(stdout,*)"None"
      do i=1,cla_num
         if (cla_registry(i)%kind == cla_flag) then
            write(stdout,'(1x,a,1x,a24,":",4x,a)')trim(cla_registry(i)%key), &
                                       trim(cla_registry(i)%longkey), &
                                       trim(cla_registry(i)%description)
         else
            write(stdout,'(1x,a,1x,a24,":",4x,a,2x,"{",a,"}")')trim(cla_registry(i)%key), &
                                 trim(cla_registry(i)%longkey), &   
                                 trim(cla_registry(i)%description), & 
                                 trim(cla_registry(i)%default) 
         endif
      end do
      write(stdout,*)' '

      write(stdout,*)'Positional arguments:'
      if (cla_posarg_num == 0) write(stdout,*)"None"
      do i=1,cla_posarg_num
        write(stdout,'(1x,a,":",1x,a,4x,a)')trim(cla_posarg_registry(i)%key), &
                                trim(cla_posarg_registry(i)%description)
      end do
      
      write(stdout,*)' '
      write(stdout,*)'Also, -?, -h, -H, -help, --help, and --usage are recognized.'
      write(stdout,*)' '
    end subroutine cla_help

    integer function cla_eq(str1,str2)
      implicit none
      character(*) :: str1, str2
      cla_eq = index(trim(str1),trim(str2))*index(trim(str2),trim(str1))
    end function cla_eq

    logical function cla_key_arg_match(key,longkey,arg)
      implicit none
      ! do a match that includes two alternate keys and possibility of = in arg
      integer :: iequal
      character(*) :: key,longkey,arg
      cla_key_arg_match = .false.
      cla_key_arg_match = cla_str_eq(trim(key),trim(arg)) .or. &
                      cla_str_eq(trim(longkey),trim(arg))
      if (cla_key_arg_match) return
      iequal = index(arg,"=")
      if (iequal > 1) &
         cla_key_arg_match = cla_str_eq(trim(key),arg(1:(iequal-1))) .or. &
                         cla_str_eq(trim(longkey),arg(1:(iequal-1)))      
    end function cla_key_arg_match   
    

    logical function cla_str_eq(str1,str2)
      implicit none
      character(*) :: str1, str2
      integer :: str_test
      str_test = index(trim(str1),trim(str2))*index(trim(str2),trim(str1))
      cla_str_eq = .false.
      if (str_test /= 0) cla_str_eq = .true.
    end function cla_str_eq
    
    
    subroutine cla_validate(cmd_name)
      implicit none
      character(len=*)      :: cmd_name
      character(len=STRLEN) :: arg
      character(len=STRLEN)  :: value, key
      integer :: k, ncla, kcla
      integer(kind=int_kind) :: kk, iequal, kkv

      print *,"Validating the command line arguments:"
      ncla = cla_command_argument_count()
      if (ncla == 0) then
         print *,"    ... none found. Returning."
         return
      end if
      
      ! First check for -?, -h, -H, -help, or --help flags.
      call cla_get_command_argument(1,arg)
      key = trim(arg)
      if (cla_str_eq(trim(key),'-h')      .or. &
          cla_str_eq(trim(key),'-?')      .or. &
          cla_str_eq(trim(key),'/?')      .or. &
          cla_str_eq(trim(key),'-H')      .or. &
          cla_str_eq(trim(key),'-help')   .or. &
          cla_str_eq(trim(key),'--help')  .or. &
          cla_str_eq(trim(key),'--usage')      &
          ) then
         call cla_help(cmd_name)
         stop
      endif

      print *,"    cla_command_argument_count = ",ncla
      do k=1,ncla
         call cla_get_command_argument(k,arg)
         print *,"    cla_command_argument #",k,": ",arg
      end do
      ! Positional arguments must all occur either before or after all the key/value arguments.
      kcla = 0
      do while (kcla < ncla)
         call cla_get_command_argument(kcla+1,arg)
         if (index(arg,"-") /= 1) then
            if (kcla == 0) print *,"    Positional arguments appear to occur prior to key/value arguments."
            kcla = kcla + 1_int_kind
            if (kcla > cla_posarg_num) then
               print *,"     ERROR: Too many positional arguments found!"
               stop
            endif
         else
            exit
         end if
         print *,"          positional arg #",kcla,"= ",trim(arg), &
              " is expected to be of type ",trim(cla_kindstr(cla_posarg_registry(kcla)%kind))
      end do
      ! Look for key value pairs:
      do while (kcla < ncla-1)
         call cla_get_command_argument(kcla,key)
         if ( (index(key,"-") == 1) .and. (kcla == 0) ) then
            print *,"    Positional arguments appear to occur after to key/value arguments."
         endif
         kkv = kcla
         do kk=1,cla_num
            ! must test for exact match, not just substring
            if (cla_key_arg_match(cla_registry(kk)%key, &
                 cla_registry(kk)%longkey, &
                 key))then
               if (cla_registry(kk)%kind == cla_flag) then
                  print *,"          key = ",trim(key)," is a flag"
                  kcla = kcla + 1
                  exit
               else
                  call cla_get_command_argument(kcla+2,value)
                  kcla = kcla + 2
                  print *,"          key, value ?= ",trim(key)," ",trim(value), &
                       " is expected to be of type ",trim(cla_kindstr(cla_registry(kk)%kind))
               end if
            end if           
         end do
         if (kcla == kkv) then
            if (index(key,"-") == 1) then
               print *,"      Error: ",trim(key)," could not be matched to any known key!"
               stop
            else
               exit
            endif
         end if
      end do
      kkv = kcla
      do while (kcla < ncla)
         call cla_get_command_argument(kcla+1_int_kind,arg)
         if (index(arg,"-") /= 1) then
            kcla = kcla + 1_int_kind
            if ((kcla - kkv) > cla_posarg_num) then
               print *,"     ERROR: Too many positional arguments found!"
               stop
            endif
         else
            print *,"    ERROR: Positional arguments appear to be mixed in with -key value arguments."
            print *,"    Move position arguments to the end of the list."
            stop
         end if
         print *,"    positional arg ?= ",arg
      end do
      print *,"    No errors found in syntax validation, but type/kind-validity not checked!"
      print *,"    If a -key value pair is repeated, the last one is used."
    end subroutine cla_validate
    
    logical function cla_key_present(key)
      implicit none
      character(len=STRLEN) :: arg
      character(len=*)  :: key
      character(len=STRLEN) :: longkey
      character(len=2) :: shortkey
      character(len=STRLEN)  :: value
      
      integer :: ncla, k, kk
!      integer :: cla_command_argument_count
!      external cla_command_argument_count

      !     Loop over the command line arguments to assign to
      !     value.
      !     Note that no error is reported if the key was NOT
      !     registered, but it is present on the command line.
 
      cla_key_present = .false.
      
!      print *,'Calling cla_key_present with key = ',trim(key)
      value = trim(cla_empty)
      do kk=1,cla_num
         ! must test for exact match, not just substring
         if (cla_key_arg_match(cla_registry(kk)%key, &
                           cla_registry(kk)%longkey, &
                           key))then
            value = trim(cla_registry(kk)%default)
            longkey = cla_registry(kk)%longkey
            shortkey = cla_registry(kk)%key
            exit
         end if
      end do
      
      if (index(trim(value),trim(cla_empty)) /= 0) then
         call cla_show
         call cla_fatal('Unknown command line argument: '//trim(key))
      endif
      
      ncla = cla_command_argument_count()
      if (ncla == 0) return
      
      do k=1,ncla
         call cla_get_command_argument(k,arg)
         ! test for exact match
         if (cla_key_arg_match(shortkey,longkey,arg))then
            cla_key_present = .true.
            return
         endif
      enddo
      
    end function cla_key_present

    subroutine cla_get_char(key,value)
      implicit none
      character(len=STRLEN)  :: arg
      character(len=*)       :: key
      character(len=2)       :: shortkey
      character(len=STRLEN)  :: longkey
      character(len=STRLEN)  :: value, pvalue
      character(len=STRLEN)  :: kkey
      integer(kind=int_kind) :: kkind, iequal
      integer :: kk, kmatch, ordinal, ncla, k
      logical :: just_matched, prev_matched, is_match, carryover
!      integer :: cla_command_argument_count
!      external cla_command_argument_count

      !     Loop over the command line arguments to assign to
      !     value.
      !     Note that no error is reported if the key was NOT
      !     registered, but it is present on the command line.
      if (index(key,"-") /= 1)then
         ! assume positional argument, confirm by matching name
         ordinal = -1
         do k=1,cla_posarg_num
            ! must test for exact match, not just substring
            if (cla_str_eq(trim(cla_posarg_registry(k)%key),trim(key))) then
               pvalue = trim(cla_posarg_registry(k)%default)
               ordinal = k
            end if
         end do

         ! It seems that value is not yet defined here:
         !         if (index(trim(value),trim(cla_empty)) /= 0) then
         if (ordinal == -1) then
            print *,'Error: You tried to retrieve an unknown command line argument: ',trim(key)
            call cla_show
            stop 5
         endif
         
         if (ordinal > 0) then
            ncla = cla_command_argument_count()
            if (ncla == 0) then
               value=pvalue
               return
            end if
            kmatch = 0
            prev_matched = .False.
            
            do k=1,ncla
               call cla_get_command_argument(k,arg)
               ! test for exact match among key args
               just_matched = .False.    
               do kk = 1, cla_num
                  kkey = cla_registry(kk)%key
                  kkind = cla_registry(kk)%kind
                  is_match = cla_key_arg_match(kkey,cla_registry(kk)%longkey,arg)
                  carryover = kkind/=cla_flag
                  iequal = int(index(arg,"="), int_kind)
                  if (is_match .and. iequal > 1)then
                     carryover = .False.
                  end if
                  just_matched = just_matched .or. is_match
                  if (just_matched) exit  ! preserve kkey and kkind
               end do
               if (just_matched .or. prev_matched )then
                  ! current arg part of keyword arg constructal
                  ! so this is not positional
                  prev_matched = just_matched .and. carryover
                  carryover = .False.
                  cycle
               end if
               kmatch = kmatch + 1
               ! increment # of positionals
               if(kmatch == ordinal) then
                  pvalue = trim(arg)
                  value=pvalue
                  return
               end if
               
            end do
         end if
         value = pvalue
         return
      end if
      
      ! keyword
      do k=1,cla_num
         ! must test for exact match, not just substring
         if (cla_key_arg_match(cla_registry(k)%key, &
              cla_registry(k)%longkey, &
              key)) then
            shortkey = cla_registry(k)%key
            longkey = cla_registry(k)%longkey
            
            value = trim(cla_registry(k)%default)
            kkind = cla_registry(k)%kind
         end if
      end do
      
      if (index(trim(value),trim(cla_empty)) /= 0) then
         print *,'Error: You tried to retrieve an unknown command line argument: ',trim(key)
         call cla_show
         stop 5
      endif
      
      ncla = cla_command_argument_count()
      if (ncla == 0) return
      
      do k=1,ncla
         call cla_get_command_argument(k,arg)
         ! test for exact match
         if (cla_key_arg_match(shortkey,longkey,trim(arg))) then
            if (kkind == cla_flag) then
               value = 't'
               return
            else
               iequal = int(index(arg,"="), int_kind)
               if (iequal < 1)then
                  call cla_get_command_argument(k+1_int_kind,arg)       
                  value = trim(arg)
                  return
               else
                  value=arg(iequal+1:len_trim(arg))
                  return
               end if
            endif
         end if
      enddo
      
    end subroutine cla_get_char
    
    
    subroutine cla_get_float_r4(key,float_value)
      implicit none
      character(len=*)       :: key
      character(len=STRLEN)  :: value
      real(kind=4)           :: float_value
      
      call cla_get_char(key,value)
      if (index(trim(value),trim(cla_empty)) == 0) read(value,*,err=100)float_value
      return
100   call cla_fatal("Input value not correct type: "//key//": "//value)
    end subroutine cla_get_float_r4
    
    subroutine cla_get_float_r8(key,float_value)
      implicit none
      character(len=*)       :: key
      character(len=STRLEN)  :: value
      real(kind=8)           :: float_value
      
      call cla_get_char(key,value)
      if (index(trim(value),trim(cla_empty)) == 0) read(value,*,err=100)float_value
      return
100   call cla_fatal("Input value not correct type: "//key//": "//value)
    end subroutine cla_get_float_r8
    
    
    subroutine cla_get_int_i4(key,int_value)
      implicit none
      character(len=*)       :: key
      character(len=STRLEN)  :: value
      integer(kind=4)        :: int_value
      
      call cla_get_char(key,value)
      if (index(trim(value),trim(cla_empty)) == 0) read(value,*,err=100)int_value
      return
100   call cla_fatal("Input value not correct type: "//value)
    end subroutine cla_get_int_i4
    
    subroutine cla_get_int_i8(key,int_value)
      implicit none
      character(len=*)       :: key
      character(len=STRLEN)  :: value
      integer(kind=8)        :: int_value
      
      call cla_get_char(key,value)
      if (index(trim(value),trim(cla_empty)) == 0) read(value,*,err=100)int_value
      return
100   call cla_fatal("Input value not correct type: "//value)        
    end subroutine cla_get_int_i8
    
    subroutine cla_get_logical(key,logical_value)
      implicit none
      character(len=*)  :: key
      character(len=STRLEN)  :: value
      logical :: logical_value
      integer(kind=int_kind) :: k
      
      logical_value = .false.
      
      call cla_get_char(key,value)
      if (index(trim(value),trim(cla_empty)) == 0) then
         do k=1,6
            if (index(trim(value),trim(cla_true_str(k))) /= 0) then
               logical_value = .true.
            endif
         end do
      end if
    end subroutine cla_get_logical

    subroutine cla_get_flag(key,logical_value)
      implicit none
      character(len=*)  :: key
      character(len=STRLEN)  :: value
      logical :: logical_value
      integer(kind=int_kind) :: k
      
      logical_value = .false.
      
      call cla_get_char(key,value)
      if (index(trim(value),trim(cla_empty)) == 0) then
         do k=1,6
            if (index(trim(value),trim(cla_true_str(k))) /= 0) then
               logical_value = .true.
            endif
         end do
      end if
    end subroutine cla_get_flag

end module cla

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
! It is an "all in one" file containing FRUIT tests that can be extended to CLI later
module test_imas
#include "../src/core/preprocessor.inc"
  implicit none
contains
  subroutine test_imas_case_one
    call imas_multi_fruit(1)
  end subroutine test_imas_case_one

  subroutine imas_multi_fruit(casenum)
    !! Multifunctional function to collect imas cases. All file IO should happen here,
    !! while the actual tests should be in a separate test routine to improve
    !! re-usability and test isolation
    use fruit
    use fruit_util
    use qlknn_evaluate_nets
    use qlknn_disk_io
    use test_regression, only: calc_error, calc_derror, passed_test

    implicit none

    integer, intent(in) :: casenum
    integer(lli) :: verbosity, n_in, i_outp, n_rho
    integer :: inp, outp
    real(qlknn_dp), dimension(:,:), allocatable :: input
    real(qlknn_dp), dimension(:), allocatable :: err
    real(qlknn_dp), dimension(:), allocatable :: derr
    real(qlknn_dp) :: max_err
    logical, dimension(:), allocatable :: this_err_okay
    character(len=4096) :: nn_path, input_path
    real(qlknn_dp) :: stepsize
    character(len=512) :: ci_msg
    real(qlknn_dp), dimension(:,:), allocatable :: err_out
    real(qlknn_dp), dimension(:,:,:), allocatable :: derr_out
    logical, dimension(:,:,:), allocatable :: err_okay

    ! Set constants for this test suite
    namelist /sizes/ n_rho, n_in
    namelist /test/ input

    input_path = 'tests/test.nml'
    nn_path = 'data/qlknn-hyper-namelists'

    verbosity = 0

    ! Load QLKNN settings from library
    if (.not. allocated(blocks%input_blocks)) then
      call load_qlknn_hyper_nets_from_disk(nn_path, verbosity)
    endif


    ! Read input namelist
    ! Automatically determines n_in and n_rho
    open(10,file=input_path,action='READ')
    read(10,nml=sizes)
    allocate(input(n_in, n_rho))
    read(10,nml=test)
    close(10)

    ! Allocate containers for temporary error data
    allocate(this_err_okay(n_rho))
    allocate(err(n_rho))
    allocate(derr(n_rho))

    ! Call internal "generalizable" test subroutine and calculate errors
    max_err = 1e-7
    call imas_hyper_multi(casenum, input, err_out, derr_out, verbosityin=verbosity)
    call passed_test(err_out, derr_out, max_err, err_okay, verbosity)

    ! Use FRUIT to assert if tests have passed
    do i_outp = 1, size(err_out, 2)
      err(:) = err_out(:, i_outp)
      if (verbosity >= 1) then
        write(*, '(A, I3, A)') 'max abs err(:, ', i_outp, ')'
        write(*, *) maxval(abs(err))
      endif
      do inp = 1, size(derr_out, 3)
        derr(:) = derr_out(i_outp, :, inp)
        if (verbosity >= 2) then
          write(*, '(A, I3, A, I3, A)') 'max abs derr(', i_outp, ', :, ', inp, ')'
          write(*, *) maxval(abs(derr))
        endif
        this_err_okay = err_okay(i_outp, :, inp)
        write(ci_msg, *) 'max abs err = ', maxval(abs(err))
        call assert_true(all(this_err_okay), trim(ci_msg))
      enddo
    enddo

    ! De-allocate SAVEed network structures
    call all_networktype_deallocate(nets)
  end subroutine imas_multi_fruit

  subroutine imas_hyper_multi(casenum, input, err_out, derr_out, verbosityin)
    !! Multifunctional test routine not dependenend on FRUIT
    use qlknn_evaluate_nets
    use qlknn_disk_io
    use test_regression, only: calc_error, calc_derror, passed_test

    implicit none
    integer, intent(in) :: casenum
    real(qlknn_dp), dimension(:,:), intent(in):: input
    real(qlknn_dp), dimension(:,:), intent(out), allocatable :: err_out
    real(qlknn_dp), dimension(:,:,:), intent(out), allocatable :: derr_out
    integer(lli), intent(in), optional :: verbosityin
    integer :: n_rho, n_in, n_out, n_in_outp, n_out_outp, n_rho_outp, inp, i_outp
    type (qlknn_options) :: opts
    type (qlknn_normpars) :: qlknn_norms
    integer(lli) :: verbosity
    real(qlknn_dp), dimension(:), allocatable :: this_err, this_derr
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out, qlknn_imas_out
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput, dqlknn_imas_out_dinput

    if(present(verbosityin)) then
       verbosity = verbosityin
    else
       verbosity = 0
    end if

    n_in = size(input, 1)
    n_rho = size(input, 2)

    call default_qlknn_hyper_options(opts)

    ! Set default options
    opts%constrain_inputs = .false.
    opts%constrain_outputs = .false.
    opts%force_evaluate_all = .true.
    opts%apply_victor_rule = .true.

    ! Variables for Victor rule
    ALLOCATE(qlknn_norms%A1(n_rho))
    qlknn_norms%A1 = 2.
    qlknn_norms%R0 = 3.
    qlknn_norms%a = 1.


    ! Set specific options, and allocated arrays that change shape between tests
    ! Each test should have at least:
    ! n_out: The amount of outputs of the outermost function
    ! n_in: The amount of inputs of the innermost function
    ! n_rho: The amount of radial points
    ! This defines the following quantities:
    ! dqlknn_out_dinput: The Jacobian of the outermost function with respect
    !    to the innermost input (n_out, n_rho, n_in)
    ! qlknn_out: The output of the outermost function
    select case (casenum)
    case(1)
      ! Test full IO conversion with Victor rule enabled
      opts%merge_modes = .false.
      n_out = 20
      allocate(qlknn_out(n_rho, n_out))
      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))

      allocate(qlknn_imas_out(n_rho, n_out))
      allocate(dqlknn_imas_out_dinput(n_out, n_rho, n_in))
    case default
      ERRORSTOP(.true., 'Given case number not implemented')
    endselect

    ! TODO: Test IMAS implementation here. For now, call the same function twice to test CI
    call evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts, qlknn_norms, dqlknn_out_dinput)
    call evaluate_QLKNN_10D(input, nets, qlknn_imas_out, verbosity, opts, qlknn_norms, dqlknn_imas_out_dinput)

    ! Allocate arrays to contain "test has passed T/F" data
    allocate(err_out(size(qlknn_out, 1), size(qlknn_out, 2)))
    allocate(derr_out(size(dqlknn_out_dinput, 1), size(dqlknn_out_dinput, 2), &
         size(dqlknn_out_dinput, 3)))
    allocate(this_err(size(qlknn_out, 1)))
    allocate(this_derr(size(qlknn_out, 1)))

    ! Calculate absolute errors
    call calc_error(qlknn_imas_out, qlknn_out, err_out)
    call calc_derror(dqlknn_imas_out_dinput, dqlknn_out_dinput, derr_out)

    ! Set errors of output array
    do i_outp = 1, n_out
      this_err(:) = err_out(:, i_outp)
      if (verbosity >= 1) then
        write(*, '(A, I3, A)') 'err(:, ', i_outp, ')'
        write(*, *) this_err(:)
      endif
      do inp = 1, n_in
        this_derr(:) = derr_out(i_outp, :, inp)
        if (verbosity >= 2) then
          write(*, '(A, I3, A, I3, A)') 'derr(', i_outp, ', :, ', inp, ')'
          write(*, *) this_derr(:)
        endif
      enddo
    enddo
  end subroutine imas_hyper_multi
end module test_imas

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
!> Module testing our quicksort implementation
module test_regression
#include "../src/core/preprocessor.inc"
  use qlknn_types
  implicit none

  real(qlknn_dp), dimension(2), parameter :: max_err_hyper = (/ 1e-12, 1e-12 /)
contains
  subroutine regression_hyper_multi(casenum, input, err, derr, verbosityin)
    use qlknn_evaluate_nets
    use qlknn_disk_io
    implicit none
    integer, intent(in) :: casenum
    real(qlknn_dp), dimension(:,:), intent(in):: input
    real(qlknn_dp), dimension(:,:), intent(out), allocatable :: err
    real(qlknn_dp), dimension(:,:,:), intent(out), allocatable :: derr
    integer(lli), intent(in), optional :: verbosityin
    integer :: n_rho, n_in, n_out, n_in_outp, n_out_outp, n_rho_outp, inp, i_outp
    type (qlknn_options) :: opts
    type (qlknn_normpars) :: qlknn_norms
    integer(lli) :: verbosity
    real(qlknn_dp), dimension(:), allocatable :: this_err, this_derr
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out, qlknn_reference_out
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput, dqlknn_reference_out_dinput
    character(len=4096) :: nn_path = '', input_path = '', output_path = ''

    namelist /sizes/ n_rho, n_in
    namelist /test/ input
    namelist /outp_sizes/ n_rho, n_in, n_out
    namelist /outp/ qlknn_out
    namelist /outp_jacobian/ dqlknn_out_dinput

    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    endif

    input_path = 'tests/test.nml'
    nn_path = 'data/qlknn-hyper-namelists'


    call default_qlknn_hyper_options(opts)

    select case (casenum)
    case(1)
      output_path = 'tests/output_regression_case1.nml'
    case(2)
      output_path = 'tests/output_regression_case2.nml'
    case default
      ERRORSTOP(.true., 'Given case number not implemented')
    endselect

    ! Read regression outputs
    open(10,file=output_path,action='READ')
    read(10,nml=outp_sizes)
    n_rho_outp = n_rho
    n_in_outp = n_in
    n_out_outp = n_out
    allocate(qlknn_out(n_rho, n_out))
    allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
    close(10)
    open(10,file=output_path,action='READ')
    read(10,nml=outp)
    read(10,nml=outp_jacobian)
    close(10)

    ! Variables for Victor rule
    ALLOCATE(qlknn_norms%A1(n_rho))
    qlknn_norms%A1 = 2.
    qlknn_norms%R0 = 3.
    qlknn_norms%a = 1.

    allocate(dqlknn_reference_out_dinput(size(dqlknn_out_dinput, 1), size(dqlknn_out_dinput, 2), size(dqlknn_out_dinput, 3)))
    allocate(qlknn_reference_out(size(qlknn_out, 1), size(qlknn_out, 2)))
    dqlknn_reference_out_dinput = dqlknn_out_dinput
    qlknn_reference_out = qlknn_out

    select case (casenum)
    case(1)
      opts%merge_modes = .false.
      opts%force_evaluate_all = .true.
    case(2)
      opts%merge_modes = .false.
      opts%force_evaluate_all = .true.
      opts%apply_victor_rule = .true.
    endselect

    call evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts, qlknn_norms, dqlknn_out_dinput)

    ERRORSTOP(size(qlknn_out, 1) /= n_rho_outp, 'Expected n_rho of network evaluation to be the same as output')
    ERRORSTOP(size(qlknn_out, 2) /= n_out_outp, 'Expected n_out of network evaluation to be the same as output')
    ERRORSTOP(size(dqlknn_out_dinput, 1) /= n_out_outp, 'Expected n_rho of network jacobian evaluation to be the same as output')
    ERRORSTOP(size(dqlknn_out_dinput, 2) /= n_rho_outp, 'Expected n_rho of network jacobian evaluation to be the same as output')
    ERRORSTOP(size(dqlknn_out_dinput, 3) /= n_in_outp, 'Expected n_rho of network jacobian evaluation to be the same as output')

    allocate(err(size(qlknn_out, 1), size(qlknn_out, 2)))
    allocate(derr(size(dqlknn_out_dinput, 1), size(dqlknn_out_dinput, 2), &
         size(dqlknn_out_dinput, 3)))
    allocate(this_err(size(qlknn_out, 1)))
    allocate(this_derr(size(qlknn_out, 1)))
    call calc_error(qlknn_reference_out, qlknn_out, err)
    call calc_derror(dqlknn_reference_out_dinput, dqlknn_out_dinput, derr)

    do i_outp = 1, n_out
      this_err(:) = err(:, i_outp)
      if (verbosity >= 1) then
        write(*, '(A, I3, A)') 'err(:, ', i_outp, ')'
        write(*, *) this_err(:)
      endif
      do inp = 1, n_in
        this_derr(:) = derr(i_outp, :, inp)
        if (verbosity >= 2) then
          write(*, '(A, I3, A, I3, A)') 'derr(', i_outp, ', :, ', inp, ')'
          write(*, *) this_derr(:)
        endif
      enddo
    enddo

  end subroutine regression_hyper_multi

  subroutine calc_error(reference, new, error)
    real(qlknn_dp), dimension(:,:), intent(in) :: reference
    real(qlknn_dp), dimension(:,:), intent(in) :: new
    real(qlknn_dp), dimension(:,:), intent(out) :: error

    error = reference - new

  end subroutine calc_error

  subroutine calc_derror(reference, new, error)
    real(qlknn_dp), dimension(:,:,:), intent(in) :: reference
    real(qlknn_dp), dimension(:,:,:), intent(in) :: new
    real(qlknn_dp), dimension(:,:,:), intent(out) :: error

    integer :: ii

    do ii = 1, size(reference, 3)
      call calc_error(reference(:, :, ii), new(:, :, ii), error(:, :, ii))
    enddo

  end subroutine calc_derror

  subroutine passed_test(perr, err, max_err, err_okay, verbosityin)
    use qlknn_primitives, only: is_not_close
    real(qlknn_dp), dimension(:,:), intent(in) :: perr
    real(qlknn_dp), dimension(:,:,:), intent(in) :: err
    real(qlknn_dp), intent(in) :: max_err
    logical, dimension(:,:,:), allocatable, intent(out) :: err_okay
    integer(lli), intent(in), optional :: verbosityin

    logical, dimension(:,:), allocatable :: perr_okay
    real(qlknn_dp), dimension(:), allocatable :: this_err
    real(qlknn_dp), dimension(:), allocatable :: this_perr
    logical, dimension(:), allocatable :: this_err_okay
    integer(lli) :: inp, outp, verbosity

    logical, dimension(:), allocatable :: is_nonzero

    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if
    if (verbosity >= 1) then
      write(*,"(A,E9.2)")"Checking against error ", max_err
    endif

    allocate(err_okay(size(err, 1), size(err, 2), size(err, 3)))
    allocate(perr_okay(size(perr, 1), size(perr, 2)))
    allocate(this_err(size(err, 2)))
    allocate(this_err_okay(size(err, 2)))
    allocate(this_perr(size(err, 2)))
    allocate(is_nonzero(size(err, 2)))

    err_okay = abs(err) < max_err
    perr_okay = abs(perr) < max_err
    do inp = 1, size(err, 3)
      err_okay(:, :, inp) = err_okay(:, :, inp) .and. transpose(perr_okay)
    enddo
    deallocate(perr_okay)

    if (verbosity >= 1) then
      do inp = 1, size(err, 3)
        do outp = 1, size(err, 1)
          this_err = err(outp, :, inp)
          this_err_okay = err_okay(outp, :, inp)
          this_perr = perr(outp, :)
          call is_not_close(this_err, 0._qlknn_dp, is_nonzero)
          if (.not. any(is_nonzero) .and. verbosity <= 4) then
            ! Skip zero errors
            cycle
          endif

          ! Debug for profile error
          if (inp == 1) then
            if (verbosity >= 2) then
              write(*,*)
              write(*,'(A, I3, A, I3)') 'outp=', outp
            endif
            if (verbosity >= 3) then
              write(*,'(A, I3, A, I3, A, *(E9.2, 1X))')'abs(perr(', outp, ', :)) = ', abs(this_perr)
            endif
            if (verbosity >= 2) then
              write(*,'(A, I3, A, I3, A, *(E9.2, 1X))')'abs(perr(', outp, ', :)) = ', maxval(abs(this_perr))
              write(*, '(A, *(L1, 1X))')'err_okay(outp, :, inp) ', err_okay(outp, :, inp)
            endif
            if (verbosity >= 1 .and. .not. all(this_err_okay)) then
              write(*,'(A, I3, A, I3, A, E9.2)')'Failed! max(abs(err(', outp, ', :, ', inp, '))) = ', maxval(abs(this_err))
            endif
          endif

          ! Debug for Jacobian profile error
          if (verbosity >= 2) then
            write(*,*)
            write(*,'(A, I3, A, I3)')'inp=', inp, ', outp=', outp
          endif
          if (verbosity >= 3) then
            write(*,'(A, I3, A, I3, A, *(E9.2, 1X))')'abs(err(', outp, ', :, ', inp, ')) = ', abs(this_err)
          endif
          if (verbosity >= 2) then
            write(*,'(A, I3, A, I3, A, *(E9.2, 1X))')'max(abs(err(', outp, ', :, ', inp, '))) = ', maxval(abs(this_err))
            write(*, '(A, *(L1, 1X))')'err_okay(outp, :, inp) ', err_okay(outp, :, inp)
          endif
          if (verbosity >= 1 .and. .not. all(this_err_okay)) then
            write(*,'(A, I3, A, I3, A, E9.2)')'Failed! max(abs(err(', outp, ', :, ', inp, '))) = ', maxval(abs(this_err))
          endif
        enddo
      enddo
    endif
  end subroutine passed_test
end module test_regression

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module test_regression_hyper
#include "../src/core/preprocessor.inc"
  use fruit
  use fruit_util
  use qlknn_types

contains
  subroutine test_regression_hyper_case_one
    call regression_hyper_multi_fruit(1)
  end subroutine test_regression_hyper_case_one

  subroutine test_regression_hyper_case_two
    call regression_hyper_multi_fruit(2)
  end subroutine test_regression_hyper_case_two

  subroutine regression_hyper_multi_fruit(casenum)
    use fruit
    use fruit_util
    use qlknn_evaluate_nets
    use qlknn_disk_io
    use test_regression

    implicit none

    integer, intent(in) :: casenum
    integer(lli) :: verbosity, n_in, n_rho=24
    integer :: inp, i_outp
    real(qlknn_dp), dimension(:,:), allocatable :: input
    !real(qlknn_dp) :: start, finish
    real(qlknn_dp), dimension(:), allocatable :: err
    real(qlknn_dp), dimension(:), allocatable :: derr
    real(qlknn_dp) :: max_err
    logical, dimension(:), allocatable :: this_err_okay
    character(len=4096) :: nn_path, input_path
    character(len=512) :: ci_msg
    real(qlknn_dp), dimension(:,:), allocatable :: err_out
    real(qlknn_dp), dimension(:,:,:), allocatable :: derr_out
    logical, dimension(:,:,:), allocatable :: err_okay

    namelist /sizes/ n_rho, n_in
    namelist /test/ input

    input_path = 'tests/test.nml'
    nn_path = 'data/qlknn-hyper-namelists'
    verbosity = 0

    if (.not. allocated(nets%nets)) then
      call load_qlknn_hyper_nets_from_disk(nn_path, verbosity - 1)
    endif


    ! Read input namelist
    open(10,file=input_path,action='READ')
    read(10,nml=sizes)
    allocate(input(n_in, n_rho))
    read(10,nml=test)
    close(10)

    allocate(this_err_okay(n_rho))
    allocate(err(n_rho))
    allocate(derr(n_rho))

    max_err = max_err_hyper(casenum)
    call regression_hyper_multi(casenum, input, err_out, derr_out, verbosity)
    call passed_test(err_out, derr_out, max_err, err_okay, verbosity)

    do i_outp = 1, size(err_out, 2)
      err(:) = err_out(:, i_outp)
      if (verbosity >= 1) then
        write(*, '(A, I3, A)') 'max abs err(:, ', i_outp, ')'
        write(*, *) maxval(abs(err))
      endif
      do inp = 1, size(derr_out, 3)
        derr(:) = derr_out(i_outp, :, inp)
        if (verbosity >= 2) then
          write(*, '(A, I3, A, I3, A)') 'max abs derr(', i_outp, ', :, ', inp, ')'
          write(*, *) maxval(abs(derr))
        endif
        this_err_okay = err_okay(i_outp, :, inp)
        write(ci_msg, *) 'max abs err = ', maxval(abs(err))
        call assert_true(all(this_err_okay), trim(ci_msg))
      enddo
    enddo
    call all_networktype_deallocate(nets)
  end subroutine regression_hyper_multi_fruit
end module test_regression_hyper

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_victor_rule
    use qlknn_types
    use qlknn_primitives

    implicit none
    real(qlknn_dp), parameter :: c_1 = 0.13, c_2 = 0.41, c_3 = 0.09, c_4 = 1.65
    real(qlknn_dp), parameter :: gamma0_lower_bound = 1e-4; !Clip, gamma0 can't be negative! Avoid infinities for now
    real(qlknn_dp), parameter :: victor_Te_norm = 1e-4;

    !! Documentation regarding Victor Rule linear GENE run reference parameters (not needed here in code but written for reference)
    !real(qlknn_dp), parameter :: Te_ref_vic = 1.98 !keV
    !real(qlknn_dp), parameter :: n_ref_vic = 2.7 !10^-19 m-3
    !real(qlknn_dp), parameter :: B_ref_vic = 3.35 !T
    !real(qlknn_dp), parameter :: L_ref_vic = 2.947 !m
    !real(qlknn_dp), parameter :: A_ref_vic = 2 !au

contains
    subroutine get_f_victorthesis(input, nets, f_victorthesis, dthesis_dinput)
        real(qlknn_dp), dimension(:,:), intent(in):: input
        type(net_collection), intent(in) :: nets

        real(qlknn_dp), dimension(:), intent(out) :: f_victorthesis
        real(qlknn_dp), dimension(:,:), optional :: dthesis_dinput

        real(qlknn_dp) :: epsLCFS_nn

        epsLCFS_nn = nets%a / nets%R_0
        f_victorthesis = c_1 * input(nets%q_ind, :) + &
            c_2 * input(nets%smag_ind, :) + &
            c_3 / (epsLCFS_nn * input(nets%x_ind, :)) - &
            c_4

       if (present(dthesis_dinput)) then
         dthesis_dinput = 0
         dthesis_dinput(:, nets%q_ind) = c_1
         dthesis_dinput(:, nets%smag_ind) = c_2
         dthesis_dinput(:, nets%x_ind) = -c_3 / (epsLCFS_nn * input(nets%x_ind, :)**2)
       endif
    end subroutine

    subroutine get_f_vic(input, nets, qlknn_norms, f_vic, verbosity, df_vic_dinput)
        real(qlknn_dp), dimension(:,:), intent(in):: input
        type(net_collection), intent(in) :: nets
        type(qlknn_normpars), intent(in):: qlknn_norms
        integer(lli), optional, intent(in) :: verbosity

        real(qlknn_dp), dimension(:), intent(out) :: f_vic
        real(qlknn_dp), dimension(:,:), optional, intent(out) :: df_vic_dinput

        integer(lli) :: n_rho, n_inputs, inp
        !gammaE below is targeted to be QLK GB units [csou/a] with csou=sqrt(Te/mi)
        real(qlknn_dp), dimension(:), allocatable :: f_victorthesis, gamma0, dvperp_dr, c_sou, gammaE, c_c_sou
        real(qlknn_dp), dimension(:,:), allocatable :: dthesis_dinput, dgamma0_dinput
        real(qlknn_dp), dimension(:), allocatable :: dvperp_dr_dgammaE_inp, dc_sou_dTe, dgammaE_dgammaE_inp, dgammaE_dTe
        real(qlknn_dp), dimension(:), allocatable :: temp_vec
        real(qlknn_dp), dimension(:,:), allocatable :: temp_matr
        logical, dimension(:), allocatable :: gamma0_clipped, f_vic_clipped
        character(len=512) :: line
        logical :: calcder

        n_rho = size(input, 2)
        n_inputs = size(input, 1)
        if (present(df_vic_dinput)) then
          calcder = .true.
        else
          calcder = .false.
        endif

        allocate(gamma0(n_rho))
        if (calcder) then
          allocate(dgamma0_dinput(n_rho, 9))
          call evaluate_network(input(1:9, :), nets%nets(20), gamma0, verbosity, dgamma0_dinput)
        else
          call evaluate_network(input(1:9, :), nets%nets(20), gamma0, verbosity)
        endif
        if (verbosity >= 3) then
            write(*,*) 'gamma0 pre-clip'
            write(*,'(F7.2)') gamma0
        end if

        !gamma0 in QLK GB units [csou/Rmin] where csou = sqrt(Te/mi)
        gamma0 = MAX(gamma0, gamma0_lower_bound)
        if (verbosity >= 3) then
            write(*,*) 'gamma0 post-clip'
            write(*,'(F7.2)') gamma0
        end if

        allocate(f_victorthesis(n_rho))
        allocate(dvperp_dr(n_rho))
        allocate(c_sou(n_rho))
        allocate(c_c_sou(n_rho))
        allocate(gammaE(n_rho))
        if (calcder) then
          allocate(dthesis_dinput(n_rho, n_inputs))
          allocate(gamma0_clipped(n_rho))
          allocate(dvperp_dr_dgammaE_inp(n_rho))
          allocate(dc_sou_dTe(n_rho))
          allocate(dgammaE_dgammaE_inp(n_rho))
          allocate(dgammaE_dTe(n_rho))
          allocate(temp_vec(n_rho))
          allocate(temp_matr(n_rho, 9))
          call is_not_close(gamma0, gamma0_lower_bound, gamma0_clipped)
          gamma0_clipped = .not. gamma0_clipped
        else
          allocate(dthesis_dinput(0,0))
          allocate(gamma0_clipped(0))
          allocate(dvperp_dr_dgammaE_inp(0))
          allocate(dc_sou_dTe(0))
          allocate(dgammaE_dgammaE_inp(0))
          allocate(dgammaE_dTe(0))
          allocate(temp_vec(0))
          allocate(temp_matr(0,0))
        endif

        !assumes gammaE input is in QLK cref/R0 normalisation
        dvperp_dr = input(nets%gammaE_ind, :) * c_qlk_ref / qlknn_norms%R0
        c_c_sou = (qe * 1e3) / (qlknn_norms%A1 * mp)
        c_sou = sqrt(c_c_sou * input(nets%Te_ind, :))
        gammaE = dvperp_dr * qlknn_norms%a / c_sou
        if (verbosity >= 3) then
            write(*,*) 'gammaE'
            write(*,'(F7.2)') gammaE
        end if
        if (calcder) then
          dvperp_dr_dgammaE_inp = c_qlk_ref / qlknn_norms%R0
          dc_sou_dTe = c_c_sou / (2 * c_sou)
          dgammaE_dgammaE_inp = qlknn_norms%a / c_sou * dvperp_dr_dgammaE_inp
          dgammaE_dTe = -dvperp_dr * qlknn_norms%a * dc_sou_dTe / c_sou**2
          call get_f_victorthesis(input, nets, f_victorthesis, dthesis_dinput)
        else
          call get_f_victorthesis(input, nets, f_victorthesis)
        endif
        if (verbosity >= 3) then
            write(*,*) 'f_victorthesis'
            write(*,'(F7.2)') f_victorthesis
        end if
        ! f = 1 + f_victorthesis(9D) * gammaE(gammaE_QLK) / gamma0(9D)
        !f_vic = MAX(1 + f_victorthesis * abs(gammaE) / gamma0, 2._qlknn_dp)
        f_vic = 1 + f_victorthesis * abs(gammaE) / gamma0
        if (calcder) then
          where (gamma0_clipped) f_vic = 0
          do inp = 1, n_inputs
            where (gamma0_clipped) df_vic_dinput(:, inp) = 0
          enddo
          ! df_vic/d9D = gammaE(gammaE_in)/ {dgamma0(9D)/d9D}**2 * (df_victorthesis(9D)/d9D * gamma0(9D) - dgamma0(9D)/d9D * f_victorthesis(9D))
          call matr_vec_mult_elemwise(n_rho * 9_li, dthesis_dinput(:, 1:9), gamma0, df_vic_dinput(:, 1:9))
          call matr_vec_mult_elemwise(n_rho * 9_li, dgamma0_dinput, f_victorthesis, temp_matr)
          df_vic_dinput(:, 1:9) =  df_vic_dinput(:, 1:9) - temp_matr
          call matr_vec_mult_elemwise(n_rho * 9_li, df_vic_dinput(:, 1:9), abs(gammaE)/gamma0**2, df_vic_dinput(:, 1:9))
          ! df_vic/dgammaE_in = f_victorthesis / gamma0 * dgammaE/dgammaE_in
          df_vic_dinput(:, nets%gammaE_ind) = f_victorthesis / (gamma0 + epsilon(gamma0)) * dgammaE_dgammaE_inp * gammaE/abs(gammaE + epsilon(gammaE))
          write(line,*) 'getting ', nets%Te_ind
          df_vic_dinput(:, nets%Te_ind) = f_victorthesis / gamma0 * dgammaE_dTe * gammaE/abs(gammaE + epsilon(gammaE))

          allocate(f_vic_clipped(n_rho))
          call is_not_close(f_vic, 0._qlknn_dp, f_vic_clipped)
          f_vic_clipped = .not. f_vic_clipped
          do inp = 1, n_inputs
            where (f_vic_clipped) df_vic_dinput(:, inp) = 0
          enddo
        endif
        if (verbosity >= 3) then
            write(*,*) 'f_vic'
            write(*,'(F7.2)') f_vic
        end if
        ! Not sure if this is needed, pending deletion
        !where (gamma0 .le. gamma0_lower_bound) f_vic = 0

    end subroutine get_f_vic

    subroutine scale_with_victor(leading_map, input, nets, qlknn_norms, net_result, verbosity, dnet_out_dinput)
        integer(lli), dimension(:,:), intent(in) :: leading_map
        real(qlknn_dp), dimension(:,:), intent(in):: input
        type(net_collection), intent(in) :: nets
        type(qlknn_normpars), intent(in):: qlknn_norms
        integer(lli), optional, intent(in) :: verbosity

        real(qlknn_dp), dimension(:,:), intent(inout) :: net_result
        real(qlknn_dp), dimension(:,:,:), optional, intent(inout) :: dnet_out_dinput
        real(qlknn_dp), dimension(:,:), allocatable :: df_vic_dinput

        integer(lli) :: n_rho, ii, idx, n_inputs, inp, leading_ITG, leading_TEM
        real(qlknn_dp), dimension(:), allocatable :: f_vic
        logical :: calcder
        character(len=512) :: line
        leading_TEM = leading_map(1, 2)
        leading_ITG = leading_map(1, 3)

        n_rho = size(input, 2)
        if (present(dnet_out_dinput)) then
          calcder = .true.
        else
          calcder = .false.
        endif

        allocate(f_vic(n_rho))
        if (calcder) then
          n_inputs = size(input, 1)
          allocate(df_vic_dinput(n_rho, n_inputs))
          write(line,*) 'size=', n_rho, 'x', n_inputs
          call get_f_vic(input, nets, qlknn_norms, f_vic, verbosity, df_vic_dinput)
        else
          call get_f_vic(input, nets, qlknn_norms, f_vic, verbosity)
        endif

        if (calcder) then
          do inp = 1, n_inputs
            !df_vic_dinput nRho x nInputs
            !net_result nRho x nOutp
            !f_vic nRho
            !dnet_out_dinput nOutp x nRho x nInp
            dnet_out_dinput(leading_ITG, :, inp) = df_vic_dinput(:, inp) * net_result(:, leading_ITG) + f_vic * dnet_out_dinput(leading_ITG,:,inp)
            do ii = 2, size(leading_map,1)
                idx = leading_map(ii, 3)
                if (idx == 0) then
                    cycle
                endif
                dnet_out_dinput(idx, :, inp) = df_vic_dinput(:, inp) * net_result(:, idx) + f_vic * dnet_out_dinput(idx,:,inp)
            enddo

            dnet_out_dinput(leading_TEM, :, inp) = df_vic_dinput(:, inp) * net_result(:, leading_TEM) + f_vic * dnet_out_dinput(leading_TEM,:,inp)
            do ii = 2, size(leading_map,1)
                idx = leading_map(ii, 2)
                if (idx == 0) then
                    cycle
                endif
                dnet_out_dinput(idx, :, inp) = df_vic_dinput(:, inp) * net_result(:, idx) + f_vic * dnet_out_dinput(idx,:,inp)
            enddo
          enddo
        endif

        net_result(:, leading_ITG) = f_vic * net_result(:, leading_ITG)
        do ii = 2, size(leading_map,1)
            idx = leading_map(ii, 3)
            if (idx == 0) then
                cycle
            endif
            net_result(:, idx) = f_vic * net_result(:, idx)
        end do

        net_result(:, leading_TEM) = f_vic * net_result(:, leading_TEM)
        do ii = 2, size(leading_map,1)
            idx = leading_map(ii, 2)
            if (idx == 0) then
                cycle
            endif
            net_result(:, idx) = f_vic * net_result(:, idx)
        end do

    end subroutine scale_with_victor

end module qlknn_victor_rule

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_10d_source_net
#include "preprocessor.inc"
  use qlknn_types
  use net_efeetg_gb              !  ,only: get_net_efeetg_gb
  use net_efeitg_gb_div_efiitg_gb!  ,only: get_net_efeitg_gb_div_efiitg_gb
  use net_efetem_gb              !  ,only: get_net_efetem_gb
  use net_efiitg_gb              !  ,only: get_net_efiitg_gb
  use net_efitem_gb_div_efetem_gb!  ,only: get_net_efitem_gb_div_efetem_gb
  use net_pfeitg_gb_div_efiitg_gb!  ,only: get_net_pfeitg_gb_div_efiitg_gb
  use net_pfetem_gb_div_efetem_gb!  ,only: get_net_pfetem_gb_div_efetem_gb
  use net_dfeitg_gb_div_efiitg_gb!  ,only: get_net_dfeitg_gb_div_efiitg_gb
  use net_dfetem_gb_div_efetem_gb!  ,only: get_net_dfetem_gb_div_efetem_gb
  use net_vteitg_gb_div_efiitg_gb!  ,only: get_net_vteitg_gb_div_efiitg_gb
  use net_vtetem_gb_div_efetem_gb!  ,only: get_net_vtetem_gb_div_efetem_gb
  use net_vceitg_gb_div_efiitg_gb!  ,only: get_net_vceitg_gb_div_efiitg_gb
  use net_vcetem_gb_div_efetem_gb!  ,only: get_net_vcetem_gb_div_efetem_gb
  use net_dfiitg_gb_div_efiitg_gb!  ,only: get_net_dfiitg_gb_div_efiitg_gb
  use net_dfitem_gb_div_efetem_gb!  ,only: get_net_dfitem_gb_div_efetem_gb
  use net_vtiitg_gb_div_efiitg_gb!  ,only: get_net_vtiitg_gb_div_efiitg_gb
  use net_vtitem_gb_div_efetem_gb!  ,only: get_net_vtitem_gb_div_efetem_gb
  use net_vciitg_gb_div_efiitg_gb!  ,only: get_net_vciitg_gb_div_efiitg_gb
  use net_vcitem_gb_div_efetem_gb!  ,only: get_net_vcitem_gb_div_efetem_gb
  use net_gam_leq_gb             !  ,only: get_net_gam_leq_gb

  implicit none
  type(net_collection), save, target :: nets
contains
  subroutine init_all_nets()
    ! Constant for all 9D networks
    nets%Zeff_ind = 1
    nets%Ati_ind = 2
    nets%Ate_ind = 3
    nets%An_ind = 4
    nets%q_ind = 5
    nets%smag_ind = 6
    nets%x_ind = 7
    nets%Ti_Te_ind = 8
    nets%logNustar_ind = 9
    nets%gammaE_ind = 10
    nets%Te_ind = 11
    nets%a = 1.
    nets%R_0 = 3.

    allocate(nets%nets(20))
    nets%nets(1)  = get_efeetg_gb()
    nets%nets(2)  = get_efeitg_gb_div_efiitg_gb()
    nets%nets(3)  = get_efetem_gb()
    nets%nets(4)  = get_efiitg_gb()
    nets%nets(5)  = get_efitem_gb_div_efetem_gb()
    nets%nets(6)  = get_pfeitg_gb_div_efiitg_gb()
    nets%nets(7)  = get_pfetem_gb_div_efetem_gb()
    nets%nets(8)  = get_dfeitg_gb_div_efiitg_gb()
    nets%nets(9)  = get_dfetem_gb_div_efetem_gb()
    nets%nets(10) = get_vteitg_gb_div_efiitg_gb()
    nets%nets(11) = get_vtetem_gb_div_efetem_gb()
    nets%nets(12) = get_vceitg_gb_div_efiitg_gb()
    nets%nets(13) = get_vcetem_gb_div_efetem_gb()
    nets%nets(14) = get_dfiitg_gb_div_efiitg_gb()
    nets%nets(15) = get_dfitem_gb_div_efetem_gb()
    nets%nets(16) = get_vtiitg_gb_div_efiitg_gb()
    nets%nets(17) = get_vtitem_gb_div_efetem_gb()
    nets%nets(18) = get_vciitg_gb_div_efiitg_gb()
    nets%nets(19) = get_vcitem_gb_div_efetem_gb()
    nets%nets(20) = get_gam_leq_gb()
  end subroutine init_all_nets
end module qlknn_10d_source_net

! Module qlknn_python defined in file /builds/qualikiz-group/QLKNN-fortran/src/qlknn_python.f90

subroutine f90wrap_evaluate_qlknn_10d_direct(qlknn_path, input, qlknn_out, verbosityin, optsin, qlknn_normsin, n0, n1, &
    n2, n3)
    use qlknn_types, only: qlknn_options, qlknn_normpars
    use qlknn_python, only: evaluate_qlknn_10d_direct
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    character(2048), intent(in) :: qlknn_path
    real(8), intent(in), dimension(n0,n1) :: input
    real(8), intent(inout), dimension(n2,n3) :: qlknn_out
    integer(8), optional, intent(in) :: verbosityin
    type(qlknn_options_ptr_type) :: optsin_ptr
    integer, optional, intent(in), dimension(2) :: optsin
    type(qlknn_normpars_ptr_type) :: qlknn_normsin_ptr
    integer, optional, intent(in), dimension(2) :: qlknn_normsin
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(qlknn_out) :: n2 = shape(qlknn_out,0)
    integer :: n3
    !f2py intent(hide), depend(qlknn_out) :: n3 = shape(qlknn_out,1)
    if (present(optsin)) then
        optsin_ptr = transfer(optsin, optsin_ptr)
    else
        optsin_ptr%p => null()
    end if
    if (present(qlknn_normsin)) then
        qlknn_normsin_ptr = transfer(qlknn_normsin, qlknn_normsin_ptr)
    else
        qlknn_normsin_ptr%p => null()
    end if
    call evaluate_qlknn_10d_direct(qlknn_path=qlknn_path, input=input, qlknn_out=qlknn_out, verbosityin=verbosityin, &
        optsin=optsin_ptr%p, qlknn_normsin=qlknn_normsin_ptr%p)
end subroutine f90wrap_evaluate_qlknn_10d_direct

subroutine f90wrap_finalize
    use qlknn_python, only: finalize
    implicit none
    
    call finalize()
end subroutine f90wrap_finalize

subroutine f90wrap_abort(msg)
    use qlknn_python, only: abort
    implicit none
    
    character(2048), intent(in) :: msg
    call abort(msg=msg)
end subroutine f90wrap_abort

! End of module qlknn_python defined in file /builds/qualikiz-group/QLKNN-fortran/src/qlknn_python.f90

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
#include "fintrf.h"

subroutine mexFunction(nlhs, plhs, nrhs, prhs)
  use qlknn_evaluate_nets
  use qlknn_disk_io
  use qlknn_types

  implicit none
  mwPointer :: plhs(*), prhs(*)
  integer :: nlhs, nrhs

  integer(lli) :: n_rho, n_out, n_raptor, n_merged_outputs, total_n_in, n_nets, nn_type
  integer(lli) :: n_members ! Specific for committee NN

  real(qlknn_dp), dimension(:,:), allocatable :: input, qlknn_out, qlknn_out_raptor, qlknn_eb
  real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput, dqlknn_out_dinput_raptor
  !logical(qlknn_bool), dimension(:,:), allocatable :: qlknn_validity, qlknn_validity_raptor
  logical, dimension(:,:), allocatable :: qlknn_validity, qlknn_validity_raptor
  integer(lli) :: verbosity, path_ix, input_ix, verbosity_ix, opts_ix, norms_ix, nntype_ix
  integer(lli) :: dout_din_ix, validity_ix
  integer :: double_id
  integer :: matlab_int
  type (qlknn_options) :: opts
  type(qlknn_normpars) :: norms

  logical, save :: nets_loaded=.false.
  logical :: has_verbosity, has_dout_din, has_validity, has_opts, has_norms, has_nntype

#if MX_HAS_INTERLEAVED_COMPLEX
  mwPointer mxGetDoubles
#else
  mwPointer mxGetPr
#endif

  mwPointer mxCreateDoubleMatrix
  mwPointer mxCreateNumericArray
  integer mxIsNumeric, mxIsChar, mxIsStruct
  integer mxClassIDFromClassName
  mwPointer mxGetM, mxGetN

  !     Pointers to input/output mxArrays:
  mwPointer inp_ptr, verb_ptr, nntype_ptr, outp_ptr, dout_din_ptr, opts_ptr, norms_ptr

  !     Array information:
  mwPointer ncols_in
  mwSize size_in, size_out
  mwSize din_dout_shape(3)

  integer status
  mwPointer mxGetString

  !     Arguments for computational routine:
  real*8 verbosityin, nntypein
  real*8 mxGetScalar
  ! Maximum string size = maxbuf
  mwSize  maxbuf
  parameter(maxbuf = 2048)
  character*2048 qlknn_path

  mwPointer  arrlen

  !-----------------------------------------------------------------------
  !     Check for proper number of arguments. 
  ! Validate inputs
  path_ix = 1
  input_ix = 2
  verbosity_ix = 3
  opts_ix = 4
  norms_ix = 5
  nntype_ix = 6
  dout_din_ix = 2
  validity_ix = 3
  ! Amount of in/outputs checking
  if (nrhs < 2) then
    call mexErrMsgIdAndTxt ('MATLAB:qlknn:nInput', &
         'At least two inputs required.')
  elseif (nlhs > 3) then
    call mexErrMsgIdAndTxt ('MATLAB:qlknn:nOutput', &
         'Too many output arguments.')
  ! Input typechecks
  elseif (mxIsChar(prhs(path_ix)) .ne. 1) then
    call mexErrMsgIdAndTxt ('MATLAB:qlknn:NonString', &
         'Input must be a string.')
    ! The input must be a row vector.
  elseif (mxGetM(prhs(path_ix)) .ne. 1) then
    call mexErrMsgIdAndTxt ('MATLAB:qlknn:NonRowVector', &
         'Input must be a row vector.')
  elseif (mxIsNumeric(prhs(input_ix)) .eq. 0) then
    call mexErrMsgIdAndTxt ('MATLAB:qlknn:NonNumeric', &
         'input array must be numeric.')
  elseif (nrhs >= verbosity_ix) then
    if (mxIsNumeric(prhs(verbosity_ix)) == 0) then
      call mexErrMsgIdAndTxt ('MATLAB:qlknn:NonNumeric', &
           'verbosity must be a number.')
    endif
  elseif (nrhs >= opts_ix) then
    if (mxIsStruct(prhs(opts_ix)) == 0) then
      call mexErrMsgIdAndTxt ('MATLAB:qlknn:NonStruct', &
         'Input opts must be a struct.')
    endif
  elseif (nrhs >= norms_ix) then
    if (mxIsStruct(prhs(norms_ix)) == 0) then
      call mexErrMsgIdAndTxt ('MATLAB:qlknn:NonStruct', &
         'Input norms must be a struct.')
    endif
  elseif (nrhs >= nntype_ix) then
    if (mxIsNumeric(prhs(nntype_ix)) == 0) then
      call mexErrMsgIdAndTxt ('MATLAB:qlknn:NonNumeric', &
         'Input NN type must be a number.')
    endif
  endif

  if (nlhs >= dout_din_ix) then
    has_dout_din = .true.
  else
    has_dout_din = .false.
  endif
  if (nlhs >= validity_ix) then
    has_validity = .true.
  else
    has_validity = .false.
  endif
  if (nrhs >= verbosity_ix) then
    has_verbosity = .true.
  else
    has_verbosity = .false.
  endif
  if (nrhs >= opts_ix) then
    has_opts = .true.
  else
    has_opts = .false.
  endif
  if (nrhs >= norms_ix) then
    has_norms = .true.
  else
    has_norms = .false.
  endif
  if (nrhs >= nntype_ix) then
    has_nntype = .true.
  else
    has_nntype = .false.
  endif

  !------------------
  ! Prepare verbosity
  if (has_verbosity) then
    arrlen = mxGetM(prhs(verbosity_ix))*mxGetN(prhs(verbosity_ix))
    if (arrlen .gt. 1) then
      call mexErrMsgIdAndTxt('MATLAB:qlknn:verbosity_in', &
           'Verbosity should be a single number.')
    endif
#if MX_HAS_INTERLEAVED_COMPLEX
    verb_ptr = mxGetInt32s(prhs(verbosity_ix))
#else
    verb_ptr = mxGetPr(prhs(verbosity_ix))
#endif
    verbosityin = mxGetScalar(prhs(verbosity_ix))
    verbosity = INT(verbosityin, li)
  else
    verbosity = 0
  endif

  !------------------
  ! Prepare path to qlknn
  ! Get the length of the input string.
  arrlen = mxGetM(prhs(path_ix))*mxGetN(prhs(path_ix))
  if (arrlen .gt. maxbuf) then
    call mexErrMsgIdAndTxt ('MATLAB:revord:maxbuf', &
         'Max string length 2048.')
  endif

  status = mxGetString(prhs(path_ix), qlknn_path, maxbuf)
  ! Check if mxGetString is successful.
  if (status .ne. 0) then
    call mexErrMsgIdAndTxt ('MATLAB:revord:readError', &
         'Error reading string.')
  endif

  !-------------
  ! Prepare network type selection
  if (has_nntype) then
    arrlen = mxGetM(prhs(nntype_ix))*mxGetN(prhs(nntype_ix))
    if (arrlen .gt. 1) then
      call mexErrMsgIdAndTxt('MATLAB:qlknn:nntype_in', &
           'NN type should be a single number.')
    endif
#if MX_HAS_INTERLEAVED_COMPLEX
    nntype_ptr = mxGetInt32s(prhs(nntype_ix))
#else
    nntype_ptr = mxGetPr(prhs(nntype_ix))
#endif
    nntypein = mxGetScalar(prhs(nntype_ix))
    nn_type = INT(nntypein, li)
  else
    nn_type = 0
  endif

  !-------------
  ! Set network specific array sizes and options
  select case (nn_type)
  case (2)
    total_n_in = 14
    n_merged_outputs = 13
    n_nets = 25
    n_members = 10
    call default_qlknn_jetexp_options(opts)
  case default   ! also represents nn_type == 0
    total_n_in = 11
    n_merged_outputs = 10
    n_nets = 20
    n_members = 1
    call default_qlknn_hyper_options(opts)
  end select

  !-------------
  ! Prepare opts struct
  if (has_opts) then
#if MX_HAS_INTERLEAVED_COMPLEX
    opts_ptr = should raise error on compile
#else
    opts_ptr = prhs(opts_ix) ! Pointer to the option mxArray
#endif
    call matlabify_opts(opts_ptr, opts, verbosity)
  endif

  if (opts%merge_modes) then
    n_out = n_merged_outputs
    n_raptor = 7
  else
    n_out = n_nets
    n_raptor = n_nets
  end if

  !------------------
  ! Prepare input array
  ! Get the size of the input array, total_n_in depends on selected network type
  n_rho = INT(mxGetM(prhs(input_ix)), li)
  ncols_in = mxGetN(prhs(input_ix))
  size_in = n_rho * ncols_in

  if (ncols_in /= total_n_in) then
    call mexErrMsgIdAndTxt ('MATLAB:qlknn:input_in', &
         'Input array should have the right number of columns')
  endif

  ! Create Fortran array from the input argument.
#if MX_HAS_INTERLEAVED_COMPLEX
  inp_ptr = mxGetDoubles(prhs(input_ix))
#else
  inp_ptr = mxGetPr(prhs(input_ix))
#endif
  allocate(input(total_n_in, n_rho))
  call mxCopyPtrToReal8(inp_ptr,TRANSPOSE(input),size_in)

  if (has_norms) then
#if MX_HAS_INTERLEAVED_COMPLEX
    norms_ptr =
#else
    norms_ptr = prhs(norms_ix) ! Pointer to the option mxArray
#endif
    allocate(norms%A1(n_rho))
    call matlabify_norms(norms_ptr, norms, verbosity)
  endif

  !------------------
  ! Loads networks before
  if (.NOT. nets_loaded) then
    if (verbosity >= 1) then
      call mexPrintf('Loading NNs from path = ')
      call mexPrintf(qlknn_path)
      call mexPrintf(achar(10))
    endif
    select case (nn_type)
    case (2)
      call load_jetexp_nets_from_disk(trim(qlknn_path), verbosity)
    case default   ! also represents nn_type == 0
      call load_qlknn_hyper_nets_from_disk(trim(qlknn_path), verbosity)
    end select
    nets_loaded=.true.
  end if

  !------------------
  ! Prepare output matrix
  ! Create matrix for the return argument, [n_outputs, n_nets, n_out, n_raptor] all depend on selected network type
  plhs(1) = mxCreateDoubleMatrix(INT(n_rho, KIND(matlab_int)), INT(n_raptor, KIND(matlab_int)),0)
#if MX_HAS_INTERLEAVED_COMPLEX
  outp_ptr = mxGetDoubles(plhs(1))
#else
  outp_ptr = mxGetPr(plhs(1))
#endif
  allocate(qlknn_out(n_rho, n_out))

  if (has_dout_din) then
    double_id = mxClassIDFromClassName('double')
    din_dout_shape = (/n_rho, n_raptor, total_n_in/)
    plhs(dout_din_ix) = mxCreateNumericArray(3, din_dout_shape, double_id, 0)
#if MX_HAS_INTERLEAVED_COMPLEX
    dout_din_ptr = mxGetDoubles(plhs(dout_din_ix))
#else
    dout_din_ptr = mxGetPr(plhs(dout_din_ix))
#endif
    allocate(dqlknn_out_dinput(n_out, n_rho, total_n_in))
  endif

  !------------------
  ! Neural networks evaluated at lower verbosity level than calling model
  verbosity = verbosity - 1_li
  open(unit=stderr,file='qlknn_stderr.txt',status='unknown')

  !------------------
  ! Adapt function call and output treatment based on selected network type
  select case (nn_type)
  case (2)

    if (has_validity) then
      plhs(validity_ix) = mxCreateDoubleMatrix(n_rho, n_raptor, 0)
      allocate(qlknn_validity(n_rho, n_out))
    endif

    if (has_dout_din .and. has_validity) then
      CALL evaluate_jetexp_net(input, nets, n_members, qlknn_out, qlknn_eb, verbosity, opts, dqlknn_out_dinput=dqlknn_out_dinput, qlknn_validity=qlknn_validity)
    elseif (has_dout_din .and. .not. has_validity) then
      CALL evaluate_jetexp_net(input, nets, n_members, qlknn_out, qlknn_eb, verbosity, opts, dqlknn_out_dinput=dqlknn_out_dinput)
    elseif (.not. has_dout_din .and. has_validity) then
      CALL evaluate_jetexp_net(input, nets, n_members, qlknn_out, qlknn_eb, verbosity, opts, qlknn_validity=qlknn_validity)
    elseif (.not. has_dout_din .and. .not. has_validity) then
      CALL evaluate_jetexp_net(input, nets, n_members, qlknn_out, qlknn_eb, verbosity, opts)
    endif
  
    if (opts%merge_modes) then
      allocate(qlknn_out_raptor(n_rho, n_raptor))
      qlknn_out_raptor(:, 1) = qlknn_out(:, 1) !qe
      qlknn_out_raptor(:, 2) = qlknn_out(:, 3) !qi
      qlknn_out_raptor(:, 3) = qlknn_out(:, 4) !Gamma_e
      qlknn_out_raptor(:, 4) = qlknn_out(:, 7) !De
      qlknn_out_raptor(:, 5) = qlknn_out(:, 8) + qlknn_out(:, 9) !Ve
      qlknn_out_raptor(:, 6) = qlknn_out(:, 10) !Di
      qlknn_out_raptor(:, 7) = qlknn_out(:, 11) + qlknn_out(:, 12) + qlknn_out(:,13) !Vi
      if (has_dout_din) then
        allocate(dqlknn_out_dinput_raptor(n_raptor, n_rho, total_n_in))
        dqlknn_out_dinput_raptor(1, :, :) = dqlknn_out_dinput(1, :, :) !qe
        dqlknn_out_dinput_raptor(2, :, :) = dqlknn_out_dinput(3, :, :) !qi
        dqlknn_out_dinput_raptor(3, :, :) = dqlknn_out_dinput(4, :, :) !Gamma_e
        dqlknn_out_dinput_raptor(4, :, :) = dqlknn_out_dinput(7, :, :) !De
        dqlknn_out_dinput_raptor(5, :, :) = dqlknn_out_dinput(8, :, :) + dqlknn_out_dinput(9, :, :) !Ve
        dqlknn_out_dinput_raptor(6, :, :) = dqlknn_out_dinput(10, :, :) !Di
        dqlknn_out_dinput_raptor(7, :, :) = dqlknn_out_dinput(11, :, :) + dqlknn_out_dinput(12, :, :) + dqlknn_out_dinput(13, :, :) !Vi
      endif
      if (has_validity) then
        allocate(qlknn_validity_raptor(n_rho, n_raptor))
        qlknn_validity_raptor(:, 1) = qlknn_validity(:, 1)
        qlknn_validity_raptor(:, 2) = qlknn_validity(:, 3) !qi
        qlknn_validity_raptor(:, 3) = qlknn_validity(:, 4) !Gamma_e
        qlknn_validity_raptor(:, 4) = qlknn_validity(:, 7) !De
        qlknn_validity_raptor(:, 5) = qlknn_validity(:, 8) .and. qlknn_validity(:, 9) !Ve
        qlknn_validity_raptor(:, 6) = qlknn_validity(:, 10) !Di
        qlknn_validity_raptor(:, 7) = qlknn_validity(:, 11) .and. qlknn_validity(:, 12) .and. qlknn_validity(:,13) !Vi
      endif
    else
      qlknn_out_raptor = qlknn_out
      if (has_dout_din) then
        dqlknn_out_dinput_raptor = dqlknn_out_dinput
      endif
      if (has_validity) then
        qlknn_validity_raptor = qlknn_validity
      endif
    endif

  case default  ! also represents nn_type == 0 

    if (.not. has_norms .and. opts%apply_victor_rule) then
      call mexErrMsgIdAndTxt ('MATLAB:qlknn:inputError', &
           'norms need to be provided when applying victor rule')
    endif

    if (has_dout_din .and. opts%apply_victor_rule) then
      CALL evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts, qlknn_normsin=norms, dqlknn_out_dinput=dqlknn_out_dinput)
    elseif (has_dout_din .and. .not. opts%apply_victor_rule) then
      CALL evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts, dqlknn_out_dinput=dqlknn_out_dinput)
    elseif (.not. has_dout_din .and. opts%apply_victor_rule) then
      CALL evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts, qlknn_normsin=norms)
    elseif (.not. has_dout_din .and. .not. opts%apply_victor_rule) then
      CALL evaluate_QLKNN_10D(input, nets, qlknn_out, verbosity, opts)
    endif
  
    if (opts%merge_modes) then
      allocate(qlknn_out_raptor(n_rho, n_raptor))
      qlknn_out_raptor(:, 1) = qlknn_out(:, 1) !qe
      qlknn_out_raptor(:, 2) = qlknn_out(:, 3) !qi
      qlknn_out_raptor(:, 3) = qlknn_out(:, 4) !Gamma_e
      qlknn_out_raptor(:, 4) = qlknn_out(:, 5) !De
      qlknn_out_raptor(:, 5) = qlknn_out(:, 6) + qlknn_out(:, 7)!Ve
      qlknn_out_raptor(:, 6) = qlknn_out(:, 8) !Di
      qlknn_out_raptor(:, 7) = qlknn_out(:, 9) + qlknn_out(:, 10) !Vi
      if (has_dout_din) then
        allocate(dqlknn_out_dinput_raptor(n_raptor, n_rho, total_n_in))
        dqlknn_out_dinput_raptor(1, :, :) = dqlknn_out_dinput(1, :, :) !qe
        dqlknn_out_dinput_raptor(2, :, :) = dqlknn_out_dinput(3, :, :) !qi
        dqlknn_out_dinput_raptor(3, :, :) = dqlknn_out_dinput(4, :, :) !Gamma_e
        dqlknn_out_dinput_raptor(4, :, :) = dqlknn_out_dinput(5, :, :) !De
        dqlknn_out_dinput_raptor(5, :, :) = dqlknn_out_dinput(6, :, :) + dqlknn_out_dinput(7, :, :)!Ve
        dqlknn_out_dinput_raptor(6, :, :) = dqlknn_out_dinput(8, :, :) !Di
        dqlknn_out_dinput_raptor(7, :, :) = dqlknn_out_dinput(9, :, :) + dqlknn_out_dinput(10, :, :) !Vi
      endif
    else
      qlknn_out_raptor = qlknn_out
      if (has_dout_din) then
        dqlknn_out_dinput_raptor = dqlknn_out_dinput
      endif
    endif
  
  end select

  !     Call the computational subroutine.
  !call timestwo(y_output, input)

  ! Load the data into y_ptr, which is the output to MATLAB.
  size_out = n_rho * n_raptor
  call mxCopyReal8ToPtr(qlknn_out_raptor,outp_ptr,size_out)
  if (has_dout_din) then
    call mxCopyReal8ToPtr(reshape(dqlknn_out_dinput_raptor, din_dout_shape, order=(/ 2, 1, 3 /)), dout_din_ptr, product(din_dout_shape))
  end if
  if (has_validity) then
    !call mxCopyReal8ToPtr(qlknn_validity_raptor, plhs(validity_ix), size_out)
  end if

  return
end

  !-----------------------------------------------------------------------
  !     Computational routine

  subroutine timestwo(y_output, x_input)
    real*8 x_input, y_output

    y_output = 2.0 * x_input
    return
  end

  subroutine matlabify_norms(norms_ptr, norms, verbosity)
    use qlknn_types
    use qlknn_mex_struct
    integer(lli), intent(in) :: verbosity
    mwPointer, intent(in) :: norms_ptr
    type (qlknn_normpars), intent(inout) :: norms
  !  character(len=512) :: line

    call set_real_struct(norms_ptr, 'a', norms%a, verbosity)
    call set_real_struct(norms_ptr, 'R0', norms%R0, verbosity)
    call set_real_array_struct(norms_ptr, 'A1', norms%A1, verbosity)

  end subroutine matlabify_norms

  subroutine matlabify_opts(opts_ptr, opts, verbosity)
    use qlknn_types
    use qlknn_mex_struct
    integer(lli), intent(in) :: verbosity
    mwPointer, intent(in) :: opts_ptr
    type (qlknn_options), intent(inout) :: opts

    call set_logical_struct(opts_ptr, 'use_ion_diffusivity_networks', opts%use_ion_diffusivity_networks, verbosity)
    call set_logical_struct(opts_ptr, 'apply_victor_rule', opts%apply_victor_rule, verbosity)
    call set_logical_struct(opts_ptr, 'use_effective_diffusivity', opts%use_effective_diffusivity, verbosity)
    call set_logical_struct(opts_ptr, 'calc_heat_transport', opts%calc_heat_transport, verbosity)
    call set_logical_struct(opts_ptr, 'calc_part_transport', opts%calc_part_transport, verbosity)
    call set_logical_struct(opts_ptr, 'use_ETG', opts%use_ETG, verbosity)
    call set_logical_struct(opts_ptr, 'use_ITG', opts%use_ITG, verbosity)
    call set_logical_struct(opts_ptr, 'use_TEM', opts%use_TEM, verbosity)
    call set_logical_struct(opts_ptr, 'apply_stability_clipping', opts%apply_stability_clipping, verbosity)
    call set_logical_struct(opts_ptr, 'merge_modes', opts%merge_modes, verbosity)
    call set_logical_struct(opts_ptr, 'force_evaluate_all', opts%force_evaluate_all, verbosity)

    call set_logical_array_struct(opts_ptr, 'constrain_inputs', opts%constrain_inputs, verbosity)
    call set_logical_array_struct(opts_ptr, 'constrain_outputs', opts%constrain_outputs, verbosity)

    call set_real_array_struct(opts_ptr, 'min_input', opts%min_input, verbosity)
    call set_real_array_struct(opts_ptr, 'max_input', opts%max_input, verbosity)
    call set_real_array_struct(opts_ptr, 'margin_input', opts%margin_input, verbosity)
    call set_real_array_struct(opts_ptr, 'min_output', opts%min_output, verbosity)
    call set_real_array_struct(opts_ptr, 'max_output', opts%max_output, verbosity)
    call set_real_array_struct(opts_ptr, 'margin_output', opts%margin_output, verbosity)
end subroutine matlabify_opts

! Module qlknn_victor_rule defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_victor_rule.f90

subroutine f90wrap_get_f_victorthesis(input, nets, f_victorthesis, dthesis_dinput, n0, n1, n2, n3, n4)
    use qlknn_types, only: net_collection
    use qlknn_victor_rule, only: get_f_victorthesis
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(net_collection_ptr_type) :: nets_ptr
    integer, intent(in), dimension(2) :: nets
    real(8), intent(inout), dimension(n2) :: f_victorthesis
    real(8), optional, dimension(n3,n4) :: dthesis_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(f_victorthesis) :: n2 = shape(f_victorthesis,0)
    integer :: n3
    !f2py intent(hide), depend(dthesis_dinput) :: n3 = shape(dthesis_dinput,0)
    integer :: n4
    !f2py intent(hide), depend(dthesis_dinput) :: n4 = shape(dthesis_dinput,1)
    nets_ptr = transfer(nets, nets_ptr)
    call get_f_victorthesis(input=input, nets=nets_ptr%p, f_victorthesis=f_victorthesis, dthesis_dinput=dthesis_dinput)
end subroutine f90wrap_get_f_victorthesis

subroutine f90wrap_get_f_vic(input, nets, qlknn_norms, f_vic, verbosity, df_vic_dinput, n0, n1, n2, n3, n4)
    use qlknn_victor_rule, only: get_f_vic
    use qlknn_types, only: net_collection, qlknn_normpars
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    real(8), intent(in), dimension(n0,n1) :: input
    type(net_collection_ptr_type) :: nets_ptr
    integer, intent(in), dimension(2) :: nets
    type(qlknn_normpars_ptr_type) :: qlknn_norms_ptr
    integer, intent(in), dimension(2) :: qlknn_norms
    real(8), intent(inout), dimension(n2) :: f_vic
    integer(8), optional, intent(in) :: verbosity
    real(8), optional, intent(inout), dimension(n3,n4) :: df_vic_dinput
    integer :: n0
    !f2py intent(hide), depend(input) :: n0 = shape(input,0)
    integer :: n1
    !f2py intent(hide), depend(input) :: n1 = shape(input,1)
    integer :: n2
    !f2py intent(hide), depend(f_vic) :: n2 = shape(f_vic,0)
    integer :: n3
    !f2py intent(hide), depend(df_vic_dinput) :: n3 = shape(df_vic_dinput,0)
    integer :: n4
    !f2py intent(hide), depend(df_vic_dinput) :: n4 = shape(df_vic_dinput,1)
    nets_ptr = transfer(nets, nets_ptr)
    qlknn_norms_ptr = transfer(qlknn_norms, qlknn_norms_ptr)
    call get_f_vic(input=input, nets=nets_ptr%p, qlknn_norms=qlknn_norms_ptr%p, f_vic=f_vic, verbosity=verbosity, &
        df_vic_dinput=df_vic_dinput)
end subroutine f90wrap_get_f_vic

subroutine f90wrap_scale_with_victor(leading_map, input, nets, qlknn_norms, net_result, verbosity, dnet_out_dinput, n0, &
    n1, n2, n3, n4, n5, n6, n7, n8)
    use qlknn_victor_rule, only: scale_with_victor
    use qlknn_types, only: net_collection, qlknn_normpars
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    integer(8), intent(in), dimension(n0,n1) :: leading_map
    real(8), intent(in), dimension(n2,n3) :: input
    type(net_collection_ptr_type) :: nets_ptr
    integer, intent(in), dimension(2) :: nets
    type(qlknn_normpars_ptr_type) :: qlknn_norms_ptr
    integer, intent(in), dimension(2) :: qlknn_norms
    real(8), intent(inout), dimension(n4,n5) :: net_result
    integer(8), optional, intent(in) :: verbosity
    real(8), optional, intent(inout), dimension(n6,n7,n8) :: dnet_out_dinput
    integer :: n0
    !f2py intent(hide), depend(leading_map) :: n0 = shape(leading_map,0)
    integer :: n1
    !f2py intent(hide), depend(leading_map) :: n1 = shape(leading_map,1)
    integer :: n2
    !f2py intent(hide), depend(input) :: n2 = shape(input,0)
    integer :: n3
    !f2py intent(hide), depend(input) :: n3 = shape(input,1)
    integer :: n4
    !f2py intent(hide), depend(net_result) :: n4 = shape(net_result,0)
    integer :: n5
    !f2py intent(hide), depend(net_result) :: n5 = shape(net_result,1)
    integer :: n6
    !f2py intent(hide), depend(dnet_out_dinput) :: n6 = shape(dnet_out_dinput,0)
    integer :: n7
    !f2py intent(hide), depend(dnet_out_dinput) :: n7 = shape(dnet_out_dinput,1)
    integer :: n8
    !f2py intent(hide), depend(dnet_out_dinput) :: n8 = shape(dnet_out_dinput,2)
    nets_ptr = transfer(nets, nets_ptr)
    qlknn_norms_ptr = transfer(qlknn_norms, qlknn_norms_ptr)
    call scale_with_victor(leading_map=leading_map, input=input, nets=nets_ptr%p, qlknn_norms=qlknn_norms_ptr%p, &
        net_result=net_result, verbosity=verbosity, dnet_out_dinput=dnet_out_dinput)
end subroutine f90wrap_scale_with_victor

subroutine f90wrap_qlknn_victor_rule__get__c_1(f90wrap_c_1)
    use qlknn_victor_rule, only: qlknn_victor_rule_c_1 => c_1
    implicit none
    real(8), intent(out) :: f90wrap_c_1
    
    f90wrap_c_1 = qlknn_victor_rule_c_1
end subroutine f90wrap_qlknn_victor_rule__get__c_1

subroutine f90wrap_qlknn_victor_rule__get__c_2(f90wrap_c_2)
    use qlknn_victor_rule, only: qlknn_victor_rule_c_2 => c_2
    implicit none
    real(8), intent(out) :: f90wrap_c_2
    
    f90wrap_c_2 = qlknn_victor_rule_c_2
end subroutine f90wrap_qlknn_victor_rule__get__c_2

subroutine f90wrap_qlknn_victor_rule__get__c_3(f90wrap_c_3)
    use qlknn_victor_rule, only: qlknn_victor_rule_c_3 => c_3
    implicit none
    real(8), intent(out) :: f90wrap_c_3
    
    f90wrap_c_3 = qlknn_victor_rule_c_3
end subroutine f90wrap_qlknn_victor_rule__get__c_3

subroutine f90wrap_qlknn_victor_rule__get__c_4(f90wrap_c_4)
    use qlknn_victor_rule, only: qlknn_victor_rule_c_4 => c_4
    implicit none
    real(8), intent(out) :: f90wrap_c_4
    
    f90wrap_c_4 = qlknn_victor_rule_c_4
end subroutine f90wrap_qlknn_victor_rule__get__c_4

subroutine f90wrap_qlknn_victor_rule__get__gamma0_lower_bound(f90wrap_gamma0_lower_bound)
    use qlknn_victor_rule, only: qlknn_victor_rule_gamma0_lower_bound => gamma0_lower_bound
    implicit none
    real(8), intent(out) :: f90wrap_gamma0_lower_bound
    
    f90wrap_gamma0_lower_bound = qlknn_victor_rule_gamma0_lower_bound
end subroutine f90wrap_qlknn_victor_rule__get__gamma0_lower_bound

subroutine f90wrap_qlknn_victor_rule__get__victor_Te_norm(f90wrap_victor_Te_norm)
    use qlknn_victor_rule, only: qlknn_victor_rule_victor_Te_norm => victor_Te_norm
    implicit none
    real(8), intent(out) :: f90wrap_victor_Te_norm
    
    f90wrap_victor_Te_norm = qlknn_victor_rule_victor_Te_norm
end subroutine f90wrap_qlknn_victor_rule__get__victor_Te_norm

! End of module qlknn_victor_rule defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_victor_rule.f90

! Module qlknn_types defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_types.f90

subroutine f90wrap_ragged_weights_array__array__weight_layer(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: ragged_weights_array
    implicit none
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    integer, intent(in) :: this(2)
    type(ragged_weights_array_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%weight_layer)) then
        dshape(1:2) = shape(this_ptr%p%weight_layer)
        dloc = loc(this_ptr%p%weight_layer)
    else
        dloc = 0
    end if
end subroutine f90wrap_ragged_weights_array__array__weight_layer

subroutine f90wrap_ragged_weights_array_initialise(this)
    use qlknn_types, only: ragged_weights_array
    implicit none
    
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    type(ragged_weights_array_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_ragged_weights_array_initialise

subroutine f90wrap_ragged_weights_array_finalise(this)
    use qlknn_types, only: ragged_weights_array
    implicit none
    
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    type(ragged_weights_array_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_ragged_weights_array_finalise

subroutine f90wrap_ragged_biases_array__array__bias_layer(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: ragged_biases_array
    implicit none
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    integer, intent(in) :: this(2)
    type(ragged_biases_array_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%bias_layer)) then
        dshape(1:1) = shape(this_ptr%p%bias_layer)
        dloc = loc(this_ptr%p%bias_layer)
    else
        dloc = 0
    end if
end subroutine f90wrap_ragged_biases_array__array__bias_layer

subroutine f90wrap_ragged_biases_array_initialise(this)
    use qlknn_types, only: ragged_biases_array
    implicit none
    
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    type(ragged_biases_array_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_ragged_biases_array_initialise

subroutine f90wrap_ragged_biases_array_finalise(this)
    use qlknn_types, only: ragged_biases_array
    implicit none
    
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    type(ragged_biases_array_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_ragged_biases_array_finalise

subroutine f90wrap_networktype__get__n_hidden_layers(this, f90wrap_n_hidden_layers)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in)   :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_n_hidden_layers
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_n_hidden_layers = this_ptr%p%n_hidden_layers
end subroutine f90wrap_networktype__get__n_hidden_layers

subroutine f90wrap_networktype__set__n_hidden_layers(this, f90wrap_n_hidden_layers)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in)   :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_n_hidden_layers
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%n_hidden_layers = f90wrap_n_hidden_layers
end subroutine f90wrap_networktype__set__n_hidden_layers

subroutine f90wrap_networktype__get__n_max_nodes(this, f90wrap_n_max_nodes)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in)   :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_n_max_nodes
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_n_max_nodes = this_ptr%p%n_max_nodes
end subroutine f90wrap_networktype__get__n_max_nodes

subroutine f90wrap_networktype__set__n_max_nodes(this, f90wrap_n_max_nodes)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in)   :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_n_max_nodes
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%n_max_nodes = f90wrap_n_max_nodes
end subroutine f90wrap_networktype__set__n_max_nodes

subroutine f90wrap_networktype__array__weights_input(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%weights_input)) then
        dshape(1:2) = shape(this_ptr%p%weights_input)
        dloc = loc(this_ptr%p%weights_input)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__weights_input

subroutine f90wrap_networktype__array__biases_input(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%biases_input)) then
        dshape(1:1) = shape(this_ptr%p%biases_input)
        dloc = loc(this_ptr%p%biases_input)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__biases_input

subroutine f90wrap_networktype__array_getitem__weights_hidden(f90wrap_this, f90wrap_i, weights_hiddenitem)
    
    use qlknn_types, only: ragged_weights_array, networktype
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: weights_hiddenitem(2)
    type(ragged_weights_array_ptr_type) :: weights_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%weights_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%weights_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            weights_hidden_ptr%p => this_ptr%p%weights_hidden(f90wrap_i)
            weights_hiddenitem = transfer(weights_hidden_ptr,weights_hiddenitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_networktype__array_getitem__weights_hidden

subroutine f90wrap_networktype__array_setitem__weights_hidden(f90wrap_this, f90wrap_i, weights_hiddenitem)
    
    use qlknn_types, only: ragged_weights_array, networktype
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: weights_hiddenitem(2)
    type(ragged_weights_array_ptr_type) :: weights_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%weights_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%weights_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            weights_hidden_ptr = transfer(weights_hiddenitem,weights_hidden_ptr)
            this_ptr%p%weights_hidden(f90wrap_i) = weights_hidden_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_networktype__array_setitem__weights_hidden

subroutine f90wrap_networktype__array_len__weights_hidden(f90wrap_this, f90wrap_n)
    
    use qlknn_types, only: ragged_weights_array, networktype
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(networktype_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%weights_hidden)) then
        f90wrap_n = size(this_ptr%p%weights_hidden)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_networktype__array_len__weights_hidden

subroutine f90wrap_networktype__array_getitem__biases_hidden(f90wrap_this, f90wrap_i, biases_hiddenitem)
    
    use qlknn_types, only: ragged_biases_array, networktype
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: biases_hiddenitem(2)
    type(ragged_biases_array_ptr_type) :: biases_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%biases_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%biases_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            biases_hidden_ptr%p => this_ptr%p%biases_hidden(f90wrap_i)
            biases_hiddenitem = transfer(biases_hidden_ptr,biases_hiddenitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_networktype__array_getitem__biases_hidden

subroutine f90wrap_networktype__array_setitem__biases_hidden(f90wrap_this, f90wrap_i, biases_hiddenitem)
    
    use qlknn_types, only: ragged_biases_array, networktype
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: biases_hiddenitem(2)
    type(ragged_biases_array_ptr_type) :: biases_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%biases_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%biases_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            biases_hidden_ptr = transfer(biases_hiddenitem,biases_hidden_ptr)
            this_ptr%p%biases_hidden(f90wrap_i) = biases_hidden_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_networktype__array_setitem__biases_hidden

subroutine f90wrap_networktype__array_len__biases_hidden(f90wrap_this, f90wrap_n)
    
    use qlknn_types, only: ragged_biases_array, networktype
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(networktype_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%biases_hidden)) then
        f90wrap_n = size(this_ptr%p%biases_hidden)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_networktype__array_len__biases_hidden

subroutine f90wrap_networktype__array__weights_output(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%weights_output)) then
        dshape(1:2) = shape(this_ptr%p%weights_output)
        dloc = loc(this_ptr%p%weights_output)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__weights_output

subroutine f90wrap_networktype__array__biases_output(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%biases_output)) then
        dshape(1:1) = shape(this_ptr%p%biases_output)
        dloc = loc(this_ptr%p%biases_output)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__biases_output

subroutine f90wrap_networktype__array__hidden_activation(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 2
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%hidden_activation)) then
        dshape(1:2) = (/len(this_ptr%p%hidden_activation(1)), shape(this_ptr%p%hidden_activation)/)
        dloc = loc(this_ptr%p%hidden_activation)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__hidden_activation

subroutine f90wrap_networktype__array__feature_prescale_bias(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%feature_prescale_bias)) then
        dshape(1:1) = shape(this_ptr%p%feature_prescale_bias)
        dloc = loc(this_ptr%p%feature_prescale_bias)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__feature_prescale_bias

subroutine f90wrap_networktype__array__feature_prescale_factor(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%feature_prescale_factor)) then
        dshape(1:1) = shape(this_ptr%p%feature_prescale_factor)
        dloc = loc(this_ptr%p%feature_prescale_factor)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__feature_prescale_factor

subroutine f90wrap_networktype__array__target_prescale_bias(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%target_prescale_bias)) then
        dshape(1:1) = shape(this_ptr%p%target_prescale_bias)
        dloc = loc(this_ptr%p%target_prescale_bias)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__target_prescale_bias

subroutine f90wrap_networktype__array__target_prescale_factor(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: networktype
    implicit none
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: this(2)
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%target_prescale_factor)) then
        dshape(1:1) = shape(this_ptr%p%target_prescale_factor)
        dloc = loc(this_ptr%p%target_prescale_factor)
    else
        dloc = 0
    end if
end subroutine f90wrap_networktype__array__target_prescale_factor

subroutine f90wrap_networktype_deallocate(net)
    use qlknn_types, only: networktype, networktype_deallocate
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type(networktype_ptr_type) :: net_ptr
    integer, intent(in), dimension(2) :: net
    net_ptr = transfer(net, net_ptr)
    call networktype_deallocate(net=net_ptr%p)
    deallocate(net_ptr%p)
end subroutine f90wrap_networktype_deallocate

subroutine f90wrap_networktype_initialise(this)
    use qlknn_types, only: networktype
    implicit none
    
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    type(networktype_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_networktype_initialise

subroutine f90wrap_net_collection__array_getitem__nets(f90wrap_this, f90wrap_i, netsitem)
    
    use qlknn_types, only: net_collection, networktype
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: netsitem(2)
    type(networktype_ptr_type) :: nets_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%nets)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%nets)) then
            call f90wrap_abort("array index out of range")
        else
            nets_ptr%p => this_ptr%p%nets(f90wrap_i)
            netsitem = transfer(nets_ptr,netsitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_net_collection__array_getitem__nets

subroutine f90wrap_net_collection__array_setitem__nets(f90wrap_this, f90wrap_i, netsitem)
    
    use qlknn_types, only: net_collection, networktype
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: netsitem(2)
    type(networktype_ptr_type) :: nets_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%nets)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%nets)) then
            call f90wrap_abort("array index out of range")
        else
            nets_ptr = transfer(netsitem,nets_ptr)
            this_ptr%p%nets(f90wrap_i) = nets_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_net_collection__array_setitem__nets

subroutine f90wrap_net_collection__array_len__nets(f90wrap_this, f90wrap_n)
    
    use qlknn_types, only: net_collection, networktype
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type networktype_ptr_type
        type(networktype), pointer :: p => NULL()
    end type networktype_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(net_collection_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%nets)) then
        f90wrap_n = size(this_ptr%p%nets)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_net_collection__array_len__nets

subroutine f90wrap_net_collection__get__Zeff_ind(this, f90wrap_Zeff_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Zeff_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Zeff_ind = this_ptr%p%Zeff_ind
end subroutine f90wrap_net_collection__get__Zeff_ind

subroutine f90wrap_net_collection__set__Zeff_ind(this, f90wrap_Zeff_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Zeff_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Zeff_ind = f90wrap_Zeff_ind
end subroutine f90wrap_net_collection__set__Zeff_ind

subroutine f90wrap_net_collection__get__Ati_ind(this, f90wrap_Ati_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ati_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ati_ind = this_ptr%p%Ati_ind
end subroutine f90wrap_net_collection__get__Ati_ind

subroutine f90wrap_net_collection__set__Ati_ind(this, f90wrap_Ati_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ati_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ati_ind = f90wrap_Ati_ind
end subroutine f90wrap_net_collection__set__Ati_ind

subroutine f90wrap_net_collection__get__Ate_ind(this, f90wrap_Ate_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ate_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ate_ind = this_ptr%p%Ate_ind
end subroutine f90wrap_net_collection__get__Ate_ind

subroutine f90wrap_net_collection__set__Ate_ind(this, f90wrap_Ate_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ate_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ate_ind = f90wrap_Ate_ind
end subroutine f90wrap_net_collection__set__Ate_ind

subroutine f90wrap_net_collection__get__An_ind(this, f90wrap_An_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_An_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_An_ind = this_ptr%p%An_ind
end subroutine f90wrap_net_collection__get__An_ind

subroutine f90wrap_net_collection__set__An_ind(this, f90wrap_An_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_An_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%An_ind = f90wrap_An_ind
end subroutine f90wrap_net_collection__set__An_ind

subroutine f90wrap_net_collection__get__q_ind(this, f90wrap_q_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_q_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_q_ind = this_ptr%p%q_ind
end subroutine f90wrap_net_collection__get__q_ind

subroutine f90wrap_net_collection__set__q_ind(this, f90wrap_q_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_q_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%q_ind = f90wrap_q_ind
end subroutine f90wrap_net_collection__set__q_ind

subroutine f90wrap_net_collection__get__smag_ind(this, f90wrap_smag_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_smag_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_smag_ind = this_ptr%p%smag_ind
end subroutine f90wrap_net_collection__get__smag_ind

subroutine f90wrap_net_collection__set__smag_ind(this, f90wrap_smag_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_smag_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%smag_ind = f90wrap_smag_ind
end subroutine f90wrap_net_collection__set__smag_ind

subroutine f90wrap_net_collection__get__x_ind(this, f90wrap_x_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_x_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_x_ind = this_ptr%p%x_ind
end subroutine f90wrap_net_collection__get__x_ind

subroutine f90wrap_net_collection__set__x_ind(this, f90wrap_x_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_x_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%x_ind = f90wrap_x_ind
end subroutine f90wrap_net_collection__set__x_ind

subroutine f90wrap_net_collection__get__Ti_Te_ind(this, f90wrap_Ti_Te_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ti_Te_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ti_Te_ind = this_ptr%p%Ti_Te_ind
end subroutine f90wrap_net_collection__get__Ti_Te_ind

subroutine f90wrap_net_collection__set__Ti_Te_ind(this, f90wrap_Ti_Te_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ti_Te_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ti_Te_ind = f90wrap_Ti_Te_ind
end subroutine f90wrap_net_collection__set__Ti_Te_ind

subroutine f90wrap_net_collection__get__logNustar_ind(this, f90wrap_logNustar_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_logNustar_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_logNustar_ind = this_ptr%p%logNustar_ind
end subroutine f90wrap_net_collection__get__logNustar_ind

subroutine f90wrap_net_collection__set__logNustar_ind(this, f90wrap_logNustar_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_logNustar_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%logNustar_ind = f90wrap_logNustar_ind
end subroutine f90wrap_net_collection__set__logNustar_ind

subroutine f90wrap_net_collection__get__gammaE_ind(this, f90wrap_gammaE_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_gammaE_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_gammaE_ind = this_ptr%p%gammaE_ind
end subroutine f90wrap_net_collection__get__gammaE_ind

subroutine f90wrap_net_collection__set__gammaE_ind(this, f90wrap_gammaE_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_gammaE_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%gammaE_ind = f90wrap_gammaE_ind
end subroutine f90wrap_net_collection__set__gammaE_ind

subroutine f90wrap_net_collection__get__Te_ind(this, f90wrap_Te_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Te_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Te_ind = this_ptr%p%Te_ind
end subroutine f90wrap_net_collection__get__Te_ind

subroutine f90wrap_net_collection__set__Te_ind(this, f90wrap_Te_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Te_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Te_ind = f90wrap_Te_ind
end subroutine f90wrap_net_collection__set__Te_ind

subroutine f90wrap_net_collection__get__Ane_ind(this, f90wrap_Ane_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ane_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ane_ind = this_ptr%p%Ane_ind
end subroutine f90wrap_net_collection__get__Ane_ind

subroutine f90wrap_net_collection__set__Ane_ind(this, f90wrap_Ane_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ane_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ane_ind = f90wrap_Ane_ind
end subroutine f90wrap_net_collection__set__Ane_ind

subroutine f90wrap_net_collection__get__Machtor_ind(this, f90wrap_Machtor_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Machtor_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Machtor_ind = this_ptr%p%Machtor_ind
end subroutine f90wrap_net_collection__get__Machtor_ind

subroutine f90wrap_net_collection__set__Machtor_ind(this, f90wrap_Machtor_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Machtor_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Machtor_ind = f90wrap_Machtor_ind
end subroutine f90wrap_net_collection__set__Machtor_ind

subroutine f90wrap_net_collection__get__Autor_ind(this, f90wrap_Autor_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Autor_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Autor_ind = this_ptr%p%Autor_ind
end subroutine f90wrap_net_collection__get__Autor_ind

subroutine f90wrap_net_collection__set__Autor_ind(this, f90wrap_Autor_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Autor_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Autor_ind = f90wrap_Autor_ind
end subroutine f90wrap_net_collection__set__Autor_ind

subroutine f90wrap_net_collection__get__alpha_ind(this, f90wrap_alpha_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_alpha_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_alpha_ind = this_ptr%p%alpha_ind
end subroutine f90wrap_net_collection__get__alpha_ind

subroutine f90wrap_net_collection__set__alpha_ind(this, f90wrap_alpha_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_alpha_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%alpha_ind = f90wrap_alpha_ind
end subroutine f90wrap_net_collection__set__alpha_ind

subroutine f90wrap_net_collection__get__Ani0_ind(this, f90wrap_Ani0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ani0_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ani0_ind = this_ptr%p%Ani0_ind
end subroutine f90wrap_net_collection__get__Ani0_ind

subroutine f90wrap_net_collection__set__Ani0_ind(this, f90wrap_Ani0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ani0_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ani0_ind = f90wrap_Ani0_ind
end subroutine f90wrap_net_collection__set__Ani0_ind

subroutine f90wrap_net_collection__get__Ani1_ind(this, f90wrap_Ani1_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ani1_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ani1_ind = this_ptr%p%Ani1_ind
end subroutine f90wrap_net_collection__get__Ani1_ind

subroutine f90wrap_net_collection__set__Ani1_ind(this, f90wrap_Ani1_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ani1_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ani1_ind = f90wrap_Ani1_ind
end subroutine f90wrap_net_collection__set__Ani1_ind

subroutine f90wrap_net_collection__get__Ati0_ind(this, f90wrap_Ati0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ati0_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ati0_ind = this_ptr%p%Ati0_ind
end subroutine f90wrap_net_collection__get__Ati0_ind

subroutine f90wrap_net_collection__set__Ati0_ind(this, f90wrap_Ati0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ati0_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ati0_ind = f90wrap_Ati0_ind
end subroutine f90wrap_net_collection__set__Ati0_ind

subroutine f90wrap_net_collection__get__normni0_ind(this, f90wrap_normni0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_normni0_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_normni0_ind = this_ptr%p%normni0_ind
end subroutine f90wrap_net_collection__get__normni0_ind

subroutine f90wrap_net_collection__set__normni0_ind(this, f90wrap_normni0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_normni0_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%normni0_ind = f90wrap_normni0_ind
end subroutine f90wrap_net_collection__set__normni0_ind

subroutine f90wrap_net_collection__get__normni1_ind(this, f90wrap_normni1_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_normni1_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_normni1_ind = this_ptr%p%normni1_ind
end subroutine f90wrap_net_collection__get__normni1_ind

subroutine f90wrap_net_collection__set__normni1_ind(this, f90wrap_normni1_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_normni1_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%normni1_ind = f90wrap_normni1_ind
end subroutine f90wrap_net_collection__set__normni1_ind

subroutine f90wrap_net_collection__get__Ti_Te0_ind(this, f90wrap_Ti_Te0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(out) :: f90wrap_Ti_Te0_ind
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_Ti_Te0_ind = this_ptr%p%Ti_Te0_ind
end subroutine f90wrap_net_collection__get__Ti_Te0_ind

subroutine f90wrap_net_collection__set__Ti_Te0_ind(this, f90wrap_Ti_Te0_ind)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    integer(8), intent(in) :: f90wrap_Ti_Te0_ind
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%Ti_Te0_ind = f90wrap_Ti_Te0_ind
end subroutine f90wrap_net_collection__set__Ti_Te0_ind

subroutine f90wrap_net_collection__get__a(this, f90wrap_a)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    real(8), intent(out) :: f90wrap_a
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_a = this_ptr%p%a
end subroutine f90wrap_net_collection__get__a

subroutine f90wrap_net_collection__set__a(this, f90wrap_a)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    real(8), intent(in) :: f90wrap_a
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%a = f90wrap_a
end subroutine f90wrap_net_collection__set__a

subroutine f90wrap_net_collection__get__R_0(this, f90wrap_R_0)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    real(8), intent(out) :: f90wrap_R_0
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_R_0 = this_ptr%p%R_0
end subroutine f90wrap_net_collection__get__R_0

subroutine f90wrap_net_collection__set__R_0(this, f90wrap_R_0)
    use qlknn_types, only: net_collection
    implicit none
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    integer, intent(in)   :: this(2)
    type(net_collection_ptr_type) :: this_ptr
    real(8), intent(in) :: f90wrap_R_0
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%R_0 = f90wrap_R_0
end subroutine f90wrap_net_collection__set__R_0

subroutine f90wrap_all_networktype_deallocate(net_coll)
    use qlknn_types, only: net_collection, all_networktype_deallocate
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type(net_collection_ptr_type) :: net_coll_ptr
    integer, intent(in), dimension(2) :: net_coll
    net_coll_ptr = transfer(net_coll, net_coll_ptr)
    call all_networktype_deallocate(net_coll=net_coll_ptr%p)
    deallocate(net_coll_ptr%p)
end subroutine f90wrap_all_networktype_deallocate

subroutine f90wrap_net_collection_initialise(this)
    use qlknn_types, only: net_collection
    implicit none
    
    type net_collection_ptr_type
        type(net_collection), pointer :: p => NULL()
    end type net_collection_ptr_type
    type(net_collection_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_net_collection_initialise

subroutine f90wrap_hornnet_output_block__array_getitem__weights_hidden(f90wrap_this, f90wrap_i, weights_hiddenitem)
    
    use qlknn_types, only: ragged_weights_array, hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: weights_hiddenitem(2)
    type(ragged_weights_array_ptr_type) :: weights_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%weights_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%weights_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            weights_hidden_ptr%p => this_ptr%p%weights_hidden(f90wrap_i)
            weights_hiddenitem = transfer(weights_hidden_ptr,weights_hiddenitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_hornnet_output_block__array_getitem__weights_hidden

subroutine f90wrap_hornnet_output_block__array_setitem__weights_hidden(f90wrap_this, f90wrap_i, weights_hiddenitem)
    
    use qlknn_types, only: ragged_weights_array, hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: weights_hiddenitem(2)
    type(ragged_weights_array_ptr_type) :: weights_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%weights_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%weights_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            weights_hidden_ptr = transfer(weights_hiddenitem,weights_hidden_ptr)
            this_ptr%p%weights_hidden(f90wrap_i) = weights_hidden_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_hornnet_output_block__array_setitem__weights_hidden

subroutine f90wrap_hornnet_output_block__array_len__weights_hidden(f90wrap_this, f90wrap_n)
    
    use qlknn_types, only: ragged_weights_array, hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type ragged_weights_array_ptr_type
        type(ragged_weights_array), pointer :: p => NULL()
    end type ragged_weights_array_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%weights_hidden)) then
        f90wrap_n = size(this_ptr%p%weights_hidden)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_hornnet_output_block__array_len__weights_hidden

subroutine f90wrap_hornnet_output_block__array_getitem__biases_hidden(f90wrap_this, f90wrap_i, biases_hiddenitem)
    
    use qlknn_types, only: ragged_biases_array, hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: biases_hiddenitem(2)
    type(ragged_biases_array_ptr_type) :: biases_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%biases_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%biases_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            biases_hidden_ptr%p => this_ptr%p%biases_hidden(f90wrap_i)
            biases_hiddenitem = transfer(biases_hidden_ptr,biases_hiddenitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_hornnet_output_block__array_getitem__biases_hidden

subroutine f90wrap_hornnet_output_block__array_setitem__biases_hidden(f90wrap_this, f90wrap_i, biases_hiddenitem)
    
    use qlknn_types, only: ragged_biases_array, hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: biases_hiddenitem(2)
    type(ragged_biases_array_ptr_type) :: biases_hidden_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%biases_hidden)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%biases_hidden)) then
            call f90wrap_abort("array index out of range")
        else
            biases_hidden_ptr = transfer(biases_hiddenitem,biases_hidden_ptr)
            this_ptr%p%biases_hidden(f90wrap_i) = biases_hidden_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_hornnet_output_block__array_setitem__biases_hidden

subroutine f90wrap_hornnet_output_block__array_len__biases_hidden(f90wrap_this, f90wrap_n)
    
    use qlknn_types, only: ragged_biases_array, hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type ragged_biases_array_ptr_type
        type(ragged_biases_array), pointer :: p => NULL()
    end type ragged_biases_array_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%biases_hidden)) then
        f90wrap_n = size(this_ptr%p%biases_hidden)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_hornnet_output_block__array_len__biases_hidden

subroutine f90wrap_hornnet_output_block__array__weights_output(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_output_block
    implicit none
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%weights_output)) then
        dshape(1:2) = shape(this_ptr%p%weights_output)
        dloc = loc(this_ptr%p%weights_output)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_output_block__array__weights_output

subroutine f90wrap_hornnet_output_block__array__biases_output(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_output_block
    implicit none
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%biases_output)) then
        dshape(1:1) = shape(this_ptr%p%biases_output)
        dloc = loc(this_ptr%p%biases_output)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_output_block__array__biases_output

subroutine f90wrap_hornnet_output_block__array__hidden_activation(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_output_block
    implicit none
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 2
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%hidden_activation)) then
        dshape(1:2) = (/len(this_ptr%p%hidden_activation(1)), shape(this_ptr%p%hidden_activation)/)
        dloc = loc(this_ptr%p%hidden_activation)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_output_block__array__hidden_activation

subroutine f90wrap_hornnet_output_block__get__blockname(this, f90wrap_blockname)
    use qlknn_types, only: hornnet_output_block
    implicit none
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(in)   :: this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    character(20), intent(out) :: f90wrap_blockname
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_blockname = this_ptr%p%blockname
end subroutine f90wrap_hornnet_output_block__get__blockname

subroutine f90wrap_hornnet_output_block__set__blockname(this, f90wrap_blockname)
    use qlknn_types, only: hornnet_output_block
    implicit none
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(in)   :: this(2)
    type(hornnet_output_block_ptr_type) :: this_ptr
    character(20), intent(in) :: f90wrap_blockname
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%blockname = f90wrap_blockname
end subroutine f90wrap_hornnet_output_block__set__blockname

subroutine f90wrap_hornnet_output_block_initialise(this)
    use qlknn_types, only: hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_hornnet_output_block_initialise

subroutine f90wrap_hornnet_output_block_finalise(this)
    use qlknn_types, only: hornnet_output_block
    implicit none
    
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    type(hornnet_output_block_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_hornnet_output_block_finalise

subroutine f90wrap_hornnet_input_block__array__weights_input(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_input_block
    implicit none
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 2
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%weights_input)) then
        dshape(1:2) = shape(this_ptr%p%weights_input)
        dloc = loc(this_ptr%p%weights_input)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_input_block__array__weights_input

subroutine f90wrap_hornnet_input_block__array__biases_input(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_input_block
    implicit none
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%biases_input)) then
        dshape(1:1) = shape(this_ptr%p%biases_input)
        dloc = loc(this_ptr%p%biases_input)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_input_block__array__biases_input

subroutine f90wrap_hornnet_input_block__array__feature_prescale_bias(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_input_block
    implicit none
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%feature_prescale_bias)) then
        dshape(1:1) = shape(this_ptr%p%feature_prescale_bias)
        dloc = loc(this_ptr%p%feature_prescale_bias)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_input_block__array__feature_prescale_bias

subroutine f90wrap_hornnet_input_block__array__feature_prescale_factor(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_input_block
    implicit none
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%feature_prescale_factor)) then
        dshape(1:1) = shape(this_ptr%p%feature_prescale_factor)
        dloc = loc(this_ptr%p%feature_prescale_factor)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_input_block__array__feature_prescale_factor

subroutine f90wrap_hornnet_input_block__array__target_prescale_bias(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_input_block
    implicit none
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%target_prescale_bias)) then
        dshape(1:1) = shape(this_ptr%p%target_prescale_bias)
        dloc = loc(this_ptr%p%target_prescale_bias)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_input_block__array__target_prescale_bias

subroutine f90wrap_hornnet_input_block__array__target_prescale_factor(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: hornnet_input_block
    implicit none
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: this(2)
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%target_prescale_factor)) then
        dshape(1:1) = shape(this_ptr%p%target_prescale_factor)
        dloc = loc(this_ptr%p%target_prescale_factor)
    else
        dloc = 0
    end if
end subroutine f90wrap_hornnet_input_block__array__target_prescale_factor

subroutine f90wrap_hornnet_input_block_initialise(this)
    use qlknn_types, only: hornnet_input_block
    implicit none
    
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_hornnet_input_block_initialise

subroutine f90wrap_hornnet_input_block_finalise(this)
    use qlknn_types, only: hornnet_input_block
    implicit none
    
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    type(hornnet_input_block_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_hornnet_input_block_finalise

subroutine f90wrap_block_collection__array_getitem__output_blocks(f90wrap_this, f90wrap_i, output_blocksitem)
    
    use qlknn_types, only: block_collection, hornnet_output_block
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(block_collection_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: output_blocksitem(2)
    type(hornnet_output_block_ptr_type) :: output_blocks_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%output_blocks)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%output_blocks)) then
            call f90wrap_abort("array index out of range")
        else
            output_blocks_ptr%p => this_ptr%p%output_blocks(f90wrap_i)
            output_blocksitem = transfer(output_blocks_ptr,output_blocksitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_block_collection__array_getitem__output_blocks

subroutine f90wrap_block_collection__array_setitem__output_blocks(f90wrap_this, f90wrap_i, output_blocksitem)
    
    use qlknn_types, only: block_collection, hornnet_output_block
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(block_collection_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: output_blocksitem(2)
    type(hornnet_output_block_ptr_type) :: output_blocks_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%output_blocks)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%output_blocks)) then
            call f90wrap_abort("array index out of range")
        else
            output_blocks_ptr = transfer(output_blocksitem,output_blocks_ptr)
            this_ptr%p%output_blocks(f90wrap_i) = output_blocks_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_block_collection__array_setitem__output_blocks

subroutine f90wrap_block_collection__array_len__output_blocks(f90wrap_this, f90wrap_n)
    
    use qlknn_types, only: block_collection, hornnet_output_block
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type hornnet_output_block_ptr_type
        type(hornnet_output_block), pointer :: p => NULL()
    end type hornnet_output_block_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(block_collection_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%output_blocks)) then
        f90wrap_n = size(this_ptr%p%output_blocks)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_block_collection__array_len__output_blocks

subroutine f90wrap_block_collection__array_getitem__input_blocks(f90wrap_this, f90wrap_i, input_blocksitem)
    
    use qlknn_types, only: block_collection, hornnet_input_block
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(block_collection_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(out) :: input_blocksitem(2)
    type(hornnet_input_block_ptr_type) :: input_blocks_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%input_blocks)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%input_blocks)) then
            call f90wrap_abort("array index out of range")
        else
            input_blocks_ptr%p => this_ptr%p%input_blocks(f90wrap_i)
            input_blocksitem = transfer(input_blocks_ptr,input_blocksitem)
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_block_collection__array_getitem__input_blocks

subroutine f90wrap_block_collection__array_setitem__input_blocks(f90wrap_this, f90wrap_i, input_blocksitem)
    
    use qlknn_types, only: block_collection, hornnet_input_block
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(in) :: f90wrap_this(2)
    type(block_collection_ptr_type) :: this_ptr
    integer, intent(in) :: f90wrap_i
    integer, intent(in) :: input_blocksitem(2)
    type(hornnet_input_block_ptr_type) :: input_blocks_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%input_blocks)) then
        if (f90wrap_i < 1 .or. f90wrap_i > size(this_ptr%p%input_blocks)) then
            call f90wrap_abort("array index out of range")
        else
            input_blocks_ptr = transfer(input_blocksitem,input_blocks_ptr)
            this_ptr%p%input_blocks(f90wrap_i) = input_blocks_ptr%p
        endif
    else
        call f90wrap_abort("derived type array not allocated")
    end if
end subroutine f90wrap_block_collection__array_setitem__input_blocks

subroutine f90wrap_block_collection__array_len__input_blocks(f90wrap_this, f90wrap_n)
    
    use qlknn_types, only: block_collection, hornnet_input_block
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type hornnet_input_block_ptr_type
        type(hornnet_input_block), pointer :: p => NULL()
    end type hornnet_input_block_ptr_type
    integer, intent(out) :: f90wrap_n
    integer, intent(in) :: f90wrap_this(2)
    type(block_collection_ptr_type) :: this_ptr
    
    this_ptr = transfer(f90wrap_this, this_ptr)
    if (allocated(this_ptr%p%input_blocks)) then
        f90wrap_n = size(this_ptr%p%input_blocks)
    else
        f90wrap_n = 0
    end if
end subroutine f90wrap_block_collection__array_len__input_blocks

subroutine f90wrap_block_collection_initialise(this)
    use qlknn_types, only: block_collection
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type(block_collection_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_block_collection_initialise

subroutine f90wrap_block_collection_finalise(this)
    use qlknn_types, only: block_collection
    implicit none
    
    type block_collection_ptr_type
        type(block_collection), pointer :: p => NULL()
    end type block_collection_ptr_type
    type(block_collection_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_block_collection_finalise

subroutine f90wrap_qlknn_options__get__use_ion_diffusivity_networks(this, f90wrap_use_ion_diffusivity_networks)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_use_ion_diffusivity_networks
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_use_ion_diffusivity_networks = this_ptr%p%use_ion_diffusivity_networks
end subroutine f90wrap_qlknn_options__get__use_ion_diffusivity_networks

subroutine f90wrap_qlknn_options__set__use_ion_diffusivity_networks(this, f90wrap_use_ion_diffusivity_networks)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_use_ion_diffusivity_networks
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%use_ion_diffusivity_networks = f90wrap_use_ion_diffusivity_networks
end subroutine f90wrap_qlknn_options__set__use_ion_diffusivity_networks

subroutine f90wrap_qlknn_options__get__apply_victor_rule(this, f90wrap_apply_victor_rule)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_apply_victor_rule
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_apply_victor_rule = this_ptr%p%apply_victor_rule
end subroutine f90wrap_qlknn_options__get__apply_victor_rule

subroutine f90wrap_qlknn_options__set__apply_victor_rule(this, f90wrap_apply_victor_rule)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_apply_victor_rule
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%apply_victor_rule = f90wrap_apply_victor_rule
end subroutine f90wrap_qlknn_options__set__apply_victor_rule

subroutine f90wrap_qlknn_options__get__use_effective_diffusivity(this, f90wrap_use_effective_diffusivity)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_use_effective_diffusivity
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_use_effective_diffusivity = this_ptr%p%use_effective_diffusivity
end subroutine f90wrap_qlknn_options__get__use_effective_diffusivity

subroutine f90wrap_qlknn_options__set__use_effective_diffusivity(this, f90wrap_use_effective_diffusivity)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_use_effective_diffusivity
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%use_effective_diffusivity = f90wrap_use_effective_diffusivity
end subroutine f90wrap_qlknn_options__set__use_effective_diffusivity

subroutine f90wrap_qlknn_options__get__calc_heat_transport(this, f90wrap_calc_heat_transport)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_calc_heat_transport
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_calc_heat_transport = this_ptr%p%calc_heat_transport
end subroutine f90wrap_qlknn_options__get__calc_heat_transport

subroutine f90wrap_qlknn_options__set__calc_heat_transport(this, f90wrap_calc_heat_transport)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_calc_heat_transport
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%calc_heat_transport = f90wrap_calc_heat_transport
end subroutine f90wrap_qlknn_options__set__calc_heat_transport

subroutine f90wrap_qlknn_options__get__calc_part_transport(this, f90wrap_calc_part_transport)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_calc_part_transport
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_calc_part_transport = this_ptr%p%calc_part_transport
end subroutine f90wrap_qlknn_options__get__calc_part_transport

subroutine f90wrap_qlknn_options__set__calc_part_transport(this, f90wrap_calc_part_transport)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_calc_part_transport
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%calc_part_transport = f90wrap_calc_part_transport
end subroutine f90wrap_qlknn_options__set__calc_part_transport

subroutine f90wrap_qlknn_options__get__use_ETG(this, f90wrap_use_ETG)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_use_ETG
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_use_ETG = this_ptr%p%use_ETG
end subroutine f90wrap_qlknn_options__get__use_ETG

subroutine f90wrap_qlknn_options__set__use_ETG(this, f90wrap_use_ETG)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_use_ETG
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%use_ETG = f90wrap_use_ETG
end subroutine f90wrap_qlknn_options__set__use_ETG

subroutine f90wrap_qlknn_options__get__use_ITG(this, f90wrap_use_ITG)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_use_ITG
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_use_ITG = this_ptr%p%use_ITG
end subroutine f90wrap_qlknn_options__get__use_ITG

subroutine f90wrap_qlknn_options__set__use_ITG(this, f90wrap_use_ITG)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_use_ITG
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%use_ITG = f90wrap_use_ITG
end subroutine f90wrap_qlknn_options__set__use_ITG

subroutine f90wrap_qlknn_options__get__use_TEM(this, f90wrap_use_TEM)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_use_TEM
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_use_TEM = this_ptr%p%use_TEM
end subroutine f90wrap_qlknn_options__get__use_TEM

subroutine f90wrap_qlknn_options__set__use_TEM(this, f90wrap_use_TEM)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_use_TEM
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%use_TEM = f90wrap_use_TEM
end subroutine f90wrap_qlknn_options__set__use_TEM

subroutine f90wrap_qlknn_options__get__apply_stability_clipping(this, f90wrap_apply_stability_clipping)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_apply_stability_clipping
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_apply_stability_clipping = this_ptr%p%apply_stability_clipping
end subroutine f90wrap_qlknn_options__get__apply_stability_clipping

subroutine f90wrap_qlknn_options__set__apply_stability_clipping(this, f90wrap_apply_stability_clipping)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_apply_stability_clipping
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%apply_stability_clipping = f90wrap_apply_stability_clipping
end subroutine f90wrap_qlknn_options__set__apply_stability_clipping

subroutine f90wrap_qlknn_options__array__constrain_inputs(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 5
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%constrain_inputs)) then
        dshape(1:1) = shape(this_ptr%p%constrain_inputs)
        dloc = loc(this_ptr%p%constrain_inputs)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__constrain_inputs

subroutine f90wrap_qlknn_options__array__min_input(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%min_input)) then
        dshape(1:1) = shape(this_ptr%p%min_input)
        dloc = loc(this_ptr%p%min_input)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__min_input

subroutine f90wrap_qlknn_options__array__max_input(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%max_input)) then
        dshape(1:1) = shape(this_ptr%p%max_input)
        dloc = loc(this_ptr%p%max_input)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__max_input

subroutine f90wrap_qlknn_options__array__margin_input(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%margin_input)) then
        dshape(1:1) = shape(this_ptr%p%margin_input)
        dloc = loc(this_ptr%p%margin_input)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__margin_input

subroutine f90wrap_qlknn_options__array__constrain_outputs(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 5
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%constrain_outputs)) then
        dshape(1:1) = shape(this_ptr%p%constrain_outputs)
        dloc = loc(this_ptr%p%constrain_outputs)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__constrain_outputs

subroutine f90wrap_qlknn_options__array__min_output(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%min_output)) then
        dshape(1:1) = shape(this_ptr%p%min_output)
        dloc = loc(this_ptr%p%min_output)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__min_output

subroutine f90wrap_qlknn_options__array__max_output(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%max_output)) then
        dshape(1:1) = shape(this_ptr%p%max_output)
        dloc = loc(this_ptr%p%max_output)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__max_output

subroutine f90wrap_qlknn_options__array__margin_output(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%margin_output)) then
        dshape(1:1) = shape(this_ptr%p%margin_output)
        dloc = loc(this_ptr%p%margin_output)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_options__array__margin_output

subroutine f90wrap_qlknn_options__get__merge_modes(this, f90wrap_merge_modes)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_merge_modes
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_merge_modes = this_ptr%p%merge_modes
end subroutine f90wrap_qlknn_options__get__merge_modes

subroutine f90wrap_qlknn_options__set__merge_modes(this, f90wrap_merge_modes)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_merge_modes
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%merge_modes = f90wrap_merge_modes
end subroutine f90wrap_qlknn_options__set__merge_modes

subroutine f90wrap_qlknn_options__get__force_evaluate_all(this, f90wrap_force_evaluate_all)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(out) :: f90wrap_force_evaluate_all
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_force_evaluate_all = this_ptr%p%force_evaluate_all
end subroutine f90wrap_qlknn_options__get__force_evaluate_all

subroutine f90wrap_qlknn_options__set__force_evaluate_all(this, f90wrap_force_evaluate_all)
    use qlknn_types, only: qlknn_options
    implicit none
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_options_ptr_type) :: this_ptr
    logical, intent(in) :: f90wrap_force_evaluate_all
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%force_evaluate_all = f90wrap_force_evaluate_all
end subroutine f90wrap_qlknn_options__set__force_evaluate_all

subroutine f90wrap_qlknn_options_initialise(this)
    use qlknn_types, only: qlknn_options
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(out), dimension(2) :: this
    allocate(this_ptr%p)
    this = transfer(this_ptr, this)
end subroutine f90wrap_qlknn_options_initialise

subroutine f90wrap_qlknn_options_finalise(this)
    use qlknn_types, only: qlknn_options
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: this_ptr
    integer, intent(in), dimension(2) :: this
    this_ptr = transfer(this, this_ptr)
    deallocate(this_ptr%p)
end subroutine f90wrap_qlknn_options_finalise

subroutine f90wrap_qlknn_normpars__get__a(this, f90wrap_a)
    use qlknn_types, only: qlknn_normpars
    implicit none
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_normpars_ptr_type) :: this_ptr
    real(8), intent(out) :: f90wrap_a
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_a = this_ptr%p%a
end subroutine f90wrap_qlknn_normpars__get__a

subroutine f90wrap_qlknn_normpars__set__a(this, f90wrap_a)
    use qlknn_types, only: qlknn_normpars
    implicit none
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_normpars_ptr_type) :: this_ptr
    real(8), intent(in) :: f90wrap_a
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%a = f90wrap_a
end subroutine f90wrap_qlknn_normpars__set__a

subroutine f90wrap_qlknn_normpars__get__R0(this, f90wrap_R0)
    use qlknn_types, only: qlknn_normpars
    implicit none
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_normpars_ptr_type) :: this_ptr
    real(8), intent(out) :: f90wrap_R0
    
    this_ptr = transfer(this, this_ptr)
    f90wrap_R0 = this_ptr%p%R0
end subroutine f90wrap_qlknn_normpars__get__R0

subroutine f90wrap_qlknn_normpars__set__R0(this, f90wrap_R0)
    use qlknn_types, only: qlknn_normpars
    implicit none
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    integer, intent(in)   :: this(2)
    type(qlknn_normpars_ptr_type) :: this_ptr
    real(8), intent(in) :: f90wrap_R0
    
    this_ptr = transfer(this, this_ptr)
    this_ptr%p%R0 = f90wrap_R0
end subroutine f90wrap_qlknn_normpars__set__R0

subroutine f90wrap_qlknn_normpars__array__A1(this, nd, dtype, dshape, dloc)
    use qlknn_types, only: qlknn_normpars
    implicit none
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    integer, intent(in) :: this(2)
    type(qlknn_normpars_ptr_type) :: this_ptr
    integer, intent(out) :: nd
    integer, intent(out) :: dtype
    integer, dimension(10), intent(out) :: dshape
    integer*8, intent(out) :: dloc
    
    nd = 1
    dtype = 12
    this_ptr = transfer(this, this_ptr)
    if (allocated(this_ptr%p%A1)) then
        dshape(1:1) = shape(this_ptr%p%A1)
        dloc = loc(this_ptr%p%A1)
    else
        dloc = 0
    end if
end subroutine f90wrap_qlknn_normpars__array__A1

subroutine f90wrap_qlknn_normpars_allocate(qlknn_norms, nrho)
    use qlknn_types, only: qlknn_normpars_allocate, qlknn_normpars
    implicit none
    
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    type(qlknn_normpars_ptr_type) :: qlknn_norms_ptr
    integer, intent(out), dimension(2) :: qlknn_norms
    integer :: nrho
    allocate(qlknn_norms_ptr%p)
    call qlknn_normpars_allocate(qlknn_norms=qlknn_norms_ptr%p, nrho=nrho)
    qlknn_norms = transfer(qlknn_norms_ptr, qlknn_norms)
end subroutine f90wrap_qlknn_normpars_allocate

subroutine f90wrap_qlknn_normpars_deallocate(qlknn_norms)
    use qlknn_types, only: qlknn_normpars_deallocate, qlknn_normpars
    implicit none
    
    type qlknn_normpars_ptr_type
        type(qlknn_normpars), pointer :: p => NULL()
    end type qlknn_normpars_ptr_type
    type(qlknn_normpars_ptr_type) :: qlknn_norms_ptr
    integer, intent(in), dimension(2) :: qlknn_norms
    qlknn_norms_ptr = transfer(qlknn_norms, qlknn_norms_ptr)
    call qlknn_normpars_deallocate(qlknn_norms=qlknn_norms_ptr%p)
    deallocate(qlknn_norms_ptr%p)
end subroutine f90wrap_qlknn_normpars_deallocate

subroutine f90wrap_default_qlknn_hyper_options(opts)
    use qlknn_types, only: qlknn_options, default_qlknn_hyper_options
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: opts_ptr
    integer, intent(out), dimension(2) :: opts
    allocate(opts_ptr%p)
    call default_qlknn_hyper_options(opts=opts_ptr%p)
    opts = transfer(opts_ptr, opts)
end subroutine f90wrap_default_qlknn_hyper_options

subroutine f90wrap_default_qlknn_fullflux_options(opts)
    use qlknn_types, only: qlknn_options, default_qlknn_fullflux_options
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: opts_ptr
    integer, intent(out), dimension(2) :: opts
    allocate(opts_ptr%p)
    call default_qlknn_fullflux_options(opts=opts_ptr%p)
    opts = transfer(opts_ptr, opts)
end subroutine f90wrap_default_qlknn_fullflux_options

subroutine f90wrap_default_qlknn_jetexp_options(opts)
    use qlknn_types, only: default_qlknn_jetexp_options, qlknn_options
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: opts_ptr
    integer, intent(out), dimension(2) :: opts
    allocate(opts_ptr%p)
    call default_qlknn_jetexp_options(opts=opts_ptr%p)
    opts = transfer(opts_ptr, opts)
end subroutine f90wrap_default_qlknn_jetexp_options

subroutine f90wrap_default_qlknn_hornnet_options(opts)
    use qlknn_types, only: qlknn_options, default_qlknn_hornnet_options
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: opts_ptr
    integer, intent(out), dimension(2) :: opts
    allocate(opts_ptr%p)
    call default_qlknn_hornnet_options(opts=opts_ptr%p)
    opts = transfer(opts_ptr, opts)
end subroutine f90wrap_default_qlknn_hornnet_options

subroutine f90wrap_print_qlknn_options(opts)
    use qlknn_types, only: qlknn_options, print_qlknn_options
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: opts_ptr
    integer, intent(in), dimension(2) :: opts
    opts_ptr = transfer(opts, opts_ptr)
    call print_qlknn_options(opts=opts_ptr%p)
end subroutine f90wrap_print_qlknn_options

subroutine f90wrap_get_networks_to_evaluate(opts, net_evaluate)
    use qlknn_types, only: qlknn_options, get_networks_to_evaluate
    implicit none
    
    type qlknn_options_ptr_type
        type(qlknn_options), pointer :: p => NULL()
    end type qlknn_options_ptr_type
    type(qlknn_options_ptr_type) :: opts_ptr
    integer, intent(in), dimension(2) :: opts
    logical, dimension(20), intent(inout) :: net_evaluate
    opts_ptr = transfer(opts, opts_ptr)
    call get_networks_to_evaluate(opts=opts_ptr%p, net_evaluate=net_evaluate)
end subroutine f90wrap_get_networks_to_evaluate

subroutine f90wrap_qlknn_types__get__qlknn_dp(f90wrap_qlknn_dp)
    use qlknn_types, only: qlknn_types_qlknn_dp => qlknn_dp
    implicit none
    integer, intent(out) :: f90wrap_qlknn_dp
    
    f90wrap_qlknn_dp = qlknn_types_qlknn_dp
end subroutine f90wrap_qlknn_types__get__qlknn_dp

subroutine f90wrap_qlknn_types__get__lli(f90wrap_lli)
    use qlknn_types, only: qlknn_types_lli => lli
    implicit none
    integer, intent(out) :: f90wrap_lli
    
    f90wrap_lli = qlknn_types_lli
end subroutine f90wrap_qlknn_types__get__lli

subroutine f90wrap_qlknn_types__get__li(f90wrap_li)
    use qlknn_types, only: qlknn_types_li => li
    implicit none
    integer, intent(out) :: f90wrap_li
    
    f90wrap_li = qlknn_types_li
end subroutine f90wrap_qlknn_types__get__li

subroutine f90wrap_qlknn_types__get__stderr(f90wrap_stderr)
    use qlknn_types, only: qlknn_types_stderr => stderr
    implicit none
    integer(8), intent(out) :: f90wrap_stderr
    
    f90wrap_stderr = qlknn_types_stderr
end subroutine f90wrap_qlknn_types__get__stderr

subroutine f90wrap_qlknn_types__get__qe(f90wrap_qe)
    use qlknn_types, only: qlknn_types_qe => qe
    implicit none
    real(8), intent(out) :: f90wrap_qe
    
    f90wrap_qe = qlknn_types_qe
end subroutine f90wrap_qlknn_types__get__qe

subroutine f90wrap_qlknn_types__get__mp(f90wrap_mp)
    use qlknn_types, only: qlknn_types_mp => mp
    implicit none
    real(8), intent(out) :: f90wrap_mp
    
    f90wrap_mp = qlknn_types_mp
end subroutine f90wrap_qlknn_types__get__mp

subroutine f90wrap_qlknn_types__get__c_qlk_ref(f90wrap_c_qlk_ref)
    use qlknn_types, only: qlknn_types_c_qlk_ref => c_qlk_ref
    implicit none
    real(8), intent(out) :: f90wrap_c_qlk_ref
    
    f90wrap_c_qlk_ref = qlknn_types_c_qlk_ref
end subroutine f90wrap_qlknn_types__get__c_qlk_ref

! End of module qlknn_types defined in file /builds/qualikiz-group/QLKNN-fortran/src/core/qlknn_types.f90

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_python
    use qlknn_evaluate_nets
    use qlknn_disk_io

    implicit none
contains
    subroutine evaluate_QLKNN_10D_direct(qlknn_path, input, qlknn_out, verbosityin, optsin, qlknn_normsin)
        real(qlknn_dp), dimension(:,:), intent(in) :: input
        character(len=2048), intent(in) :: qlknn_path
        integer(lli), optional, intent(in) :: verbosityin
        type (qlknn_options), optional, intent(in) :: optsin
        type(qlknn_normpars), optional, intent(in) :: qlknn_normsin

        real(qlknn_dp), dimension(:,:), intent(out) :: qlknn_out

        logical, save :: nets_loaded=.false.

        if (.NOT. nets_loaded) then
            call load_qlknn_hyper_nets_from_disk(trim(qlknn_path), verbosityin)
            nets_loaded=.true.
        end if
        CALL evaluate_QLKNN_10D(input, nets, qlknn_out, verbosityin, optsin, qlknn_normsin)
    end subroutine evaluate_QLKNN_10D_direct

    subroutine finalize()
        call all_networktype_deallocate(nets)
    end subroutine

    !subroutine evaluate_QLKNN_fusion_direct(qlknn_path, input, qlknn_out, verbosityin, optsin, qlknn_normsin)
    !    real(qlknn_dp), dimension(:,:), intent(in) :: input
    !    character(len=2048), intent(in) :: qlknn_path
    !    integer(lli), optional, intent(in) :: verbosityin
    !    type (qlknn_options), optional, intent(in) :: optsin
    !    type(qlknn_normpars), optional, intent(in) :: qlknn_normsin

    !    real(qlknn_dp), dimension(:,:), intent(out) :: qlknn_out

    !    real(qlknn_dp), dimension(:,:), allocatable :: fusion_constants
    !    logical, save :: nets_loaded=.false.

    !    print *, 'entering function'

    !    if (.NOT. nets_loaded) then
    !        call load_fusion_nets_from_disk(trim(qlknn_path), verbosityin)
    !        nets_loaded=.true.
    !    end if
    !    print *, 'allocating constants'
    !    allocate(fusion_constants(size(input, 2), 15))
    !    print *, 'eval constants'
    !    call evaluate_fusion_constants(input, blocks, fusion_constants, verbosityin, optsin, qlknn_normsin)
    !    print *, 'eval flux'
    !    call fusion_flux_from_constants(input, blocks, fusion_constants, qlknn_out, verbosityin, optsin, qlknn_normsin)
    !end subroutine evaluate_QLKNN_fusion_direct

    subroutine abort(msg)
        character(len=2048), intent(in) :: msg
        write(stderr, *) trim(msg)
      end subroutine abort

end module qlknn_python

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
! Dummy test implementation
! Do not forget to add Makefile rules to fruit.make!
module test_dummy
#include "../src/core/preprocessor.inc"
  use fruit
  use fruit_util
#ifdef MPI
  use mpi
#endif
  implicit none
contains
  subroutine test_stuff
    use qlknn_types
    !use qlknn_random_modules
    implicit none
    integer :: weird_dummy_int
    integer :: verbosity
    integer(lli) :: dummy_int

#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) my_world_rank
#else
    integer(li) my_world_rank
#endif

#ifdef MPI
#if defined(LLI) && defined(__INTEL_COMPILER)
    integer(lli) mpi_ierr, world_size
#else
    integer(li) mpi_ierr, world_size
#endif
#endif

#ifdef MPI
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
#else
    my_world_rank = 0
#endif
    verbosity = 1
    if (verbosity >= 1) then
      write(*, *) 'I am test dummy and my world rank is', my_world_rank
    endif

    weird_dummy_int = 1
    dummy_int = 1
    if (my_world_rank == 0) then
      call assert_equals(INT(dummy_int), INT(weird_dummy_int),'Casted integer gives different value!')
    endif

  end subroutine test_stuff
end module test_dummy

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module qlknn_evaluate_nets
#include "preprocessor.inc"
  use qlknn_types
  use qlknn_primitives
  use qlknn_victor_rule
  use qlknn_error_filter, only: determine_validity_with_eb, determine_validity_multiplied_networks, determine_validity_merged_modes

#ifdef MPI
  use mpi
#endif
  implicit none
contains
  subroutine evaluate_QLKNN_10D(input, nets, qlknn_out, verbosityin, optsin, qlknn_normsin, dqlknn_out_dinput)
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    real(qlknn_dp), dimension(:,:), allocatable :: input_clipped
    integer(lli), optional, intent(in) :: verbosityin
    type(net_collection), intent(in) :: nets
    type(qlknn_options), optional, intent(in) :: optsin
    type(qlknn_normpars), optional, intent(in) :: qlknn_normsin

    real(qlknn_dp), dimension(:,:), intent(out) :: qlknn_out
    real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: dqlknn_out_dinput

    type(qlknn_normpars) :: qlknn_norms

    integer(lli) :: ii, rho, verbosity, outp
    integer(li) :: n_rho, n_outputs, n_total_inputs
    integer(li), parameter :: n_nets = 20
    real(qlknn_dp), dimension(:), allocatable :: res
    real(qlknn_dp), dimension(:,:), allocatable :: net_result
    real(qlknn_dp), dimension(:,:), allocatable :: net_input
    real(qlknn_dp), dimension(:,:,:), allocatable :: dnet_out_dnet_in, dnet_out_dinput
    logical, dimension(:,:), allocatable :: jacobian_clipmask
    type(qlknn_options) :: opts
    logical, dimension(n_nets) :: net_evaluate
    logical :: calcder
    character(len=100) :: fmt_tmp
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: my_world_rank
#else
    integer(li) :: my_world_rank
#endif
#ifdef MPI
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: mpi_ierr, world_size
#else
    integer(li) :: mpi_ierr, world_size
#endif
#endif
    integer(lli), dimension(10,3), parameter :: merge_map = reshape( (/ &
         1, 1, 4, 6, 8, 10, 12, 14, 16, 18, &
         2, 0, 5, 7, 9, 11, 13, 15, 17, 19, &
         3, 0, 0, 0, 0,  0,  0,  0,  0,  0 &
         /), (/ 10,3 /))
         !  1 efe_GB
         !  2 efeETG_GB
         !  3 efi_GB
         !  4 pfe_GB
         !  5 dfe_GB
         !  6 vte_GB
         !  7 vce_GB
         !  8 dfi_GB
         !  9 vti_GB
         ! 10 vci_GB
    integer(lli), dimension(9,3) :: leading_map
    leading_map = reshape( (/ &
         1, 0, 0, 0,  0,  0,  0,  0,  0, & ! ETG
         3, 5, 7, 9, 11, 13, 15, 17, 19, & ! TEM
         4, 2, 6, 8, 10, 12, 14, 16, 18  & ! ITG
         /), (/ 9, 3 /))

    ! zeff ati  ate   an         q      smag         x  ti_te logNustar
    !1.0   2.000000  5.0  2.0  0.660156  0.399902  0.449951    1.0      0.001
    !1.0  13.000000  5.0  2.0  0.660156  0.399902  0.449951    1.0      0.001
    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

#ifdef MPI
    call MPI_COMM_SIZE(MPI_COMM_WORLD, world_size, mpi_ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
    if (my_world_rank == 0) then
       if (verbosity >= 2) write(*,*) 'World size is ', world_size
    end if
    if (verbosity >= 2) write(*,*) 'Hello world from rank ', my_world_rank
#else
    my_world_rank = 0
#endif

    if(present(dqlknn_out_dinput)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    n_total_inputs = int(size(input, 1), li)
    n_rho = int(size(input, 2), li)
    n_outputs = int(size(qlknn_out, 2), li)
    allocate(net_input(9, n_rho))
    allocate(net_result(n_rho, n_nets))

    allocate(res(n_rho)) !Debug

    if (calcder) then
      allocate(dnet_out_dnet_in(n_nets, n_rho, 9))
      dnet_out_dnet_in = 0
    end if

    if (.NOT. (n_rho == size(qlknn_out, 1))) then
       write(stderr,*) 'size(qlknn_out, 1)=', size(qlknn_out, 1),', nrho=', n_rho

       ERRORSTOP(.true., 'Rows of qlknn_out should be equal to number of radial points!')
    end if

    ! set options according to optsin if present from calling program. Otherwise set default
    if(present(optsin)) then
       opts=optsin
    else
       CALL default_qlknn_hyper_options(opts)
    end if

    if (verbosity >= 1 .and. my_world_rank == 0) then
       call print_qlknn_options(opts)
       write(*,*) 'input, n_rho=', n_rho
       do rho = 1, n_rho
          WRITE(*,'(11(F7.2, 1X))') (input(ii, rho), ii=1,n_total_inputs)
       end do
    end if

    if (opts%merge_modes .AND. .NOT. (n_outputs == size(qlknn_out, 2))) then
       write(stderr,*) 'size(qlknn_out, 2)=', size(qlknn_out, 2),', n_outputs=', n_outputs
       ERRORSTOP(.true., 'Columns of qlknn_out should be equal to number of outputs!')
    elseif (.NOT. opts%merge_modes .AND. .NOT. (n_nets == size(qlknn_out, 2))) then
       write(stderr,*) 'size(qlknn_out, 2)=', size(qlknn_out, 2),', n_nets=', n_nets
       ERRORSTOP(.true., 'Columns of qlknn_out should be equal to number of nets!')
    end if

    if (opts%apply_victor_rule .AND. .NOT. present(qlknn_normsin)) then
       ERRORSTOP(.true., 'Need to pass qlknn_normsin when applying Victor rule')
    else if (present(qlknn_normsin)) then
       qlknn_norms = qlknn_normsin
    end if



    ! Impose input constants
    if (calcder) then
      call impose_input_constraints(input, input_clipped, opts, verbosity, jacobian_clipmask)
    else
      call impose_input_constraints(input, input_clipped, opts, verbosity)
    endif

    net_input = input_clipped((/ nets%Zeff_ind, nets%Ati_ind, nets%Ate_ind, &
         nets%An_ind, nets%q_ind, nets%smag_ind, nets%x_ind, &
         nets%Ti_Te_ind, nets%logNustar_ind /), :)

    if (verbosity >= 2 .and. my_world_rank == 0) then
       write(*,*) 'net_input(:,1)'
       write(*,*) net_input(:,1)
    end if
    call get_networks_to_evaluate(opts, net_evaluate)

    if (verbosity >= 2 .and. my_world_rank == 0) then
       write(*,*) 'Evaluate networks:'
       write(*,*) net_evaluate
    end if


    ! Evaluate all neural networks
    if (calcder) then
      call evaluate_multinet(net_input, nets, net_evaluate, net_result, verbosity, dnet_out_dnet_in)
    else
      call evaluate_multinet(net_input, nets, net_evaluate, net_result, verbosity)
    endif

    if (calcder) then
      allocate(dnet_out_dinput(n_nets, n_rho, n_total_inputs))
      dnet_out_dinput(:, :, 1:size(dnet_out_dinput, 3) - 2) = dnet_out_dnet_in
      dnet_out_dinput(:, :, size(dnet_out_dinput, 3) - 1:size(dnet_out_dinput, 3)) = 0
    endif

    ! Clip leading fluxes to 0
    if (calcder) then
      call impose_leading_flux_constraints(leading_map, net_result, verbosity, dnet_out_dinput)
    else
      call impose_leading_flux_constraints(leading_map, net_result, verbosity)
    endif
    if (verbosity >= 3 .and. my_world_rank == 0) then
       WRITE(*,*) 'net_result (pre-div-multiplicate)'
       WRITE(fmt_tmp,'(A,I0,A)') '(', n_nets, '(F7.2,X))'
       do rho = 1, n_rho
          WRITE(*, fmt_tmp) (net_result(rho, ii), ii=1,n_nets)
       end do
    end if

    if (calcder) then
      call multiply_div_networks(leading_map, net_result, verbosity, dnet_out_dinput)
    else
      call multiply_div_networks(leading_map, net_result, verbosity)
    endif

    if (verbosity >= 3 .and. my_world_rank == 0) then
       WRITE(*,'(A)') 'net_result'
       do rho = 1, n_rho
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_nets, '(F7.2,X))'
          WRITE(*,fmt_tmp) (net_result(rho, ii), ii=1,n_nets)
       end do
    end if

    if (opts%apply_victor_rule) then
      if (calcder) then
        call scale_with_victor(leading_map, input_clipped, nets, qlknn_norms, net_result, verbosity, dnet_out_dinput)
      else
        call scale_with_victor(leading_map, input_clipped, nets, qlknn_norms, net_result, verbosity)
      endif
    end if

    ! Clip based on leading
    call apply_stability_clipping(leading_map, net_result, verbosity)
    if (verbosity >= 3 .and. my_world_rank == 0) then
       WRITE(*,'(A)') 'with rotation stability clipped'
       do rho = 1, n_rho
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_nets, '(F7.2,X))'
          WRITE(*,fmt_tmp) (net_result(rho, ii), ii=1,n_nets)
       end do
    end if

    ! Zero out Jacobians of clipped inputs
    if (calcder) then
     do outp = 1, n_nets
       !dqlknn_out_dinput(n_outputs, n_rho, total_n_in)
       where(transpose(jacobian_clipmask)) dnet_out_dinput(outp, :, :) = 0
     enddo
    endif

    if (calcder) then
      call impose_output_constraints(net_result, opts, verbosity, dnet_out_dinput)
    else
      call impose_output_constraints(net_result, opts, verbosity)
    endif
    if (verbosity >= 2 .and. my_world_rank == 0) then
       WRITE(*,'(A)') 'with rotation output clipped'
       do rho = 1, n_rho
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_nets, '(F7.2,X))'
          WRITE(*,fmt_tmp) (net_result(rho, ii), ii=1,n_nets)
       end do
    end if

    ! Merge ETG/ITG/TEM modes together
    if (opts%merge_modes) then
       if (calcder) then
         call merge_modes(merge_map, net_result, qlknn_out, verbosity, dnet_out_dinput, dqlknn_out_dinput)
       else
         call merge_modes(merge_map, net_result, qlknn_out, verbosity)
       endif
       if (verbosity >= 1 .and. my_world_rank == 0) then
          WRITE(*,*) 'with rotation modes merged'
          do rho = 1, n_rho
             WRITE(*,'(10(F7.2, 1X))') (qlknn_out(rho, ii), ii=1,10)
          end do
       end if
    else
       qlknn_out = net_result
       if (calcder) then
         dqlknn_out_dinput = dnet_out_dinput
       endif
       if (verbosity >= 1 .and. my_world_rank == 0) then
          WRITE(*,*) 'with rotation modes non-merged'
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_nets, '(F7.2,X))'
          do rho = 1, n_rho
             WRITE(*,fmt_tmp) (qlknn_out(rho, ii), ii=1,n_nets)
          end do
       end if
    end if

  end subroutine evaluate_QLKNN_10D

  subroutine evaluate_fullflux_net(input, nets, qlknn_out, verbosityin, optsin, dqlknn_out_dinput)
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    real(qlknn_dp), dimension(:,:), allocatable :: input_clipped
    integer(lli), optional, intent(in) :: verbosityin
    type(net_collection), intent(in) :: nets
    type(qlknn_options), optional, intent(in) :: optsin

    real(qlknn_dp), dimension(:,:), intent(out) :: qlknn_out
    real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: dqlknn_out_dinput

    integer(lli) ii, rho, verbosity, outp
    integer(li) :: n_outputs = 3
    integer(li) n_rho, n_in
    real(qlknn_dp), dimension(:), allocatable :: res
    real(qlknn_dp), dimension(:,:), allocatable :: net_result
    real(qlknn_dp), dimension(:,:), allocatable :: net_input
    real(qlknn_dp), dimension(:,:,:), allocatable :: dnet_out_dnet_in, dnet_out_dinput
    logical, dimension(:,:), allocatable :: jacobian_clipmask
    type(qlknn_options) :: opts
    logical, dimension(3) :: net_evaluate
    logical :: calcder
    character(len=100) :: fmt_tmp
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: my_world_rank
#else
    integer(li) :: my_world_rank
#endif
#ifdef MPI
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: mpi_ierr, world_size
#else
    integer(li) :: mpi_ierr, world_size
#endif
#endif
    net_evaluate = .true.

    ! zeff ati  ate   an         q      smag         x  ti_te logNustar
    !1.0   2.000000  5.0  2.0  0.660156  0.399902  0.449951    1.0      0.001
    !1.0  13.000000  5.0  2.0  0.660156  0.399902  0.449951    1.0      0.001
    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

#ifdef MPI
    call MPI_COMM_SIZE(MPI_COMM_WORLD, world_size, mpi_ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
    if (my_world_rank == 0) then
       if (verbosity >= 2) write(*,*) 'World size in evaluate_fullflux_net is ', world_size
    end if
    if (verbosity >= 2) write(*,*) 'Hello world from evaluate_fullflux_net rank ', my_world_rank
#else
    my_world_rank = 0
#endif

    if(present(dqlknn_out_dinput)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    n_rho = int(size(input, 2), li)
    n_in = int(size(input, 1), li)
    allocate(net_input(9, n_rho))
    allocate(net_result(n_rho, n_outputs))

    allocate(res(n_rho)) !Debug

    if (calcder) then
      allocate(dnet_out_dnet_in(n_outputs, n_rho, 9))
      dnet_out_dnet_in = 0
    end if

    if (.NOT. (n_rho == size(qlknn_out, 1))) then
       write(stderr,*) 'size(qlknn_out, 1)=', size(qlknn_out, 1),', nrho=', n_rho

       ERRORSTOP(.true., 'Rows of qlknn_out should be equal to number of radial points!')
    end if

    ! set options according to optsin if present from calling program. Otherwise set default
    if(present(optsin)) then
       opts=optsin
    else
       CALL default_qlknn_fullflux_options(opts)
    end if

    if (verbosity >= 1 .and. my_world_rank == 0) then
       call print_qlknn_options(opts)
       write(*,*) 'input, n_rho=', n_rho
       do rho = 1, n_rho
          WRITE(*,'(11(F7.2, 1X))') (input(ii, rho), ii=1,n_in)
       end do
    end if

    if (opts%merge_modes .AND. .NOT. (n_outputs == size(qlknn_out, 2))) then
       write(stderr,*) 'size(qlknn_out, 2)=', size(qlknn_out, 2),', n_outputs=', n_outputs
       ERRORSTOP(.true., 'Columns of qlknn_out should be equal to number of outputs!')
     endif

    ! Impose input constants
    if (calcder) then
      call impose_input_constraints(input, input_clipped, opts, verbosity, jacobian_clipmask)
    else
      call impose_input_constraints(input, input_clipped, opts, verbosity)
    endif

    net_input = input_clipped((/ nets%Zeff_ind, nets%Ati_ind, nets%Ate_ind, &
         nets%An_ind, nets%q_ind, nets%smag_ind, nets%x_ind, &
         nets%Ti_Te_ind, nets%logNustar_ind /), :)

    if (verbosity >= 2 .and. my_world_rank == 0) then
       write(*,*) 'net_input(:,1)'
       write(*,*) net_input(:,1)
    end if

    if (verbosity >= 2 .and. my_world_rank == 0) then
       write(*,*) 'Evaluate networks:'
       write(*,*) net_evaluate
    end if


    ! Evaluate all neural networks
    if (calcder) then
      call evaluate_multinet(net_input, nets, net_evaluate, net_result, verbosity, dnet_out_dnet_in)
    else
      call evaluate_multinet(net_input, nets, net_evaluate, net_result, verbosity)
    endif

    !TODO check
    if (calcder) then
      allocate(dnet_out_dinput(n_outputs, n_rho, n_in))
      dnet_out_dinput(:, :, 1:size(dnet_out_dinput, 3) - 2) = dnet_out_dnet_in
      dnet_out_dinput(:, :, size(dnet_out_dinput, 3) - 1:size(dnet_out_dinput, 3)) = 0
    endif

    ! Zero out Jacobians of clipped inputs
    if (calcder) then
     do outp = 1, n_outputs
       !dqlknn_out_dinput(n_outputs, n_rho, n_in)
       where(transpose(jacobian_clipmask)) dnet_out_dinput(outp, :, :) = 0
     enddo
    endif

    if (calcder) then
      call impose_output_constraints(net_result, opts, verbosity, dnet_out_dinput)
      dqlknn_out_dinput = dnet_out_dinput
    else
      call impose_output_constraints(net_result, opts, verbosity)
    endif
    if (verbosity >= 1 .and. my_world_rank == 0) then
       WRITE(*,'(A)') 'with rotation output clipped'
       do rho = 1, n_rho
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_outputs, '(F7.2,X))'
          WRITE(*,fmt_tmp) (net_result(rho, ii), ii=1,n_outputs)
       end do
    end if

    qlknn_out = net_result
  end subroutine evaluate_fullflux_net

  subroutine evaluate_jetexp_net(input, nets, n_members, qlknn_out, qlknn_eb, verbosityin, optsin, dqlknn_out_dinput, qlknn_validity)
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    real(qlknn_dp), dimension(:,:), allocatable :: input_clipped
    integer(lli), optional, intent(in) :: verbosityin
    type(net_collection), intent(in) :: nets
    integer(lli), intent(in) :: n_members
    type(qlknn_options), optional, intent(in) :: optsin

    real(qlknn_dp), dimension(:,:), intent(out) :: qlknn_out, qlknn_eb
    real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: dqlknn_out_dinput
    !logical, dimension(:,:), optional, intent(out) :: qlknn_validity
    logical, dimension(:,:), optional, intent(out) :: qlknn_validity

    integer(lli) ii, rho, verbosity, outp
    integer(li) :: n_outputs, n_net_outputs
    integer(li) n_rho, n_in, n_post_committee_outputs
    real(qlknn_dp), dimension(:), allocatable :: res
    real(qlknn_dp), dimension(:,:), allocatable :: net_out, committee_out, committee_eb
    real(qlknn_dp), dimension(:,:,:), allocatable :: dnet_out_dinput, dcommittee_out_dinput
    logical, dimension(:,:), allocatable :: jacobian_clipmask
    !logical, dimension(:,:), allocatable :: committee_validity
    logical, dimension(:,:), allocatable :: committee_validity
    type(qlknn_options) :: opts
    logical, dimension(:), allocatable :: net_evaluate
    logical :: calcder
    character(len=100) :: fmt_tmp
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: my_world_rank
#else
    integer(li) :: my_world_rank
#endif
#ifdef MPI
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: mpi_ierr, world_size
#else
    integer(li) :: mpi_ierr, world_size
#endif
#endif
    integer(lli), dimension(13,3), parameter :: merge_map = reshape( (/ &
         1, 1, 4, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24, &
         2, 0, 5, 7, 9, 11, 13, 15, 17, 19, 21, 23, 25, &
         3, 0, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0  &
         /), (/ 13, 3/))
         !  1 efe_GB
         !  2 efeETG_GB
         !  3 efi_GB
         !  4 pfe_GB
         !  5 pfi_GB
         !  6 vfi_GB
         !  7 dfe_GB
         !  8 vte_GB
         !  9 vce_GB
         ! 10 dfi_GB
         ! 11 vti_GB
         ! 12 vci_GB
         ! 13 vri_GB
    integer(lli), dimension(12,3), parameter :: leading_map = reshape( (/ &
         1, 0, 0, 0,  0,  0,  0,  0,  0,  0,  0,  0, & ! ETG
         3, 5, 7, 9, 11, 13, 15, 17, 19, 21, 23, 25, & ! TEM
         4, 2, 6, 8, 10, 12, 14, 16, 18, 20, 22, 24  & ! ITG
         /), (/ 12,3 /))
    ! New variance thresholds (15D NN)
    ! Determined from quantiles of 10000 random samples: 90% abs, 50% rel
    real(qlknn_dp), dimension(25):: aeb_limits = (/ &
         8.4,  5.6,  9.0, & ! efe_GB
              13.0,  8.6, & ! efi_GB
               3.4,  3.6, & ! pfe_GB
               5.6,  5.0, & ! pfi_GB
               2.3,  2.3, & ! vfi_GB
               4.1,  3.2, & ! dfe_GB
               4.6,  2.0, & ! vte_GB
               1.6,  1.3, & ! vce_GB
               8.0,  9.5, & ! dfi_GB
               8.7,  9.0, & ! vti_GB
               3.0,  3.2, & ! vci_GB
               1.0,  1.0  & ! vri_GB
         /)
         ! 1 ETG
         ! 2 ITG
         ! 3 TEM
    real(qlknn_dp), dimension(25):: reb_limits = (/ &
         0.5,  1.0,  0.9, & ! efe_GB
               0.4,  1.4, & ! efi_GB
               2.5,  2.1, & ! pfe_GB
               3.2,  2.5, & ! pfi_GB
               1.9,  2.5, & ! vfi_GB
               2.5,  2.4, & ! dfe_GB
               2.4,  1.5, & ! vte_GB
               2.6,  1.2, & ! vce_GB
               3.0,  2.8, & ! dfi_GB
               2.0,  2.5, & ! vti_GB
               2.3,  2.6, & ! vci_GB
               0.1,  0.1  & ! vri_GB
         /)
         ! 1 ETG
         ! 2 ITG
         ! 3 TEM
!    ! Old variance threshold (14D NN)
!    ! Determined from quantiles of 10000 random samples: 90% abs, 50% rel
!    real(qlknn_dp), dimension(25):: aeb_limits = (/ &
!         8.0,  7.0, 11.5, & ! efe_GB
!              12.5, 11.5, & ! efi_GB
!               8.4,  6.9, & ! pfe_GB
!              11.6,  8.2, & ! pfi_GB
!               2.5,  5.5, & ! vfi_GB
!               6.4,  8.1, & ! dfe_GB
!               7.2,  6.2, & ! vte_GB
!               2.3,  3.7, & ! vce_GB
!              11.7, 14.5, & ! dfi_GB
!              12.2, 11.7, & ! vti_GB
!               4.2,  4.3, & ! vci_GB
!              20.0, 20.0  & ! vri_GB
!         /)
         ! 1 ETG
         ! 2 ITG
         ! 3 TEM
!    real(qlknn_dp), dimension(25):: reb_limits = (/ &
!         0.5,  1.6,  1.1, & ! efe_GB
!               0.5,  1.5, & ! efi_GB
!               2.7,  2.3, & ! pfe_GB
!               3.0,  2.2, & ! pfi_GB
!               1.1,  1.4, & ! vfi_GB
!               2.2,  2.0, & ! dfe_GB
!               2.2,  1.8, & ! vte_GB
!               2.9,  2.1, & ! vce_GB
!               2.3,  2.1, & ! dfi_GB
!               2.5,  2.0, & ! vti_GB
!               2.0,  2.0, & ! vci_GB
!              10.0, 10.0  & ! vri_GB
!         /)
         ! 1 ETG
         ! 2 ITG
         ! 3 TEM
    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

#ifdef MPI
    call MPI_COMM_SIZE(MPI_COMM_WORLD, world_size, mpi_ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
    if (my_world_rank == 0) then
       if (verbosity >= 2) write(*,*) 'World size in evaluate_jetexp_net is ', world_size
    end if
    if (verbosity >= 2) write(*,*) 'Hello world from evaluate_jetexp_net rank ', my_world_rank
#else
    my_world_rank = 0
#endif

    if(present(dqlknn_out_dinput)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    n_rho = int(size(input, 2), li)
    n_in = int(size(input, 1), li)
    n_outputs = int(size(qlknn_out, 2), li)
    n_net_outputs = int(size(nets%nets), li)
    n_post_committee_outputs = n_net_outputs / int(n_members, li)
    allocate(net_out(n_rho, n_net_outputs))
    allocate(net_evaluate(n_net_outputs))
    net_evaluate = .true.

    allocate(res(n_rho)) !Debug

    ERRORSTOP(.not. all(shape(qlknn_out) == shape(qlknn_eb)), 'Errorbound array should be the same size as out array')
    if (present(qlknn_validity)) then
       ERRORSTOP(.not. all(shape(qlknn_out) == shape(qlknn_validity)), 'Validity array should be the same size as out array')
    end if

    if (.NOT. (n_rho == size(qlknn_out, 1))) then
       write(stderr,*) 'size(qlknn_out, 1)=', size(qlknn_out, 1),', nrho=', n_rho

       ERRORSTOP(.true., 'Rows of qlknn_out should be equal to number of radial points!')
    end if

    ! set options according to optsin if present from calling program. Otherwise set default
    if(present(optsin)) then
       opts=optsin
    else
       CALL default_qlknn_jetexp_options(opts)
    end if

    if (verbosity >= 1 .and. my_world_rank == 0) then
       call print_qlknn_options(opts)
       write(fmt_tmp, '(A,I0,A)') '(', n_in, '(F7.2,X))'
       write(*,*) 'input, n_rho=', n_rho
       do rho = 1, n_rho
          WRITE(*, fmt_tmp) (input(ii, rho), ii=1,n_in)
       end do
    end if

    ! Impose input constants
    allocate(input_clipped(n_in, n_rho))
    if (calcder) then
      call impose_input_constraints(input, input_clipped, opts, verbosity, jacobian_clipmask)
    else
      call impose_input_constraints(input, input_clipped, opts, verbosity)
    endif

    if (verbosity >= 2 .and. my_world_rank == 0) then
       write(*,*) 'input_clipped(:,1)'
       write(*,*) input_clipped(:,1)
    end if

    if (verbosity >= 2 .and. my_world_rank == 0) then
       write(*,*) 'Evaluate networks:'
       write(*,*) net_evaluate
    end if

    if (calcder) then
      allocate(dnet_out_dinput(n_net_outputs, n_rho, n_in))
      dnet_out_dinput = 0
    end if

    ! Evaluate all neural networks
    if (calcder) then
      call evaluate_multinet(input_clipped, nets, net_evaluate, net_out, verbosityin, dnet_out_dinput)
    else
      call evaluate_multinet(input_clipped, nets, net_evaluate, net_out, verbosityin)
    endif

    ! Zero out Jacobians of clipped inputs
    if (calcder) then
     do outp = 1, n_net_outputs
       where(transpose(jacobian_clipmask))
         dnet_out_dinput(outp, :, :) = 0
       endwhere
     enddo
    endif

    if (verbosity >= 3 .and. my_world_rank == 0) then
       WRITE(*,'(A)') 'After evaluation'
       do rho = 1, n_rho
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_net_outputs, '(F7.2,X))'
          WRITE(*,fmt_tmp) (net_out(rho, ii), ii=1,n_net_outputs)
       end do
    end if

    ! Merge committee members together
    allocate(committee_out(n_rho, n_post_committee_outputs))
    allocate(committee_eb(n_rho, n_post_committee_outputs))
    if (calcder) then
      allocate(dcommittee_out_dinput(n_post_committee_outputs, n_rho, n_in))
      call merge_committee(net_out, n_members, committee_out, committee_eb, verbosity, dnet_out_dinput, dcommittee_out_dinput)
    else
      call merge_committee(net_out, n_members, committee_out, committee_eb, verbosity)
    endif

    if (verbosity >= 2 .and. my_world_rank == 0) then
       WRITE(*,'(A)') 'After committee merge'
       do rho = 1, n_rho
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_post_committee_outputs, '(F7.2,X))'
          WRITE(*,fmt_tmp) (committee_out(rho, ii), ii=1,n_post_committee_outputs)
       end do
       WRITE(*,'(A)') 'With error bound'
       do rho = 1, n_rho
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_post_committee_outputs, '(F7.2,X))'
          WRITE(*,fmt_tmp) (committee_eb(rho, ii), ii=1,n_post_committee_outputs)
       end do
    end if

    ! Clip leading fluxes to 0
    if (calcder) then
      call impose_leading_flux_constraints(leading_map, committee_out, verbosity, dnet_out_dinput, net_eb=committee_eb)
    else
      call impose_leading_flux_constraints(leading_map, committee_out, verbosity, net_eb=committee_eb)
    endif
    if (verbosity >= 3 .and. my_world_rank == 0) then
       write(*,*) 'net_result (pre-div-multiplication)'
       do rho = 1, n_rho
          write(fmt_tmp,'(a,i0,a)') '(', n_post_committee_outputs, '(f7.2,x))'
          write(*,fmt_tmp) (committee_out(rho, ii), ii=1,n_post_committee_outputs)
       end do
       write(*,'(a)') 'with error bound'
       do rho = 1, n_rho
          write(fmt_tmp,'(a,i0,a)') '(', n_post_committee_outputs, '(f7.2,x))'
          write(*,fmt_tmp) (committee_eb(rho, ii), ii=1,n_post_committee_outputs)
       end do
    end if

    if (calcder) then
      call multiply_div_networks(leading_map, committee_out, verbosity, dcommittee_out_dinput, net_eb=committee_eb)
    else
      call multiply_div_networks(leading_map, committee_out, verbosity, net_eb=committee_eb)
    endif

    if (verbosity >= 3 .and. my_world_rank == 0) then
       write(*,*) 'net_result (post-div-multiplication)'
       do rho = 1, n_rho
          write(fmt_tmp,'(a,i0,a)') '(', n_post_committee_outputs, '(f7.2,x))'
          write(*,fmt_tmp) (committee_out(rho, ii), ii=1,n_post_committee_outputs)
       end do
       write(*,'(a)') 'with error bound'
       do rho = 1, n_rho
          write(fmt_tmp,'(a,i0,a)') '(', n_post_committee_outputs, '(f7.2,x))'
          write(*,fmt_tmp) (committee_eb(rho, ii), ii=1,n_post_committee_outputs)
       end do
    end if

    allocate(committee_validity(n_rho, n_post_committee_outputs))
    call determine_validity_with_eb(aeb_limits, reb_limits, committee_out, committee_eb, committee_validity, verbosity)
    if (verbosity >= 3 .and. my_world_rank == 0) then
       write(*,'(a)') 'net_validity (post-div-multiplication)'
       do rho = 1, n_rho
          write(fmt_tmp,'(a,i0,a)') '(', n_post_committee_outputs, '(L2,x))'
          write(*,fmt_tmp) (committee_validity(rho, ii), ii=1,n_post_committee_outputs)
       end do
       write(*,'(a)') 'applied absolute validity limit'
       write(fmt_tmp,'(a,i0,a)') '(', n_post_committee_outputs, '(f7.2,x))'
       write(*,fmt_tmp) (aeb_limits(ii), ii=1,n_post_committee_outputs)
       write(*,'(a)') 'applied relative validity limit'
       write(fmt_tmp,'(a,i0,a)') '(', n_post_committee_outputs, '(f7.2,x))'
       write(*,fmt_tmp) (reb_limits(ii), ii=1,n_post_committee_outputs)
    end if

    ! Merge ETG/ITG/TEM modes together
    if (opts%merge_modes) then
      if (calcder) then
        call merge_modes(merge_map, committee_out, qlknn_out, verbosity, dcommittee_out_dinput, dqlknn_out_dinput, net_eb=committee_eb, merged_net_eb=qlknn_eb)
      else
        call merge_modes(merge_map, committee_out, qlknn_out, verbosity, net_eb=committee_eb, merged_net_eb=qlknn_eb)
      endif
      if (verbosity >= 1 .and. my_world_rank == 0) then
        write(*,*) 'With modes merged'
        write(fmt_tmp,'(a,i0,a)') '(', n_outputs, '(f7.2,x))'
        do rho = 1, n_rho
          write(*,fmt_tmp) (qlknn_out(rho, ii), ii=1,n_outputs)
        end do
        write(*,'(a)') 'And error bound'
        do rho = 1, n_rho
          write(*,fmt_tmp) (qlknn_eb(rho, ii), ii=1,n_outputs)
        end do
      end if

      call determine_validity_merged_modes(merge_map, committee_validity, qlknn_validity, verbosity)
      if (verbosity >= 1 .and. my_world_rank == 0) then
        write(*,'(a)') 'net_validity (modes merged)'
        do rho = 1, n_rho
          write(fmt_tmp,'(a,i0,a)') '(', n_outputs, '(L2,x))'
          write(*,fmt_tmp) (qlknn_validity(rho, ii), ii=1,n_outputs)
        end do
      end if
    else
       qlknn_out = committee_out
       qlknn_eb = committee_eb
       qlknn_validity = committee_validity
       if (calcder) then
         dqlknn_out_dinput = dcommittee_out_dinput
       endif
       if (verbosity >= 1 .and. my_world_rank == 0) then
          WRITE(*,*) 'without modes merged'
          WRITE(fmt_tmp,'(A,I0,A)') '(', n_post_committee_outputs, '(F7.2,X))'
          do rho = 1, n_rho
             WRITE(*,fmt_tmp) (qlknn_out(rho, ii), ii=1,n_post_committee_outputs)
          end do
          WRITE(*,'(A)') 'And error bound'
          do rho = 1, n_rho
             WRITE(fmt_tmp,'(A,I0,A)') '(', n_post_committee_outputs, '(F7.2,X))'
             WRITE(*,fmt_tmp) (qlknn_eb(rho, ii), ii=1,n_post_committee_outputs)
          end do
       end if
    end if

  end subroutine evaluate_jetexp_net

  subroutine hornnet_flux_from_constants(input, blocks, hornnet_constants, flux_out, verbosityin, optsin, qlknn_normsin, dflux_dhornnet_constants, dflux_dinput)
    !! Calculate the transport fluxes as predicted by the given HornNet
    !! weights and biases

    real(qlknn_dp), dimension(:,:), intent(in) :: input
    !! Global input to the NN. Same as [[evaluate_QLKNN_10D]]
    type(block_collection), intent(in) :: blocks
    !! Blocks of NN layers to evaluate.
    !! Usually loaded with [[load_hornnet_nets_from_disk]]
    real(qlknn_dp), dimension(:,:), intent(in) :: hornnet_constants
    !! C* constants from [[evaluate_hornnet_constants]]
    integer(lli), optional, intent(in) :: verbosityin
    type(qlknn_options), optional, intent(in) :: optsin
    !! Options to be used while evaluating the nets
    !! Usually initialized with [[default_qlknn_hornnet_options]]
    type(qlknn_normpars), optional, intent(in) :: qlknn_normsin
    !! Normalizations needed for the Victor rule, see [[scale_with_victor]]

    real(qlknn_dp), dimension(:,:), intent(out) :: flux_out
    !! Fluxes as calculated by HornNet. Columns when opts%merge_modes = .true.
    !!
    !! - \( q_e, q_{e, ETG}, q_i, \Gamma_e \)
    !!
    !! If opts%merge_modes = .false.
    !!
    !! - \( q_{e, ETG}, q_{e, ITG}, q_{e, TEM}, q_{i, ITG}, q_{i, TEM} \)
    !! - \( \Gamma_{e, ITG}, \Gamma_{e, TEM} \)
    real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: dflux_dhornnet_constants
    !! Jacobians for flux_out vs C*
    real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: dflux_dinput
    !! Jacobians for flux_out vs input

    type(qlknn_normpars) :: qlknn_norms
    type(qlknn_options)  :: opts

    integer(lli), dimension(4,3), parameter :: merge_map = reshape( (/ &
         1, 1, 4, 6, &
         2, 0, 5, 7, &
         3, 0, 0, 0 &
         /), (/ 4, 3 /))
    ! efe_GB 1
    ! efeETG_gb 2
    ! efi_GB 3
    ! pfe_GB 4

    !integer(lli), dimension(15), parameter :: late_fuse_var_map = &
    !     (/ 3, 2, 3, 3, 2, 3, 2, 3, 3, 2, 3, 2, 3, 2, 3 /)

    integer(lli), dimension(3,3) :: output_mode_map
    integer(lli), dimension(:), allocatable :: output_mode_local
    !integer(lli) :: ii, rho, verbosity, outp
    integer(lli) :: ii, rho, verbosity, n_rho, outp, n_sep_out, inp, pow_idx, block_idx, slope_idx
    !integer(li) :: n_rho, n_outputs, n_total_inputs, n_common_out, n_hidden_in, n_hidden_out, n_output_out
    integer(li) :: n_outputs, n_total_inputs
    logical :: calcder

    real(qlknn_dp), dimension(:,:), allocatable :: special_input
    real(qlknn_dp), dimension(:,:), allocatable :: difference
    real(qlknn_dp), dimension(:,:), allocatable :: heaviside_function_times
    real(qlknn_dp), dimension(:,:), allocatable :: clip_by_value
    real(qlknn_dp), dimension(:,:), allocatable :: input_clipped
    real(qlknn_dp), dimension(:,:), allocatable :: sepflux_out
    real(qlknn_dp), dimension(:,:), allocatable :: sepflux_out_descaled
    logical, dimension(:,:), allocatable :: jacobian_clipmask

    real(qlknn_dp), dimension(:,:,:), allocatable :: dsepflux_dinput
    real(qlknn_dp), dimension(:,:,:), allocatable :: dsepflux_dhornnet_constants

    real(qlknn_dp), dimension(:,:,:), allocatable :: dclip_by_value_dinput
    real(qlknn_dp), dimension(:,:,:), allocatable :: drelu_dinput

    real(qlknn_dp), dimension(:,:,:), allocatable :: dclip_by_value_dhornnet_constants
    real(qlknn_dp), dimension(:,:,:), allocatable :: drelu_dhornnet_constants

    real(qlknn_dp), dimension(:,:), allocatable :: f, g, h
    real(qlknn_dp), dimension(:,:,:), allocatable :: df_dhornnet_constants, dg_dhornnet_constants, dh_dhornnet_constants
    real(qlknn_dp), dimension(:,:,:), allocatable :: df_dinput, dg_dinput


    output_mode_map = reshape( (/ &
         1, 0, 0, & ! ETG
         2, 4, 6, & ! ITG
         3, 5, 7  & ! TEM
         /), (/ 3, 3 /))


    if(present(verbosityin)) then
       verbosity = verbosityin
    else
       verbosity = 0
    end if

    if(present(dflux_dhornnet_constants)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    if (calcder .and. .not. present(dflux_dinput)) then
      ERRORSTOP(.true., 'Also give dflux_dinput if dflux_dhornnet_constants is given')
    endif

    if (calcder) then
      dflux_dhornnet_constants = 0
      dflux_dinput = 0
    endif

    n_total_inputs = int(size(input, 1), li)
    n_rho = int(size(input, 2), lli)
    n_outputs = int(size(flux_out, 2), li)
    n_sep_out = 7

    if (verbosity >= 1) then
      write(*, '(A,I2,A,I3,A,I3,A,I3,A,I3)') 'Calculating c* constants from input with n_hornet_constants=', 15, ', n_total_inputs=', n_total_inputs, ', n_outputs=', n_outputs, ', n_rho=', n_rho, ', n_sep_out=', n_sep_out
    endif
    ! set options according to optsin if present from calling program. Otherwise set default
    if(present(optsin)) then
       opts=optsin
    else
       CALL default_qlknn_hornnet_options(opts)
    end if

    ! Check sizes
    if (.NOT. (n_rho == size(flux_out, 1))) then
       write(stderr,*) 'size(flux_out, 1)=', size(flux_out, 1), ', nrho=', n_rho

       ERRORSTOP(.true., 'Rows of flux_out should be equal to number of radial points!')
    endif
    if (opts%merge_modes .and. 4 /= n_outputs) then
       write(stderr,*) 'size(flux_out, 2)=', size(flux_out, 2)
       ERRORSTOP(.true., 'Columns of flux_out should be 4!')
    endif
    if (.not. opts%merge_modes .and. n_sep_out /= n_outputs) then
       write(stderr,*) 'size(flux_out, 2)=', size(flux_out, 2), ', n_sep_out=', n_sep_out
       ERRORSTOP(.true., 'Columns of flux_out should be n_sep_out!')
    endif

    if (calcder) then
      if (n_outputs /= size(dflux_dhornnet_constants, 1)) then
        write(stderr,*) 'size(dflux_dhornnet_constants, 1)=', size(dflux_dhornnet_constants, 1)
        ERRORSTOP(.true., 'Rows of dflux_dhornnet_constants should be equal to n_outputs!')
      endif
      if (n_rho /= size(dflux_dhornnet_constants, 2)) then
        write(stderr,*) 'size(dflux_dhornnet_constants, 2)=', size(dflux_dhornnet_constants, 2), ', nrho=', n_rho
        ERRORSTOP(.true., 'Columns of dflux_dhornnet_constants should be equal to number of radial points!')
      endif
      if (15 /= size(dflux_dhornnet_constants, 3)) then
        write(stderr,*) 'size(dflux_dhornnet_constants, 3)=', size(dflux_dhornnet_constants, 3)
        ERRORSTOP(.true., 'Pages of dflux_dhornnet_constants should be equal to 15!')
      endif
    endif

    if (opts%apply_victor_rule .AND. .NOT. present(qlknn_normsin)) then
       ERRORSTOP(.true., 'Need to pass qlknn_normsin when applying Victor rule')
    else if (present(qlknn_normsin)) then
       qlknn_norms = qlknn_normsin
    end if
    ERRORSTOP(opts%apply_victor_rule, 'Victor rule not implemented yet')

    ! Impose input constants
    if (calcder) then
      call impose_input_constraints(input, input_clipped, opts, verbosity, jacobian_clipmask)
    else
      call impose_input_constraints(input, input_clipped, opts, verbosity)
    endif

    if (verbosity >= 3) then
      write(*,*) 'input_clipped:'
      do rho = 1, n_rho
        write(*,'(11(f7.4, 1x))') input_clipped(:, rho)
      enddo
    endif
    allocate(special_input(3, n_rho))
    ! Assuming all blocks have the same scaling/dataset
    special_input(1, :) =  blocks%input_blocks(1)%feature_prescale_factor(3) * input_clipped(3, :) + &
       blocks%input_blocks(1)%feature_prescale_bias(3) ! ETG needs Ate
    special_input(2, :) =  blocks%input_blocks(1)%feature_prescale_factor(2) * input_clipped(2, :) + &
       blocks%input_blocks(1)%feature_prescale_bias(2) ! ITG needs Ati
    special_input(3, :) =  blocks%input_blocks(1)%feature_prescale_factor(3) * input_clipped(3, :) + &
       blocks%input_blocks(1)%feature_prescale_bias(3) ! TEM needs Ate
    if (verbosity >= 3) then
      write(*,*) 'special_input:'
      do rho = 1, n_rho
        write(*,'(3(f7.4, 1x))') special_input(:, rho)
      enddo
    endif

    ! Sepflux out
    ! c1 == threshold
    ! c2 == power bending
    ! c3 == linear bending
    ! efeetg_gb 1
    ! efeitg_gb 2
    ! efetem_gb 3
    ! efiitg_gb 4
    ! efitem_gb 5
    ! pfeitg_gb 6
    ! pfetem_gb 7

    allocate(sepflux_out(n_rho, 7))
    allocate(difference(n_rho, 3))
    allocate(clip_by_value(n_rho, 3))
    allocate(heaviside_function_times(n_rho, 3))
    if (calcder) then
      allocate(dclip_by_value_dhornnet_constants(n_sep_out, n_rho, 15))
      allocate(drelu_dhornnet_constants(n_sep_out, n_rho, 15))
      allocate(dclip_by_value_dinput(3, n_rho, n_total_inputs))
      allocate(drelu_dinput(3, n_rho, n_total_inputs))
      dclip_by_value_dhornnet_constants = 0.
      drelu_dhornnet_constants = 0.
      dclip_by_value_dinput = 0.
      drelu_dinput = 0.
      dclip_by_value_dinput(1, :, 3) = blocks%input_blocks(1)%feature_prescale_factor(3)
      dclip_by_value_dinput(2, :, 2) = blocks%input_blocks(1)%feature_prescale_factor(2)
      dclip_by_value_dinput(3, :, 3) = blocks%input_blocks(1)%feature_prescale_factor(3)
      drelu_dinput(1, :, 3) = blocks%input_blocks(1)%feature_prescale_factor(3)
      drelu_dinput(2, :, 2) = blocks%input_blocks(1)%feature_prescale_factor(2)
      drelu_dinput(3, :, 3) = blocks%input_blocks(1)%feature_prescale_factor(3)
    endif
    do ii = 1, 3
      difference(:, ii) = special_input(ii, :) - hornnet_constants(:, ii)
      ! TODO: Not implemented in tf_op_layer_clip_by_values final values are the tf_op_layer_clip_by_valye/Mimumum and tf_op_layer_clip_by_value layers. Ask Philipp what they do
      clip_by_value(:, ii) = abs(difference(:, ii))
      call relu(n_rho, difference(:, ii), heaviside_function_times(:, ii))
      if (calcder) then
        if (ii == 1) then
          dclip_by_value_dhornnet_constants((/ 1 /), :, ii) = -1 !ddifference_dhornet_constants
        elseif (ii == 2) then
          dclip_by_value_dhornnet_constants((/ 2, 4, 6 /), :, ii) = -1 !ddifference_dhornet_constants
        elseif (ii == 3) then
          dclip_by_value_dhornnet_constants((/ 3, 5, 7 /), :, ii) = -1 !ddifference_dhornet_constants
        endif
        ! dclip_by_value_dhornet_constants. Does not exist at x != 0, put zero  in the 'bigger than 0' camp
        do outp = 1, n_sep_out
          where (difference(:, ii) < 0.)
            dclip_by_value_dhornnet_constants(outp, :, ii) = -1 * dclip_by_value_dhornnet_constants(outp, :, ii)
            dclip_by_value_dinput(ii, :, 2) = -1 * dclip_by_value_dinput(ii, :, 2)
            dclip_by_value_dinput(ii, :, 3) = -1 * dclip_by_value_dinput(ii, :, 3)
          endwhere
          where (difference(:, ii) >= 0.)
            dclip_by_value_dhornnet_constants(outp, :, ii) = 1 * dclip_by_value_dhornnet_constants(outp, :, ii)
            dclip_by_value_dinput(ii, :, 2) = 1 * dclip_by_value_dinput(ii, :, 2)
            dclip_by_value_dinput(ii, :, 3) = 1 * dclip_by_value_dinput(ii, :, 3)
          endwhere
        enddo
        ! drelu_dhornnet_constants
        if (ii == 1) then
          drelu_dhornnet_constants((/ 1 /), :, ii) = -1 !ddifference_dhornet_constants
        elseif (ii == 2) then
          drelu_dhornnet_constants((/ 2, 4, 6 /), :, ii) = -1 !ddifference_dhornet_constants
        elseif (ii == 3) then
          drelu_dhornnet_constants((/ 3, 5, 7 /), :, ii) = -1 !ddifference_dhornet_constants
        endif
        ! dclip_by_value_dhornet_constants. Does not exist at x != 0, let's take 0 to be sure
        do outp = 1, n_sep_out
          where (difference(:, ii) < 0.)
            drelu_dhornnet_constants(outp, :, ii) = 0
            drelu_dinput(ii, :, 2) = 0
            drelu_dinput(ii, :, 3) = 0
          endwhere
          where (difference(:, ii) >= 0.)
            drelu_dhornnet_constants(outp, :, ii) = 1 * drelu_dhornnet_constants(outp, :, ii)
            drelu_dinput(ii, :, 2) = 1 * drelu_dinput(ii, :, 2)
            drelu_dinput(ii, :, 3) = 1 * drelu_dinput(ii, :, 3)
          endwhere
        enddo
      endif
    enddo

    ! Initialize temp variables
    allocate(f(n_rho, n_sep_out))
    allocate(g(n_rho, n_sep_out))
    allocate(h(n_rho, n_sep_out))
    if (calcder) then
      allocate(dsepflux_dhornnet_constants(n_sep_out, n_rho, 15))
      allocate(dsepflux_dinput(n_sep_out, n_rho, n_total_inputs))
      allocate(df_dhornnet_constants(n_sep_out, n_rho, 15))
      allocate(dg_dhornnet_constants(n_sep_out, n_rho, 15))
      allocate(dh_dhornnet_constants(n_sep_out, n_rho, 15))
      allocate(df_dinput(n_sep_out, n_rho, n_total_inputs))
      allocate(dg_dinput(n_sep_out, n_rho, n_total_inputs))
      dsepflux_dhornnet_constants = 0.
      df_dhornnet_constants = 0.
      dg_dhornnet_constants = 0.
      dh_dhornnet_constants = 0.
      df_dinput = 0.
      dg_dinput = 0.
    endif

    ! ETG network
    outp = 1 ! efeetg_gb
    pow_idx = 4
    block_idx = 1
    slope_idx = 9
    if (calcder) then
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h, drelu_dhornnet_constants, drelu_dinput, &
         dclip_by_value_dhornnet_constants, dclip_by_value_dinput, df_dhornnet_constants, df_dinput, dg_dhornnet_constants, dg_dinput, dh_dhornnet_constants)
    else
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h)
    endif


    ! ITG network
    outp = 2 ! efeitg_gb
    pow_idx = 5
    block_idx = 2
    slope_idx = 10
    if (calcder) then
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h, drelu_dhornnet_constants, drelu_dinput, &
         dclip_by_value_dhornnet_constants, dclip_by_value_dinput, df_dhornnet_constants, df_dinput, dg_dhornnet_constants, dg_dinput, dh_dhornnet_constants)
    else
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h)
    endif

    outp = 4 ! efiitg_gb
    pow_idx = 7
    block_idx = 2
    slope_idx = 12
    if (calcder) then
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h, drelu_dhornnet_constants, drelu_dinput, &
         dclip_by_value_dhornnet_constants, dclip_by_value_dinput, df_dhornnet_constants, df_dinput, dg_dhornnet_constants, dg_dinput, dh_dhornnet_constants)
    else
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h)
    endif

    outp = 6 ! pfeitg_gb
    block_idx = 2
    slope_idx = 14 ! Misuse slope_idx, it's actually a full net, not a slope
    f(:, outp) = heaviside_function_times(:, block_idx)
    g(:, outp) = 0.
    h(:, outp) = hornnet_constants(:, slope_idx)
    if (calcder) then
      df_dhornnet_constants(outp, :, :) = drelu_dhornnet_constants(outp, :, :)
      df_dinput(outp, :, :) = drelu_dinput(block_idx, : , :)
      dh_dhornnet_constants(outp, :, slope_idx) = 1.
    endif
    sepflux_out(:, outp) = f(:, outp) * h(:, outp)


    ! TEM network
    outp = 3 ! efetem_gb
    pow_idx = 6
    block_idx = 3
    slope_idx = 11
    if (calcder) then
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h, drelu_dhornnet_constants, drelu_dinput, &
         dclip_by_value_dhornnet_constants, dclip_by_value_dinput, df_dhornnet_constants, df_dinput, dg_dhornnet_constants, dg_dinput, dh_dhornnet_constants)
    else
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h)
    endif

    outp = 5 ! efetem_gb
    pow_idx = 8
    block_idx = 3
    slope_idx = 13
    if (calcder) then
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h, drelu_dhornnet_constants, drelu_dinput, &
         dclip_by_value_dhornnet_constants, dclip_by_value_dinput, df_dhornnet_constants, df_dinput, dg_dhornnet_constants, dg_dinput, dh_dhornnet_constants)
    else
      call hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h)
    endif

    outp = 7 ! pfetem_gb
    block_idx = 3
    slope_idx = 15 ! Misuse slope_idx, it's actually a full net, not a slope
    f(:, outp) = heaviside_function_times(:, block_idx)
    g(:, outp) = 0.
    h(:, outp) = hornnet_constants(:, slope_idx)
    if (calcder) then
      df_dhornnet_constants(outp, :, :) = drelu_dhornnet_constants(outp, :, :)
      df_dinput(outp, :, :) = drelu_dinput(block_idx, : , :)
      dh_dhornnet_constants(outp, :, slope_idx) = 1.
    endif
    sepflux_out(:, outp) = f(:, outp) * h(:, outp)

    if (calcder) then
      do outp = 1, n_sep_out - 2
        do inp = 1, 15
          ! Only f
          !dsepflux_dhornnet_constants(outp, :, inp) = df_dhornnet_constants(outp, :, inp)
          ! Only h
          !dsepflux_dhornnet_constants(outp, :, inp) = dh_dhornnet_constants(outp, :, inp)
          ! f * g
          !dsepflux_dhornnet_constants(outp, :, inp) = df_dhornnet_constants(outp, :, inp) * g(:, outp) + &
          !     f(:, outp) * dg_dhornnet_constants(outp, :, inp)
          ! f * h
          !dsepflux_dhornnet_constants(outp, :, inp) = df_dhornnet_constants(outp, :, inp) * h(:, outp) + &
          !     f(:, outp) * dh_dhornnet_constants(outp, :, inp)
          ! f * g * h
          dsepflux_dhornnet_constants(outp, :, inp) = df_dhornnet_constants(outp, :, inp) * g(:, outp) * h(:, outp) + &
               f(:, outp) * dg_dhornnet_constants(outp, :, inp) * h(:, outp) + &
               f(:, outp) * g(:, outp) * dh_dhornnet_constants(outp, :, inp)
        enddo
        do inp = 1, n_total_inputs
          ! Only f
          !dsepflux_dinput(outp, :, inp) = df_dinput(outp, :, inp)
          ! f * g
          !dsepflux_dinput(outp, :, inp) = df_dinput(outp, :, inp) * g(:, outp) + &
          !     f(:, outp) * dg_dinput(outp, :, inp)
          ! f * h
          !dsepflux_dinput(outp, :, inp) = df_dinput(outp, :, inp) * h(:, outp) ! + 0
          ! f * g * h
          dsepflux_dinput(outp, :, inp) = df_dinput(outp, :, inp) * g(:, outp) * h(:, outp) + &
               f(:, outp) * dg_dinput(outp, :, inp) * h(:, outp) ! + 0
        enddo
      enddo
      ! pfe* are special, we only have f and h
      do outp = n_sep_out - 1, n_sep_out
        do inp = 1, 15
          ! Only f
          !dsepflux_dhornnet_constants(outp, :, inp) = df_dhornnet_constants(outp, :, inp)
          ! Only h
          !dsepflux_dhornnet_constants(outp, :, inp) = dh_dhornnet_constants(outp, :, inp)
          ! f * h
          dsepflux_dhornnet_constants(outp, :, inp) = df_dhornnet_constants(outp, :, inp) * h(:, outp) + &
               f(:, outp) * dh_dhornnet_constants(outp, :, inp)
        enddo
        do inp = 1, n_total_inputs
          ! Only f
          !dsepflux_dinput(outp, :, inp) = df_dinput(outp, :, inp)
          ! f * h
          dsepflux_dinput(outp, :, inp) = df_dinput(outp, :, inp) * h(:, outp) ! + 0
        enddo
      enddo
    endif


    if (verbosity >= 3) then
      write(*,*) 'sepflux_out:'
      do rho = 1, n_rho
        write(*,'(7(f7.3, 1x))') sepflux_out(rho, :)
      enddo
    endif

    if (verbosity >= 3) then
      write(*,*) 'sepflux_out ITG:'
      do rho = 1, n_rho
        write(*,'(7(f7.3, 1x))') sepflux_out(rho, (/ 2, 4, 6 /))
      enddo
    endif

    !------------------------
    ! Denormalize output
    allocate(sepflux_out_descaled(n_rho, 7))
    do ii = 1, 3
      allocate(output_mode_local(count(output_mode_map(:, ii)/=0)))
      output_mode_local = pack(output_mode_map(:, ii), output_mode_map(:, ii) /=0)
      do rho = 1, n_rho
        sepflux_out_descaled(rho, output_mode_local) = 1/blocks%input_blocks(ii)%target_prescale_factor * &
             (sepflux_out(rho, output_mode_local) - blocks%input_blocks(ii)%target_prescale_bias)
        if (calcder) then
          do inp = 1, 15
            dsepflux_dhornnet_constants(output_mode_local, rho, inp) = dsepflux_dhornnet_constants(output_mode_local, rho, inp) / blocks%input_blocks(ii)%target_prescale_factor
          enddo
          do inp = 1, n_total_inputs
            dsepflux_dinput(output_mode_local, rho, inp) = dsepflux_dinput(output_mode_local, rho, inp) / blocks%input_blocks(ii)%target_prescale_factor
          enddo
        endif
      end do
      deallocate(output_mode_local)
    enddo
    if (verbosity >= 2) then
      write(*,*) 'sepflux_out_descaled:'
      do rho = 1, n_rho
        write(*,'(7(f7.3, 1x))') sepflux_out_descaled(rho, :)
      enddo
    endif

    if (calcder) then
    else
      call impose_output_constraints(sepflux_out_descaled, opts, verbosity)
    endif
    if (verbosity >= 2) then
       write(*,*) 'with output clipped'
       do rho = 1, n_rho
        write(*,'(7(f7.3, 1x))') sepflux_out_descaled(rho, :)
       end do
    end if

    ! Merge ETG/ITG/TEM modes together
    if (opts%merge_modes) then
       if (calcder) then
         call merge_modes(merge_map, sepflux_out_descaled, flux_out, verbosity, dsepflux_dhornnet_constants, dflux_dhornnet_constants)
         call merge_modes(merge_map, sepflux_out_descaled, flux_out, verbosity, dsepflux_dinput, dflux_dinput)
       else
         call merge_modes(merge_map, sepflux_out_descaled, flux_out, verbosity)
       endif
       if (verbosity >= 1) then
          write(*,*) 'with modes merged'
          do rho = 1, n_rho
            write(*,'(4(f7.3, 1x))') flux_out(rho, :)
          end do
       end if
    else
       flux_out = sepflux_out_descaled
       if (calcder) then
         dflux_dhornnet_constants = dsepflux_dhornnet_constants
         dflux_dinput = dsepflux_dinput
       endif
       if (verbosity >= 1) then
          write(*,*) 'with modes non-merged'
          do rho = 1, n_rho
            write(*,'(7(f7.3, 1x))') flux_out(rho, :)
          end do
       end if
    end if
  end subroutine hornnet_flux_from_constants

  subroutine hornnet_multiply_jacobians(dhornnet_constants_dinput, dflux_dhornnet_constants, dflux_dinput, dqlknn_out_dinput, verbosityin)
    !! Multiply the Jacobians as calculated by [[hornnet_flux_from_constants]] and [[evaluate_hornnet_constants]]
    real(qlknn_dp), dimension(:,:,:), intent(in) :: dhornnet_constants_dinput
    real(qlknn_dp), dimension(:,:,:), intent(in) :: dflux_dhornnet_constants
    real(qlknn_dp), dimension(:,:,:), intent(in) :: dflux_dinput
    integer(lli), intent(in), optional :: verbosityin
    real(qlknn_dp), dimension(:,:,:), intent(out) :: dqlknn_out_dinput

    integer(lli) :: ii, verbosity, n_rho, outp, inp, n_hornet_constants, n_in, n_out
    logical, dimension(:), allocatable :: is_nonzero
    character(len=200) :: error_msg

    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

    ! Check all shapes
    n_hornet_constants = size(dhornnet_constants_dinput, 1)
    n_out = size(dflux_dinput, 1)
    n_rho = size(dflux_dinput, 2)
    n_in = size(dflux_dinput, 3)

    if (verbosity >= 1) then
      write(*, '(A,I2,A,I3,A,I3,A,I3)') 'Multiplying HornNet Jacobians with n_hornet_constants=', n_hornet_constants, ', n_in=', n_in, ', n_out=', n_out, ', n_rho=', n_rho
    endif

    ERRORSTOP(size(dqlknn_out_dinput, 1) /= n_out, 'Passed dqlknn_out_dinput has wrong amount of rows')
    ERRORSTOP(size(dqlknn_out_dinput, 2) /= n_rho, 'Passed dqlknn_out_dinput has wrong amount of columns')
    ERRORSTOP(size(dqlknn_out_dinput, 3) /= n_in, 'Passed dqlknn_out_dinput has wrong amount of pages')

    ERRORSTOP(size(dflux_dhornnet_constants, 1) /= n_out, 'Passed dflux_dhornnet_constants has wrong amount of rows')

    ERRORSTOP(size(dhornnet_constants_dinput, 2) /= n_rho, 'Passed dhornnet_constants_dinput has wrong amount of columns')
    ERRORSTOP(size(dflux_dhornnet_constants, 2) /= n_rho, 'Passed dflux_dhornnet_constants has wrong amount of columns')

    ERRORSTOP(size(dflux_dhornnet_constants, 3) /= n_hornet_constants, 'Passed dflux_dhornnet_constants has wrong amount of pages')
    ERRORSTOP(size(dhornnet_constants_dinput, 3) /= n_in, 'Passed dhornnet_constants_dinput has wrong amount of pages')

    dqlknn_out_dinput = 0.
    do inp = 1, n_in
      do outp = 1, n_out
        do ii = 1, n_hornet_constants
          dqlknn_out_dinput(outp, :, inp) = dqlknn_out_dinput(outp, :, inp) +  dflux_dhornnet_constants(outp, :, ii) * dhornnet_constants_dinput(ii, :, inp)
        enddo
      enddo
    enddo

    allocate(is_nonzero(n_rho))
    if (n_out > 4) then
      ! Not merging modes
      call is_not_close(dqlknn_out_dinput(1, :, 3), 0._qlknn_dp, is_nonzero)
      write(error_msg, *) 'output 1 (ETG) depends directly on special variable!'
      ERRORSTOP(any(is_nonzero), error_msg)
      dqlknn_out_dinput(1, :, 3) = dflux_dinput(1, :, 3)
      do outp = 2, 4, 2
        call is_not_close(dqlknn_out_dinput(outp, :, 2), 0._qlknn_dp, is_nonzero)
        ERRORSTOP(any(is_nonzero), 'output 2 or 4 (ITG) depends directly on special variable!')
        dqlknn_out_dinput(outp, :, 2) = dflux_dinput(outp, :, 2)
      enddo

      do outp =  3, 5, 2
        call is_not_close(dqlknn_out_dinput(outp, :, 3),  0._qlknn_dp, is_nonzero)
        ERRORSTOP(any(is_nonzero), 'output 3 or 5 (TEM) depends directly on special variable!')
        dqlknn_out_dinput(outp, :, 3) = dflux_dinput(outp, :, 3)
      enddo
    else
      call is_not_close(dqlknn_out_dinput(2, :, 3),  0._qlknn_dp, is_nonzero)
      write(error_msg, *) 'output 2 (ETG) depends directly on special variable!'
      ERRORSTOP(any(is_nonzero), error_msg)
      dqlknn_out_dinput(2, :, 3) = dqlknn_out_dinput(2, :, 3) + dflux_dinput(2, :, 3)
    endif
  end subroutine hornnet_multiply_jacobians

  subroutine hornnet_multiplier(heaviside_function_times, clip_by_value, hornnet_constants, sepflux_out, outp, pow_idx, block_idx, slope_idx, f, g, h, drelu_dhornnet_constants, drelu_dinput, &
         dclip_by_value_dhornnet_constants, dclip_by_value_dinput, df_dhornnet_constants, df_dinput, dg_dhornnet_constants, dg_dinput, dh_dhornnet_constants)
    real(qlknn_dp), dimension(:,:), intent(in) :: heaviside_function_times
    real(qlknn_dp), dimension(:,:), intent(in) :: clip_by_value
    real(qlknn_dp), dimension(:,:), intent(in) :: hornnet_constants
    real(qlknn_dp), dimension(:,:,:), intent(in), optional :: drelu_dhornnet_constants
    real(qlknn_dp), dimension(:,:,:), intent(in), optional :: drelu_dinput
    real(qlknn_dp), dimension(:,:,:), intent(in), optional :: dclip_by_value_dhornnet_constants
    real(qlknn_dp), dimension(:,:,:), intent(in), optional :: dclip_by_value_dinput
    integer(lli), intent(in) :: outp, pow_idx, block_idx, slope_idx
    real(qlknn_dp), dimension(:,:), intent(inout) :: f, g, h

    real(qlknn_dp), dimension(:,:), intent(inout) :: sepflux_out
    real(qlknn_dp), dimension(:,:,:), intent(inout), optional :: df_dhornnet_constants, dg_dhornnet_constants, dh_dhornnet_constants
    real(qlknn_dp), dimension(:,:,:), intent(inout), optional :: df_dinput, dg_dinput

    integer(lli) ::n_rho, n_sep_out
    logical :: calcder

    if(present(drelu_dhornnet_constants)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    n_rho = int(size(sepflux_out, 1), li)
    n_sep_out = int(size(sepflux_out, 2), li)
    f(:, outp) = heaviside_function_times(:, block_idx)
    g(:, outp) = clip_by_value(:, block_idx)**max(hornnet_constants(:, pow_idx), 0._qlknn_dp)
    h(:, outp) = hornnet_constants(:, slope_idx)
    sepflux_out(:, outp) = f(:, outp) * g(:, outp) * h(:, outp)

    if (calcder) then
      df_dhornnet_constants(outp, :, :) = drelu_dhornnet_constants(outp, :, :)
      df_dinput(outp, :, :) = drelu_dinput(block_idx, : , :)

      where(hornnet_constants(:, pow_idx) > 0)
        ! g(u, z) = u(x,z) ^ z -> dg/dx = du/dx(x) * z * u(x, z) ^ (z - 1)
        dg_dhornnet_constants(outp, :, block_idx) = dclip_by_value_dhornnet_constants(outp, :, block_idx) * &
             hornnet_constants(:, pow_idx) * clip_by_value(:, block_idx) ** (hornnet_constants(:, pow_idx) - 1)
        dg_dinput(outp, :, 2) = dclip_by_value_dinput(block_idx, :, 2) * &
             hornnet_constants(:, pow_idx) * clip_by_value(:, block_idx) ** (hornnet_constants(:, pow_idx) - 1)
        dg_dinput(outp, :, 3) = dclip_by_value_dinput(block_idx, :, 3) * &
             hornnet_constants(:, pow_idx) * clip_by_value(:, block_idx) ** (hornnet_constants(:, pow_idx) - 1)

        ! g(u, z) = u(x,z) ^ z -> dg/dz = u(x, z) ^ (z) * [log(u(x, z)) + z * du/dz(x,z) / u(x,z)]
        dg_dhornnet_constants(outp, :, pow_idx) = clip_by_value(:, block_idx)**max(hornnet_constants(:, pow_idx), 0._qlknn_dp) * &
             (log(clip_by_value(:, block_idx)) + max(hornnet_constants(:, pow_idx), 0._qlknn_dp) * dclip_by_value_dhornnet_constants(block_idx, :, pow_idx) / clip_by_value(:, block_idx))
      endwhere

      dh_dhornnet_constants(outp, :, slope_idx) = 1.
    endif
  end subroutine hornnet_multiplier


  subroutine evaluate_hornnet_constants(input, blocks, qlknn_out, verbosityin, optsin, qlknn_normsin, dqlknn_out_dinput)
    !! Calculate the C* constants for HornNet
    real(qlknn_dp), dimension(:,:), intent(in) :: input
    !! Global input to the NN. Same as [[evaluate_QLKNN_10D]]
    real(qlknn_dp), dimension(:,:), allocatable :: input_clipped
    integer(lli), optional, intent(in) :: verbosityin
    type(block_collection), intent(in) :: blocks
    !! Blocks of NN layers to evaluate.
    !! Usually loaded with [[load_hornnet_nets_from_disk]]
    type(qlknn_options), optional, intent(in) :: optsin
    !! Options to be used while evaluating the nets
    !! Usually initialized with [[default_qlknn_hornnet_options]]
    type(qlknn_normpars), optional, intent(in) :: qlknn_normsin
    !! Normalizations needed for the Victor rule, see [[scale_with_victor]]

    real(qlknn_dp), dimension(:,:), intent(out) :: qlknn_out
    !! Output of the C* constants. Columns are (in order):
    !!
    !! - 1-3: \( c_{1, ETG}, c_{1, ITG}, c_{1, TEM} \)
    !! - 4-8: \( c_{2, q_{e,ETG}} c_{2, q_{e,ITG}}, c_{2,q_{e, TEM}}, c_{2, q_{i,ITG}}, c_{2, q_{i,TEM}} \)
    !! - 9-13: \( c_{3, q_{e,ETG}}, c_{3, q_{e, ITG}}, c_{3, q_{e, TEM}}, c_{3, q_{i,ITG}}, c_{3, q_{i, TEM}} \)
    !! - 14-15: \(c_{\Gamma_{e, ITG}}, c_{\Gamma_{e, TEM}} \)
    real(qlknn_dp), dimension(:,:,:), optional, intent(out) :: dqlknn_out_dinput
    !! Jacobians of qlknn_out to input

    type(qlknn_normpars) :: qlknn_norms

    integer(lli) :: ii, rho, verbosity, outp, n_common_out, n_common_in, inp, jj
    integer(lli) :: n_rho, n_outputs, n_total_inputs, n_hidden_in, n_hidden_out, n_output_out, n_hidden_layers, n_general_in
    integer(lli) :: n_concat_in, n_concat_out
    integer(li), parameter :: n_nets = 20
    real(qlknn_dp), dimension(:), allocatable :: res
    real(qlknn_dp), dimension(:,:), allocatable :: net_result
    real(qlknn_dp), dimension(:,:), allocatable :: hidden_result
    real(qlknn_dp), dimension(:,:), allocatable :: output_result
    real(qlknn_dp), dimension(:,:,:), allocatable :: hidden_results_cs
    real(qlknn_dp), dimension(:,:,:), allocatable :: hidden_results_pfes
    real(qlknn_dp), dimension(:,:,:), allocatable :: pfe_hidden_input_layers
    real(qlknn_dp), dimension(:,:,:), allocatable :: common_in
    real(qlknn_dp), dimension(:,:,:), allocatable :: common_in_resc
    real(qlknn_dp), dimension(:,:), allocatable :: common_in_layers
    real(qlknn_dp), dimension(:,:,:), allocatable :: concat_layers
    real(qlknn_dp), dimension(:,:,:), allocatable :: common_out

    ! Jacobians!
    real(qlknn_dp), dimension(:,:), allocatable :: dqlknn_out_dinput_tmp
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dcommon_in_resc
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dgeneral_in_resc
    real(qlknn_dp), dimension(:), allocatable :: dqlknn_out_dcommon_in_resc_tmp
    real(qlknn_dp), dimension(:,:,:,:), allocatable :: dhidden_result_cs_dcommon_in_resc
    real(qlknn_dp), dimension(:,:,:,:), allocatable :: dcommon_out_dcommon_in_resc
    real(qlknn_dp), dimension(:,:,:,:), allocatable :: dconcat_layers_dgeneral_in_resc
    real(qlknn_dp), dimension(:,:,:,:), allocatable :: dcommon_in_resc_dcommon_in
    real(qlknn_dp), dimension(:), allocatable :: dcommon_in_resc_dcommon_in_tmp
    real(qlknn_dp), dimension(:,:,:,:), allocatable :: dpfe_hidden_input_layers_dgeneral_in_resc
    real(qlknn_dp), dimension(:,:,:,:), allocatable :: dpfe_hidden_input_layers_dconcat_layers
    real(qlknn_dp), dimension(:,:,:), allocatable :: doutput_result_dhidden_results
    logical, dimension(:,:), allocatable :: jacobian_clipmask
    type(qlknn_options) :: opts
    logical :: calcder
    !character(len=100) :: fmt_tmp
    integer(lli), dimension(15) :: input_map
    integer(lli), dimension(8) :: this_input_map
    integer(lli), dimension(15) :: late_fuse_var_map
    integer(lli), dimension(8,3) :: common_input_map

    common_input_map = reshape( (/ &
         1, 2, 4, 5,  6,  7,  8,  9, & ! ETG
         1, 3, 4, 5,  6,  7,  8,  9, & ! ITG
         1, 2, 4, 5,  6,  7,  8,  9  & ! TEM
         /), (/ 8, 3 /))

    late_fuse_var_map = (/ 3, 2, 3, 3, 2, 3, 2, 3, 3, 2, 3, 2, 3, 2, 3 /)

    input_map = (/ 1, 2, 3, 1, 2, 3, 2, 3, 1, 2, 3, 2, 3, 2, 3 /)

    ! zeff ati  ate   an         q      smag         x  ti_te logNustar
    !1.0   2.000000  5.0  2.0  0.660156  0.399902  0.449951    1.0      0.001
    !1.0  13.000000  5.0  2.0  0.660156  0.399902  0.449951    1.0      0.001
    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

    if(present(dqlknn_out_dinput)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    n_total_inputs = int(size(input, 1), li)
    n_rho = int(size(input, 2), li)
    n_outputs = int(size(qlknn_out, 2), li)
    allocate(net_result(n_rho, n_nets))

    allocate(res(n_rho)) !Debug

    if (verbosity >= 1) then
      write(*, '(A,I2,A,I3,A,I3,A,I3)') 'Calculating c* constants from input with n_hornet_constants=', 15, ', n_total_inputs=', n_total_inputs, ', n_outputs=', n_outputs, ', n_rho=', n_rho
    endif
    if (.NOT. (n_rho == size(qlknn_out, 1))) then
       write(stderr,*) 'size(qlknn_out, 1)=', size(qlknn_out, 1), ', nrho=', n_rho

       ERRORSTOP(.true., 'Rows of qlknn_out should be equal to number of radial points!')
    end if
    if (15 /= n_outputs) then
       write(stderr,*) 'size(qlknn_out, 2)=', size(qlknn_out, 2)

       ERRORSTOP(.true., 'Columns of qlknn_out should be 15!')
    end if

    if (calcder) then
      if (15 /= size(dqlknn_out_dinput, 1)) then
        write(stderr,*) 'size(dqlknn_out_dinput, 1)=', size(dqlknn_out_dinput, 1)
        ERRORSTOP(.true., 'Rows of dqlknn_out_dinput should be equal to 15!')
      endif
      if (n_rho /= size(dqlknn_out_dinput, 2)) then
        write(stderr,*) 'size(dqlknn_out_dinput, 2)=', size(dqlknn_out_dinput, 2), ', nrho=', n_rho
        ERRORSTOP(.true., 'Columns of dqlknn_out_dinput should be equal to number of radial points!')
      endif
      if (n_total_inputs /= size(dqlknn_out_dinput, 3)) then
        write(stderr,*) 'size(dqlknn_out_dinput, 3)=', size(dqlknn_out_dinput, 3), ', n_total_inputs=', n_total_inputs
        ERRORSTOP(.true., 'Pages of dqlknn_out_dinput should be equal to number of inputs!')
      endif
    endif

    ! set options according to optsin if present from calling program. Otherwise set default
    if(present(optsin)) then
       opts=optsin
    else
       CALL default_qlknn_hornnet_options(opts)
    end if

    if (verbosity >= 1) then
       call print_qlknn_options(opts)
       write(*,*) 'input, n_rho=', n_rho
       do rho = 1, n_rho
          WRITE(*,'(11(F7.2, 1X))') (input(ii, rho), ii=1,n_total_inputs)
       end do
    end if

    if (.NOT. (n_outputs == size(qlknn_out, 2))) then
       write(stderr,*) 'size(qlknn_out, 2)=', size(qlknn_out, 2),', n_outputs=', n_outputs
       ERRORSTOP(.true., 'Columns of qlknn_out should be equal to number of outputs!')
    endif

    if (opts%apply_victor_rule .AND. .NOT. present(qlknn_normsin)) then
       ERRORSTOP(.true., 'Need to pass qlknn_normsin when applying Victor rule')
    else if (present(qlknn_normsin)) then
       qlknn_norms = qlknn_normsin
    end if



    ! Impose input constraints
    if (calcder) then
      call impose_input_constraints(input, input_clipped, opts, verbosity, jacobian_clipmask)
    else
      call impose_input_constraints(input, input_clipped, opts, verbosity)
    endif

    n_common_in = int(size(blocks%input_blocks(1)%weights_input, 2), lli) ! Assume all modes have same shaped input layer
    allocate(common_in(n_common_in, n_rho, 3))
    if (calcder) then
      n_hidden_layers = size(blocks%output_blocks(1)%biases_hidden)
      n_hidden_out = int(size(blocks%output_blocks(1)%biases_hidden(n_hidden_layers)%bias_layer), li)
      allocate(dhidden_result_cs_dcommon_in_resc(n_hidden_out, n_rho, n_common_in, 13))
      dhidden_result_cs_dcommon_in_resc = 0
    else
      allocate(dhidden_result_cs_dcommon_in_resc(0,0,0,0))
    endif
    do ii = 1, 3
      common_in(:, :, ii) = input_clipped(common_input_map(:, ii), :)
    enddo

    ! Scale common input
    ! If calcder, also calculate dcommon_in_resc_dcommon_in. We will need this at the end
    allocate(common_in_resc(n_common_in, n_rho, 3))
    allocate(dcommon_in_resc_dcommon_in(n_outputs, n_rho, n_common_in, 3))
    do rho = 1, n_rho
      do ii = 1, 3
        common_in_resc(:, rho, ii) = blocks%input_blocks(ii)%feature_prescale_factor(common_input_map(:, ii)) * common_in(:, rho, ii) + &
             blocks%input_blocks(ii)%feature_prescale_bias(common_input_map(:, ii))
        if (calcder) then
          do outp = 1, n_outputs
            dcommon_in_resc_dcommon_in(outp, rho,:, ii) = blocks%input_blocks(ii)%feature_prescale_factor(common_input_map(:, ii))
          enddo
        endif
      enddo
    enddo

    if (verbosity >= 3) then
      write(*,*) 'common_in_resc ETG'
      do rho = 1, n_rho
        write(*,'(8(f7.2, 1x))') common_in_resc(:, rho, 1)
      enddo
      write(*,*) 'common_in_resc ITG'
      do rho = 1, n_rho
        write(*,'(8(f7.2, 1x))') common_in_resc(:, rho, 2)
      enddo
    endif

    ! Caclulate common_out, the output of the common input layers
    ! If calcder, also calculate dcommon_out_dcommon_in_resc. This will be updated one-by-one, and will finally store
    ! the Jacobian output of the common output vs the scaled input of the common layers.
    n_common_out = int(size(blocks%input_blocks(1)%weights_input, 1), lli) ! Assume all modes have same shaped input layer. (ie. 64)
    allocate(common_out(n_common_out, n_rho, 3))
    ! Evaluate common input layers
    if (calcder) then
      allocate(dcommon_out_dcommon_in_resc(n_common_out, n_rho, n_common_in, 3)) ! ie. 64 x 24 x 8
      do ii = 1, 3
        call evaluate_layer(common_in_resc(:, :, ii), blocks%input_blocks(ii)%weights_input, blocks%input_blocks(ii)%biases_input, 'tanh', common_out(:, :, ii), verbosity, dcommon_out_dcommon_in_resc(:,:,:,ii))
      enddo
    else
      allocate(dcommon_out_dcommon_in_resc(0,0,0,0))
      do ii = 1, 3
        call evaluate_layer(common_in_resc(:, :, ii), blocks%input_blocks(ii)%weights_input, blocks%input_blocks(ii)%biases_input, 'tanh', common_out(:, :, ii), verbosity)
      enddo
    endif

    if (verbosity >= 3) then
      write(*,*) 'common_out ETG(:10, :)'
      do rho = 1, n_rho
        write(*,'(10(f7.2, 1x))') common_out(:10, rho, 1)
      enddo
      write(*,*) 'common_out ITG(:10, :)'
      do rho = 1, n_rho
        write(*,'(10(f7.2, 1x))') common_out(:10, rho, 2)
      enddo
      if (calcder) then
        write(*,*) 'dcommon_out_dcommon_in_resc ITG(:10, :, 1)'
        do rho = 1, n_rho
          write(*,'(10(f7.2, 1x))') dcommon_out_dcommon_in_resc(:10, rho, 1, 2)
        enddo
      endif
    endif

    ! Evaluate pfe concat layer
    ! This is equivalent to the 'input layer' of regular nets, as this one is differently shaped
    ! From all the other layers
    n_concat_in = int(size(blocks%input_blocks(4)%weights_input, 2), li) ! Assume all modes have same shaped input layer
    n_concat_out = int(size(blocks%input_blocks(4)%weights_input, 1), li) ! Assume all modes have same shaped input layer
    allocate(concat_layers(n_concat_in, n_rho, 3)) ! eg. 65 x 24 x 3
    allocate(pfe_hidden_input_layers(n_concat_out, n_rho, 3))
    concat_layers(:, :, 1) = 0
    pfe_hidden_input_layers(:, :, 1) = 0
    ! Concat input. The last input will be the special input
    concat_layers(:size(concat_layers, 1) - 1, :, 2) = common_out(:, :, input_map(14))
    concat_layers(size(concat_layers, 1), :, 2) = blocks%input_blocks(1)%feature_prescale_factor(2) * &
       input_clipped(2, :) + blocks%input_blocks(1)%feature_prescale_bias(2) ! ITG needs Ati
    concat_layers(:size(concat_layers, 1) - 1, :, 3) = common_out(:, :, input_map(15))
    concat_layers(size(concat_layers, 1), :, 3) = blocks%input_blocks(1)%feature_prescale_factor(3) * &
       input_clipped(3, :) + blocks%input_blocks(1)%feature_prescale_bias(3) ! TEM needs Ate
    n_general_in = 9
    if (calcder) then
      allocate(dconcat_layers_dgeneral_in_resc(n_concat_in, n_rho, n_general_in, 3)) ! eg. 65 x 24 x 9
      dconcat_layers_dgeneral_in_resc(:n_concat_in - 1, :, :n_general_in - 1, 2) = dcommon_out_dcommon_in_resc(:, :, :, input_map(14))
      dconcat_layers_dgeneral_in_resc(:n_concat_in - 1, :, n_general_in, 2) = 0.
      dconcat_layers_dgeneral_in_resc(n_concat_in, :, :n_general_in - 1, 2) = 0. ! Last output only depends on itself
      dconcat_layers_dgeneral_in_resc(n_concat_in, :, n_general_in, 2) = 1. ! Last output only depends on itself

      dconcat_layers_dgeneral_in_resc(:n_concat_in - 1, :, :n_general_in - 1, 3) = dcommon_out_dcommon_in_resc(:, :, :, input_map(15))
      dconcat_layers_dgeneral_in_resc(:n_concat_in - 1, :, n_general_in, 3) = 0.
      dconcat_layers_dgeneral_in_resc(n_concat_in, :, :n_general_in - 1, 3) = 0. ! Last output only depends on itself
      dconcat_layers_dgeneral_in_resc(n_concat_in, :, n_general_in, 3) = 1. ! Last output only depends on itself
    else
      allocate(dconcat_layers_dgeneral_in_resc(0,0,0,0))
    endif

    if (verbosity >= 3) then
      write(*,*) 'concat_layer_pfeITG_GB(:10, :)'
      do rho = 1, n_rho
        write(*,'(11(f7.3, 1x))') concat_layers(:10, rho, 2), concat_layers(size(concat_layers, 1), rho, 2)
      enddo
    endif

    ! Evaluate pfe input layers
    if (calcder) then
      allocate(dpfe_hidden_input_layers_dconcat_layers(n_concat_out, n_rho, n_concat_in, 3))
      allocate(dpfe_hidden_input_layers_dgeneral_in_resc(n_concat_out, n_rho, n_general_in, 3)) ! 64 x 24 x 9 x 3
      dpfe_hidden_input_layers_dgeneral_in_resc(:, :, :, 1) = 0.
      dpfe_hidden_input_layers_dconcat_layers(:, :, :, 1) = 0.
      allocate(dqlknn_out_dinput_tmp(n_concat_out, n_general_in))
      ! Calculate dpfe_hidden_input_layers_dconcat_layers, the Jacobian of the
      ! Hidden input layers vs the concat input layers. E.g. 64 x 24 x 65
      call evaluate_layer(concat_layers(:, :, 2), blocks%input_blocks(4)%weights_input, &
         blocks%input_blocks(4)%biases_input, 'tanh', pfe_hidden_input_layers(:, :, 2), verbosity, &
         dpfe_hidden_input_layers_dconcat_layers(:, :, :, 2))
      call evaluate_layer(concat_layers(:, :, 3), blocks%input_blocks(5)%weights_input, &
         blocks%input_blocks(5)%biases_input, 'tanh', pfe_hidden_input_layers(:, :, 3), verbosity, &
         dpfe_hidden_input_layers_dconcat_layers(:, :, :, 3))
      do rho = 1, n_rho
        call dgemm('N', 'N', n_concat_out, n_general_in, n_concat_in, 1._qlknn_dp, dpfe_hidden_input_layers_dconcat_layers(:, rho, :, 2), n_concat_out, &
             dconcat_layers_dgeneral_in_resc(:, rho, :, 2), n_concat_in, 0._qlknn_dp, dqlknn_out_dinput_tmp(:,:), n_concat_out)
        dpfe_hidden_input_layers_dgeneral_in_resc(:, rho, :, 2) = dqlknn_out_dinput_tmp
        call dgemm('N', 'N', n_concat_out, n_general_in, n_concat_in, 1._qlknn_dp, dpfe_hidden_input_layers_dconcat_layers(:, rho, :, 3), n_concat_out, &
             dconcat_layers_dgeneral_in_resc(:, rho, :, 3), n_concat_in, 0._qlknn_dp, dqlknn_out_dinput_tmp(:,:), n_concat_out)
        dpfe_hidden_input_layers_dgeneral_in_resc(:, rho, :, 3) = dqlknn_out_dinput_tmp
      enddo
      deallocate(dqlknn_out_dinput_tmp)
    else
      allocate(dpfe_hidden_input_layers_dgeneral_in_resc(0,0,0,0))
      call evaluate_layer(concat_layers(:, :, 2), blocks%input_blocks(4)%weights_input, &
         blocks%input_blocks(4)%biases_input, 'tanh', pfe_hidden_input_layers(:, :, 2), verbosity)
      call evaluate_layer(concat_layers(:, :, 3), blocks%input_blocks(5)%weights_input, &
         blocks%input_blocks(5)%biases_input, 'tanh', pfe_hidden_input_layers(:, :, 3), verbosity)
    endif

    if (verbosity >= 3) then
      write(*,*) '1.hidden_layer_pfeITG_GB((:10 -1), :)'
      do rho = 1, n_rho
        write(*,'(11(f7.3, 1x))') pfe_hidden_input_layers(:10, rho, 2), pfe_hidden_input_layers(size(pfe_hidden_input_layers, 1), rho, 2)
      enddo
      write(*,*) '1.hidden_layer_pfeTEM_GB((:10 -1), :)'
      do rho = 1, n_rho
        write(*,'(11(f7.3, 1x))') pfe_hidden_input_layers(:10, rho, 3), pfe_hidden_input_layers(size(pfe_hidden_input_layers, 1), rho, 3)
      enddo
      if (calcder) then
        write(*,*) 'dpfeITG_dpfe_hidden_input_layers_resc(:10, :, 4)'
        do rho = 1, n_rho
          write(*,'(10(f7.3, 1x))') dpfe_hidden_input_layers_dgeneral_in_resc(:10, rho, 4, 2)
        enddo
      endif
    endif

    ! This assumes all hidden layers have the same output shape
    n_hidden_layers = size(blocks%output_blocks(1)%biases_hidden)
    n_hidden_in = int(size(blocks%output_blocks(1)%weights_hidden(n_hidden_layers)%weight_layer, 2), li)
    n_hidden_out = int(size(blocks%output_blocks(1)%biases_hidden(n_hidden_layers)%bias_layer), li)
    allocate(common_in_layers(n_hidden_in, n_rho))
    allocate(hidden_result(n_hidden_out, n_rho))
    allocate(hidden_results_cs(n_hidden_out, n_rho, 13))
    if (calcder) then
      if (n_hidden_in /= n_common_out) then
        write(stderr,*) 'Warning! n_hidden_in /= n_common_out. unexpected'
      endif
      if (n_hidden_out /= n_common_out) then
        write(stderr,*) 'Warning! n_hidden_out /= n_common_out. unexpected'
      endif
    endif
    ! Evaluate the hidden layers of c*, do not evaluate pfe layers!
    ! evaluate_layers will internally auto-multiply, so we get dhidden_result_cs_dcommon_in_resc directly
    do ii = 1, 13
      common_in_layers = common_out(:, :, input_map(ii))
      if (calcder) then
        dhidden_result_cs_dcommon_in_resc(:,:,:, ii) = dcommon_out_dcommon_in_resc(:,:,:, input_map(ii))
        call evaluate_layers(common_in_layers, blocks%output_blocks(ii)%weights_hidden, &
             blocks%output_blocks(ii)%biases_hidden, blocks%output_blocks(ii)%hidden_activation, &
             hidden_result, verbosity, dhidden_result_cs_dcommon_in_resc(:,:,:, ii))
      else
        call evaluate_layers(common_in_layers, blocks%output_blocks(ii)%weights_hidden, &
             blocks%output_blocks(ii)%biases_hidden, blocks%output_blocks(ii)%hidden_activation, &
             hidden_result, verbosity)
      endif
      hidden_results_cs(:,:,ii) = hidden_result
    enddo
    deallocate(hidden_result)
    deallocate(common_in_layers)

    ! Evaluate pfe layers
    ! This assumes all hidden layers have the same output shape
    ! dpfe_hidden_input_layers_dconcat_layers e.g. 64 x 24 x 65 x 3
    ! pfe_hidden_input_layers e.g. 64 x 24 x 3
    n_hidden_in = int(size(blocks%output_blocks(14)%weights_hidden(1)%weight_layer, 2), li)
    n_hidden_layers = size(blocks%output_blocks(14)%biases_hidden)
    n_hidden_out = int(size(blocks%output_blocks(14)%biases_hidden(n_hidden_layers)%bias_layer), li) !64
    allocate(hidden_results_pfes(n_hidden_out, n_rho, 3))
    hidden_results_pfes(:, :, 1) = 0
    if (calcder) then
      call evaluate_layers(pfe_hidden_input_layers(:, :, 2), blocks%output_blocks(14)%weights_hidden, &
           blocks%output_blocks(14)%biases_hidden, blocks%output_blocks(14)%hidden_activation, &
           hidden_results_pfes(:, :, 2), verbosity, dpfe_hidden_input_layers_dgeneral_in_resc(:,:,:,2))
      call evaluate_layers(pfe_hidden_input_layers(:, :, 3), blocks%output_blocks(15)%weights_hidden, &
           blocks%output_blocks(15)%biases_hidden, blocks%output_blocks(15)%hidden_activation, &
           hidden_results_pfes(:, :, 3), verbosity, dpfe_hidden_input_layers_dgeneral_in_resc(:,:,:,3))
    else
      call evaluate_layers(pfe_hidden_input_layers(:, :, 2), blocks%output_blocks(14)%weights_hidden, &
           blocks%output_blocks(14)%biases_hidden, blocks%output_blocks(14)%hidden_activation, &
           hidden_results_pfes(:, :, 2), verbosity)
      call evaluate_layers(pfe_hidden_input_layers(:, :, 3), blocks%output_blocks(15)%weights_hidden, &
           blocks%output_blocks(15)%biases_hidden, blocks%output_blocks(15)%hidden_activation, &
           hidden_results_pfes(:, :, 3), verbosity)
    endif

    if (verbosity >= 3) then
      write(*,*) 'hidden_out c1_etg(:10)'
      do rho = 1, n_rho
        write(*,'(10(f7.3, 1x))') hidden_results_cs(:10, rho, 1)
      enddo
      write(*,*) 'hidden_out c2_efeitg(:10)'
      do rho = 1, n_rho
        write(*,'(10(f7.3, 1x))') hidden_results_cs(:10, rho, 5)
      enddo
      if (calcder) then
        write(*,*) 'hidden_out dc2_efeitg_dcommon_in(:10, :, 1)'
        do rho = 1, n_rho
          write(*,'(10(f7.3, 1x))') dhidden_result_cs_dcommon_in_resc(:10, rho, 1, 5)
        enddo
        write(*,*) 'dpfeITG_dpfe_hidden_layers_resc(:10, :, 4)'
        do rho = 1, n_rho
          write(*,'(10(f7.3, 1x))') dpfe_hidden_input_layers_dgeneral_in_resc(:10, rho, 4, 2)
        enddo
      endif
      write(*,*) 'hidden_out pfeitg(:10)'
      do rho = 1, n_rho
        write(*,'(10(f7.3, 1x))') hidden_results_pfes(:10, rho, 2)
      enddo
      write(*,*) 'hidden_out pfetem(:10)'
      do rho = 1, n_rho
        write(*,'(10(f7.3, 1x))') hidden_results_pfes(:10, rho, 3)
      enddo
    endif

    ! Apply c* output layer
    n_hidden_layers = size(blocks%output_blocks(1)%biases_hidden)
    n_hidden_out = int(size(blocks%output_blocks(1)%biases_hidden(n_hidden_layers)%bias_layer), li)
    n_output_out = int(size(blocks%output_blocks(1)%weights_output, 1), li)
    ERRORSTOP(n_output_out /= 1, 'Expected 1D output from c* layers')
    allocate(output_result(1, n_rho))
    if (calcder) then
      allocate(doutput_result_dhidden_results(n_output_out, n_rho, n_hidden_out)) ! e.g. 1 x 24 x 64
      allocate(dqlknn_out_dinput_tmp(n_output_out, n_common_in)) ! 1 x 8
      allocate(dqlknn_out_dcommon_in_resc(13, n_rho, n_common_in)) ! 13 x 24 x 8
    else
      allocate(dqlknn_out_dcommon_in_resc(0,0,0))
    endif
    if (n_output_out /= 1) then
      write(stderr, *) 'shape output block is ', n_output_out
      ERRORSTOP(.true., 'ND output block. Expected 1D')
    endif
    do ii = 1, 13
      if (calcder) then
        call evaluate_layer(hidden_results_cs(:, :, ii), blocks%output_blocks(ii)%weights_output, &
             blocks%output_blocks(ii)%biases_output, 'none', &
             output_result, verbosity, doutput_result_dhidden_results)
        do rho = 1, n_rho
          ! Gives us doutput_result_dcommon_in_resc ~= dqlknn_out_dinput (still need to clip)
          ! e.g. dhidden_result_cs_dcommon_in_resc 64 x 24 x 8 x 15
          call dgemm('N', 'N', n_output_out, n_common_in, n_hidden_out, 1._qlknn_dp, doutput_result_dhidden_results(:, rho, :), n_output_out, &
               dhidden_result_cs_dcommon_in_resc(:, rho, :, ii), n_hidden_out, 0._qlknn_dp, dqlknn_out_dinput_tmp(:,:), n_output_out)

          ! dqlknn_out_dinput_tmp is general here: It could be ND. We want it to be 1D (for now)
          ERRORSTOP(size(dqlknn_out_dinput_tmp, 1) /= 1, 'Output of hidden layer is not 1D')
          dqlknn_out_dcommon_in_resc(ii, rho, :) = dqlknn_out_dinput_tmp(1, :)
        enddo
      else
        call evaluate_layer(hidden_results_cs(:, :, ii), blocks%output_blocks(ii)%weights_output, &
             blocks%output_blocks(ii)%biases_output, 'none', &
             output_result, verbosity)
      endif
      qlknn_out(:, ii) = output_result(1, :)
    enddo

    ! Apply pfe output layer
    n_hidden_layers = size(blocks%output_blocks(14)%biases_hidden)
    n_hidden_out = int(size(blocks%output_blocks(14)%biases_hidden(n_hidden_layers)%bias_layer), li)
    n_output_out = int(size(blocks%output_blocks(14)%weights_output, 1), li)
    ERRORSTOP(n_output_out /= 1, 'Expected 1D output from pfe layers')
    if (calcder) then
      deallocate(dqlknn_out_dinput_tmp)
      allocate(dqlknn_out_dinput_tmp(n_output_out, n_general_in)) ! 1 x 9
      allocate(dqlknn_out_dgeneral_in_resc(3, n_rho, n_general_in)) ! 3 x 24 x 9
      do jj = 14, 15
        ii = jj - 12
        call evaluate_layer(hidden_results_pfes(:, :, ii), blocks%output_blocks(jj)%weights_output, &
             blocks%output_blocks(jj)%biases_output, 'none', &
             output_result, verbosity, doutput_result_dhidden_results)
        do rho = 1, n_rho
          ! dpfe_hidden_input_layers_dgeneral_in e.g. 64 x 24 x 9 x 3
          call dgemm('N', 'N', n_output_out, n_general_in, n_hidden_out, 1._qlknn_dp, doutput_result_dhidden_results(:, rho, :), n_output_out, &
               dpfe_hidden_input_layers_dgeneral_in_resc(:, rho, :, ii), n_hidden_out, 0._qlknn_dp, dqlknn_out_dinput_tmp(:,:), n_output_out)

          ! dqlknn_out_dinput_tmp is general here: It could be ND. We want it to be 1D (for now)
          ERRORSTOP(size(output_result, 1) /= 1, 'Output of hidden layer is not 1D')
          ERRORSTOP(size(dqlknn_out_dinput_tmp, 1) /= 1, 'Output of hidden layer is not 1D')
          dqlknn_out_dgeneral_in_resc(ii, rho, :) = dqlknn_out_dinput_tmp(1, :)
          qlknn_out(:, jj) = output_result(1, :)
        enddo
      enddo
    else
      allocate(dqlknn_out_dgeneral_in_resc(0,0,0))
      call evaluate_layer(hidden_results_pfes(:, :, 2), blocks%output_blocks(14)%weights_output, &
           blocks%output_blocks(14)%biases_output, 'none', &
           output_result, verbosity)

      qlknn_out(:, 14) = output_result(1, :)
      call evaluate_layer(hidden_results_pfes(:, :, 3), blocks%output_blocks(15)%weights_output, &
           blocks%output_blocks(15)%biases_output, 'none', &
           output_result, verbosity)
      qlknn_out(:, 15) = output_result(1, :)
    endif

    if (verbosity >= 3) then
      write(*,*) 'c* output layers out'
      do rho = 1, n_rho
        write(*,'(15(f7.3, 1x))') qlknn_out(rho, :)
      enddo
    endif
    ! c* does not depend on the special input, nor the victorrule inputs
    ! dcommon_in_resc_dcommon_in: 15 x 24 x 9 x 3
    if (calcder) then
      allocate(dcommon_in_resc_dcommon_in_tmp(n_total_inputs))
      allocate(dqlknn_out_dcommon_in_resc_tmp(n_total_inputs))
      do rho = 1, n_rho
        do outp = 1, 13
          this_input_map = common_input_map(:, input_map(outp))
          dcommon_in_resc_dcommon_in_tmp = 0.
          dcommon_in_resc_dcommon_in_tmp(this_input_map) = dcommon_in_resc_dcommon_in(outp, rho, :, input_map(outp))
          dqlknn_out_dcommon_in_resc_tmp = 0.
          dqlknn_out_dcommon_in_resc_tmp(this_input_map) = dqlknn_out_dcommon_in_resc(outp, rho, 1:8)
          call vdmul(n_total_inputs, dqlknn_out_dcommon_in_resc_tmp, dcommon_in_resc_dcommon_in_tmp, dqlknn_out_dinput(outp, rho, :))
        enddo
        do outp = 14, 15
          ! pfe DOES depend on special input
          ! input_map = (/ 1, 2, 3, 1, 2, 3, 2, 3, 1, 2, 3, 2, 3, 2, 3 /)
          ! common_input_map(:, 2) = 1, 3, 4, 5,  6,  7,  8,  9
          ! late_fuse_var_map = (/ 3, 2, 3, 3, 2, 3, 2, 3, 3, 2, 3, 2, 3, 2, 3 /)
          ii = outp - 12
          this_input_map = common_input_map(:, input_map(outp))
          dcommon_in_resc_dcommon_in_tmp = 0.
          dcommon_in_resc_dcommon_in_tmp(this_input_map) = dcommon_in_resc_dcommon_in(outp, rho, :, input_map(outp))
          dcommon_in_resc_dcommon_in_tmp(late_fuse_var_map(outp)) = dcommon_in_resc_dcommon_in(outp, rho, late_fuse_var_map(outp), input_map(outp))
          dqlknn_out_dcommon_in_resc_tmp = 0.
          dqlknn_out_dcommon_in_resc_tmp(this_input_map) = dqlknn_out_dgeneral_in_resc(ii, rho, 1:8) ! The first 8 vars are in the input map
          dqlknn_out_dcommon_in_resc_tmp(late_fuse_var_map(outp)) = dqlknn_out_dgeneral_in_resc(ii, rho, n_general_in) ! The 9th var is the special input
          call vdmul(n_total_inputs, dqlknn_out_dcommon_in_resc_tmp, dcommon_in_resc_dcommon_in_tmp, dqlknn_out_dinput(outp, rho, :))
        enddo
      enddo
    endif


    ! c2 neuron has a rectifier as activation function
    if (calcder) then
      do inp = 1, n_total_inputs
        do outp = 4, 8
          where (qlknn_out(:, outp) < 0.)
            dqlknn_out_dinput(outp, :, inp) = 0
          end where
        end do
      end do
    endif
    do outp = 4, 8
      qlknn_out(:, outp) = max(qlknn_out(:, outp), 0._qlknn_dp)
    enddo

    if (verbosity >= 1) then
      write(*,*) 'c* outputs:'
      do rho = 1, n_rho
        write(*,'(15(f7.3, 1x))') qlknn_out(rho, :)
      enddo
    endif
    if (verbosity >= 2) then
      if (calcder) then
        write(*,*) 'dc*_dinput (:, :, 2)'
        do rho = 1, n_rho
          write(*,'(15(f7.3, 1x))') dqlknn_out_dinput(:, rho, 2)
        enddo
        write(*,*) 'dc*_dinput (:, :, 3)'
        do rho = 1, n_rho
          write(*,'(15(f7.3, 1x))') dqlknn_out_dinput(:, rho, 3)
        enddo
      endif
    endif


  end subroutine evaluate_hornnet_constants

  subroutine evaluate_multinet(net_input, nets, net_evaluate, net_result, verbosityin, dnet_out_dnet_in)
    real(qlknn_dp), dimension(:,:), intent(in) :: net_input
    type(net_collection), intent(in) :: nets
    logical, dimension(:), intent(in) :: net_evaluate
    integer(lli), intent(in), optional :: verbosityin

    real(qlknn_dp), dimension(:,:), intent(out) :: net_result
    real(qlknn_dp), dimension(:,:,:), intent(out), optional :: dnet_out_dnet_in

    integer(li) :: job, n_in
    integer(lli) ii, jj, verbosity
    integer(lli), dimension(:), allocatable :: myjobs, joblist
    logical :: calcder
    !integer(lli), parameter :: max_nets = 23*10
    !integer(lli), dimension(max_nets), parameter :: potential_net_joblist = (/(ii, ii=1,max_nets)/)
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: my_world_rank, myjobs_length
#else
    integer(li) :: my_world_rank, myjobs_length
#endif
#ifdef MPI
    integer(li) :: n_rho
    integer(li), dimension(:), allocatable :: their_jobs, to_gather_jobs
    real(qlknn_dp), dimension(:), allocatable :: rec_buffer
    real(qlknn_dp), dimension(:,:), allocatable :: rec_buffer_jac
    integer(li) recv_status(MPI_STATUS_SIZE)
    logical :: master_is_no_worker
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
    integer(lli) :: mpi_ierr, world_size, their_world_rank, their_jobs_length
#else
    integer(li) :: mpi_ierr, world_size, their_world_rank, their_jobs_length
#endif
#endif

    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

#ifdef MPI
    call MPI_COMM_SIZE(MPI_COMM_WORLD, world_size, mpi_ierr)
    call MPI_COMM_RANK(MPI_COMM_WORLD, my_world_rank, mpi_ierr)
    if (my_world_rank == 0) then
      if (verbosity >= 2) write(*,*) 'World size in evaluate_multinet is ', world_size
    end if
    if (verbosity >= 2) write(*,*) 'Hello world from evaluate_multinet rank ', my_world_rank
    n_rho = int(size(net_input, 2), li)
#else
    my_world_rank = 0
#endif

    if(present(verbosityin)) then
      verbosity=verbosityin
    else
      verbosity = 0
    end if

    if(present(dnet_out_dnet_in)) then
      calcder = .true.
    else
      calcder = .false.
    end if

    !ERRORSTOP(size(net_evaluate) > max_nets, 'Number of nets to evaluate bigger than max_nets!')

    n_in = int(size(net_input, 1), li)

    allocate(joblist(COUNT(net_evaluate)))
    ! TODO Somhow this is making fullflux nets crash, suspicious!
    !joblist(1:COUNT(net_evaluate)) = PACK(potential_net_joblist, net_evaluate)
    jj = 1
    do ii = 1, SIZE(net_evaluate)
      if (net_evaluate(ii)) then
        joblist(jj) = ii
        jj = jj + 1
      endif
    enddo
    ERRORSTOP(maxval(joblist) > size(nets%nets), 'joblist contains index larger than amount of nets!')
    net_result = 0.
#ifdef MPI
    master_is_no_worker = .false.
    if (master_is_no_worker .and. world_size > 1) then
      if (my_world_rank /= 0) then
        CALL calc_length(world_size - my_world_rank, size(joblist), world_size - 1, myjobs_length)
        allocate(myjobs(myjobs_length))
        myjobs = joblist(world_size - my_world_rank:size(joblist):world_size - 1)
      else
        allocate(myjobs(0))
      end if
    else
      CALL calc_length(world_size - my_world_rank, size(joblist), world_size, myjobs_length)
      allocate(myjobs(myjobs_length))
      myjobs = joblist(world_size - my_world_rank:size(joblist):world_size)
    end if
#else
    myjobs_length = INT(size(joblist), li)
    allocate(myjobs(myjobs_length))
    myjobs = joblist
#endif
    do ii = 1,size(myjobs)
      job = INT(myjobs(ii), li)
      if (net_evaluate(job)) then
        if (verbosity >= 2) write(*,*) 'rank ', my_world_rank, 'doing job ', job
        if (calcder) then
          call evaluate_network(net_input, nets%nets(job), net_result(:, job), verbosity, dnet_out_dnet_in(job, :, :))
        else
          call evaluate_network(net_input, nets%nets(job), net_result(:, job), verbosity)
        endif
      end if
    end do
#ifdef MPI
    if (verbosity >= 2) write(*,*) 'rank ', my_world_rank, 'done with working'
    call mpi_barrier(MPI_COMM_WORLD, mpi_ierr)
    is_zero_rank: if (my_world_rank /= 0) then
      do ii =1,size(myjobs)
        job = INT(myjobs(ii), li)
        if (net_evaluate(job)) then
          if (verbosity >= 2) write(*,*) 'rank ', my_world_rank, 'sending job ', job, 'len ', size(net_result(:,job))
          call mpi_send(net_result(:,job), n_rho, MPI_DOUBLE_PRECISION, INT(0, li), job, MPI_COMM_WORLD, mpi_ierr)
          if (calcder) then
            call mpi_send(dnet_out_dnet_in(job, :, :), INT(n_rho * n_in, li), MPI_DOUBLE_PRECISION, INT(0, li), job, MPI_COMM_WORLD, mpi_ierr)
          end if
        end if
      end do
    else is_zero_rank
      allocate(to_gather_jobs(INT(size(joblist), li)))
      to_gather_jobs = INT(joblist, li)
      do ii = 1, size(myjobs)
        where(to_gather_jobs == myjobs(ii))
          to_gather_jobs = 0
        endwhere
      end do

      allocate(rec_buffer(n_rho))
      if (calcder) then
        allocate(rec_buffer_jac(n_rho, n_in))
      else
        allocate(rec_buffer_jac(0, 0))
      end if
      gathering: do while (.not. all(to_gather_jobs == 0))
        gather_jobs: do ii =1,size(to_gather_jobs)
          job = to_gather_jobs(ii)
          have_to_gather: if (job /= 0) then
#if (defined(LLI) && defined(__INTEL_COMPILER)) || defined(MEXING)
            do their_world_rank=1_lli, world_size-1_lli
#else
            do their_world_rank=1_li, world_size-1_li
#endif
              if (master_is_no_worker) then
                CALL calc_length(world_size - their_world_rank, size(joblist), world_size - 1_li, their_jobs_length)
                allocate(their_jobs(their_jobs_length))
                their_jobs = INT(joblist(world_size - their_world_rank:size(joblist):world_size - 1), li)
              else
                CALL calc_length(world_size - their_world_rank, size(joblist), world_size, their_jobs_length)
                allocate(their_jobs(their_jobs_length))
                their_jobs = INT(joblist(world_size - their_world_rank:INT(size(joblist), li):world_size), li)
              end if
              if (any(job == their_jobs)) then
                if (verbosity >= 2) write(*,*) 'rank ', my_world_rank, 'trying to receive job ', job, 'from rank ', their_world_rank
                call mpi_recv(rec_buffer, n_rho, MPI_DOUBLE_PRECISION, MPI_ANY_SOURCE, job, MPI_COMM_WORLD, recv_status, mpi_ierr)
                net_result(:,job) = rec_buffer
                if (calcder) then
                  call mpi_recv(rec_buffer_jac, INT(n_rho * n_in, li), MPI_DOUBLE_PRECISION, MPI_ANY_SOURCE, job, MPI_COMM_WORLD, recv_status, mpi_ierr)
                  dnet_out_dnet_in(job, :, :) = rec_buffer_jac
                end if
                where(to_gather_jobs == job)
                  to_gather_jobs = 0
                endwhere
              end if
              deallocate(their_jobs)
            end do
          end if have_to_gather
        end do gather_jobs
      end do gathering
    end if is_zero_rank
    call mpi_barrier(MPI_COMM_WORLD, mpi_ierr)

    if (my_world_rank /= 0) then
      if (verbosity >= 2) write(*,*) 'rank ', my_world_rank, 'returning'
      return
    else
      if (verbosity >= 2) write(*,*) 'rank ', my_world_rank, 'continuing'
    endif
#endif
  end subroutine evaluate_multinet

end module qlknn_evaluate_nets

! This file is part of QLKNN-fortran
! You should have received the QLKNN-fortran LICENSE in the root of the project
module test_jacobian
#include "../src/core/preprocessor.inc"
  use qlknn_types

  real(qlknn_dp), dimension(5), parameter :: max_err_hyper = (/ 1e-5, 1e-6, 1e-8, 1., 1e-1 /)
  real(qlknn_dp), parameter :: stepsize_hyper = 1e-3

  real(qlknn_dp), dimension(6), parameter :: max_err_hornnet = (/ 1e-10, 1e-9, 1e-5, 2e-5 , 1e-1, 1e-2/)
  real(qlknn_dp), parameter :: stepsize_hornnet = 1e-4

contains
  function calc_error(dprofa,dprofn,prof0) result(error)
    use qlknn_primitives, only: is_not_close
    !! generic function to calculate calculate relative numerical vs analytical error in Jacobian
    !! err = ||numerical-analytical||/||analytical||
    real(qlknn_dp), dimension(:), intent(in):: dprofa, dprofn, prof0
    real(qlknn_dp), dimension(size(dprofa)) :: error
    real(qlknn_dp) :: near_zero

    real(qlknn_dp), dimension(:), allocatable :: difference

    logical, dimension(:), allocatable :: is_zeron
    logical, dimension(:), allocatable :: is_zeroa
    logical, dimension(:), allocatable :: is_zero0

    allocate(is_zeroa(size(dprofa, 1)))
    allocate(is_zeron(size(dprofn, 1)))
    allocate(is_zero0(size(prof0, 1)))

    near_zero = 10*epsilon(error)
    call is_not_close(dprofa, 0._qlknn_dp, is_zeroa)
    is_zeroa = .not. is_zeroa

    call is_not_close(dprofn, 0._qlknn_dp, is_zeron)
    is_zeron = .not. is_zeron

    call is_not_close(prof0, 0._qlknn_dp, is_zero0)
    is_zero0 = .not. is_zero0

    if ((all(is_zeron)) .and. (all(is_zeroa))) then
      write(stderr, *) 'Warning! No dependence'
      error = 0 !zero error because no dependence
    elseif (all(is_zero0)) then
      ERRORSTOP(.true., 'Normalization profile is 0.')
    elseif (all(is_zeron) .and.  .not. all(is_zeroa)) then
      write(stderr, *)'Numerical profile is zero while analytical profile is non-zero!'
    elseif (.not. all(is_zeron) .and.  all(is_zeroa)) then
      ERRORSTOP(.true., 'Analytical profile is zero while numerical profile is non-zero!')
    elseif ((norm2(dprofn)/norm2(prof0) < near_zero) .or. &
            (norm2(dprofa)/norm2(prof0) < near_zero) .or. &
            (norm2(dprofn) < near_zero) .or. &
            (norm2(dprofa) < near_zero)) then
      error = 0 ! zero because relative change is too small (but nonzero)
    else
      ! Workaround temp array for PGI compiler bug
      ! https://forums.developer.nvidia.com/t/fortran-expression-in-norm2-not-allowed/136385
      allocate(difference(size(dprofa, 1)))
      difference = dprofa - dprofn
      error = difference / (prof0 + epsilon(error))
    endif
  end function calc_error

  subroutine jacobian_hyper_multi(casenum, input, stepsize, net, err_out, verbosityin)
    use qlknn_evaluate_nets
    use qlknn_disk_io
    implicit none

    integer, intent(in) :: casenum
    real(qlknn_dp), dimension(:,:), intent(in):: input
    real(qlknn_dp), intent(in) :: stepsize
    integer(lli), intent(in) :: net
    integer(lli), intent(in), optional :: verbosityin
    real(qlknn_dp), dimension(:,:,:), allocatable, intent(out) :: err_out

    integer(lli) :: verbosity, n_rho=24, n_input_layer_out, rho, n_hidden_layers, n_hidden_layers_out
    integer :: inp, outp, n_out, n_in
    type (qlknn_options) :: opts
    type (qlknn_normpars) :: qlknn_norms
    real(qlknn_dp), dimension(:,:), allocatable :: input_min_half, input_plus_half
    !real(qlknn_dp) :: start, finish
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out_min_half, qlknn_out_plus_half
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out_tmp, qlknn_input_layer_out, qlknn_input_layer_out_min_half, qlknn_input_layer_out_plus_half
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_input_layer_out_dinput
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_hidden_out, qlknn_hidden_out_plus, qlknn_hidden_out_min
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out_min_half_tmp, qlknn_out_plus_half_tmp
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput_tmp
    real(qlknn_dp), dimension(:,:), allocatable :: dinput_numerical, dout_numerical
    real(qlknn_dp), dimension(:), allocatable :: err, dana, dnum
    logical, dimension(:), allocatable :: err_okay
    !character(len=2) :: testcase_str
    !integer(lli) :: num_args, inp, n_inputs, outp, n_out, rho, testcase, n_in
    !integer(li) :: stat, length
    !real(qlknn_dp) :: stepsize, err, max_err
    !real(qlknn_dp), dimension(:,:), allocatable :: din

    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

    n_in = size(input, 1)

    call default_qlknn_hyper_options(opts)

    ! Set default options
    opts%constrain_inputs = .false.
    opts%constrain_outputs = .false.
    opts%force_evaluate_all = .true.

    ! Set specific options, and allocated arrays that change shape between tests
    ! Each test should have at least:
    ! n_out: The amount of outputs of the outermost function
    ! n_in: The amount of inputs of the innermost function
    ! n_rho: The amount of radial points
    ! This defines the following quantities:
    ! dqlknn_out_dinput: The Jacobian of the outermost function with respect
    !    to the innermost input (n_out, n_rho, n_in)
    ! qlknn_out: The output of the outermost function
    ! qlknn_out_min_half: The output of the outermost function with input
    !    modified by -step
    ! qlknn_out_min_half: The output of the outermost function with input
    !    modified by +step
    select case (casenum)
    case(1)
      ! Test a single (input) layer
      opts%merge_modes = .false.
      n_out = size(nets%nets(1)%biases_input)
      ! First layer only depends on the first 9 dimensions, fill rest with 0s and
      ! define temporary variable to store the layers Jacobian in
      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
      allocate(err_out(n_out, n_rho, 9))
      allocate(dqlknn_out_dinput_tmp(n_out, n_rho, 9))
      dqlknn_out_dinput = 0
      ! The Jacobians of the layers are transposed as compared to the final
      ! outputted Jacobians. Allocate temporary arrays to save this transposed array
      allocate(qlknn_out_tmp(n_out, n_rho))
      allocate(qlknn_out_min_half_tmp(n_out, n_rho))
      allocate(qlknn_out_plus_half_tmp(n_out, n_rho))
    case(2)
      ! Test input layer + a single hidden layer
      n_out = size(nets%nets(1)%biases_hidden(1)%bias_layer)
      n_input_layer_out = size(nets%nets(1)%biases_input)
      ! First layer only depends on the first 9 dimensions, fill rest with 0s and
      ! define temporary variable to store the layers Jacobian in
      allocate(dqlknn_out_dinput(n_out, n_rho, 9))
      allocate(err_out(n_out, n_rho, 9))
      allocate(dqlknn_out_dinput_tmp(n_out, n_rho, n_input_layer_out))
      dqlknn_out_dinput = 0
      ! The Jacobians of the layers are transposed as compared to the final
      ! outputted Jacobians. Allocate temporary arrays to save this transposed array
      allocate(qlknn_out_tmp(n_out, n_rho))
      allocate(qlknn_out_min_half_tmp(n_out, n_rho))
      allocate(qlknn_out_plus_half_tmp(n_out, n_rho))
      ! We need to manually calculate the final combined Jacobian of the two layers
      allocate(dqlknn_input_layer_out_dinput(n_input_layer_out, n_rho, 9))
      allocate(qlknn_input_layer_out(n_input_layer_out, n_rho))
      allocate(qlknn_input_layer_out_plus_half(n_input_layer_out, n_rho))
      allocate(qlknn_input_layer_out_min_half(n_input_layer_out, n_rho))
      opts%merge_modes = .false.
    case(3)
      ! Test evaluate_net
      n_out = 1
      opts%merge_modes = .false.
      allocate(dqlknn_out_dinput(n_out, n_rho, 9))
      allocate(err_out(n_out, n_rho, 9))
    case(4)
      ! Test input layer + a all hidden layers with evaluate_nets
      n_hidden_layers = size(nets%nets(net)%biases_hidden)
      n_out = size(nets%nets(net)%biases_hidden(n_hidden_layers)%bias_layer)
      n_input_layer_out = size(nets%nets(net)%biases_input)
      ! First layer only depends on the first 9 dimensions, fill rest with 0s and
      ! define temporary variable to store the layers Jacobian in
      allocate(dqlknn_out_dinput(n_out, n_rho, 9))
      allocate(err_out(n_out, n_rho, 9))
      allocate(dqlknn_out_dinput_tmp(n_out, n_rho, n_input_layer_out))
      dqlknn_out_dinput = 0
      ! The Jacobians of the layers are transposed as compared to the final
      ! outputted Jacobians. Allocate temporary arrays to save this transposed array
      allocate(qlknn_out_tmp(n_out, n_rho))
      allocate(qlknn_out_min_half_tmp(n_out, n_rho))
      allocate(qlknn_out_plus_half_tmp(n_out, n_rho))
      ! We need to manually calculate the final combined Jacobian of the two layers
      allocate(dqlknn_input_layer_out_dinput(n_input_layer_out, n_rho, 9))
      allocate(qlknn_input_layer_out(n_input_layer_out, n_rho))
      allocate(qlknn_input_layer_out_plus_half(n_input_layer_out, n_rho))
      allocate(qlknn_input_layer_out_min_half(n_input_layer_out, n_rho))
      opts%merge_modes = .false.
    case(5)
      ! Test input layer + a all hidden layers with evaluate_nets
      n_hidden_layers = size(nets%nets(net)%biases_hidden)
      n_out = size(nets%nets(net)%biases_output)
      n_input_layer_out = size(nets%nets(net)%biases_input)
      n_hidden_layers_out = size(nets%nets(net)%biases_hidden(n_hidden_layers)%bias_layer)
      ! First layer only depends on the first 9 dimensions, fill rest with 0s and
      ! define temporary variable to store the layers Jacobian in
      allocate(dqlknn_out_dinput(n_out, n_rho, 9))
      allocate(err_out(n_out, n_rho, 9))
      allocate(dqlknn_out_dinput_tmp(n_out, n_rho, n_hidden_layers_out))
      dqlknn_out_dinput = 0
      !

      allocate(qlknn_hidden_out(n_hidden_layers_out, n_rho))
      allocate(qlknn_hidden_out_plus(n_hidden_layers_out, n_rho))
      allocate(qlknn_hidden_out_min(n_hidden_layers_out, n_rho))
      ! The Jacobians of the layers are transposed as compared to the final
      ! outputted Jacobians. Allocate temporary arrays to save this transposed array
      allocate(qlknn_out_tmp(n_out, n_rho))
      allocate(qlknn_out_min_half_tmp(n_out, n_rho))
      allocate(qlknn_out_plus_half_tmp(n_out, n_rho))
      ! We need to manually calculate the final combined Jacobian of the two layers
      allocate(dqlknn_input_layer_out_dinput(n_input_layer_out, n_rho, 9))
      allocate(qlknn_input_layer_out(n_input_layer_out, n_rho))
      allocate(qlknn_input_layer_out_plus_half(n_input_layer_out, n_rho))
      allocate(qlknn_input_layer_out_min_half(n_input_layer_out, n_rho))
      opts%merge_modes = .false.
    case default
      ERRORSTOP(.true., 'Given case number not implemented')
    endselect

    ! To store the results of evaluating at x, x-h and x+h
    allocate(qlknn_out(n_rho, n_out))
    allocate(qlknn_out_min_half(n_rho, n_out))
    allocate(qlknn_out_plus_half(n_rho, n_out))

    ! To store  x-h and x+h
    allocate(input_min_half(n_in, n_rho))
    allocate(input_plus_half(n_in, n_rho))

    ! To store profile data of the error
    allocate(err(n_rho))
    allocate(dana(n_rho))
    allocate(dnum(n_rho))
    allocate(err_okay(n_rho))

    ! To store f(x+h) - f(x-h)
    allocate(dout_numerical(n_rho, n_out))
    ! To store x+h - x - h (aka 2h)
    allocate(dinput_numerical(n_in, n_rho))

    ! Variables for Victor rule
    allocate(qlknn_norms%a1(n_rho))
    qlknn_norms%A1 = 2.
    qlknn_norms%R0 = 3.
    qlknn_norms%a = 1.

    do inp = 1, n_in - 2
      input_min_half(:, :) = input
      input_plus_half(:, :) = input
      input_min_half(inp, :) = input(inp, :) - 0.5 * stepsize
      input_plus_half(inp, :) = input(inp, :) + 0.5 * stepsize
      select case (casenum)
      case(1)
        call evaluate_layer(input(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(1)%biases_input, 'tanh', &
             qlknn_out_tmp, verbosity - 1, dqlknn_out_dinput_tmp)
        call evaluate_layer(input_plus_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(1)%biases_input, 'tanh', &
             qlknn_out_plus_half_tmp, verbosity - 1)
        call evaluate_layer(input_min_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(1)%biases_input, 'tanh', &
             qlknn_out_min_half_tmp, verbosity - 1)

        qlknn_out_plus_half = transpose(qlknn_out_plus_half_tmp)
        qlknn_out_min_half = transpose(qlknn_out_min_half_tmp)
        qlknn_out = transpose(qlknn_out_tmp)
        dqlknn_out_dinput(:, :, 1:9) = dqlknn_out_dinput_tmp
      case(2)
        call evaluate_layer(input(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out, verbosity - 1, dqlknn_input_layer_out_dinput)
        call evaluate_layer(input_plus_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out_plus_half, verbosity - 1)
        call evaluate_layer(input_min_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out_min_half, verbosity - 1)

        call evaluate_layer(qlknn_input_layer_out, &
             nets%nets(net)%weights_hidden(1)%weight_layer, nets%nets(net)%biases_hidden(1)%bias_layer, 'tanh', &
             qlknn_out_tmp, verbosity - 1, dqlknn_out_dinput_tmp)
        call evaluate_layer(qlknn_input_layer_out_plus_half, &
             nets%nets(net)%weights_hidden(1)%weight_layer, nets%nets(net)%biases_hidden(1)%bias_layer, 'tanh', &
             qlknn_out_plus_half_tmp, verbosity - 1)
        call evaluate_layer(qlknn_input_layer_out_min_half, &
             nets%nets(net)%weights_hidden(1)%weight_layer, nets%nets(net)%biases_hidden(1)%bias_layer, 'tanh', &
             qlknn_out_min_half_tmp, verbosity - 1)

        ! Copied from evaulate_net on 98b641de6e72a601c699e22c1234c8b1090bd85c
        do rho = 1, n_rho
          call dgemm('N', 'N', int(n_out, lli), 9_lli, n_input_layer_out, 1._qlknn_dp, dqlknn_out_dinput_tmp(:, rho, :), n_input_layer_out, &
               dqlknn_input_layer_out_dinput(:, rho, :), int(n_out, lli), 0._qlknn_dp,  dqlknn_out_dinput(:, rho, :), int(n_out, lli))
        enddo

        qlknn_out_plus_half = transpose(qlknn_out_plus_half_tmp)
        qlknn_out_min_half = transpose(qlknn_out_min_half_tmp)
        qlknn_out = transpose(qlknn_out_tmp)
      case(3)
        call evaluate_network(input(1:9, :), &
             nets%nets(1), qlknn_out(:, 1), &
             verbosity - 1, dqlknn_out_dinput(1, :, :))
        call evaluate_network(input_plus_half(1:9, :), &
             nets%nets(1), qlknn_out_plus_half(:, 1), &
             verbosity - 1)
        call evaluate_network(input_min_half(1:9, :), &
             nets%nets(1), qlknn_out_min_half(:, 1), &
             verbosity - 1)
      case(4)
        call evaluate_layer(input(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out, verbosity - 1, dqlknn_input_layer_out_dinput)
        call evaluate_layer(input_plus_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out_plus_half, verbosity - 1)
        call evaluate_layer(input_min_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out_min_half, verbosity - 1)

        call evaluate_layers(qlknn_input_layer_out, &
             nets%nets(net)%weights_hidden, nets%nets(net)%biases_hidden, nets%nets(net)%hidden_activation, &
             qlknn_out_tmp, verbosity - 1, dqlknn_input_layer_out_dinput)
        call evaluate_layers(qlknn_input_layer_out_plus_half, &
             nets%nets(net)%weights_hidden, nets%nets(net)%biases_hidden, nets%nets(net)%hidden_activation, &
             qlknn_out_plus_half_tmp, verbosity - 1)
        call evaluate_layers(qlknn_input_layer_out_min_half, &
             nets%nets(net)%weights_hidden, nets%nets(net)%biases_hidden, nets%nets(net)%hidden_activation, &
             qlknn_out_min_half_tmp, verbosity - 1)

        dqlknn_out_dinput = dqlknn_input_layer_out_dinput
        qlknn_out_plus_half = transpose(qlknn_out_plus_half_tmp)
        qlknn_out_min_half = transpose(qlknn_out_min_half_tmp)
        qlknn_out = transpose(qlknn_out_tmp)
      case(5)
        call evaluate_layer(input(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out, verbosity - 1, dqlknn_input_layer_out_dinput)
        call evaluate_layer(input_plus_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out_plus_half, verbosity - 1)
        call evaluate_layer(input_min_half(1:9, :), &
             nets%nets(net)%weights_input, nets%nets(net)%biases_input, 'tanh', &
             qlknn_input_layer_out_min_half, verbosity - 1)

        call evaluate_layers(qlknn_input_layer_out, &
             nets%nets(net)%weights_hidden, nets%nets(net)%biases_hidden, nets%nets(net)%hidden_activation, &
             qlknn_hidden_out, verbosity - 1, dqlknn_input_layer_out_dinput)
        call evaluate_layers(qlknn_input_layer_out_plus_half, &
             nets%nets(net)%weights_hidden, nets%nets(net)%biases_hidden, nets%nets(net)%hidden_activation, &
             qlknn_hidden_out_plus, verbosity - 1)
        call evaluate_layers(qlknn_input_layer_out_min_half, &
             nets%nets(net)%weights_hidden, nets%nets(net)%biases_hidden, nets%nets(net)%hidden_activation, &
             qlknn_hidden_out_min, verbosity - 1)

        call evaluate_layer(qlknn_hidden_out, &
             nets%nets(net)%weights_output, nets%nets(net)%biases_output, 'tanh', &
             qlknn_out_tmp, verbosity - 1, dqlknn_out_dinput_tmp)
        call evaluate_layer(qlknn_hidden_out_plus, &
             nets%nets(net)%weights_output, nets%nets(net)%biases_output, 'tanh', &
             qlknn_out_plus_half_tmp, verbosity - 1)
        call evaluate_layer(qlknn_hidden_out_min, &
             nets%nets(net)%weights_output, nets%nets(net)%biases_output, 'tanh', &
             qlknn_out_min_half_tmp, verbosity - 1)

        do rho = 1, n_rho
          call dgemm('N', 'N', int(n_out, lli), 9_lli, n_hidden_layers_out, 1._qlknn_dp, dqlknn_out_dinput_tmp(:, rho, :), int(n_out, lli), &
               dqlknn_input_layer_out_dinput(:, rho, :), int(n_hidden_layers_out, lli), 0._qlknn_dp,  dqlknn_out_dinput(:, rho, :), int(n_out, lli))
        enddo

        qlknn_out_plus_half = transpose(qlknn_out_plus_half_tmp)
        qlknn_out_min_half = transpose(qlknn_out_min_half_tmp)
      end select

      dout_numerical = qlknn_out_plus_half - qlknn_out_min_half
      dinput_numerical = input_plus_half - input_min_half

      do outp = 1, n_out
        dana = dqlknn_out_dinput(outp, :, inp) * dinput_numerical(inp, :)
        dnum = qlknn_out_plus_half(:, outp) - qlknn_out_min_half(:, outp)
        if (verbosity >= 1) then
          write(*, *)
          write(*, *)'---------------------------'
          write(*, '(A,I4,A,I4)') 'outp=', outp, ', inp=', inp
          write(*, *)'---------------------------'
          write(*, *)'danalytical'
          write(*, *) dana
          write(*, *)
          write(*, *)'dnumerical'
          write(*, *) dnum
          write(*, *)
          write(*, *)'danalytical - dnumerical'
          write(*, *) dana - dnum
          write(*, *)
        endif

        err(:) = calc_error(dana, dnum, qlknn_out_min_half(:, outp))

        if (verbosity >= 1) then
          write(*, *)'err(:)'
          write(*, *) err(:)
        endif
        err_out(outp, :, inp) = err
      enddo
    enddo
  end subroutine jacobian_hyper_multi

  subroutine jacobian_hornnet_multi(casenum, input, stepsize, err_out, verbosityin)
    use qlknn_evaluate_nets
    use qlknn_disk_io
    implicit none

    integer, intent(in) :: casenum
    real(qlknn_dp), dimension(:,:), intent(in):: input
    real(qlknn_dp), intent(in) :: stepsize
    integer(lli), intent(in), optional :: verbosityin
    real(qlknn_dp), dimension(:,:,:), allocatable, intent(out) :: err_out

    !integer(lli), dimension(8) :: etg_map = (/ 1, 2, 4, 5,  6,  7,  8,  9 /)
    integer(lli), dimension(8) :: itg_map = (/ 1, 3, 4, 5,  6,  7,  8,  9 /)
    integer(lli), dimension(8) :: tem_map = (/ 1, 2, 4, 5,  6,  7,  8,  9 /)

    !integer(lli), dimension(1) :: c_etg_outp_map = (/ 1 /)
    !integer(lli), dimension(7) :: c_itg_outp_map = (/ 2, 4, 6, 8, 10, 12, 14 /)
    !integer(lli), dimension(7) :: c_tem_outp_map = (/ 3, 5, 7, 9, 11, 13, 15 /)

    integer(lli) :: verbosity, n_in, n_out, n_rho=24, outp, inp
    type (qlknn_options) :: opts
    type (qlknn_normpars) :: qlknn_norms
    real(qlknn_dp), dimension(:,:), allocatable :: input_min_half, input_plus_half
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out_min_half, qlknn_out_plus_half
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out_min_half_tmp, qlknn_out_plus_half_tmp
    real(qlknn_dp), dimension(:,:), allocatable :: hornnet_constants
    real(qlknn_dp), dimension(:,:), allocatable :: hornnet_constants_min_half, hornnet_constants_plus_half
    real(qlknn_dp), dimension(:,:), allocatable :: qlknn_out_tmp
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput
    real(qlknn_dp), dimension(:,:,:), allocatable :: dqlknn_out_dinput_tmp
    real(qlknn_dp), dimension(:,:,:), allocatable :: dflux_dhornnet_constants, dhornnet_constants_dinput, dflux_dinput
    real(qlknn_dp), dimension(:,:), allocatable :: dinput_numerical, dout_numerical
    real(qlknn_dp), dimension(:), allocatable :: err, dana, dnum
    logical, dimension(:), allocatable :: err_okay

    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if

    n_in = size(input, 1)

    call default_qlknn_hornnet_options(opts)

    ! Set default options
    opts%constrain_inputs = .false.
    opts%constrain_outputs = .false.
    opts%force_evaluate_all = .true.
    opts%apply_victor_rule = .false.

    ! Set specific options, and allocated arrays that change shape between tests
    ! Each test should have at least:
    ! n_out: The amount of outputs of the outermost function
    ! n_in: The amount of inputs of the innermost function
    ! n_rho: The amount of radial points
    ! This defines the following quantities:
    ! dqlknn_out_dinput: The Jacobian of the outermost function with respect
    !    to the innermost input (n_out, n_rho, n_in)
    ! qlknn_out: The output of the outermost function
    ! qlknn_out_min_half: The output of the outermost function with input
    !    modified by -step
    ! qlknn_out_min_half: The output of the outermost function with input
    !    modified by +step
    select case (casenum)
    case(1)
      ! Test a single (input) layer
      n_out = size(blocks%input_blocks(2)%biases_input)
      ! Common layer only depends on the first 8 dimensions, fill rest with 0s and
      ! define temporary variable to store the layers Jacobian in
      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
      allocate(err_out(n_out, n_rho, 9))
      allocate(dqlknn_out_dinput_tmp(n_out, n_rho, 8))
      dqlknn_out_dinput = 0
      ! The Jacobians of the layers are transposed as compared to the final
      ! outputted Jacobians. Allocate temporary arrays to save this transposed array
      allocate(qlknn_out_tmp(n_out, n_rho))
      allocate(qlknn_out_min_half_tmp(n_out, n_rho))
      allocate(qlknn_out_plus_half_tmp(n_out, n_rho))
    case(2)
      ! Test getting the c* constants
      n_out = 15
      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
      allocate(err_out(n_out, n_rho, n_in))
    case(3)
      ! Test getting the non-pfe fluxes
      opts%merge_modes = .false.
      n_out = 7
      allocate(hornnet_constants(n_rho, 15))
      allocate(hornnet_constants_min_half(n_rho, 15))
      allocate(hornnet_constants_plus_half(n_rho, 15))

      allocate(dhornnet_constants_dinput(15, n_rho, n_in))
      allocate(dflux_dhornnet_constants(n_out, n_rho, 15))
      allocate(dflux_dinput(n_out, n_rho, n_in))

      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
      allocate(err_out(n_out, n_rho, n_in))
    case(4)
      ! Test getting the c_pfe constants on the threshold dim
      n_out = 15
      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
      allocate(err_out(n_out, n_rho, n_in))
    case(5)
      ! Test getting the pfe fluxes
      opts%merge_modes = .false.
      n_out = 7
      allocate(hornnet_constants(n_rho, 15))
      allocate(hornnet_constants_min_half(n_rho, 15))
      allocate(hornnet_constants_plus_half(n_rho, 15))

      allocate(dhornnet_constants_dinput(15, n_rho, n_in))
      allocate(dflux_dhornnet_constants(n_out, n_rho, 15))
      allocate(dflux_dinput(n_out, n_rho, n_in))

      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
      allocate(err_out(n_out, n_rho, n_in))
    case(6)
      ! Test getting merged fluxes
      opts%merge_modes = .true.
      n_out = 4
      allocate(hornnet_constants(n_rho, 15))
      allocate(hornnet_constants_min_half(n_rho, 15))
      allocate(hornnet_constants_plus_half(n_rho, 15))

      allocate(dhornnet_constants_dinput(15, n_rho, n_in))
      allocate(dflux_dhornnet_constants(n_out, n_rho, 15))
      allocate(dflux_dinput(n_out, n_rho, n_in))

      allocate(dqlknn_out_dinput(n_out, n_rho, n_in))
      allocate(err_out(n_out, n_rho, n_in))
    case default
      ERRORSTOP(.true., 'Given case number not implemented')
    endselect

    ! To store the results of evaluating at x, x-h and x+h
    allocate(qlknn_out(n_rho, n_out))
    allocate(qlknn_out_min_half(n_rho, n_out))
    allocate(qlknn_out_plus_half(n_rho, n_out))
    allocate(dout_numerical(n_rho, n_out))

    ! To store  x-h and x+h
    allocate(input_min_half(n_in, n_rho))
    allocate(input_plus_half(n_in, n_rho))
    allocate(dinput_numerical(n_in, n_rho))

    ! To store profile data of the error
    allocate(err(n_rho))
    allocate(dana(n_rho))
    allocate(dnum(n_rho))
    allocate(err_okay(n_rho))

    ! Variables for Victor rule
    allocate(qlknn_norms%a1(n_rho))
    qlknn_norms%A1 = 2.
    qlknn_norms%R0 = 3.
    qlknn_norms%a = 1.

    select case (casenum)
    case(2,3,4,5,6)
      err_out(:, :, 10:11) = 0.
    endselect
    do inp = 1, n_in - 2
      input_min_half(:, :) = input
      input_plus_half(:, :) = input
      input_min_half(inp, :) = input(inp, :) - stepsize
      input_plus_half(inp, :) = input(inp, :) + stepsize
      select case (casenum)
      case(1)
        if (.not. any(itg_map == inp)) then
          err_out(:, :, inp) = 0.
          cycle
        endif
        call evaluate_layer(input(itg_map, :), &
             blocks%input_blocks(2)%weights_input, blocks%input_blocks(2)%biases_input, 'tanh', &
             qlknn_out_tmp, verbosity - 1, dqlknn_out_dinput_tmp)
        call evaluate_layer(input_plus_half(itg_map, :), &
             blocks%input_blocks(2)%weights_input, blocks%input_blocks(2)%biases_input, 'tanh', &
             qlknn_out_plus_half_tmp, verbosity - 1)
        call evaluate_layer(input_min_half(itg_map, :), &
             blocks%input_blocks(2)%weights_input, blocks%input_blocks(2)%biases_input, 'tanh', &
             qlknn_out_min_half_tmp, verbosity - 1)
        qlknn_out_plus_half = transpose(qlknn_out_plus_half_tmp)
        qlknn_out_min_half = transpose(qlknn_out_min_half_tmp)
        qlknn_out = transpose(qlknn_out_tmp)
        dqlknn_out_dinput(:, :, itg_map) = dqlknn_out_dinput_tmp
      case(2)
        call evaluate_hornnet_constants(input, blocks, qlknn_out, verbosity - 1, opts, qlknn_norms, dqlknn_out_dinput)
        call evaluate_hornnet_constants(input_min_half, blocks, qlknn_out_min_half, verbosity - 1, opts, qlknn_norms)
        call evaluate_hornnet_constants(input_plus_half, blocks, qlknn_out_plus_half, verbosity - 1, opts, qlknn_norms)
      case(3)
        call evaluate_hornnet_constants(input, blocks, hornnet_constants, verbosity - 1, opts, qlknn_norms, dhornnet_constants_dinput)
        call evaluate_hornnet_constants(input_min_half, blocks, hornnet_constants_min_half, verbosity - 1, opts, qlknn_norms)
        call evaluate_hornnet_constants(input_plus_half, blocks, hornnet_constants_plus_half, verbosity - 1, opts, qlknn_norms)

        call hornnet_flux_from_constants(input, blocks, hornnet_constants, qlknn_out, verbosity - 1, opts, qlknn_norms, dflux_dhornnet_constants, dflux_dinput)
        call hornnet_flux_from_constants(input_min_half, blocks, hornnet_constants_min_half, qlknn_out_min_half, verbosity - 1, opts, qlknn_norms)
        call hornnet_flux_from_constants(input_plus_half, blocks, hornnet_constants_plus_half, qlknn_out_plus_half, verbosity - 1, opts, qlknn_norms)

        call hornnet_multiply_jacobians(dhornnet_constants_dinput, dflux_dhornnet_constants, dflux_dinput, dqlknn_out_dinput)
      case(4)
        call evaluate_hornnet_constants(input, blocks, qlknn_out, verbosity - 1, opts, qlknn_norms, dqlknn_out_dinput)
        call evaluate_hornnet_constants(input_min_half, blocks, qlknn_out_min_half, verbosity - 1, opts, qlknn_norms)
        call evaluate_hornnet_constants(input_plus_half, blocks, qlknn_out_plus_half, verbosity - 1, opts, qlknn_norms)
      case(5)
        call evaluate_hornnet_constants(input, blocks, hornnet_constants, verbosity - 1, opts, qlknn_norms, dhornnet_constants_dinput)
        call evaluate_hornnet_constants(input_min_half, blocks, hornnet_constants_min_half, verbosity - 1, opts, qlknn_norms)
        call evaluate_hornnet_constants(input_plus_half, blocks, hornnet_constants_plus_half, verbosity - 1, opts, qlknn_norms)

        call hornnet_flux_from_constants(input, blocks, hornnet_constants, qlknn_out, verbosity - 1, opts, qlknn_norms, dflux_dhornnet_constants, dflux_dinput)
        call hornnet_flux_from_constants(input_min_half, blocks, hornnet_constants_min_half, qlknn_out_min_half, verbosity - 1, opts, qlknn_norms)
        call hornnet_flux_from_constants(input_plus_half, blocks, hornnet_constants_plus_half, qlknn_out_plus_half, verbosity - 1, opts, qlknn_norms)

        call hornnet_multiply_jacobians(dhornnet_constants_dinput, dflux_dhornnet_constants, dflux_dinput, dqlknn_out_dinput)
      case(6)
        call evaluate_hornnet_constants(input, blocks, hornnet_constants, verbosity - 1, opts, qlknn_norms, dhornnet_constants_dinput)
        call evaluate_hornnet_constants(input_min_half, blocks, hornnet_constants_min_half, verbosity - 1, opts, qlknn_norms)
        call evaluate_hornnet_constants(input_plus_half, blocks, hornnet_constants_plus_half, verbosity - 1, opts, qlknn_norms)

        call hornnet_flux_from_constants(input, blocks, hornnet_constants, qlknn_out, verbosity - 1, opts, qlknn_norms, dflux_dhornnet_constants, dflux_dinput)
        call hornnet_flux_from_constants(input_min_half, blocks, hornnet_constants_min_half, qlknn_out_min_half, verbosity - 1, opts, qlknn_norms)
        call hornnet_flux_from_constants(input_plus_half, blocks, hornnet_constants_plus_half, qlknn_out_plus_half, verbosity - 1, opts, qlknn_norms)

        call hornnet_multiply_jacobians(dhornnet_constants_dinput, dflux_dhornnet_constants, dflux_dinput, dqlknn_out_dinput)
      end select

      dout_numerical = qlknn_out_plus_half - qlknn_out_min_half
      dinput_numerical = input_plus_half - input_min_half

      do outp = 1, n_out
        select case (casenum)
        case(2)
          ! Some outputs (the bendy guys) are hard to check. Ignore for now
          if (any(outp == (/ 5, 8 /))) then
            err_out(outp, :, inp) = 0.
            cycle
          endif
          ! Skip the threshold dimension for c_pfe. Test those separately
          if (outp == 14 .and. .not. any(inp == itg_map) .or. &
              outp == 15 .and. .not. any(inp == tem_map)) then
            err_out(outp, :, inp) = 0.
            cycle
          endif
        case(3)
          ! Skip pfe
          if (any(outp == (/ 6, 7 /))) then
            err_out(outp, :, inp) = 0.
            cycle
          endif
        case(4)
          ! Check the threshold dimension for c_pfe.
          if (.not. (outp == 14 .and. .not. any(inp == itg_map)) .and. &
              .not. (outp == 15 .and. .not. any(inp == tem_map))) then
            err_out(outp, :, inp) = 0.
            cycle
          endif
        case(5)
          ! Check pfe
          if (.not. any(outp == (/ 6, 7 /))) then
            err_out(outp, :, inp) = 0.
            cycle
          endif
        endselect
        dana = dqlknn_out_dinput(outp, :, inp) * dinput_numerical(inp, :)
        dnum = qlknn_out_plus_half(:, outp) - qlknn_out_min_half(:, outp)
        if (verbosity >= 1) then
          write(*, *)
          write(*, *)'---------------------------'
          write(*, '(A,I4,A,I4)') 'outp=', outp, ', inp=', inp
          write(*, *)'---------------------------'
          write(*, *)'danalytical'
          write(*, *) dana
          write(*, *)
          write(*, *)'dnumerical'
          write(*, *) dnum
          write(*, *)
          write(*, *)'danalytical - dnumerical'
          write(*, *) dana - dnum
          write(*, *)
        endif

        err(:) = calc_error(dana, dnum, qlknn_out_min_half(:, outp))

        if (verbosity >= 1) then
          write(*, *)'err(:)'
          write(*, *) err(:)
          write(*, *)'max(abs(err(:)))', maxval(abs(err))
        endif
        err_out(outp, :, inp) = err
      enddo
    enddo
  end subroutine jacobian_hornnet_multi

  subroutine passed_test(err, max_err, err_okay, verbosityin)
    use qlknn_primitives, only: is_not_close

    real(qlknn_dp), dimension(:,:,:), intent(in) :: err
    real(qlknn_dp), intent(in) :: max_err
    logical, dimension(:,:,:), allocatable, intent(out) :: err_okay
    integer(lli), intent(in), optional :: verbosityin

    real(qlknn_dp), dimension(:), allocatable :: this_err
    logical, dimension(:), allocatable :: this_err_okay
    integer(lli) :: inp, outp, verbosity

    logical, dimension(:), allocatable :: is_nonzero

    if(present(verbosityin)) then
       verbosity=verbosityin
    else
       verbosity = 0
    end if
    if (verbosity >= 1) then
      write(*,"(A,E9.2)")"Checking against error ", max_err
    endif

    allocate(err_okay(size(err, 1), size(err, 2), size(err, 3)))
    allocate(this_err(size(err, 2)))
    allocate(this_err_okay(size(err, 2)))
    allocate(is_nonzero(size(err, 2)))

    err_okay = abs(err) < max_err
    if (verbosity >= 1) then
      do inp = 1, size(err, 3)
        do outp = 1, size(err, 1)
          this_err = err(outp, :, inp)
          this_err_okay = err_okay(outp, :, inp)
          call is_not_close(this_err, 0._qlknn_dp, is_nonzero)
          if (.not. any(is_nonzero) .and. verbosity <= 4) then
            ! Skip zero errors
            cycle
          endif

          if (verbosity >= 2) then
            write(*,*)
            write(*,'(A, I3, A, I3)')'inp=', inp, ', outp=', outp
          endif
          if (verbosity >= 3) then
            write(*,'(A, I3, A, I3, A, *(E9.2, 1X))')'abs(err(', outp, ', :, ', inp, ')) = ', abs(this_err)
          endif
          if (verbosity >= 2) then
            write(*,'(A, I3, A, I3, A, *(E9.2, 1X))')'max(abs(err(', outp, ', :, ', inp, '))) = ', maxval(abs(this_err))
            write(*, '(A, *(L1, 1X))')'err_okay(outp, :, inp) ', err_okay(outp, :, inp)
          endif
          if (verbosity >= 1 .and. .not. all(this_err_okay)) then
            write(*,'(A, I3, A, I3, A, E9.2)')'Failed! max(abs(err(', outp, ', :, ', inp, '))) = ', maxval(abs(this_err))
          endif
        enddo
      enddo
    endif
  end subroutine passed_test

end module test_jacobian

#!/usr/bin/env bash
# This file is part of QLKNN-fortran
# You should have received the QLKNN-fortran LICENSE in the root of the project
set -e

export TOOLCHAIN=gcc
export BUILD=debug
export TUBSCFG_MPI=0
export TUBSCFG_MKL=0
export HOSTFULL=docker-debian
export VERBOSE=1
CLEAN=1

MKLS="0 1"
MPIS="0 1"
TOOLCHAINS="gcc intel"

for TOOLCHAIN in $TOOLCHAINS; do
  for TUBSCFG_MKL in $MKLS; do
    for TUBSCFG_MPI in $MPIS; do
      export TOOLCHAIN
      export TUBSCFG_MKL
      export TUBSCFG_MPI
      #env TOOLCHAIN=gcc BUILD=debug TUBSCFG_MPI=0 TUBSCFG_MKL=0 HOSTFULL=docker-debian VERBOSE=1 ./lib/src/fruitsh/fruit.shtests/test_regression.f90
      echo
      echo -------------------------------------------------------------------------------
      echo Building TOOLCHAIN=$TOOLCHAIN TUBSCFG_MKL=$TUBSCFG_MKL TUBSCFG_MPI=$TUBSCFG_MPI
      echo -------------------------------------------------------------------------------
      echo
      if [ $CLEAN == 1 ]; then
        make clean
      fi
      make
      #./lib/src/fruitsh/fruit.sh tests/test_regression.f90
    done
  done
done

#env TOOLCHAIN=gcc BUILD=debug TUBSCFG_MPI=0 TUBSCFG_MKL=0 HOSTFULL=docker-debian VERBOSE=1 ./lib/src/fruitsh/fruit.shtests/test_regression.f90

#!/bin/sh
#
# overview.sh : prettyprint list of active makefiles
#
# Invoked by "make overview" to pretty print the list of active makefiles.
# Tries to output something similar to "tree", but has a few limitations.
#
# Warning: pretty bad code follows.

indent=""
current="."

if [ x"$1" != x"1" ]; then
	fmtEND="\e[0m"
	fmtFIL="\e[31m"
	fmtDEF="\e[34m"
else
	fmtEND=""
	fmtFIL=""
	fmtDEF=""
fi

inside() {
	echo "$1" | grep -o "^$2" >/dev/null
}
defsfile() {
	echo "$1" | grep -o 'defs/.*\.make' >/dev/null
}

common() {
	# See https://stackoverflow.com/a/6973268
	printf "%s\n%s\n" "$1" "$2" | sed -e 'N;s/^\(.*\).*\n\1.*$/\1/'
}

output() {
	echo "O"
	echo "$name"
}

ascend() {
	echo "A"
	echo "$1"
	current="$1"
}
descend() {
	pat="$1";
	if [ -z "$pat" ]; then
		pat="///////////////"; # hack: avoid empty sed expression
	fi
	
	for step in $(echo "$current" | sed "s:$pat::" | sed 's:/: :'); do
		echo "D"
	done
	current="$1"
}

balance() {
	level=0
	
	while read line; do
		echo "$line"
		if [ x"$line" == x"A" ]; then
			level=$((level+1))
		elif [ x"$line" == x"D" ]; then
			level=$((level-1))
		fi
	done

	while [ x"$level" != x"0" ]; do
		echo "D"
		level=$((level-1))
	done
}

prettyprint() {
	indent=""

	last=""
	lastindent=""

	echo "."

	read next
	while [ ! -z "$next" ]; do
		line="$next"
		read next

		if [ x"$line" == x"O" ]; then
			item="$next"
			read next

			if [ x"$next" == x"D" ]; then
				last="$item"
				lastindent="$indent│"
			else
				echo -e "$indent├── ${fmtFIL}$item${fmtEND}"
			fi
		elif [ x"$line" == x"A" ]; then
			if [ ! -z "$last" ]; then
				echo -n "$lastindent" | sed 's/ $//';
				echo -e "└── ${fmtFIL}$last${fmtEND}";
				last=""
				lastindent=""
			fi

			item="$next"
			read next

			echo "$indent├── $item"
			indent="$indent│   ";
		elif [ x"$line" == x"D" ]; then
			indent="$(echo "$indent" | sed 's/│   $//')";
			lastindent="$(echo "$lastindent" | sed 's/│\(\s*\)$/ \1/')";
		fi
	done

	if [ ! -z "$last" ]; then
		echo -n "$lastindent" | sed 's/ $//';
		echo -e "└── ${fmtFIL}$last${fmtEND}";
	fi
}

for file in $(cat -); do
	dir="$(dirname $file)"
	name="$(basename $file)"

	if defsfile "$file"; then
		continue;
	fi

	if [ x"$dir" == x"$current" ]; then
		output "$name"
	elif inside "$dir" "$current"; then
		ascend "$dir"
		output "$name"
	else
		descend $(common "$dir" "$current")
		ascend "$dir"
		output "$name"
	fi
done | balance | prettyprint

echo -e "└── ${fmtDEF}defs/*.make (support files)${fmtEND}"

#EOF

#!/bin/bash

dir="$(dirname "$(realpath "$0")")";
makefile="$(realpath "${dir}/../Makefile")";

if ! grep -e 'include .*tubs/main.make' "${makefile}" >/dev/null 2>&1; then
    echo "No TUBS-importing Makefile found, abort!" >&2;
    exit 1
fi

echo "${makefile}"
IFS='\n' readarray -t  files < <(find "$(dirname "$makefile")" \( -name '*.o' -or -name '*.a' -or -name '*.mod' -or -name '*.exe' \) -print)
if [[ "${#files[@]}" -eq 0 ]]; then
    echo "No purgable files found, nothing to do"
    exit 0
fi

echo "Found purgable files:"
echo "${files[@]}";

read -p "Purge files [Y/n] " yno
if [ -z "$yno" ]; then
  echo Y
  yno=Y
fi

case "$yno" in
  Y | y)
    echo "Purging files"
    rm "${files[@]}"
    ;;
  N | n)
    echo "Not purging files"
    exit 0
    ;;
esac

src_dir: ./src
output_dir: ./doc
project: QLKNN-fortran
project_website: https://gitlab.com/qualikiz-group/QLKNN-fortran/wikis
project_download: https://gitlab.com/Karel-van-de-Plassche/QLKNN-develop
summary: FORTRAN interface for QuaLiKiz Neural Networks (QLKNN)
author: Karel van de Plassche
author_description: I am a junior researcher at the Dutch Institude For Fundamental Energy Research ([DIFFER](https://www.differ.nl/)). In our Integrated Modelling and Transport ([IMT](https://www.differ.nl/research/integrated-modelling-and-transport)) group we model and support models for full-device modelling of Tokamaks. I mostly focus on quick modelling of core transport using machine learning techniques, but we are always interested to learn more!)
github: https://gitlab.com/Karel-van-de-Plassche
email: k.l.vandeplassche@differ.nl
linkedin: https://www.linkedin.com/in/karelvandeplassche
fpp_extensions: f90
predocmark: >
media_dir: ./media
docmark_alt: #
predocmark_alt: <
display: public
         protected
         private
source: true
graph: true
coloured_edges: true
search: true
macro: MPI
warn: true
page_dir: .

Please refer to the [wiki](https://gitlab.com/qualikiz-group/QLKNN-fortran/wikis) for more usage-type documentation. This page contains detailed information about all methods and types defined in QLKNN-fortran.
